import 'package:flutter/material.dart';

class HFColorUtils {
  static String colorDelpToHex(int aDelpColor) {
    String ret = "0xFF000000";
    try {
      if (aDelpColor < 0) {
        aDelpColor *= -1;
      }
      int R, G, B;
      B = (aDelpColor / 65536).floor();
      G = ((aDelpColor - (B * 65536)) / 256).floor();
      R = (aDelpColor - (B * 65536 + G * 256)).floor();
      String bStr = getFormattedColorUnit(B);
      String gStr = getFormattedColorUnit(G);
      String rStr = getFormattedColorUnit(R);

      ret = "/$rStr$gStr$bStr";
    } catch (aE) {
      print("exce $aE");
    }
    return ret;
  }

  ///
  /// This method converts int to hex
  ///
  static String getFormattedColorUnit(int colorUnit) {
    String radixString = colorUnit.toRadixString(16);
    if (radixString.length == 1) {
      radixString = "0$radixString";
    }
    return radixString;
  }

  static Color convertDelphiColorToColor(int aDelpColor) {
    var hexColor = colorDelpToHex(aDelpColor);
    return new Color(int.parse(
          "0xFF" + hexColor.substring(1, 7),
          radix: 16,
        ) +
        0xFF000000);
  }
}
