import 'package:intl/intl.dart';

class HFDateTimeUtils {
  static String reformatDate(String inputDate, String inputFormat, String outputFormat) {
    try {
      DateFormat inputFM = DateFormat(inputFormat);
      DateTime inputDT = inputFM.parse(inputDate);

      DateFormat outputF = DateFormat(outputFormat);

      return outputF.format(inputDT);
    } on Exception catch (e) {
      print("exception while converting date $e");
      return "";
    }
  }

  static String getampmfrom24(String inputTime) {
    return DateFormat.jm().format(DateFormat.Hms().parseStrict(inputTime)).toString();
  }

  static bool checkWeekly(DateTime date) {
    var monday = 1;
    var currentDate = new DateTime.now();
    var recentMonday = currentDate.subtract(Duration(days: currentDate.weekday - monday));
    var upcomingSunday = recentMonday.add(Duration(days: 6));

    if (date.isAfter(recentMonday) && date.isBefore(upcomingSunday)) {
      return true;
    } else {
      return false;
    }
  }
}
