import 'package:hotech_flutter_utilities/Constants.dart';

import 'BaseModelSync.dart';

class BaseModelCode extends BaseModelSync {
  String code;
  String shortcode;
  String description;
  bool isdef;
  bool isActive;
  Map<String, dynamic> jsonMap;

  BaseModelCode({
    this.code,
    this.shortcode,
    this.description,
    this.isdef,
    this.isActive,
    this.jsonMap,
  }) : super(
          id: jsonMap[DBConst.FDN_ID],
          jsonMap: jsonMap,
        );

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_CODE: code,
      DBConst.FDN_SHORTCODE: shortcode,
      DBConst.FDN_DESCRIPTION: description,
      DBConst.FDN_ISDEF: isdef,
      DBConst.FDN_ISACTIVE: isActive,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is BaseModelCode &&
          runtimeType == other.runtimeType &&
          code == other.code &&
          shortcode == other.shortcode &&
          description == other.description &&
          isdef == other.isdef &&
          isActive == other.isActive &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      code.hashCode ^ shortcode.hashCode ^ description.hashCode ^ isdef.hashCode ^ isActive.hashCode ^ jsonMap.hashCode;

  @override
  String toString() {
    return '${super.toString()}, code: $code, shortcode: $shortcode, description: $description, isdef: $isdef, isActive: $isActive, jsonMap: $jsonMap';
  }
}
