import 'package:hotech_flutter_utilities/model/BaseModelTable.dart';

import 'package:hotech_flutter_utilities/Constants.dart';

class BaseModelSync extends BaseModelTable {
  int id;

  Map<String, dynamic> jsonMap;

  BaseModelSync({
    this.id,
    this.jsonMap,
  }) : super(
          userid: jsonMap[DBConst.FDN_USERID],
          usercode: jsonMap[DBConst.FDN_USERCODE],
          username: jsonMap[DBConst.FDN_USERNAME],
          insuserid: jsonMap[DBConst.FDN_INSUSERID],
          insusercode: jsonMap[DBConst.FDN_INSUSERCODE],
          insusername: jsonMap[DBConst.FDN_INSUSERNAME],
          hotelrefno: jsonMap[DBConst.FDN_HOTELREFNO],
          gid: jsonMap[DBConst.FDN_GID],
          mid: jsonMap[DBConst.FDN_MID],
          refid: jsonMap[DBConst.FDN_REFID],
          refcode: jsonMap[DBConst.FDN_REFCODE],
          ver: jsonMap[DBConst.FDN_VER],
          updtl: jsonMap[DBConst.FDN_UPDTL],
          insdatetime: jsonMap[DBConst.FDN_INSDATETIME],
          updatetime: jsonMap[DBConst.FDN_UPDATETIME],
          xcode: jsonMap[DBConst.FDN_XCODE],
        );

  factory BaseModelSync.fromJson(Map<String, dynamic> json) {
    return new BaseModelSync(
      id: json[DBConst.FDN_ID],
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_ID: id,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other && other is BaseModelSync && runtimeType == other.runtimeType && id == other.id;

  @override
  int get hashCode => super.hashCode ^ id.hashCode;

  @override
  String toString() {
    return '${super.toString()}, id: $id';
  }
}
