import 'package:hotech_flutter_utilities/Constants.dart';

class BaseModelTable {
  int userid;
  int insuserid;
  int hotelrefno;
  int mid;
  int refid;
  int ver;
  int updtl;
  String gid;
  String refcode;
  String insdatetime;
  String updatetime;
  String xcode;
  String username;
  String usercode;
  String insusercode;
  String insusername;

  BaseModelTable({
    this.userid,
    this.usercode,
    this.username,
    this.insuserid,
    this.insusercode,
    this.insusername,
    this.hotelrefno,
    this.gid,
    this.mid,
    this.refid,
    this.refcode,
    this.ver,
    this.updtl,
    this.insdatetime,
    this.updatetime,
    this.xcode,
  });

  factory BaseModelTable.fromJson(Map<String, dynamic> json) {
    return new BaseModelTable(
      userid: json[DBConst.FDN_USERID],
      usercode: json[DBConst.FDN_USERCODE],
      username: json[DBConst.FDN_USERNAME],
      insuserid: json[DBConst.FDN_INSUSERID],
      insusercode: json[DBConst.FDN_INSUSERCODE],
      insusername: json[DBConst.FDN_INSUSERNAME],
      hotelrefno: json[DBConst.FDN_HOTELREFNO],
      gid: json[DBConst.FDN_GID],
      mid: json[DBConst.FDN_MID],
      refid: json[DBConst.FDN_REFID],
      refcode: json[DBConst.FDN_REFCODE],
      ver: json[DBConst.FDN_VER],
      updtl: json[DBConst.FDN_UPDTL],
      insdatetime: json[DBConst.FDN_INSDATETIME],
      updatetime: json[DBConst.FDN_INSDATETIME],
      xcode: json[DBConst.FDN_XCODE],
    );
  }

  Map<String, dynamic> toJson() {
    return <String, dynamic>{
      DBConst.FDN_USERID: userid,
      DBConst.FDN_USERCODE: usercode,
      DBConst.FDN_USERNAME: username,
      DBConst.FDN_INSUSERID: insuserid,
      DBConst.FDN_INSUSERCODE: insusercode,
      DBConst.FDN_INSUSERNAME: insusername,
      DBConst.FDN_HOTELREFNO: hotelrefno,
      DBConst.FDN_GID: gid,
      DBConst.FDN_MID: mid,
      DBConst.FDN_REFID: refid,
      DBConst.FDN_REFCODE: refcode,
      DBConst.FDN_VER: ver,
      DBConst.FDN_UPDTL: updtl,
      DBConst.FDN_INSDATETIME: insdatetime,
      DBConst.FDN_XCODE: xcode,
      DBConst.FDN_INSDATETIME: insdatetime,
      DBConst.FDN_UPDATETIME: updatetime,
    };
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is BaseModelTable &&
          runtimeType == other.runtimeType &&
          userid == other.userid &&
          usercode == other.usercode &&
          username == other.username &&
          insuserid == other.insuserid &&
          insusercode == other.insusercode &&
          insusername == other.insusername &&
          hotelrefno == other.hotelrefno &&
          gid == other.gid &&
          mid == other.mid &&
          refid == other.refid &&
          refcode == other.refcode &&
          ver == other.ver &&
          updtl == other.updtl &&
          insdatetime == other.insdatetime &&
          xcode == other.xcode;

  @override
  int get hashCode =>
      userid.hashCode ^
      usercode.hashCode ^
      username.hashCode ^
      insuserid.hashCode ^
      insusercode.hashCode ^
      insusername.hashCode ^
      hotelrefno.hashCode ^
      gid.hashCode ^
      mid.hashCode ^
      refid.hashCode ^
      refcode.hashCode ^
      ver.hashCode ^
      updtl.hashCode ^
      insdatetime.hashCode ^
      xcode.hashCode;

  @override
  String toString() {
    return 'userid: $userid, vvusercode: $usercode, vVusername: $username, insuserid: $insuserid, vvinsusercode: $insusercode, vvinsusername: $insusername, hotelrefno: $hotelrefno, gid: $gid, mid: $mid, refid: $refid, refcode: $refcode, ver: $ver, updtl: $updtl, insdatetime: $insdatetime, xcode: $xcode';
  }
}
