import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/ResponseConverter.dart';

class ListDataResult<M> {
  final bool success;
  final String msg;
  final List<String> spuriousParameters;
  final List<M> data;
  final int count;

  ListDataResult({
    this.success,
    this.msg,
    this.spuriousParameters,
    this.data,
    this.count,
  });

  factory ListDataResult.fromJson(Map<String, dynamic> json) {
    return ListDataResult(
      success: json[DBConst.FDN_SUCCESS],
      msg: json[DBConst.FDN_MSG],
      spuriousParameters: new List<String>.from(json[DBConst.FDN_SPURIOUSPARAMETERS].map((x) => x)),
      data: listConverter<M>(json[DBConst.FDN_DATA] as List).cast<M>(),
      count: json[DBConst.FDN_COUNT],
    );
  }
}
