import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/ResponseConverter.dart';

class SingleDataResult<M> {
  final bool success;
  final String msg;
  final List<String> spuriousParameters;
  final M data;
  final int count;

  SingleDataResult({
    this.success,
    this.msg,
    this.spuriousParameters,
    this.data,
    this.count,
  });

  factory SingleDataResult.fromJson(Map<String, dynamic> json) {
    return SingleDataResult(
      success: json[DBConst.FDN_SUCCESS],
      msg: json[DBConst.FDN_MSG],
      spuriousParameters: new List<String>.from(json[DBConst.FDN_SPURIOUSPARAMETERS].map((x) => x)),
      data: objectConverter<M>(json[DBConst.FDN_DATA]),
      count: json[DBConst.FDN_COUNT],
    );
  }
}
