import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelCode.dart';

class CmsGallery extends BaseModelCode {
  String folder;

  // view fields
  String hotelname;

  Map<String, dynamic> jsonMap;

  CmsGallery({
    this.folder,
    this.hotelname,
    this.jsonMap,
  }) : super(
          code: jsonMap[DBConst.FDN_CODE],
          shortcode: jsonMap[DBConst.FDN_SHORTCODE],
          description: jsonMap[DBConst.FDN_DESCRIPTION],
          isdef: jsonMap[DBConst.FDN_ISDEF],
          isActive: jsonMap[DBConst.FDN_ISACTIVE],
          jsonMap: jsonMap,
        );

  factory CmsGallery.fromJson(Map<String, dynamic> json) {
    return new CmsGallery(
      folder: json[DBConst.FDN_FOLDER],
      hotelname: json[DBConst.FDN_HOTELNAME],
      jsonMap: json,
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_FOLDER: folder,
      DBConst.FDN_HOTELNAME: hotelname,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is CmsGallery &&
          runtimeType == other.runtimeType &&
          folder == other.folder &&
          hotelname == other.hotelname &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode => super.hashCode ^ folder.hashCode ^ hotelname.hashCode ^ jsonMap.hashCode;

  @override
  String toString() {
    return 'CmsGallery{${super.toString()}, folder: $folder, hotelname: $hotelname, jsonMap: $jsonMap}';
  }
}
