import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelSync.dart';

class CmsGalleryItem extends BaseModelSync {
  int galleryid;
  String description;
  String imageurl;
  String caption;
  String url;
  int orderno;
  String thumbnail;
  String content;

  // view fields
  String hotelname;

  Map<String, dynamic> jsonMap;

  CmsGalleryItem({
    this.galleryid,
    this.description,
    this.imageurl,
    this.caption,
    this.url,
    this.orderno,
    this.thumbnail,
    this.content,
    this.hotelname,
    this.jsonMap,
  }) : super(
          id: jsonMap[DBConst.FDN_ID],
          jsonMap: jsonMap,
        );

  factory CmsGalleryItem.fromJson(Map<String, dynamic> json) {
    return new CmsGalleryItem(
      galleryid: json[DBConst.FDN_GALLERYID],
      description: json[DBConst.FDN_DESCRIPTION],
      imageurl: json[DBConst.FDN_IMAGEURL],
      caption: json[DBConst.FDN_CAPTION],
      url: json[DBConst.FDN_URL],
      orderno: json[DBConst.FDN_ORDERNO],
      thumbnail: json[DBConst.FDN_THUMBNAIL],
      content: json[DBConst.FDN_CONTENT],
      hotelname: json[DBConst.FDN_HOTELNAME],
      jsonMap: json,
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_GALLERYID: galleryid,
      DBConst.FDN_DESCRIPTION: description,
      DBConst.FDN_IMAGEURL: imageurl,
      DBConst.FDN_CAPTION: caption,
      DBConst.FDN_URL: url,
      DBConst.FDN_ORDERNO: orderno,
      DBConst.FDN_THUMBNAIL: thumbnail,
      DBConst.FDN_CONTENT: content,
      DBConst.FDN_HOTELNAME: hotelname,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is CmsGalleryItem &&
          runtimeType == other.runtimeType &&
          galleryid == other.galleryid &&
          description == other.description &&
          imageurl == other.imageurl &&
          caption == other.caption &&
          url == other.url &&
          orderno == other.orderno &&
          thumbnail == other.thumbnail &&
          content == other.content &&
          hotelname == other.hotelname &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      galleryid.hashCode ^
      description.hashCode ^
      imageurl.hashCode ^
      caption.hashCode ^
      url.hashCode ^
      orderno.hashCode ^
      thumbnail.hashCode ^
      content.hashCode ^
      hotelname.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'CmsGalleryItem{${super.toString()}, galleryid: $galleryid, description: $description, imageurl: $imageurl, caption: $caption, url: $url, orderno: $orderno, thumbnail: $thumbnail, content: $content, hotelname: $hotelname, jsonMap: $jsonMap}';
  }
}
