import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelCode.dart';

class CmsSlider extends BaseModelCode {
  String cssstyle;
  String url;

  // view fields
  String hotelname;

  Map<String, dynamic> jsonMap;

  CmsSlider({
    this.cssstyle,
    this.hotelname,
    this.url,
    this.jsonMap,
  }) : super(
          code: jsonMap[DBConst.FDN_CODE],
          shortcode: jsonMap[DBConst.FDN_SHORTCODE],
          description: jsonMap[DBConst.FDN_DESCRIPTION],
          isdef: jsonMap[DBConst.FDN_ISDEF],
          isActive: jsonMap[DBConst.FDN_ISACTIVE],
          jsonMap: jsonMap,
        );

  factory CmsSlider.fromJson(Map<String, dynamic> json) {
    return new CmsSlider(
      cssstyle: json[DBConst.FDN_CSSSTYLE],
      url: json[DBConst.FDN_URL],
      hotelname: json[DBConst.FDN_HOTELNAME],
      jsonMap: json,
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_CSSSTYLE: cssstyle,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_URL: url,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is CmsSlider &&
          runtimeType == other.runtimeType &&
          cssstyle == other.cssstyle &&
          url == other.url &&
          hotelname == other.hotelname &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode => super.hashCode ^ cssstyle.hashCode ^ url.hashCode ^ hotelname.hashCode ^ jsonMap.hashCode;

  @override
  String toString() {
    return 'CmsSlider{${super.toString()}, cssstyle: $cssstyle, url: $url, hotelname: $hotelname, jsonMap: $jsonMap}';
  }
}
