import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelSync.dart';

class CmsSliderItem extends BaseModelSync {
  int sliderid;
  String imageurl;
  String caption;
  String description;
  String url;
  int orderno;
  String thumbnail;
  String content;
  int ratesurveyid;

  // view fields
  String hotelname;
  String gidstr;
  String ratesurveydesc;
  Map<String, dynamic> jsonMap;

  CmsSliderItem({
    this.sliderid,
    this.imageurl,
    this.caption,
    this.description,
    this.url,
    this.orderno,
    this.thumbnail,
    this.content,
    this.hotelname,
    this.ratesurveyid,
    this.ratesurveydesc,
    this.gidstr,
    this.jsonMap,
  }) : super(
          id: jsonMap[DBConst.FDN_ID],
          jsonMap: jsonMap,
        );

  factory CmsSliderItem.fromJson(Map<String, dynamic> json) {
    return new CmsSliderItem(
      sliderid: json[DBConst.FDN_SLIDERID],
      imageurl: json[DBConst.FDN_IMAGEURL],
      caption: json[DBConst.FDN_CAPTION],
      description: json[DBConst.FDN_DESCRIPTION],
      url: json[DBConst.FDN_URL],
      orderno: json[DBConst.FDN_ORDERNO],
      thumbnail: json[DBConst.FDN_THUMBNAIL],
      content: json[DBConst.FDN_CONTENT],
      hotelname: json[DBConst.FDN_HOTELNAME],
      ratesurveyid: json[DBConst.FDN_RATESURVEYID],
      ratesurveydesc: json[DBConst.FDN_RATESURVEYDESC],
      gidstr: json[DBConst.FDN_GIDSTR],
      jsonMap: json,
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_SLIDERID: sliderid,
      DBConst.FDN_IMAGEURL: imageurl,
      DBConst.FDN_CAPTION: caption,
      DBConst.FDN_DESCRIPTION: description,
      DBConst.FDN_URL: url,
      DBConst.FDN_ORDERNO: orderno,
      DBConst.FDN_THUMBNAIL: thumbnail,
      DBConst.FDN_CONTENT: content,
      DBConst.FDN_HOTELNAME: hotelname,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is CmsSliderItem &&
          runtimeType == other.runtimeType &&
          sliderid == other.sliderid &&
          imageurl == other.imageurl &&
          caption == other.caption &&
          description == other.description &&
          url == other.url &&
          orderno == other.orderno &&
          thumbnail == other.thumbnail &&
          content == other.content &&
          hotelname == other.hotelname &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      sliderid.hashCode ^
      imageurl.hashCode ^
      caption.hashCode ^
      description.hashCode ^
      url.hashCode ^
      orderno.hashCode ^
      thumbnail.hashCode ^
      content.hashCode ^
      hotelname.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'CmsSliderItem{${super.toString()}, sliderid: $sliderid, imageurl: $imageurl, caption: $caption, description: $description, url: $url, orderno: $orderno, thumbnail: $thumbnail, content: $content, hotelname: $hotelname, jsonMap: $jsonMap}';
  }
}
