import 'package:hotech_flutter_utilities/Constants.dart';

class SurveyScore {
  double resavg;
  double restotalavg;
  double restotal;

  Map<String, dynamic> jsonMap;

  SurveyScore({
    this.resavg,
    this.restotalavg,
    this.restotal,
  });

  factory SurveyScore.fromJson(Map<String, dynamic> json) => new SurveyScore(
      resavg: json[DBConst.FDN_RESAVG],
      restotalavg: json[DBConst.FDN_RESTOTALAVG],
      restotal: json[DBConst.FDN_RESTOTAL]);

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_RESAVG: resavg,
      DBConst.FDN_RESTOTALAVG: restotalavg,
      DBConst.FDN_RESTOTAL: restotal,
    };
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is SurveyScore &&
          runtimeType == other.runtimeType &&
          resavg == other.resavg &&
          restotalavg == other.restotalavg &&
          restotal == other.restotal &&
          jsonMap == other.jsonMap;

  @override
  String toString() {
    return 'SurveyScore{resavg: $resavg, restotalavg: $restotalavg, restotal: $restotal, jsonMap: $jsonMap}';
  }

  @override
  int get hashCode => resavg.hashCode ^ restotalavg.hashCode ^ restotal.hashCode ^ jsonMap.hashCode;
}
