import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelSync.dart';

///
///Defines the data found in the BonusTrans table in the service
///

class Bonustrans extends BaseModelSync {
  int reservno;
  String roomno;
  bool isprivate;
  String firstname;
  String lastname;
  String checkin;
  String checkout;
  String gidstr;
  String hotelname;
  String acccode;
  String accdesc;
  String currencycode;
  String currencydesc;
  int hotelpid;
  String bonustplcode;
  String bonustpldesc;
  String couponcode;
  String coupondesc;
  String resrefcode;
  String resstatus;
  int hoteltopid;
  String resgid;
  int reshotelrefno;
  String currency;
  int masterid;
  String transdate;
  String transtime;
  double excrate;
  int accid;
  bool isactive;
  int currencyid;
  double grosstotal;
  String expiredate;
  int bonustplid;
  double bonustotal;
  double bonushomecurr;
  int couponid;
  String note;
  String updatetime;

  Map<String, dynamic> jsonMap;

  Bonustrans({
    this.reservno,
    this.roomno,
    this.isprivate,
    this.firstname,
    this.lastname,
    this.checkin,
    this.checkout,
    this.gidstr,
    this.hotelname,
    this.acccode,
    this.accdesc,
    this.currencycode,
    this.currencydesc,
    this.hotelpid,
    this.bonustplcode,
    this.bonustpldesc,
    this.couponcode,
    this.coupondesc,
    this.resrefcode,
    this.resstatus,
    this.hoteltopid,
    this.resgid,
    this.reshotelrefno,
    this.currency,
    this.masterid,
    this.transdate,
    this.transtime,
    this.excrate,
    this.accid,
    this.isactive,
    this.currencyid,
    this.grosstotal,
    this.expiredate,
    this.bonustplid,
    this.bonustotal,
    this.bonushomecurr,
    this.couponid,
    this.note,
    this.updatetime,
    this.jsonMap,
  }) : super(
          id: jsonMap[DBConst.FDN_ID],
          jsonMap: jsonMap,
        );

  factory Bonustrans.fromJson(Map<String, dynamic> json) => new Bonustrans(
        reservno: json[DBConst.FDN_RESERVNO],
        roomno: json[DBConst.FDN_ROOMNO],
        isprivate: json[DBConst.FDN_ISPRIVATE],
        firstname: json[DBConst.FDN_FIRSTNAME],
        lastname: json[DBConst.FDN_LASTNAME],
        checkin: json[DBConst.FDN_CHECKIN],
        checkout: json[DBConst.FDN_CHECKOUT],
        gidstr: json[DBConst.FDN_GIDSTR],
        hotelname: json[DBConst.FDN_HOTELNAME],
        acccode: json[DBConst.FDN_ACCCODE],
        accdesc: json[DBConst.FDN_ACCDESC],
        currencycode: json[DBConst.FDN_CURRENCYCODE],
        currencydesc: json[DBConst.FDN_CURRENCYDESC],
        hotelpid: json[DBConst.FDN_HOTELPID],
        bonustplcode: json[DBConst.FDN_BONUSTPLCODE],
        bonustpldesc: json[DBConst.FDN_BONUSTPLDESC],
        couponcode: json[DBConst.FDN_COUPONCODE],
        coupondesc: json[DBConst.FDN_COUPONDESC],
        resrefcode: json[DBConst.FDN_RESREFCODE],
        resstatus: json[DBConst.FDN_RESSTATUS],
        hoteltopid: json[DBConst.FDN_HOTELTOPID],
        resgid: json[DBConst.FDN_RESGID],
        reshotelrefno: json[DBConst.FDN_RESHOTELREFNO],
        currency: json[DBConst.FDN_CURRENCY],
        masterid: json[DBConst.FDN_MASTERID],
        transdate: json[DBConst.FDN_TRANSDATE],
        transtime: json[DBConst.FDN_TRANSTIME],
        excrate: json[DBConst.FDN_EXCRATE],
        accid: json[DBConst.FDN_ACCID],
        isactive: json[DBConst.FDN_ISACTIVE],
        currencyid: json[DBConst.FDN_CURRENCYID],
        grosstotal: json[DBConst.FDN_GROSSTOTAL],
        expiredate: json[DBConst.FDN_EXPIREDATE],
        bonustplid: json[DBConst.FDN_BONUSTPLID],
        bonustotal: json[DBConst.FDN_BONUSTOTAL],
        bonushomecurr: json[DBConst.FDN_BONUSHOMECURR],
        couponid: json[DBConst.FDN_COUPONID],
        note: json[DBConst.FDN_NOTE],
        updatetime: json[DBConst.FDN_UPDATETIME],
        jsonMap: json,
      );

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_RESERVNO: reservno,
      DBConst.FDN_ROOMNO: roomno,
      DBConst.FDN_ISPRIVATE: isprivate,
      DBConst.FDN_FIRSTNAME: firstname,
      DBConst.FDN_LASTNAME: lastname,
      DBConst.FDN_CHECKIN: checkin,
      DBConst.FDN_CHECKOUT: checkout,
      DBConst.FDN_GIDSTR: gidstr,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_ACCCODE: acccode,
      DBConst.FDN_ACCDESC: accdesc,
      DBConst.FDN_CURRENCYCODE: currencycode,
      DBConst.FDN_CURRENCYDESC: currencydesc,
      DBConst.FDN_HOTELPID: hotelpid,
      DBConst.FDN_BONUSTPLCODE: bonustplcode,
      DBConst.FDN_BONUSTPLDESC: bonustpldesc,
      DBConst.FDN_COUPONCODE: couponcode,
      DBConst.FDN_COUPONDESC: coupondesc,
      DBConst.FDN_RESREFCODE: resrefcode,
      DBConst.FDN_RESSTATUS: resstatus,
      DBConst.FDN_HOTELTOPID: hoteltopid,
      DBConst.FDN_RESGID: resgid,
      DBConst.FDN_RESHOTELREFNO: reshotelrefno,
      DBConst.FDN_CURRENCY: currency,
      DBConst.FDN_MASTERID: masterid,
      DBConst.FDN_TRANSDATE: transdate,
      DBConst.FDN_TRANSTIME: transtime,
      DBConst.FDN_EXCRATE: excrate,
      DBConst.FDN_ACCID: accid,
      DBConst.FDN_ISACTIVE: isactive,
      DBConst.FDN_CURRENCYID: currencyid,
      DBConst.FDN_GROSSTOTAL: grosstotal,
      DBConst.FDN_EXPIREDATE: expiredate,
      DBConst.FDN_BONUSTPLID: bonustplid,
      DBConst.FDN_BONUSTOTAL: bonustotal,
      DBConst.FDN_BONUSHOMECURR: bonushomecurr,
      DBConst.FDN_COUPONID: couponid,
      DBConst.FDN_NOTE: note,
      DBConst.FDN_UPDATETIME: updatetime,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Bonustrans &&
          runtimeType == other.runtimeType &&
          reservno == other.reservno &&
          roomno == other.roomno &&
          isprivate == other.isprivate &&
          firstname == other.firstname &&
          lastname == other.lastname &&
          checkin == other.checkin &&
          checkout == other.checkout &&
          gidstr == other.gidstr &&
          hotelname == other.hotelname &&
          acccode == other.acccode &&
          accdesc == other.accdesc &&
          currencycode == other.currencycode &&
          currencydesc == other.currencydesc &&
          hotelpid == other.hotelpid &&
          bonustplcode == other.bonustplcode &&
          bonustpldesc == other.bonustpldesc &&
          couponcode == other.couponcode &&
          coupondesc == other.coupondesc &&
          resrefcode == other.resrefcode &&
          resstatus == other.resstatus &&
          hoteltopid == other.hoteltopid &&
          resgid == other.resgid &&
          reshotelrefno == other.reshotelrefno &&
          currency == other.currency &&
          masterid == other.masterid &&
          transdate == other.transdate &&
          transtime == other.transtime &&
          excrate == other.excrate &&
          accid == other.accid &&
          isactive == other.isactive &&
          currencyid == other.currencyid &&
          grosstotal == other.grosstotal &&
          expiredate == other.expiredate &&
          bonustplid == other.bonustplid &&
          bonustotal == other.bonustotal &&
          bonushomecurr == other.bonushomecurr &&
          couponid == other.couponid &&
          note == other.note &&
          updatetime == other.updatetime &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      reservno.hashCode ^
      roomno.hashCode ^
      isprivate.hashCode ^
      firstname.hashCode ^
      lastname.hashCode ^
      checkin.hashCode ^
      checkout.hashCode ^
      gidstr.hashCode ^
      hotelname.hashCode ^
      acccode.hashCode ^
      accdesc.hashCode ^
      currencycode.hashCode ^
      currencydesc.hashCode ^
      hotelpid.hashCode ^
      bonustplcode.hashCode ^
      bonustpldesc.hashCode ^
      couponcode.hashCode ^
      coupondesc.hashCode ^
      resrefcode.hashCode ^
      resstatus.hashCode ^
      hoteltopid.hashCode ^
      resgid.hashCode ^
      reshotelrefno.hashCode ^
      currency.hashCode ^
      masterid.hashCode ^
      transdate.hashCode ^
      transtime.hashCode ^
      excrate.hashCode ^
      accid.hashCode ^
      isactive.hashCode ^
      currencyid.hashCode ^
      grosstotal.hashCode ^
      expiredate.hashCode ^
      bonustplid.hashCode ^
      bonustotal.hashCode ^
      bonushomecurr.hashCode ^
      couponid.hashCode ^
      note.hashCode ^
      updatetime.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Bonustrans{${super.toString()}, reservno: $reservno, roomno: $roomno, isprivate: $isprivate, firstname: $firstname, lastname: $lastname, checkin: $checkin, checkout: $checkout, gidstr: $gidstr, hotelname: $hotelname, acccode: $acccode, accdesc: $accdesc, currencycode: $currencycode, currencydesc: $currencydesc, hotelpid: $hotelpid, bonustplcode: $bonustplcode, bonustpldesc: $bonustpldesc, couponcode: $couponcode, coupondesc: $coupondesc, resrefcode: $resrefcode, resstatus: $resstatus, hoteltopid: $hoteltopid, resgid: $resgid, reshotelrefno: $reshotelrefno, currency: $currency, masterid: $masterid, transdate: $transdate, transtime: $transtime, excrate: $excrate, accid: $accid, isactive: $isactive, currencyid: $currencyid, grosstotal: $grosstotal, expiredate: $expiredate, bonustplid: $bonustplid, bonustotal: $bonustotal, bonushomecurr: $bonushomecurr, couponid: $couponid, note: $note, updatetime: $updatetime, jsonMap: $jsonMap}';
  }
}
