import 'package:hotech_flutter_utilities/Constants.dart';

///
///Defines the data found in the BonusTrans/Gift table in the service
///

class BonustransGift {
  int id;
  int mid;
  String code;
  String ineng;
  double bonusamount;
  int hotelrefno;
  String enddate;
  String qty;
  String salegroup;
  String startdate;
  String imagefolder;
  String thumburl;
  String spgroupcode;
  String spgroupdesc;
  String description;
  String groupname;

  Map<String, dynamic> jsonMap;

  BonustransGift({
    this.id,
    this.mid,
    this.code,
    this.ineng,
    this.bonusamount,
    this.hotelrefno,
    this.enddate,
    this.qty,
    this.salegroup,
    this.startdate,
    this.imagefolder,
    this.thumburl,
    this.spgroupcode,
    this.spgroupdesc,
    this.description,
    this.groupname,
    this.jsonMap,
  });

  factory BonustransGift.fromJson(Map<String, dynamic> json) {
    return BonustransGift(
      id: json[DBConst.FDN_ID],
      mid: json[DBConst.FDN_MID],
      code: json[DBConst.FDN_CODE],
      ineng: json[DBConst.FDN_INENG],
      bonusamount: json[DBConst.FDN_BONUSAMOUNT],
      hotelrefno: json[DBConst.FDN_HOTELREFNO],
      enddate: json[DBConst.FDN_ENDDATE],
      qty: json[DBConst.FDN_QTY],
      salegroup: json[DBConst.FDN_SALEGROUP],
      startdate: json[DBConst.FDN_STARTDATE],
      imagefolder: json[DBConst.FDN_IMAGEFOLDER],
      thumburl: json[DBConst.FDN_THUMBURL],
      spgroupcode: json[DBConst.FDN_SPGROUPCODE],
      spgroupdesc: json[DBConst.FDN_SPGROUPDESC],
      description: json[DBConst.FDN_DESCRIPTION],
      groupname: json[DBConst.FDN_GROUPNAME],
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_ID: id,
      DBConst.FDN_MID: mid,
      DBConst.FDN_CODE: code,
      DBConst.FDN_INENG: ineng,
      DBConst.FDN_BONUSAMOUNT: bonusamount,
      DBConst.FDN_HOTELREFNO: hotelrefno,
      DBConst.FDN_ENDDATE: enddate,
      DBConst.FDN_QTY: qty,
      DBConst.FDN_SALEGROUP: salegroup,
      DBConst.FDN_STARTDATE: startdate,
      DBConst.FDN_IMAGEFOLDER: imagefolder,
      DBConst.FDN_THUMBURL: thumburl,
      DBConst.FDN_SPGROUPCODE: spgroupcode,
      DBConst.FDN_SPGROUPDESC: spgroupdesc,
      DBConst.FDN_DESCRIPTION: description,
      DBConst.FDN_GROUPNAME: groupname,
    };
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is BonustransGift &&
          runtimeType == other.runtimeType &&
          id == other.id &&
          mid == other.mid &&
          code == other.code &&
          ineng == other.ineng &&
          bonusamount == other.bonusamount &&
          hotelrefno == other.hotelrefno &&
          enddate == other.enddate &&
          qty == other.qty &&
          salegroup == other.salegroup &&
          startdate == other.startdate &&
          imagefolder == other.imagefolder &&
          thumburl == other.thumburl &&
          spgroupcode == other.spgroupcode &&
          spgroupdesc == other.spgroupdesc &&
          description == other.description &&
          groupname == other.groupname &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      id.hashCode ^
      mid.hashCode ^
      code.hashCode ^
      ineng.hashCode ^
      bonusamount.hashCode ^
      hotelrefno.hashCode ^
      enddate.hashCode ^
      qty.hashCode ^
      salegroup.hashCode ^
      startdate.hashCode ^
      imagefolder.hashCode ^
      thumburl.hashCode ^
      spgroupcode.hashCode ^
      spgroupdesc.hashCode ^
      description.hashCode ^
      groupname.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'BonustransGift{id: $id, mid: $mid, code: $code, ineng: $ineng, bonusamount: $bonusamount, hotelrefno: $hotelrefno, enddate: $enddate, qty: $qty, salegroup: $salegroup, startdate: $startdate, imagefolder: $imagefolder, thumburl: $thumburl, spgroupcode: $spgroupcode, spgroupdesc: $spgroupdesc, description: $description, groupname: $groupname, jsonMap: $jsonMap}';
  }
}
