import 'package:hotech_flutter_utilities/Constants.dart';

///
///Defines the data found in the BonusTrans/Gift/Sent table in the service
///

class BonustransGiftSent {
  int id;
  String code;
  int hotelrefno;
  int transno;
  String transdate;
  String transtime;
  double amount;
  int mid;
  String salegrp;
  String salegrpdesc;
  double bonustotal;
  double pricebonus;
  int linecounter;
  String description;

  Map<String, dynamic> jsonMap;

  BonustransGiftSent({
    this.id,
    this.code,
    this.hotelrefno,
    this.transno,
    this.transdate,
    this.transtime,
    this.amount,
    this.mid,
    this.salegrp,
    this.salegrpdesc,
    this.bonustotal,
    this.pricebonus,
    this.linecounter,
    this.description,
    this.jsonMap,
  });

  factory BonustransGiftSent.fromJson(Map<String, dynamic> json) => new BonustransGiftSent(
        id: json[DBConst.FDN_ID],
        code: json[DBConst.FDN_CODE],
        hotelrefno: json[DBConst.FDN_HOTELREFNO],
        transno: json[DBConst.FDN_TRANSNO],
        transdate: json[DBConst.FDN_TRANSDATE],
        transtime: json[DBConst.FDN_TRANSTIME],
        mid: json[DBConst.FDN_MID],
        amount: json[DBConst.FDN_AMOUNT],
        salegrp: json[DBConst.FDN_SALEGRP],
        salegrpdesc: json[DBConst.FDN_SALEGRPDESC],
        bonustotal: json[DBConst.FDN_BONUSTOTAL],
        pricebonus: json[DBConst.FDN_PRICEBONUS],
        linecounter: json[DBConst.FDN_LINECOUNTER],
        description: json[DBConst.FDN_DESCRIPTION],
      );

  Map<String, dynamic> toJson() {
    return {
      DBConst.FDN_ID: id,
      DBConst.FDN_CODE: code,
      DBConst.FDN_HOTELREFNO: hotelrefno,
      DBConst.FDN_TRANSNO: transno,
      DBConst.FDN_TRANSDATE: transdate,
      DBConst.FDN_TRANSTIME: transtime,
      DBConst.FDN_AMOUNT: amount,
      DBConst.FDN_MID: mid,
      DBConst.FDN_SALEGRP: salegrp,
      DBConst.FDN_SALEGRPDESC: salegrpdesc,
      DBConst.FDN_BONUSTOTAL: bonustotal,
      DBConst.FDN_PRICEBONUS: pricebonus,
      DBConst.FDN_LINECOUNTER: linecounter,
      DBConst.FDN_DESCRIPTION: description,
    };
  }

  @override
  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is BonustransGiftSent &&
          runtimeType == other.runtimeType &&
          id == other.id &&
          code == other.code &&
          hotelrefno == other.hotelrefno &&
          transno == other.transno &&
          transdate == other.transdate &&
          transtime == other.transtime &&
          amount == other.amount &&
          mid == other.mid &&
          salegrp == other.salegrp &&
          salegrpdesc == other.salegrpdesc &&
          bonustotal == other.bonustotal &&
          pricebonus == other.pricebonus &&
          linecounter == other.linecounter &&
          description == other.description &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      id.hashCode ^
      id.hashCode ^
      code.hashCode ^
      hotelrefno.hashCode ^
      transno.hashCode ^
      transdate.hashCode ^
      transtime.hashCode ^
      amount.hashCode ^
      mid.hashCode ^
      salegrp.hashCode ^
      salegrpdesc.hashCode ^
      bonustotal.hashCode ^
      pricebonus.hashCode ^
      linecounter.hashCode ^
      description.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'BonustransGiftSent{id: $id, code: $code, hotelrefno: $hotelrefno, transno: $transno, transdate: $transdate, transtime: $transtime, amount: $amount, mid: $mid, salegrp: $salegrp, salegrpdesc: $salegrpdesc, bonustotal: $bonustotal, pricebonus: $pricebonus, linecounter: $linecounter, description: $description, jsonMap: $jsonMap}';
  }
}
