import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelSync.dart';

class Survey extends BaseModelSync {
  String gidstr;
  String hotelname;
  String notesurveydesc;
  String email;
  String enddate;
  bool isstd;
  String startdate;
  bool ists;
  bool istemplate;
  int qsfontsize;
  int grfontsize;
  int descfontsize;
  String logofilecode;
  int optionfontsize;
  bool sendclientmail;
  int notesurveyid;
  int totalview;
  bool isweb;
  int clientlevel;
  String description;
  String note;

  Map<String, dynamic> jsonMap;

  Survey({
    this.gidstr,
    this.hotelname,
    this.notesurveydesc,
    this.email,
    this.enddate,
    this.isstd,
    this.startdate,
    this.ists,
    this.istemplate,
    this.qsfontsize,
    this.grfontsize,
    this.descfontsize,
    this.logofilecode,
    this.optionfontsize,
    this.sendclientmail,
    this.notesurveyid,
    this.totalview,
    this.isweb,
    this.clientlevel,
    this.description,
    this.note,
    this.jsonMap,
  }) : super(
          id: jsonMap[DBConst.FDN_ID],
          jsonMap: jsonMap,
        );

  factory Survey.fromJson(Map<String, dynamic> json) => new Survey(
        gidstr: json[DBConst.FDN_GIDSTR],
        hotelname: json[DBConst.FDN_HOTELNAME],
        notesurveydesc: json[DBConst.FDN_NOTESURVEYDESC],
        email: json[DBConst.FDN_EMAIL],
        enddate: json[DBConst.FDN_ENDDATE],
        isstd: json[DBConst.FDN_ISSTD],
        startdate: json[DBConst.FDN_STARTDATE],
        ists: json[DBConst.FDN_ISTS],
        istemplate: json[DBConst.FDN_ISTEMPLATE],
        qsfontsize: json[DBConst.FDN_QSFONTSIZE],
        grfontsize: json[DBConst.FDN_GRFONTSIZE],
        descfontsize: json[DBConst.FDN_DESCFONTSIZE],
        logofilecode: json[DBConst.FDN_LOGOFILECODE],
        optionfontsize: json[DBConst.FDN_OPTIONFONTSIZE],
        sendclientmail: json[DBConst.FDN_SENDCLIENTMAIL],
        notesurveyid: json[DBConst.FDN_NOTESURVEYID],
        totalview: json[DBConst.FDN_TOTALVIEW],
        isweb: json[DBConst.FDN_ISWEB],
        clientlevel: json[DBConst.FDN_CLIENTLEVEL],
        description: json[DBConst.FDN_DESCRIPTION],
        note: json[DBConst.FDN_NOTE],
        jsonMap: json,
      );

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_GIDSTR: gidstr,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_NOTESURVEYDESC: notesurveydesc,
      DBConst.FDN_EMAIL: email,
      DBConst.FDN_ENDDATE: enddate,
      DBConst.FDN_ISSTD: isstd,
      DBConst.FDN_STARTDATE: startdate,
      DBConst.FDN_ISTS: ists,
      DBConst.FDN_ISTEMPLATE: istemplate,
      DBConst.FDN_QSFONTSIZE: qsfontsize,
      DBConst.FDN_GRFONTSIZE: grfontsize,
      DBConst.FDN_DESCFONTSIZE: descfontsize,
      DBConst.FDN_LOGOFILECODE: logofilecode,
      DBConst.FDN_OPTIONFONTSIZE: optionfontsize,
      DBConst.FDN_SENDCLIENTMAIL: sendclientmail,
      DBConst.FDN_NOTESURVEYID: notesurveyid,
      DBConst.FDN_TOTALVIEW: totalview,
      DBConst.FDN_ISWEB: isweb,
      DBConst.FDN_CLIENTLEVEL: clientlevel,
      DBConst.FDN_DESCRIPTION: description,
      DBConst.FDN_NOTE: note,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Survey &&
          gidstr == other.gidstr &&
          hotelname == other.hotelname &&
          notesurveydesc == other.notesurveydesc &&
          email == other.email &&
          enddate == other.enddate &&
          isstd == other.isstd &&
          startdate == other.startdate &&
          ists == other.ists &&
          istemplate == other.istemplate &&
          qsfontsize == other.qsfontsize &&
          grfontsize == other.grfontsize &&
          descfontsize == other.descfontsize &&
          logofilecode == other.logofilecode &&
          optionfontsize == other.optionfontsize &&
          sendclientmail == other.sendclientmail &&
          notesurveyid == other.notesurveyid &&
          totalview == other.totalview &&
          isweb == other.isweb &&
          clientlevel == other.clientlevel &&
          description == other.description &&
          note == other.note;

  @override
  int get hashCode =>
      super.hashCode ^
      gidstr.hashCode ^
      hotelname.hashCode ^
      notesurveydesc.hashCode ^
      email.hashCode ^
      enddate.hashCode ^
      isstd.hashCode ^
      startdate.hashCode ^
      ists.hashCode ^
      istemplate.hashCode ^
      qsfontsize.hashCode ^
      grfontsize.hashCode ^
      descfontsize.hashCode ^
      logofilecode.hashCode ^
      optionfontsize.hashCode ^
      sendclientmail.hashCode ^
      notesurveyid.hashCode ^
      totalview.hashCode ^
      isweb.hashCode ^
      clientlevel.hashCode ^
      description.hashCode ^
      note.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Survey{${super.toString()}, gidstr: $gidstr, hotelname: $hotelname, notesurveydesc: $notesurveydesc, email: $email, enddate: $enddate, isstd: $isstd, startdate: $startdate, ists: $ists, istemplate: $istemplate, qsfontsize: $qsfontsize, grfontsize: $grfontsize, descfontsize: $descfontsize, logofilecode: $logofilecode, optionfontsize: $optionfontsize, sendclientmail: $sendclientmail, notesurveyid: $notesurveyid, totalview: $totalview, isweb: $isweb, clientlevel: $clientlevel, description: $description, note: $note, jsonMap: $jsonMap}';
  }
}
