import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelCode.dart';

class Eventloc extends BaseModelCode {
  bool isperroom;
  int totalroom;
  int totalpax;
  String note;
  int resourceid;
  int blockid;
  bool isbanquet;
  bool isspares;
  bool islocres;
  String starttime;
  String endtime;
  String resinterval;
  int intervalreslimit;
  String resduration;
  int totalchd;
  int totalbaby;
  int totalpaxcap;
  bool isstd;
  int empid;
  bool needemp;
  int evlocgrpid;
  String department;
  int screenpos;
  int color;
  int departmentid;

  //View Fields
  String hotelname;
  String departmentcode;
  String departmentdesc;
  String empcode;
  String empname;
  String evlocgrpcode;
  String evlocgrpdesc;

  Map<String, dynamic> jsonMap;

  Eventloc({
    this.isperroom,
    this.totalroom,
    this.totalpax,
    this.note,
    this.resourceid,
    this.blockid,
    this.isbanquet,
    this.isspares,
    this.islocres,
    this.starttime,
    this.endtime,
    this.resinterval,
    this.intervalreslimit,
    this.resduration,
    this.totalchd,
    this.totalbaby,
    this.totalpaxcap,
    this.isstd,
    this.empid,
    this.needemp,
    this.evlocgrpid,
    this.department,
    this.screenpos,
    this.color,
    this.departmentid,
    this.hotelname,
    this.departmentcode,
    this.departmentdesc,
    this.empcode,
    this.empname,
    this.evlocgrpcode,
    this.evlocgrpdesc,
    this.jsonMap,
  }) : super(
          code: jsonMap[DBConst.FDN_CODE],
          shortcode: jsonMap[DBConst.FDN_SHORTCODE],
          description: jsonMap[DBConst.FDN_DESCRIPTION],
          isdef: jsonMap[DBConst.FDN_ISDEF],
          isActive: jsonMap[DBConst.FDN_ISACTIVE],
          jsonMap: jsonMap,
        );

  factory Eventloc.fromJson(Map<String, dynamic> json) => new Eventloc(
        blockid: json[DBConst.FDN_BLOCKID],
        color: json[DBConst.FDN_COLOR],
        department: json[DBConst.FDN_DEPARTMENT],
        departmentcode: json[DBConst.FDN_DEPARTMENTCODE],
        departmentdesc: json[DBConst.FDN_DEPARTMENTDESC],
        departmentid: json[DBConst.FDN_DEPARTMENTID],
        empcode: json[DBConst.FDN_EMPCODE],
        empid: json[DBConst.FDN_EMPID],
        empname: json[DBConst.FDN_EMPNAME],
        endtime: json[DBConst.FDN_ENDTIME],
        evlocgrpcode: json[DBConst.FDN_EVLOCGRPCODE],
        evlocgrpdesc: json[DBConst.FDN_EVLOCGRPDESC],
        evlocgrpid: json[DBConst.FDN_EVLOCGRPID],
        hotelname: json[DBConst.FDN_HOTELNAME],
        intervalreslimit: json[DBConst.FDN_INTERVALRESLIMIT],
        isbanquet: json[DBConst.FDN_ISBANQUET],
        islocres: json[DBConst.FDN_ISLOCRES],
        isperroom: json[DBConst.FDN_ISPERROOM],
        isspares: json[DBConst.FDN_ISSPARES],
        isstd: json[DBConst.FDN_ISSTD],
        needemp: json[DBConst.FDN_NEEDEMP],
        note: json[DBConst.FDN_NOTE],
        resduration: json[DBConst.FDN_RESDURATION],
        resinterval: json[DBConst.FDN_RESINTERVAL],
        resourceid: json[DBConst.FDN_RESOURCEID],
        screenpos: json[DBConst.FDN_SCREENPOS],
        starttime: json[DBConst.FDN_STARTTIME],
        totalbaby: json[DBConst.FDN_TOTALBABY],
        totalchd: json[DBConst.FDN_TOTALCHD],
        totalpax: json[DBConst.FDN_TOTALPAX],
        totalpaxcap: json[DBConst.FDN_TOTALPAXCAP],
        totalroom: json[DBConst.FDN_TOTALROOM],
        jsonMap: json,
      );

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_BLOCKID: blockid,
      DBConst.FDN_COLOR: color,
      DBConst.FDN_DEPARTMENT: department,
      DBConst.FDN_DEPARTMENTCODE: departmentcode,
      DBConst.FDN_DEPARTMENTDESC: departmentdesc,
      DBConst.FDN_DEPARTMENTID: departmentid,
      DBConst.FDN_EMPCODE: empcode,
      DBConst.FDN_EMPID: empid,
      DBConst.FDN_EMPNAME: empname,
      DBConst.FDN_ENDTIME: endtime,
      DBConst.FDN_EVLOCGRPCODE: evlocgrpcode,
      DBConst.FDN_EVLOCGRPDESC: evlocgrpdesc,
      DBConst.FDN_EVLOCGRPID: evlocgrpid,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_INTERVALRESLIMIT: intervalreslimit,
      DBConst.FDN_ISBANQUET: isbanquet,
      DBConst.FDN_ISLOCRES: islocres,
      DBConst.FDN_ISPERROOM: isperroom,
      DBConst.FDN_ISSPARES: isspares,
      DBConst.FDN_ISSTD: isstd,
      DBConst.FDN_NEEDEMP: needemp,
      DBConst.FDN_NOTE: note,
      DBConst.FDN_RESDURATION: resduration,
      DBConst.FDN_RESINTERVAL: resinterval,
      DBConst.FDN_RESOURCEID: resourceid,
      DBConst.FDN_SCREENPOS: screenpos,
      DBConst.FDN_STARTTIME: starttime,
      DBConst.FDN_TOTALBABY: totalbaby,
      DBConst.FDN_TOTALCHD: totalchd,
      DBConst.FDN_TOTALPAX: totalpax,
      DBConst.FDN_TOTALPAXCAP: totalpaxcap,
      DBConst.FDN_TOTALROOM: totalroom,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Eventloc &&
          runtimeType == other.runtimeType &&
          isperroom == other.isperroom &&
          totalroom == other.totalroom &&
          totalpax == other.totalpax &&
          note == other.note &&
          resourceid == other.resourceid &&
          blockid == other.blockid &&
          isbanquet == other.isbanquet &&
          isspares == other.isspares &&
          islocres == other.islocres &&
          starttime == other.starttime &&
          endtime == other.endtime &&
          resinterval == other.resinterval &&
          intervalreslimit == other.intervalreslimit &&
          resduration == other.resduration &&
          totalchd == other.totalchd &&
          totalbaby == other.totalbaby &&
          totalpaxcap == other.totalpaxcap &&
          isstd == other.isstd &&
          empid == other.empid &&
          needemp == other.needemp &&
          evlocgrpid == other.evlocgrpid &&
          department == other.department &&
          screenpos == other.screenpos &&
          color == other.color &&
          departmentid == other.departmentid &&
          hotelname == other.hotelname &&
          departmentcode == other.departmentcode &&
          departmentdesc == other.departmentdesc &&
          empcode == other.empcode &&
          empname == other.empname &&
          evlocgrpcode == other.evlocgrpcode &&
          evlocgrpdesc == other.evlocgrpdesc &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      isperroom.hashCode ^
      totalroom.hashCode ^
      totalpax.hashCode ^
      note.hashCode ^
      resourceid.hashCode ^
      blockid.hashCode ^
      isbanquet.hashCode ^
      isspares.hashCode ^
      islocres.hashCode ^
      starttime.hashCode ^
      endtime.hashCode ^
      resinterval.hashCode ^
      intervalreslimit.hashCode ^
      resduration.hashCode ^
      totalchd.hashCode ^
      totalbaby.hashCode ^
      totalpaxcap.hashCode ^
      isstd.hashCode ^
      empid.hashCode ^
      needemp.hashCode ^
      evlocgrpid.hashCode ^
      department.hashCode ^
      screenpos.hashCode ^
      color.hashCode ^
      departmentid.hashCode ^
      hotelname.hashCode ^
      departmentcode.hashCode ^
      departmentdesc.hashCode ^
      empcode.hashCode ^
      empname.hashCode ^
      evlocgrpcode.hashCode ^
      evlocgrpdesc.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Eventloc{${super.toString()}, isperroom: $isperroom, totalroom: $totalroom, totalpax: $totalpax, note: $note, resourceid: $resourceid, blockid: $blockid, isbanquet: $isbanquet, isspares: $isspares, islocres: $islocres, starttime: $starttime, endtime: $endtime, resinterval: $resinterval, intervalreslimit: $intervalreslimit, resduration: $resduration, totalchd: $totalchd, totalbaby: $totalbaby, totalpaxcap: $totalpaxcap, isstd: $isstd, empid: $empid, needemp: $needemp, evlocgrpid: $evlocgrpid, department: $department, screenpos: $screenpos, color: $color, departmentid: $departmentid, hotelname: $hotelname, departmentcode: $departmentcode, departmentdesc: $departmentdesc, empcode: $empcode, empname: $empname, evlocgrpcode: $evlocgrpcode, evlocgrpdesc: $evlocgrpdesc, jsonMap: $jsonMap}';
  }
}
