import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelCode.dart';

///
///Defines the data found in the Eventype table in the service
///

class Eventype extends BaseModelCode {
  bool hasmenupage;
  bool hasnotepage;
  bool hastaskpage;
  bool hassalepage;
  bool hasconsumppage;
  bool hasrentpage;
  bool hasclientinfopage;
  bool isbanquet;
  bool isdefbanquet;
  bool islocres;
  bool isdeflocres;
  bool isspares;
  bool isdefspa;
  bool haspricepage;
  bool hasweddingpage;
  bool haslocationpage;
  bool hastatpage;
  bool hasresname;

  //View Fields
  String hotelname;

  Map<String, dynamic> jsonMap;

  Eventype({
    this.hasmenupage,
    this.hasnotepage,
    this.hastaskpage,
    this.hassalepage,
    this.hasconsumppage,
    this.hasrentpage,
    this.hasclientinfopage,
    this.isbanquet,
    this.isdefbanquet,
    this.islocres,
    this.isdeflocres,
    this.isspares,
    this.isdefspa,
    this.haspricepage,
    this.hasweddingpage,
    this.haslocationpage,
    this.hastatpage,
    this.hotelname,
    this.hasresname,
    this.jsonMap,
  }) : super(
          code: jsonMap[DBConst.FDN_CODE],
          shortcode: jsonMap[DBConst.FDN_SHORTCODE],
          description: jsonMap[DBConst.FDN_DESCRIPTION],
          isdef: jsonMap[DBConst.FDN_ISDEF],
          isActive: jsonMap[DBConst.FDN_ISACTIVE],
          jsonMap: jsonMap,
        );

  factory Eventype.fromJson(Map<String, dynamic> json) {
    return Eventype(
      hasresname: json[DBConst.FDN_HASRESNAME],
      hasmenupage: json[DBConst.FDN_HASMENUPAGE],
      hasnotepage: json[DBConst.FDN_HASNOTEPAGE],
      hastaskpage: json[DBConst.FDN_HASTASKPAGE],
      hassalepage: json[DBConst.FDN_HASSALEPAGE],
      hasconsumppage: json[DBConst.FDN_HASCONSUMPPAGE],
      hasrentpage: json[DBConst.FDN_HASRENTPAGE],
      hasclientinfopage: json[DBConst.FDN_HASCLIENTINFOPAGE],
      isbanquet: json[DBConst.FDN_ISBANQUET],
      isdefbanquet: json[DBConst.FDN_ISDEFBANQUET],
      islocres: json[DBConst.FDN_ISLOCRES],
      isdeflocres: json[DBConst.FDN_ISDEFLOCRES],
      isspares: json[DBConst.FDN_ISSPARES],
      isdefspa: json[DBConst.FDN_ISDEFSPA],
      haspricepage: json[DBConst.FDN_HASPRICEPAGE],
      hasweddingpage: json[DBConst.FDN_HASWEDDINGPAGE],
      haslocationpage: json[DBConst.FDN_HASLOCATIONPAGE],
      hastatpage: json[DBConst.FDN_HASTATPAGE],
      jsonMap: json,
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_HASMENUPAGE: hasmenupage,
      DBConst.FDN_HASNOTEPAGE: hasnotepage,
      DBConst.FDN_HASTASKPAGE: hastaskpage,
      DBConst.FDN_HASSALEPAGE: hassalepage,
      DBConst.FDN_HASCONSUMPPAGE: hasconsumppage,
      DBConst.FDN_HASRENTPAGE: hasrentpage,
      DBConst.FDN_HASCLIENTINFOPAGE: hasclientinfopage,
      DBConst.FDN_ISBANQUET: isbanquet,
      DBConst.FDN_ISDEFBANQUET: isdefbanquet,
      DBConst.FDN_ISLOCRES: islocres,
      DBConst.FDN_ISDEFLOCRES: isdeflocres,
      DBConst.FDN_ISSPARES: isspares,
      DBConst.FDN_ISDEFSPA: isdefspa,
      DBConst.FDN_HASPRICEPAGE: haspricepage,
      DBConst.FDN_HASWEDDINGPAGE: hasweddingpage,
      DBConst.FDN_HASLOCATIONPAGE: haslocationpage,
      DBConst.FDN_HASTATPAGE: hastatpage,
      DBConst.FDN_HASRESNAME: hasresname,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Eventype &&
          runtimeType == other.runtimeType &&
          hasmenupage == other.hasmenupage &&
          hasresname == other.hasresname &&
          hasnotepage == other.hasnotepage &&
          hastaskpage == other.hastaskpage &&
          hassalepage == other.hassalepage &&
          hasconsumppage == other.hasconsumppage &&
          hasrentpage == other.hasrentpage &&
          hasclientinfopage == other.hasclientinfopage &&
          isbanquet == other.isbanquet &&
          isdefbanquet == other.isdefbanquet &&
          islocres == other.islocres &&
          isdeflocres == other.isdeflocres &&
          isspares == other.isspares &&
          isdefspa == other.isdefspa &&
          haspricepage == other.haspricepage &&
          hasweddingpage == other.hasweddingpage &&
          haslocationpage == other.haslocationpage &&
          hastatpage == other.hastatpage &&
          hotelname == other.hotelname &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      hasmenupage.hashCode ^
      hasnotepage.hashCode ^
      hastaskpage.hashCode ^
      hassalepage.hashCode ^
      hasconsumppage.hashCode ^
      hasrentpage.hashCode ^
      hasclientinfopage.hashCode ^
      isbanquet.hashCode ^
      isdefbanquet.hashCode ^
      islocres.hashCode ^
      isdeflocres.hashCode ^
      isspares.hashCode ^
      isdefspa.hashCode ^
      haspricepage.hashCode ^
      hasweddingpage.hashCode ^
      haslocationpage.hashCode ^
      hastatpage.hashCode ^
      hotelname.hashCode ^
      hasresname.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Eventype{${super.toString()},  hasresname: $hasresname,hasmenupage: $hasmenupage, hasnotepage: $hasnotepage, hastaskpage: $hastaskpage, hassalepage: $hassalepage, hasconsumppage: $hasconsumppage, hasrentpage: $hasrentpage, hasclientinfopage: $hasclientinfopage, isbanquet: $isbanquet, isdefbanquet: $isdefbanquet, islocres: $islocres, isdeflocres: $isdeflocres, isspares: $isspares, isdefspa: $isdefspa, haspricepage: $haspricepage, hasweddingpage: $hasweddingpage, haslocationpage: $haslocationpage, hastatpage: $hastatpage, hotelname: $hotelname, jsonMap: $jsonMap}';
  }
}
