import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelSync.dart';

class ForecastDay extends BaseModelSync {
  String answerdesc;
  int answerid;
  String answernote;
  int clientid;
  String gidstr;
  String hotelname;
  bool isactive;
  bool isvalid;
  int locationid;
  int parentid;
  String qsgroupdesc;
  int qsgroupid;
  String qsgroupname;
  String questiondesc;
  int questionid;
  String questionnote;
  int score;
  int surveyid;
  String transdate;
  int transid;
  String typ;
  bool valuebool;
  String valuedate;
  int valuefloat;
  int valueint;
  String valuelongtext;
  String valuestr;
  String valuetext;
  String valuetime;
  String valuetyp;

  Map<String, dynamic> jsonMap;

  ForecastDay(
      {this.answerdesc,
      this.answerid,
      this.answernote,
      this.clientid,
      this.gidstr,
      this.hotelname,
      this.isactive,
      this.isvalid,
      this.locationid,
      this.parentid,
      this.qsgroupdesc,
      this.qsgroupid,
      this.qsgroupname,
      this.questiondesc,
      this.questionid,
      this.questionnote,
      this.score,
      this.surveyid,
      this.transdate,
      this.transid,
      this.typ,
      this.valuebool,
      this.valuedate,
      this.valuefloat,
      this.valueint,
      this.valuelongtext,
      this.valuestr,
      this.valuetext,
      this.valuetime,
      this.valuetyp,
      this.jsonMap})
      : super(
          id: jsonMap[DBConst.FDN_ID],
          jsonMap: jsonMap,
        );

  factory ForecastDay.fromJson(Map<String, dynamic> json) => ForecastDay(
      answerdesc: json[DBConst.FDN_ANSWERDESC],
      answerid: json[DBConst.FDN_ANSWERID],
      answernote: json[DBConst.FDN_ANSWERNOTE],
      clientid: json[DBConst.FDN_CLIENTID],
      gidstr: json[DBConst.FDN_GIDSTR],
      hotelname: json[DBConst.FDN_HOTELNAME],
      isactive: json[DBConst.FDN_ISACTIVE],
      isvalid: json[DBConst.FDN_ISVALID],
      locationid: json[DBConst.FDN_LOCATIONID],
      parentid: json[DBConst.FDN_PARENTID],
      qsgroupdesc: json[DBConst.FDN_QSGROUPDESC],
      qsgroupid: json[DBConst.FDN_QSGROUPID],
      qsgroupname: json[DBConst.FDN_QSGROUPNAME],
      questiondesc: json[DBConst.FDN_QUESTIONDESC],
      questionid: json[DBConst.FDN_QUESTIONID],
      questionnote: json[DBConst.FDN_QUESTIONNOTE],
      score: json[DBConst.FDN_SCORE],
      surveyid: json[DBConst.FDN_SURVEYID],
      transdate: json[DBConst.FDN_TRANSDATE],
      transid: json[DBConst.FDN_TRANSID],
      typ: json[DBConst.FDN_TYP],
      valuebool: json[DBConst.FDN_VALUEBOOL],
      valuedate: json[DBConst.FDN_VALUEDATE],
      valuefloat: json[DBConst.FDN_VALUEFLOAT],
      valueint: json[DBConst.FDN_VALUEINT],
      valuelongtext: json[DBConst.FDN_VALUELONGTEXT],
      valuestr: json[DBConst.FDN_VALUESTR],
      valuetext: json[DBConst.FDN_VALUETEXT],
      valuetime: json[DBConst.FDN_VALUETIME],
      valuetyp: json[DBConst.FDN_VALUETYP],
      jsonMap: json);

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_ANSWERDESC: answerdesc,
      DBConst.FDN_ANSWERID: answerid,
      DBConst.FDN_ANSWERNOTE: answernote,
      DBConst.FDN_CLIENTID: clientid,
      DBConst.FDN_GIDSTR: gidstr,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_ISACTIVE: locationid,
      DBConst.FDN_ISVALID: parentid,
      DBConst.FDN_LOCATIONID: qsgroupdesc,
      DBConst.FDN_PARENTID: qsgroupid,
      DBConst.FDN_QSGROUPDESC: qsgroupname,
      DBConst.FDN_QSGROUPID: questiondesc,
      DBConst.FDN_QSGROUPNAME: questionid,
      DBConst.FDN_QUESTIONDESC: questionnote,
      DBConst.FDN_QUESTIONID: refcode,
      DBConst.FDN_QUESTIONNOTE: refid,
      DBConst.FDN_SCORE: score,
      DBConst.FDN_SURVEYID: surveyid,
      DBConst.FDN_TRANSDATE: transdate,
      DBConst.FDN_TRANSID: transid,
      DBConst.FDN_TYP: typ,
      DBConst.FDN_VALUEBOOL: valuebool,
      DBConst.FDN_VALUEDATE: valuedate,
      DBConst.FDN_VALUEFLOAT: valuefloat,
      DBConst.FDN_VALUEINT: valueint,
      DBConst.FDN_VALUELONGTEXT: valuelongtext,
      DBConst.FDN_VALUESTR: valuestr,
      DBConst.FDN_VALUETEXT: valuetext,
      DBConst.FDN_VALUETIME: valuetime,
      DBConst.FDN_VALUETYP: valuetyp,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is ForecastDay &&
          runtimeType == other.runtimeType &&
          answerdesc == other.answerdesc &&
          answerid == other.answerid &&
          answernote == other.answernote &&
          clientid == other.clientid &&
          gidstr == other.gidstr &&
          hotelname == other.hotelname &&
          isactive == other.isactive &&
          isvalid == other.isvalid &&
          locationid == other.locationid &&
          parentid == other.parentid &&
          qsgroupdesc == other.qsgroupdesc &&
          qsgroupid == other.qsgroupid &&
          qsgroupname == other.qsgroupname &&
          questiondesc == other.questiondesc &&
          questionid == other.questionid &&
          questionnote == other.questionnote &&
          score == other.score &&
          surveyid == other.surveyid &&
          transdate == other.transdate &&
          transid == other.transid &&
          typ == other.typ &&
          valuebool == other.valuebool &&
          valuedate == other.valuedate &&
          valuefloat == other.valuefloat &&
          valueint == other.valueint &&
          valuelongtext == other.valuelongtext &&
          valuestr == other.valuestr &&
          valuetext == other.valuetext &&
          valuetime == other.valuetime &&
          valuetyp == other.valuetyp &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      answerdesc.hashCode ^
      answerid.hashCode ^
      answernote.hashCode ^
      clientid.hashCode ^
      gidstr.hashCode ^
      hotelname.hashCode ^
      isactive.hashCode ^
      isvalid.hashCode ^
      locationid.hashCode ^
      parentid.hashCode ^
      qsgroupdesc.hashCode ^
      qsgroupid.hashCode ^
      qsgroupname.hashCode ^
      questiondesc.hashCode ^
      questionid.hashCode ^
      questionnote.hashCode ^
      score.hashCode ^
      surveyid.hashCode ^
      transdate.hashCode ^
      transid.hashCode ^
      typ.hashCode ^
      valuebool.hashCode ^
      valuedate.hashCode ^
      valuefloat.hashCode ^
      valueint.hashCode ^
      valuelongtext.hashCode ^
      valuestr.hashCode ^
      valuetext.hashCode ^
      valuetime.hashCode ^
      valuetyp.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'ForecastDay{answerdesc: $answerdesc, answerid: $answerid, answernote: $answernote, clientid: $clientid, gidstr: $gidstr, hotelname: $hotelname, isactive: $isactive, isvalid: $isvalid, locationid: $locationid, parentid: $parentid, qsgroupdesc: $qsgroupdesc, qsgroupid: $qsgroupid, qsgroupname: $qsgroupname, questiondesc: $questiondesc, questionid: $questionid, questionnote: $questionnote, score: $score, surveyid: $surveyid, transdate: $transdate, transid: $transid, typ: $typ, valuebool: $valuebool, valuedate: $valuedate, valuefloat: $valuefloat, valueint: $valueint, valuelongtext: $valuelongtext, valuestr: $valuestr, valuetext: $valuetext, valuetime: $valuetime, valuetyp: $valuetyp, jsonMap: $jsonMap}';
  }
}
