import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelCode.dart';

class Salegrp extends BaseModelCode {
  String accplancode;
  String codestr;
  String gidstr;
  String hotelname;
  bool isalcohol;
  bool isbev;
  bool isboarding;
  bool isfood;
  bool isrooming;
  String longdesc;

  Map<String, dynamic> jsonMap;

  Salegrp({
    this.accplancode,
    this.codestr,
    this.gidstr,
    this.hotelname,
    this.isalcohol,
    this.isbev,
    this.isboarding,
    this.isfood,
    this.isrooming,
    this.longdesc,
    this.jsonMap,
  }) : super(
          code: jsonMap[DBConst.FDN_CODE],
          shortcode: jsonMap[DBConst.FDN_SHORTCODE],
          description: jsonMap[DBConst.FDN_DESCRIPTION],
          isdef: jsonMap[DBConst.FDN_ISDEF],
          isActive: jsonMap[DBConst.FDN_ISACTIVE],
          jsonMap: jsonMap,
        );

  factory Salegrp.fromJson(Map<String, dynamic> json) {
    return Salegrp(
        accplancode: json[DBConst.FDN_ACCPLANCODE],
        codestr: json[DBConst.FDN_CODESTR],
        gidstr: json[DBConst.FDN_GIDSTR],
        hotelname: json[DBConst.FDN_HOTELNAME],
        isalcohol: json[DBConst.FDN_ISALCOHOL],
        isbev: json[DBConst.FDN_ISBEV],
        isboarding: json[DBConst.FDN_ISBOARDING],
        isfood: json[DBConst.FDN_ISFOOD],
        isrooming: json[DBConst.FDN_ISROOMING],
        longdesc: json[DBConst.FDN_LONGDESC],
        jsonMap: json);
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_ACCPLANCODE: accplancode,
      DBConst.FDN_CODESTR: codestr,
      DBConst.FDN_GIDSTR: gidstr,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_ISALCOHOL: isalcohol,
      DBConst.FDN_ISBEV: isbev,
      DBConst.FDN_ISBOARDING: isboarding,
      DBConst.FDN_ISFOOD: isfood,
      DBConst.FDN_ISROOMING: isrooming,
      DBConst.FDN_LONGDESC: longdesc,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Salegrp &&
          runtimeType == other.runtimeType &&
          accplancode == other.accplancode &&
          codestr == other.codestr &&
          gidstr == other.gidstr &&
          hotelname == other.hotelname &&
          isalcohol == other.isalcohol &&
          isbev == other.isbev &&
          isboarding == other.isboarding &&
          isfood == other.isfood &&
          isrooming == other.isrooming &&
          longdesc == other.longdesc &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      accplancode.hashCode ^
      codestr.hashCode ^
      gidstr.hashCode ^
      hotelname.hashCode ^
      isalcohol.hashCode ^
      isbev.hashCode ^
      isboarding.hashCode ^
      isfood.hashCode ^
      isrooming.hashCode ^
      longdesc.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Salegrp{${super.toString()},accplancode: $accplancode, codestr: $codestr, gidstr: $gidstr, hotelname: $hotelname, isalcohol: $isalcohol, isbev: $isbev, isboarding: $isboarding, isfood: $isfood, isrooming: $isrooming, longdesc: $longdesc, jsonMap: $jsonMap}';
  }
}
