import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelCode.dart';

///
///Defines the data found in the Currency table in the service
///

class Currency extends BaseModelCode {
  String cashboxcode;
  String cashboxdesc;
  int cashboxid;
  String centcode;
  String centdescription;
  String codestr;
  String currsymbol;
  String gidstr;
  String longdesc;

  Map<String, dynamic> jsonMap;

  Currency({
    this.cashboxcode,
    this.cashboxdesc,
    this.cashboxid,
    this.centcode,
    this.centdescription,
    this.codestr,
    this.currsymbol,
    this.gidstr,
    this.longdesc,
    this.jsonMap,
  }) : super(
          code: jsonMap[DBConst.FDN_CODE],
          shortcode: jsonMap[DBConst.FDN_SHORTCODE],
          description: jsonMap[DBConst.FDN_DESCRIPTION],
          isdef: jsonMap[DBConst.FDN_ISDEF],
          isActive: jsonMap[DBConst.FDN_ISACTIVE],
          jsonMap: jsonMap,
        );

  factory Currency.fromJson(Map<String, dynamic> json) => new Currency(
        cashboxcode: json[DBConst.FDN_CASHBOXCODE],
        cashboxdesc: json[DBConst.FDN_CASHBOXDESC],
        cashboxid: json[DBConst.FDN_CASHBOXID],
        centcode: json[DBConst.FDN_CENTCODE],
        centdescription: json[DBConst.FDN_CENTDESCRIPTION],
        codestr: json[DBConst.FDN_CODESTR],
        currsymbol: json[DBConst.FDN_CURRSYMBOL],
        gidstr: json[DBConst.FDN_GIDSTR],
        longdesc: json[DBConst.FDN_LONGDESC],
        jsonMap: json,
      );

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_CASHBOXCODE: cashboxcode,
      DBConst.FDN_CASHBOXDESC: cashboxdesc,
      DBConst.FDN_CASHBOXID: cashboxid,
      DBConst.FDN_CENTCODE: centcode,
      DBConst.FDN_CENTDESCRIPTION: centdescription,
      DBConst.FDN_CODESTR: codestr,
      DBConst.FDN_CURRSYMBOL: currsymbol,
      DBConst.FDN_GIDSTR: gidstr,
      DBConst.FDN_LONGDESC: longdesc,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Currency &&
          runtimeType == other.runtimeType &&
          cashboxcode == other.cashboxcode &&
          cashboxdesc == other.cashboxdesc &&
          cashboxid == other.cashboxid &&
          centcode == other.centcode &&
          centdescription == other.centdescription &&
          codestr == other.codestr &&
          currsymbol == other.currsymbol &&
          gidstr == other.gidstr &&
          longdesc == other.longdesc &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      cashboxcode.hashCode ^
      cashboxdesc.hashCode ^
      cashboxid.hashCode ^
      centcode.hashCode ^
      centdescription.hashCode ^
      codestr.hashCode ^
      currsymbol.hashCode ^
      gidstr.hashCode ^
      longdesc.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Currency{${super.toString()},cashboxcode: $cashboxcode, cashboxdesc: $cashboxdesc, cashboxid: $cashboxid, centcode: $centcode, centdescription: $centdescription, codestr: $codestr, currsymbol: $currsymbol, gidstr: $gidstr, longdesc: $longdesc, jsonMap: $jsonMap}';
  }
}
