import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelCode.dart';

class Depart extends BaseModelCode {
  String accplancode;
  String bevstore;
  String bevstorecode;
  String bevstoredesc;
  int bevstoreid;
  String cashboxcode;
  String cashboxdesc;
  int cashboxid;
  String codestr;
  String departtype;
  String foodstore;
  String foodstorecode;
  String foodstoredesc;
  int foodstoreid;
  String gidstr;
  int groupno;
  String hotelname;
  bool isactivity;
  bool isbaltr;
  bool isbanquet;
  bool isboarding;
  bool isconactive;
  bool isfront;
  bool islocres;
  bool isorsactive;
  bool ispaidout;
  bool isposdepart;
  bool ispostable;
  bool isrooming;
  bool isspares;
  int locid;
  String longdesc;
  String responsible;
  double taxrate;

  Map<String, dynamic> jsonMap;

  Depart({
    this.accplancode,
    this.bevstore,
    this.bevstorecode,
    this.bevstoredesc,
    this.bevstoreid,
    this.cashboxcode,
    this.cashboxdesc,
    this.cashboxid,
    this.codestr,
    this.departtype,
    this.foodstore,
    this.foodstorecode,
    this.foodstoredesc,
    this.foodstoreid,
    this.gidstr,
    this.groupno,
    this.hotelname,
    this.isactivity,
    this.isbaltr,
    this.isbanquet,
    this.isboarding,
    this.isconactive,
    this.isfront,
    this.islocres,
    this.isorsactive,
    this.ispaidout,
    this.isposdepart,
    this.ispostable,
    this.isrooming,
    this.isspares,
    this.locid,
    this.longdesc,
    this.responsible,
    this.taxrate,
    this.jsonMap,
  }) : super(
          code: jsonMap[DBConst.FDN_CODE],
          shortcode: jsonMap[DBConst.FDN_SHORTCODE],
          description: jsonMap[DBConst.FDN_DESCRIPTION],
          isdef: jsonMap[DBConst.FDN_ISDEF],
          isActive: jsonMap[DBConst.FDN_ISACTIVE],
          jsonMap: jsonMap,
        );

  factory Depart.fromJson(Map<String, dynamic> json) => new Depart(
        accplancode: json[DBConst.FDN_ACCPLANCODE],
        bevstore: json[DBConst.FDN_BEVSTORE],
        bevstorecode: json[DBConst.FDN_BEVSTORECODE],
        bevstoredesc: json[DBConst.FDN_BEVSTOREDESC],
        bevstoreid: json[DBConst.FDN_BEVSTOREID],
        cashboxcode: json[DBConst.FDN_CASHBOXCODE],
        cashboxdesc: json[DBConst.FDN_CASHBOXDESC],
        cashboxid: json[DBConst.FDN_CASHBOXID],
        codestr: json[DBConst.FDN_CODESTR],
        departtype: json[DBConst.FDN_DEPARTTYPE],
        foodstore: json[DBConst.FDN_FOODSTORE],
        foodstorecode: json[DBConst.FDN_FOODSTORECODE],
        foodstoredesc: json[DBConst.FDN_FOODSTOREDESC],
        foodstoreid: json[DBConst.FDN_FOODSTOREID],
        gidstr: json[DBConst.FDN_GIDSTR],
        groupno: json[DBConst.FDN_GROUPNO],
        hotelname: json[DBConst.FDN_HOTELNAME],
        isactivity: json[DBConst.FDN_ISACTIVITY],
        isbaltr: json[DBConst.FDN_ISBALTR],
        isbanquet: json[DBConst.FDN_ISBANQUET],
        isboarding: json[DBConst.FDN_ISBOARDING],
        isconactive: json[DBConst.FDN_ISONACTIVE],
        isfront: json[DBConst.FDN_ISFRONT],
        islocres: json[DBConst.FDN_ISLOCRES],
        isorsactive: json[DBConst.FDN_ISORSACTIVE],
        ispaidout: json[DBConst.FDN_ISPAIDOUT],
        isposdepart: json[DBConst.FDN_ISPOSDEPART],
        ispostable: json[DBConst.FDN_ISPOSTABLE],
        isrooming: json[DBConst.FDN_ISROOMING],
        isspares: json[DBConst.FDN_ISSPARES],
        locid: json[DBConst.FDN_LOCID],
        longdesc: json[DBConst.FDN_LONGDESC],
        responsible: json[DBConst.FDN_RESPONSIBLE],
        taxrate: json[DBConst.FDN_TAXRATE],
        jsonMap: json,
      );

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_ACCPLANCODE: accplancode,
      DBConst.FDN_BEVSTORE: bevstore,
      DBConst.FDN_BEVSTORECODE: bevstorecode,
      DBConst.FDN_BEVSTOREDESC: bevstoredesc,
      DBConst.FDN_BEVSTOREID: bevstoreid,
      DBConst.FDN_CASHBOXCODE: cashboxcode,
      DBConst.FDN_CASHBOXDESC: cashboxdesc,
      DBConst.FDN_CASHBOXID: cashboxid,
      DBConst.FDN_CODESTR: codestr,
      DBConst.FDN_DEPARTTYPE: departtype,
      DBConst.FDN_DESCRIPTION: description,
      DBConst.FDN_FOODSTORE: foodstore,
      DBConst.FDN_FOODSTORECODE: foodstorecode,
      DBConst.FDN_FOODSTOREDESC: foodstoredesc,
      DBConst.FDN_FOODSTOREID: foodstoreid,
      DBConst.FDN_GIDSTR: gidstr,
      DBConst.FDN_GROUPNO: groupno,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_ISACTIVITY: isactivity,
      DBConst.FDN_ISBALTR: isbaltr,
      DBConst.FDN_ISBANQUET: isbanquet,
      DBConst.FDN_ISBOARDING: isboarding,
      DBConst.FDN_ISONACTIVE: isconactive,
      DBConst.FDN_ISFRONT: isfront,
      DBConst.FDN_ISLOCRES: islocres,
      DBConst.FDN_ISORSACTIVE: isorsactive,
      DBConst.FDN_ISPAIDOUT: ispaidout,
      DBConst.FDN_ISPAIDOUT: isposdepart,
      DBConst.FDN_ISPOSTABLE: ispostable,
      DBConst.FDN_ISROOMING: isrooming,
      DBConst.FDN_ISSPARES: isspares,
      DBConst.FDN_LOCID: locid,
      DBConst.FDN_LONGDESC: longdesc,
      DBConst.FDN_RESPONSIBLE: responsible,
      DBConst.FDN_TAXRATE: taxrate,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Depart &&
          runtimeType == other.runtimeType &&
          accplancode == other.accplancode &&
          bevstore == other.bevstore &&
          bevstorecode == other.bevstorecode &&
          bevstoredesc == other.bevstoredesc &&
          bevstoreid == other.bevstoreid &&
          cashboxcode == other.cashboxcode &&
          cashboxdesc == other.cashboxdesc &&
          cashboxid == other.cashboxid &&
          codestr == other.codestr &&
          departtype == other.departtype &&
          foodstore == other.foodstore &&
          foodstorecode == other.foodstorecode &&
          foodstoredesc == other.foodstoredesc &&
          foodstoreid == other.foodstoreid &&
          gidstr == other.gidstr &&
          groupno == other.groupno &&
          hotelname == other.hotelname &&
          isactivity == other.isactivity &&
          isbaltr == other.isbaltr &&
          isbanquet == other.isbanquet &&
          isboarding == other.isboarding &&
          isconactive == other.isconactive &&
          isfront == other.isfront &&
          islocres == other.islocres &&
          isorsactive == other.isorsactive &&
          ispaidout == other.ispaidout &&
          isposdepart == other.isposdepart &&
          ispostable == other.ispostable &&
          isrooming == other.isrooming &&
          isspares == other.isspares &&
          locid == other.locid &&
          longdesc == other.longdesc &&
          responsible == other.responsible &&
          taxrate == other.taxrate &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      accplancode.hashCode ^
      bevstore.hashCode ^
      bevstorecode.hashCode ^
      bevstoredesc.hashCode ^
      bevstoreid.hashCode ^
      cashboxcode.hashCode ^
      cashboxdesc.hashCode ^
      cashboxid.hashCode ^
      codestr.hashCode ^
      departtype.hashCode ^
      foodstore.hashCode ^
      foodstorecode.hashCode ^
      foodstoredesc.hashCode ^
      foodstoreid.hashCode ^
      gidstr.hashCode ^
      groupno.hashCode ^
      hotelname.hashCode ^
      isactivity.hashCode ^
      isbaltr.hashCode ^
      isbanquet.hashCode ^
      isboarding.hashCode ^
      isconactive.hashCode ^
      isfront.hashCode ^
      islocres.hashCode ^
      isorsactive.hashCode ^
      ispaidout.hashCode ^
      isposdepart.hashCode ^
      ispostable.hashCode ^
      isrooming.hashCode ^
      isspares.hashCode ^
      locid.hashCode ^
      longdesc.hashCode ^
      responsible.hashCode ^
      taxrate.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Depart{${super.toString()},accplancode: $accplancode, bevstore: $bevstore, bevstorecode: $bevstorecode, bevstoredesc: $bevstoredesc, bevstoreid: $bevstoreid, cashboxcode: $cashboxcode, cashboxdesc: $cashboxdesc, cashboxid: $cashboxid, codestr: $codestr, departtype: $departtype, foodstore: $foodstore, foodstorecode: $foodstorecode, foodstoredesc: $foodstoredesc, foodstoreid: $foodstoreid, gidstr: $gidstr, groupno: $groupno, hotelname: $hotelname, isactivity: $isactivity, isbaltr: $isbaltr, isbanquet: $isbanquet, isboarding: $isboarding, isconactive: $isconactive, isfront: $isfront, islocres: $islocres, isorsactive: $isorsactive, ispaidout: $ispaidout, isposdepart: $isposdepart, ispostable: $ispostable, isrooming: $isrooming, isspares: $isspares, locid: $locid, longdesc: $longdesc, responsible: $responsible, taxrate: $taxrate, jsonMap: $jsonMap}';
  }
}
