import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelCode.dart';

class TsDesc extends BaseModelCode {
  int tscatid;
  int priorityid;
  int tstypeid;
  String duration;
  int empposid;
  String transtype;
  bool isinstart;
  int reasonid;
  int locid;
  int defempid;
  String gidstr;
  bool isstd;

  //View Fields
  String vvlongdesc;
  String vvcodestr;
  String vvtscat;
  String vvtscatdesc;
  String vvtspriority;
  String vvtstype;
  int vvempdepartid;
  String vvempdepart;
  String vvemppos;
  String vvtranstypedesc;
  String vvreasoncode;
  String vvreasondesc;
  String vvloccode;
  String vvlocdesc;
  String vvempposcode;
  String vvempposdesc;
  String vvtstypecode;
  String vvtstypedesc;
  String vvhotelname;
  String vvdefempcode;
  String vvdefempname;
  int vvdefempposid;
  String vvdefempposcode;
  String vvdefempposdesc;
  int vvdefempdepartid;
  String vvdefempdepart;
  String vvdefempdepartdesc;

  Map<String, dynamic> jsonMap;

  TsDesc({
    this.tscatid,
    this.priorityid,
    this.tstypeid,
    this.duration,
    this.empposid,
    this.transtype,
    this.isinstart,
    this.reasonid,
    this.locid,
    this.defempid,
    this.gidstr,
    this.isstd,
    this.vvlongdesc,
    this.vvcodestr,
    this.vvtscat,
    this.vvtscatdesc,
    this.vvtspriority,
    this.vvtstype,
    this.vvempdepartid,
    this.vvempdepart,
    this.vvemppos,
    this.vvtranstypedesc,
    this.vvreasoncode,
    this.vvreasondesc,
    this.vvloccode,
    this.vvlocdesc,
    this.vvempposcode,
    this.vvempposdesc,
    this.vvtstypecode,
    this.vvtstypedesc,
    this.vvhotelname,
    this.vvdefempcode,
    this.vvdefempname,
    this.vvdefempposid,
    this.vvdefempposcode,
    this.vvdefempposdesc,
    this.vvdefempdepartid,
    this.vvdefempdepart,
    this.vvdefempdepartdesc,
    this.jsonMap,
  }) : super(
          code: jsonMap[DBConst.FDN_CODE],
          shortcode: jsonMap[DBConst.FDN_SHORTCODE],
          description: jsonMap[DBConst.FDN_DESCRIPTION],
          isdef: jsonMap[DBConst.FDN_ISDEF],
          isActive: jsonMap[DBConst.FDN_ISACTIVE],
          jsonMap: jsonMap,
        );

  factory TsDesc.fromJson(Map<String, dynamic> json) {
    return new TsDesc(
      transtype: json[DBConst.FDN_TRANSTYPE],
      duration: json[DBConst.FDN_DURATION],
      locid: json[DBConst.FDN_LOCID],
      empposid: json[DBConst.FDN_EMPPOSID],
      reasonid: json[DBConst.FDN_REASONID],
      defempid: json[DBConst.FDN_DEFEMPID],
      isinstart: json[DBConst.FDN_ISINSTART],
      tscatid: json[DBConst.FDN_TSCATID],
      priorityid: json[DBConst.FDN_PRIORITYID],
      tstypeid: json[DBConst.FDN_TSTYPEID],
      gidstr: json[DBConst.FDN_GIDSTR],
      isstd: json[DBConst.FDN_ISSTD],
      vvhotelname: json[DBConst.FDN_HOTELNAME],
      vvtranstypedesc: json[DBConst.FDN_TRANSTYPEDESC],
      vvlongdesc: json[DBConst.FDN_LONGDESC],
      vvcodestr: json[DBConst.FDN_CODESTR],
      vvloccode: json[DBConst.FDN_LOCCODE],
      vvlocdesc: json[DBConst.FDN_LOCDESC],
      vvempdepartid: json[DBConst.FDN_EMPDEPARTID],
      vvempposdesc: json[DBConst.FDN_EMPPOSDESC],
      vvempposcode: json[DBConst.FDN_EMPPOSCODE],
      vvemppos: json[DBConst.FDN_EMPPOS],
      vvempdepart: json[DBConst.FDN_EMPDEPART],
      vvreasoncode: json[DBConst.FDN_REASONCODE],
      vvreasondesc: json[DBConst.FDN_REASONDESC],
      vvtscat: json[DBConst.FDN_TSCAT],
      vvtscatdesc: json[DBConst.FDN_TSCATDESC],
      vvtspriority: json[DBConst.FDN_TSPRIORITY],
      vvtstype: json[DBConst.FDN_TSTYPE],
      vvtstypecode: json[DBConst.FDN_TSTYPECODE],
      vvtstypedesc: json[DBConst.FDN_TSTYPEDESC],
      vvdefempcode: json[DBConst.FDN_DEFEMPCODE],
      vvdefempname: json[DBConst.FDN_DEFEMPNAME],
      vvdefempposid: json[DBConst.FDN_DEFEMPPOSID],
      vvdefempposcode: json[DBConst.FDN_DEFEMPPOSCODE],
      vvdefempposdesc: json[DBConst.FDN_DEFEMPPOSDESC],
      vvdefempdepartid: json[DBConst.FDN_DEFEMPDEPARTID],
      vvdefempdepart: json[DBConst.FDN_DEFEMPDEPART],
      vvdefempdepartdesc: json[DBConst.FDN_DEFEMPDEPARTDESC],
      jsonMap: json,
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_TRANSTYPE: transtype,
      DBConst.FDN_DURATION: duration,
      DBConst.FDN_LOCID: locid,
      DBConst.FDN_EMPPOSID: empposid,
      DBConst.FDN_REASONID: reasonid,
      DBConst.FDN_DEFEMPID: defempid,
      DBConst.FDN_ISINSTART: isinstart,
      DBConst.FDN_TSCATID: tscatid,
      DBConst.FDN_PRIORITYID: priorityid,
      DBConst.FDN_TSTYPEID: tstypeid,
      DBConst.FDN_GIDSTR: gidstr,
      DBConst.FDN_ISSTD: isstd,
      DBConst.FDN_HOTELNAME: vvhotelname,
      DBConst.FDN_TRANSTYPEDESC: vvtranstypedesc,
      DBConst.FDN_LONGDESC: vvlongdesc,
      DBConst.FDN_CODESTR: vvcodestr,
      DBConst.FDN_LOCCODE: vvloccode,
      DBConst.FDN_LOCDESC: vvlocdesc,
      DBConst.FDN_EMPDEPARTID: vvempdepartid,
      DBConst.FDN_EMPPOSDESC: vvempposdesc,
      DBConst.FDN_EMPPOSCODE: vvempposcode,
      DBConst.FDN_EMPPOS: vvemppos,
      DBConst.FDN_EMPDEPART: vvempdepart,
      DBConst.FDN_REASONCODE: vvreasoncode,
      DBConst.FDN_REASONDESC: vvreasondesc,
      DBConst.FDN_TSCAT: vvtscat,
      DBConst.FDN_TSCATDESC: vvtscatdesc,
      DBConst.FDN_TSPRIORITY: vvtspriority,
      DBConst.FDN_TSTYPE: vvtstype,
      DBConst.FDN_TSTYPECODE: vvtstypecode,
      DBConst.FDN_TSTYPEDESC: vvtstypedesc,
      DBConst.FDN_DEFEMPCODE: vvdefempcode,
      DBConst.FDN_DEFEMPNAME: vvdefempname,
      DBConst.FDN_DEFEMPPOSID: vvdefempposid,
      DBConst.FDN_DEFEMPPOSCODE: vvdefempposcode,
      DBConst.FDN_DEFEMPPOSDESC: vvdefempposdesc,
      DBConst.FDN_DEFEMPDEPARTID: vvdefempdepartid,
      DBConst.FDN_DEFEMPDEPART: vvdefempdepart,
      DBConst.FDN_DEFEMPDEPARTDESC: vvdefempdepartdesc,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is TsDesc &&
          runtimeType == other.runtimeType &&
          tscatid == other.tscatid &&
          priorityid == other.priorityid &&
          tstypeid == other.tstypeid &&
          duration == other.duration &&
          empposid == other.empposid &&
          transtype == other.transtype &&
          isinstart == other.isinstart &&
          reasonid == other.reasonid &&
          locid == other.locid &&
          defempid == other.defempid &&
          gidstr == other.gidstr &&
          isstd == other.isstd &&
          vvlongdesc == other.vvlongdesc &&
          vvcodestr == other.vvcodestr &&
          vvtscat == other.vvtscat &&
          vvtscatdesc == other.vvtscatdesc &&
          vvtspriority == other.vvtspriority &&
          vvtstype == other.vvtstype &&
          vvempdepartid == other.vvempdepartid &&
          vvempdepart == other.vvempdepart &&
          vvemppos == other.vvemppos &&
          vvtranstypedesc == other.vvtranstypedesc &&
          vvreasoncode == other.vvreasoncode &&
          vvreasondesc == other.vvreasondesc &&
          vvloccode == other.vvloccode &&
          vvlocdesc == other.vvlocdesc &&
          vvempposcode == other.vvempposcode &&
          vvempposdesc == other.vvempposdesc &&
          vvtstypecode == other.vvtstypecode &&
          vvtstypedesc == other.vvtstypedesc &&
          vvhotelname == other.vvhotelname &&
          vvdefempcode == other.vvdefempcode &&
          vvdefempname == other.vvdefempname &&
          vvdefempposid == other.vvdefempposid &&
          vvdefempposcode == other.vvdefempposcode &&
          vvdefempposdesc == other.vvdefempposdesc &&
          vvdefempdepartid == other.vvdefempdepartid &&
          vvdefempdepart == other.vvdefempdepart &&
          vvdefempdepartdesc == other.vvdefempdepartdesc;

  @override
  int get hashCode =>
      tscatid.hashCode ^
      priorityid.hashCode ^
      tstypeid.hashCode ^
      duration.hashCode ^
      empposid.hashCode ^
      transtype.hashCode ^
      isinstart.hashCode ^
      reasonid.hashCode ^
      locid.hashCode ^
      defempid.hashCode ^
      gidstr.hashCode ^
      isstd.hashCode ^
      vvlongdesc.hashCode ^
      vvcodestr.hashCode ^
      vvtscat.hashCode ^
      vvtscatdesc.hashCode ^
      vvtspriority.hashCode ^
      vvtstype.hashCode ^
      vvempdepartid.hashCode ^
      vvempdepart.hashCode ^
      vvemppos.hashCode ^
      vvtranstypedesc.hashCode ^
      vvreasoncode.hashCode ^
      vvreasondesc.hashCode ^
      vvloccode.hashCode ^
      vvlocdesc.hashCode ^
      vvempposcode.hashCode ^
      vvempposdesc.hashCode ^
      vvtstypecode.hashCode ^
      vvtstypedesc.hashCode ^
      vvhotelname.hashCode ^
      vvdefempcode.hashCode ^
      vvdefempname.hashCode ^
      vvdefempposid.hashCode ^
      vvdefempposcode.hashCode ^
      vvdefempposdesc.hashCode ^
      vvdefempdepartid.hashCode ^
      vvdefempdepart.hashCode ^
      vvdefempdepartdesc.hashCode;

  @override
  String toString() {
    return 'TsDesc{${super.toString()}, tscatid: $tscatid, priorityid: $priorityid, tstypeid: $tstypeid, duration: $duration, empposid: $empposid, transtype: $transtype, isinstart: $isinstart, reasonid: $reasonid, locid: $locid, defempid: $defempid, gidstr: $gidstr, isstd: $isstd, vvlongdesc: $vvlongdesc, vvcodestr: $vvcodestr, vvtscat: $vvtscat, vvtscatdesc: $vvtscatdesc, vvtspriority: $vvtspriority, vvtstype: $vvtstype, vvempdepartid: $vvempdepartid, vvempdepart: $vvempdepart, vvemppos: $vvemppos, vvtranstypedesc: $vvtranstypedesc, vvreasoncode: $vvreasoncode, vvreasondesc: $vvreasondesc, vvloccode: $vvloccode, vvlocdesc: $vvlocdesc, vvempposcode: $vvempposcode, vvempposdesc: $vvempposdesc, vvtstypecode: $vvtstypecode, vvtstypedesc: $vvtstypedesc, vvhotelname: $vvhotelname, vvdefempcode: $vvdefempcode, vvdefempname: $vvdefempname, vvdefempposid: $vvdefempposid, vvdefempposcode: $vvdefempposcode, vvdefempposdesc: $vvdefempposdesc, vvdefempdepartid: $vvdefempdepartid, vvdefempdepart: $vvdefempdepart, vvdefempdepartdesc: $vvdefempdepartdesc}';
  }
}
