import 'dart:core';

import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelCode.dart';

class TsStatus extends BaseModelCode {
  bool needinitialtime;
  bool needwaittime;
  bool needplantime;
  bool needstarttime;
  bool needendtime;
  bool needtesttime;
  bool needconfirmtime;
  bool needcanceltime;
  int statuscolor;
  String iconcode;
  int prlevel;
  bool isbusy;
  bool showinchart;
  bool isreadonly;
  bool reqtrans;
  bool reqnote;
  bool ismet;
  bool islinked;
  bool isreqwaiting;
  bool isclose;
  bool istodo;
  bool iswait;
  bool needcustomtime;
  bool isaccwaiting;
  bool reqconf;
  bool needsuspendtime;

  //View Fields
  bool isclosed;
  bool iswaiting;
  String hotelname;

  Map<String, dynamic> jsonMap;

  TsStatus({
    this.needinitialtime,
    this.needwaittime,
    this.needplantime,
    this.needstarttime,
    this.needendtime,
    this.needtesttime,
    this.needconfirmtime,
    this.needcanceltime,
    this.statuscolor,
    this.iconcode,
    this.prlevel,
    this.isbusy,
    this.showinchart,
    this.isreadonly,
    this.reqtrans,
    this.reqnote,
    this.ismet,
    this.islinked,
    this.isreqwaiting,
    this.isclose,
    this.istodo,
    this.iswait,
    this.needcustomtime,
    this.isaccwaiting,
    this.reqconf,
    this.needsuspendtime,
    this.isclosed,
    this.iswaiting,
    this.hotelname,
    this.jsonMap,
  }) : super(
          code: jsonMap[DBConst.FDN_CODE],
          shortcode: jsonMap[DBConst.FDN_SHORTCODE],
          description: jsonMap[DBConst.FDN_DESCRIPTION],
          isdef: jsonMap[DBConst.FDN_ISDEF],
          isActive: jsonMap[DBConst.FDN_ISACTIVE],
          jsonMap: jsonMap,
        );

  factory TsStatus.fromJson(Map<String, dynamic> json) {
    return new TsStatus(
      needinitialtime: json[DBConst.FDN_NEEDINITIALTIME],
      needwaittime: json[DBConst.FDN_NEEDWAITTIME],
      needplantime: json[DBConst.FDN_NEEDPLANTIME],
      needstarttime: json[DBConst.FDN_NEEDSTARTTIME],
      needendtime: json[DBConst.FDN_NEEDENDTIME],
      needtesttime: json[DBConst.FDN_NEEDTESTTIME],
      needconfirmtime: json[DBConst.FDN_NEEDCONFIRMTIME],
      needcanceltime: json[DBConst.FDN_NEEDCANCELTIME],
      statuscolor: json[DBConst.FDN_STATUSCOLOR],
      iconcode: json[DBConst.FDN_ICONCODE],
      prlevel: json[DBConst.FDN_PRLEVEL],
      isbusy: json[DBConst.FDN_ISBUSY],
      showinchart: json[DBConst.FDN_SHOWINCHART],
      isreadonly: json[DBConst.FDN_ISREADONLY],
      reqtrans: json[DBConst.FDN_REQTRANS],
      reqnote: json[DBConst.FDN_REQNOTE],
      ismet: json[DBConst.FDN_ISMET],
      islinked: json[DBConst.FDN_ISLINKED],
      isreqwaiting: json[DBConst.FDN_ISREQWAITING],
      isclose: json[DBConst.FDN_ISCLOSE],
      istodo: json[DBConst.FDN_ISTODO],
      iswait: json[DBConst.FDN_ISWAIT],
      needcustomtime: json[DBConst.FDN_NEEDCUSTOMTIME],
      isaccwaiting: json[DBConst.FDN_ISACCWAITING],
      reqconf: json[DBConst.FDN_REQCONF],
      needsuspendtime: json[DBConst.FDN_NEEDSUSPENDTIME],
      isclosed: json[DBConst.FDN_ISCLOSED],
      iswaiting: json[DBConst.FDN_ISWAITING],
      hotelname: json[DBConst.FDN_HOTELNAME],
      jsonMap: json,
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_NEEDINITIALTIME: needinitialtime,
      DBConst.FDN_NEEDWAITTIME: needwaittime,
      DBConst.FDN_NEEDPLANTIME: needplantime,
      DBConst.FDN_NEEDSTARTTIME: needstarttime,
      DBConst.FDN_NEEDENDTIME: needendtime,
      DBConst.FDN_NEEDTESTTIME: needtesttime,
      DBConst.FDN_NEEDCONFIRMTIME: needconfirmtime,
      DBConst.FDN_NEEDCANCELTIME: needcanceltime,
      DBConst.FDN_STATUSCOLOR: statuscolor,
      DBConst.FDN_ICONCODE: iconcode,
      DBConst.FDN_PRLEVEL: prlevel,
      DBConst.FDN_ISBUSY: isbusy,
      DBConst.FDN_SHOWINCHART: showinchart,
      DBConst.FDN_ISREADONLY: isreadonly,
      DBConst.FDN_REQTRANS: reqtrans,
      DBConst.FDN_REQNOTE: reqnote,
      DBConst.FDN_ISMET: ismet,
      DBConst.FDN_ISLINKED: islinked,
      DBConst.FDN_ISREQWAITING: isreqwaiting,
      DBConst.FDN_ISCLOSE: isclose,
      DBConst.FDN_ISTODO: istodo,
      DBConst.FDN_ISWAIT: iswait,
      DBConst.FDN_NEEDCUSTOMTIME: needcustomtime,
      DBConst.FDN_ISACCWAITING: isaccwaiting,
      DBConst.FDN_REQCONF: reqconf,
      DBConst.FDN_NEEDSUSPENDTIME: needsuspendtime,
      DBConst.FDN_ISCLOSED: isclosed,
      DBConst.FDN_ISWAITING: iswaiting,
      DBConst.FDN_HOTELNAME: hotelname,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is TsStatus &&
          runtimeType == other.runtimeType &&
          needinitialtime == other.needinitialtime &&
          needwaittime == other.needwaittime &&
          needplantime == other.needplantime &&
          needstarttime == other.needstarttime &&
          needendtime == other.needendtime &&
          needtesttime == other.needtesttime &&
          needconfirmtime == other.needconfirmtime &&
          needcanceltime == other.needcanceltime &&
          statuscolor == other.statuscolor &&
          iconcode == other.iconcode &&
          prlevel == other.prlevel &&
          isbusy == other.isbusy &&
          showinchart == other.showinchart &&
          isreadonly == other.isreadonly &&
          reqtrans == other.reqtrans &&
          reqnote == other.reqnote &&
          ismet == other.ismet &&
          islinked == other.islinked &&
          isreqwaiting == other.isreqwaiting &&
          isclose == other.isclose &&
          istodo == other.istodo &&
          iswait == other.iswait &&
          needcustomtime == other.needcustomtime &&
          isaccwaiting == other.isaccwaiting &&
          reqconf == other.reqconf &&
          needsuspendtime == other.needsuspendtime &&
          isclosed == other.isclosed &&
          iswaiting == other.iswaiting &&
          hotelname == other.hotelname &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      needinitialtime.hashCode ^
      needwaittime.hashCode ^
      needplantime.hashCode ^
      needstarttime.hashCode ^
      needendtime.hashCode ^
      needtesttime.hashCode ^
      needconfirmtime.hashCode ^
      needcanceltime.hashCode ^
      statuscolor.hashCode ^
      iconcode.hashCode ^
      prlevel.hashCode ^
      isbusy.hashCode ^
      showinchart.hashCode ^
      isreadonly.hashCode ^
      reqtrans.hashCode ^
      reqnote.hashCode ^
      ismet.hashCode ^
      islinked.hashCode ^
      isreqwaiting.hashCode ^
      isclose.hashCode ^
      istodo.hashCode ^
      iswait.hashCode ^
      needcustomtime.hashCode ^
      isaccwaiting.hashCode ^
      reqconf.hashCode ^
      needsuspendtime.hashCode ^
      isclosed.hashCode ^
      iswaiting.hashCode ^
      hotelname.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'TsStatus{${super.toString()}, needinitialtime: $needinitialtime, needwaittime: $needwaittime, needplantime: $needplantime, needstarttime: $needstarttime, needendtime: $needendtime, needtesttime: $needtesttime, needconfirmtime: $needconfirmtime, needcanceltime: $needcanceltime, statuscolor: $statuscolor, iconcode: $iconcode, prlevel: $prlevel, isbusy: $isbusy, showinchart: $showinchart, isreadonly: $isreadonly, reqtrans: $reqtrans, reqnote: $reqnote, ismet: $ismet, islinked: $islinked, isreqwaiting: $isreqwaiting, isclose: $isclose, istodo: $istodo, iswait: $iswait, needcustomtime: $needcustomtime, isaccwaiting: $isaccwaiting, reqconf: $reqconf, needsuspendtime: $needsuspendtime, isclosed: $isclosed, iswaiting: $iswaiting, hotelname: $hotelname}';
  }
}
