import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelCode.dart';

class Tstype extends BaseModelCode {
  bool useforautoserv;
  bool useforautocalib;
  String duration;
  String empdepart;
  String reqtype;
  bool isroom;
  bool isloc;
  bool iscomplaint;
  bool issaletask;
  String transtype;
  bool isopnote;
  bool istasktype;
  bool isreqtype;
  bool iststype;
  int defstatusid;
  int taskinstid;
  int empdepartid;
  bool isguide;

  //View Fields
  String defstatuscode;

  Map<String, dynamic> jsonMap;

  Tstype({
    this.useforautoserv,
    this.useforautocalib,
    this.duration,
    this.empdepart,
    this.reqtype,
    this.isroom,
    this.isloc,
    this.iscomplaint,
    this.issaletask,
    this.transtype,
    this.isopnote,
    this.istasktype,
    this.isreqtype,
    this.iststype,
    this.defstatusid,
    this.taskinstid,
    this.empdepartid,
    this.isguide,
    this.defstatuscode,
    this.jsonMap,
  }) : super(
          code: jsonMap[DBConst.FDN_CODE],
          shortcode: jsonMap[DBConst.FDN_SHORTCODE],
          description: jsonMap[DBConst.FDN_DESCRIPTION],
          isdef: jsonMap[DBConst.FDN_ISDEF],
          isActive: jsonMap[DBConst.FDN_ISACTIVE],
          jsonMap: jsonMap,
        );

  factory Tstype.fromJson(Map<String, dynamic> json) {
    return Tstype(
      useforautoserv: json[DBConst.FDN_USEFORAUTOSERV],
      useforautocalib: json[DBConst.FDN_USEFORAUTOCALIB],
      duration: json[DBConst.FDN_DURATION],
      empdepart: json[DBConst.FDN_EMPDEPART],
      reqtype: json[DBConst.FDN_REQTYPE],
      isroom: json[DBConst.FDN_ISROOM],
      isloc: json[DBConst.FDN_ISLOC],
      iscomplaint: json[DBConst.FDN_ISCOMPLAINT],
      issaletask: json[DBConst.FDN_ISSALETASK],
      transtype: json[DBConst.FDN_TRANSTYPE],
      isopnote: json[DBConst.FDN_ISOPNOTE],
      istasktype: json[DBConst.FDN_ISTASKTYPE],
      isreqtype: json[DBConst.FDN_ISREQTYPE],
      iststype: json[DBConst.FDN_ISTSTYPE],
      defstatusid: json[DBConst.FDN_DEFSTATUSID],
      taskinstid: json[DBConst.FDN_TASKINSTID],
      empdepartid: json[DBConst.FDN_EMPDEPARTID],
      isguide: json[DBConst.FDN_ISGUIDE],
      defstatuscode: json[DBConst.FDN_DEFSTATUSCODE],
      jsonMap: json,
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_USEFORAUTOSERV: useforautoserv,
      DBConst.FDN_USEFORAUTOCALIB: useforautocalib,
      DBConst.FDN_DURATION: duration,
      DBConst.FDN_EMPDEPART: empdepart,
      DBConst.FDN_REQTYPE: reqtype,
      DBConst.FDN_ISROOM: isroom,
      DBConst.FDN_ISLOC: isloc,
      DBConst.FDN_ISCOMPLAINT: iscomplaint,
      DBConst.FDN_ISSALETASK: issaletask,
      DBConst.FDN_TRANSTYPE: transtype,
      DBConst.FDN_ISOPNOTE: isopnote,
      DBConst.FDN_ISTASKTYPE: istasktype,
      DBConst.FDN_ISREQTYPE: isreqtype,
      DBConst.FDN_ISTSTYPE: iststype,
      DBConst.FDN_DEFSTATUSID: defstatusid,
      DBConst.FDN_TASKINSTID: taskinstid,
      DBConst.FDN_EMPDEPARTID: empdepartid,
      DBConst.FDN_ISGUIDE: isguide,
      DBConst.FDN_DEFSTATUSCODE: defstatuscode,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Tstype &&
          runtimeType == other.runtimeType &&
          useforautoserv == other.useforautoserv &&
          useforautocalib == other.useforautocalib &&
          duration == other.duration &&
          empdepart == other.empdepart &&
          reqtype == other.reqtype &&
          isroom == other.isroom &&
          isloc == other.isloc &&
          iscomplaint == other.iscomplaint &&
          issaletask == other.issaletask &&
          transtype == other.transtype &&
          isopnote == other.isopnote &&
          istasktype == other.istasktype &&
          isreqtype == other.isreqtype &&
          iststype == other.iststype &&
          defstatusid == other.defstatusid &&
          taskinstid == other.taskinstid &&
          empdepartid == other.empdepartid &&
          isguide == other.isguide &&
          defstatuscode == other.defstatuscode &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      useforautoserv.hashCode ^
      useforautocalib.hashCode ^
      duration.hashCode ^
      empdepart.hashCode ^
      reqtype.hashCode ^
      isroom.hashCode ^
      isloc.hashCode ^
      iscomplaint.hashCode ^
      issaletask.hashCode ^
      transtype.hashCode ^
      isopnote.hashCode ^
      istasktype.hashCode ^
      isreqtype.hashCode ^
      iststype.hashCode ^
      defstatusid.hashCode ^
      taskinstid.hashCode ^
      empdepartid.hashCode ^
      isguide.hashCode ^
      defstatuscode.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Tstype{${super.toString()}, useforautoserv: $useforautoserv, useforautocalib: $useforautocalib, duration: $duration, empdepart: $empdepart, reqtype: $reqtype, isroom: $isroom, isloc: $isloc, iscomplaint: $iscomplaint, issaletask: $issaletask, transtype: $transtype, isopnote: $isopnote, istasktype: $istasktype, isreqtype: $isreqtype, iststype: $iststype, defstatusid: $defstatusid, taskinstid: $taskinstid, empdepartid: $empdepartid, isguide: $isguide, defstatuscode: $defstatuscode}';
  }
}
