import 'package:hotech_flutter_utilities/Constants.dart';

class CacheDir {
  String key; //use file URL if available,some form of a primary key otherwise, or Rafile.id if using Rafile.
  String filePath;
  String updateTime;

  Map<String, dynamic> jsonMap;

  CacheDir({
    this.key,
    this.filePath,
    this.updateTime,
    this.jsonMap,
  });

  factory CacheDir.fromJson(Map<String, dynamic> json) {
    return CacheDir(
      key: json[Consts.PARAM_KEY],
      filePath: json[DBConst.FDN_CACHE_FILEPATH],
      updateTime: json[DBConst.FDN_CACHE_UPDATETIME],
      jsonMap: json,
    );
  }

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      Consts.PARAM_KEY: key,
      DBConst.FDN_CACHE_FILEPATH: filePath,
      DBConst.FDN_CACHE_UPDATETIME: updateTime,
    };
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is CacheDir &&
          runtimeType == other.runtimeType &&
          key == other.key &&
          filePath == other.filePath &&
          updateTime == other.updateTime &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode => key.hashCode ^ filePath.hashCode ^ updateTime.hashCode ^ jsonMap.hashCode;

  @override
  String toString() {
    return 'CacheDir{url: $key, filePath: $filePath, updateTime: $updateTime, jsonMap: $jsonMap}';
  }
}
