import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/BaseModelSync.dart';

class Geoloc extends BaseModelSync {
  int masterid;
  double lng;
  double lat;
  double tol;
  bool isdef;

  //View Fields
  String hotelname;
  int hotelpid;

  Map<String, dynamic> jsonMap;

  Geoloc({
    this.masterid,
    this.lng,
    this.lat,
    this.tol,
    this.isdef,
    this.hotelname,
    this.hotelpid,
    this.jsonMap,
  }) : super(
          id: jsonMap[DBConst.FDN_ID],
          jsonMap: jsonMap,
        );

  factory Geoloc.fromJson(Map<String, dynamic> json) => new Geoloc(
        masterid: json[DBConst.FDN_MASTERID],
        lng: json[DBConst.FDN_LNG],
        lat: json[DBConst.FDN_LAT],
        tol: json[DBConst.FDN_TOL],
        isdef: json[DBConst.FDN_ISDEF],
        hotelname: json[DBConst.FDN_HOTELNAME],
        hotelpid: json[DBConst.FDN_HOTELPID],
        jsonMap: json,
      );

  Map<String, dynamic> toJson() {
    Map<String, dynamic> map = <String, dynamic>{
      DBConst.FDN_MASTERID: masterid,
      DBConst.FDN_LNG: lng,
      DBConst.FDN_LAT: lat,
      DBConst.FDN_TOL: tol,
      DBConst.FDN_ISDEF: isdef,
      DBConst.FDN_HOTELNAME: hotelname,
      DBConst.FDN_HOTELPID: hotelpid,
    };
    map.addAll(super.toJson());
    return map;
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is Geoloc &&
          runtimeType == other.runtimeType &&
          masterid == other.masterid &&
          lng == other.lng &&
          lat == other.lat &&
          tol == other.tol &&
          isdef == other.isdef &&
          hotelname == other.hotelname &&
          hotelpid == other.hotelpid &&
          jsonMap == other.jsonMap;

  @override
  int get hashCode =>
      super.hashCode ^
      masterid.hashCode ^
      lng.hashCode ^
      lat.hashCode ^
      tol.hashCode ^
      isdef.hashCode ^
      hotelname.hashCode ^
      hotelpid.hashCode ^
      jsonMap.hashCode;

  @override
  String toString() {
    return 'Geoloc{${super.toString()}, masterid: $masterid, lng: $lng, lat: $lat, tol: $tol, isdef: $isdef, hotelname: $hotelname, hotelpid: $hotelpid, jsonMap: $jsonMap}';
  }
}
