import 'dart:async';

import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/HFSharedPreferences.dart';

class LoginHelper {
  static Map<String, String> headers;

  static var postHeader = {
    Consts.HEADER_ACCEPT: Consts.HEADER_JSON_CONTENT_TYPE,
    Consts.HEADER_CONTENT_TYPE: Consts.HEADER_JSON_CONTENT_TYPE
  };

  static Future<Map<String, String>> getPostHeaders() async {
    var headers = await getHeaders();
    headers.addAll(postHeader);
    return headers;
  }

  static Future<Map<String, String>> getHeaders() async {
    HFSharedPreferences prefs = await HFSharedPreferences.getInstance();
    String accessToken = await prefs.getAccessToken();
    return {
      Consts.AUTHORIZATION: "${Consts.BEARER}$accessToken",
    };
  }

  static Map<String, String> getHotelGidBasedHeaders() {
    return {
      Consts.AUTHORIZATION: Consts.BEARER + Consts.HOTEL_DEMO_GID,
      Consts.REQTYPE: Consts.COMPANY,
    };
  }
}
