import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/ResponseConverter.dart';

class SyncResponse<M> {
  List<M> updates;

  List<M> deletes;

  List<M> conflicts;

  int syncStartTime;

  int syncEndTime;

  SyncResponse({
    this.updates,
    this.deletes,
    this.conflicts,
    this.syncStartTime,
    this.syncEndTime,
  });

  factory SyncResponse.fromJson(Map<String, dynamic> json) {
    return SyncResponse(
      updates: listConverter<M>(json[DBConst.FDN_UPDATES] as List).cast<M>(),
      deletes: listConverter<M>(json[DBConst.FDN_DELETES] as List).cast<M>(),
      conflicts: listConverter<M>(json[DBConst.FDN_CONFLICTS] as List).cast<M>(),
      syncStartTime: json[DBConst.FDN_SYNCSTARTTIME],
      syncEndTime: json[DBConst.FDN_SYNCENDTIME],
    );
  }
}
