import 'dart:async';
import 'dart:convert';

import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/ResModel.dart';
import 'package:hotech_flutter_utilities/model/SingleDataResult.dart';
import 'package:hotech_flutter_utilities/service/LoginHelper.dart';
import 'package:hotech_flutter_utilities/service/ServiceResponse.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';
import 'package:http/http.dart';

class SysService extends ServiceFactory<ResModel> {
  static SysService instance;

  static SysService getInstance() {
    return instance != null ? instance : SysService();
  }

  @override
  String getTableName() {
    return DBConst.TBL_SYS;
  }

  Future<ResModel> getSuperRefno() async {
    Response response = await callService(
      HttpMethod.GET,
      Consts.PATH_REFNO_SUPER,
      await LoginHelper.getHeaders(),
    );
    return response != null && ResponseType.isSuccessful(response.statusCode)
        ? SingleDataResult<ResModel>.fromJson(json.decode(response.body)).data
        : null;
  }
}
