import 'dart:async';
import 'dart:convert';

import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/ListDataResult.dart';
import 'package:hotech_flutter_utilities/model/crm/Bonustrans.dart';
import 'package:hotech_flutter_utilities/model/crm/BonustransGift.dart';
import 'package:hotech_flutter_utilities/model/crm/BonustransGiftSent.dart';
import 'package:hotech_flutter_utilities/service/LoginHelper.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';
import 'package:http/http.dart';

import '../ServiceResponse.dart';

class BonustransService extends ServiceFactory<Bonustrans> {
  static BonustransService instance;

  static BonustransService getInstance() {
    return instance != null ? instance : BonustransService();
  }

  @override
  String getTableName() {
    return DBConst.TBL_BONUSTRANS;
  }

  Future<List<BonustransGift>> getBonustransGiftList() async {
    Response response = await callService(
      HttpMethod.GET,
      Consts.PATH_GIFT_LIST,
      await LoginHelper.getHeaders(),
    );

    return response != null && ResponseType.isSuccessful(response.statusCode)
        ? ListDataResult<BonustransGift>.fromJson(json.decode(response.body)).data
        : null;
  }

  Future<List<BonustransGiftSent>> getBonustransGiftSent() async {
    Response response = await callService(
      HttpMethod.GET,
      Consts.PATH_GIFT_SENT,
      await LoginHelper.getHeaders(),
    );

    return response != null && ResponseType.isSuccessful(response.statusCode)
        ? ListDataResult<BonustransGiftSent>.fromJson(json.decode(response.body)).data
        : null;
  }
}
