import 'dart:async';
import 'dart:convert';
import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/ListDataResult.dart';
import 'package:hotech_flutter_utilities/model/cms/CmsSliderItem.dart';
import 'package:hotech_flutter_utilities/model/cms/surveyScore.dart';
import 'package:hotech_flutter_utilities/model/crm/Survey.dart';
import 'package:hotech_flutter_utilities/service/LoginHelper.dart';
import 'package:hotech_flutter_utilities/service/ServiceResponse.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';
import 'package:http/http.dart';

class SurveyService extends ServiceFactory<Survey> {
  static SurveyService instance;

  static SurveyService getInstance() {
    return instance != null ? instance : SurveyService();
  }

  @override
  String getTableName() {
    return DBConst.TBL_SURVEY;
  }

  Future<List<SurveyScore>> getStarRating(CmsSliderItem item, {bool isUserLoggedin = false}) async {
    Response response = await callService(HttpMethod.GET, Consts.PATH_SURVEY_SCORE,
        isUserLoggedin ? await LoginHelper.getHeaders() : LoginHelper.getHotelGidBasedHeaders(),
        params: {
          DBConst.FDN_SURVEYID: item.ratesurveyid,
          DBConst.FDN_ALLHOTELS: true,
        });

    return response != null && ResponseType.isSuccessful(response.statusCode)
        ? ListDataResult<SurveyScore>.fromJson(json.decode(response.body)).data
        : null;
  }
}
