import 'dart:async';
import 'dart:convert';

import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/ListDataResult.dart';
import 'package:hotech_flutter_utilities/model/SingleDataResult.dart';
import 'package:hotech_flutter_utilities/model/task/TstransStatEmp.dart';
import 'package:hotech_flutter_utilities/model/task/Tstrans.dart';
import 'package:hotech_flutter_utilities/service/LoginHelper.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';
import 'package:hotech_flutter_utilities/service/ServiceResponse.dart';
import 'package:hotech_flutter_utilities/service/SyncRequest.dart';
import 'package:hotech_flutter_utilities/service/SyncResponse.dart';
import 'package:http/http.dart';

class TstransService extends ServiceFactory<Tstrans> {
  static TstransService instance;

  static TstransService getInstance() {
    return instance != null ? instance : TstransService();
  }

  Future<TstransStatEmp> getStatEmp() async {
    Response response = await callService(HttpMethod.GET, Consts.PATH_TSTRANS_STAT_EMP, await LoginHelper.getHeaders());
    return response != null && ResponseType.isSuccessful(response.statusCode)
        ? ListDataResult<TstransStatEmp>.fromJson(json.decode(response.body)).data[0]
        : null;
  }

  @override
  String getTableName() {
    return DBConst.TBL_TSTRANS;
  }

  @override
  Future<SingleDataResult<SyncResponse<Tstrans>>> syncRequest(SyncRequest request) async {
    return null;
  }
}
