import 'dart:convert';

import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/ListDataResult.dart';
import 'package:hotech_flutter_utilities/model/tools/ReminderStatEmp.dart';
import 'package:hotech_flutter_utilities/service/LoginHelper.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';
import 'package:hotech_flutter_utilities/service/ServiceResponse.dart';
import 'package:http/http.dart';

class RemindersService extends ServiceFactory<ReminderStatEmp> {
  static RemindersService instance;

  static RemindersService getInstance() {
    return instance != null ? instance : RemindersService();
  }

  Future<ReminderStatEmp> getStatEmp() async {
    Response response =
        await callService(HttpMethod.GET, Consts.PATH_REMINDER_STAT_EMP, await LoginHelper.getHeaders());
    return response != null && ResponseType.isSuccessful(response.statusCode)
        ? ListDataResult<ReminderStatEmp>.fromJson(json.decode(response.body)).data[0]
        : null;
  }

  @override
  String getTableName() {
    return DBConst.TBL_REMINDERSTAT;
  }
}
