import 'dart:async';
import 'dart:convert';

import 'package:hotech_flutter_utilities/Constants.dart';
import 'package:hotech_flutter_utilities/model/SingleDataResult.dart';
import 'package:hotech_flutter_utilities/model/weather/weather.dart';
import 'package:hotech_flutter_utilities/service/ServiceFactory.dart';
import 'package:hotech_flutter_utilities/service/SyncRequest.dart';
import 'package:hotech_flutter_utilities/service/SyncResponse.dart';
import 'package:http/http.dart';
import 'package:sprintf/sprintf.dart';

class WeatherService extends ServiceFactory {
  static WeatherService instance;

  static WeatherService getInstance() {
    return instance != null ? instance : WeatherService();
  }

  @override
  String getBaseUrl() {
    return Consts.WEATHER_API_BASE_URL;
  }

  Future<dynamic> getWeatherForecast(double lat, double lon, {bool metric = true, bool today = false}) async {
    Response weather = await callService(
      HttpMethod.GET,
      sprintf(
        Consts.WEATHER_API,
        [
          today ? "weather" : "forecast/daily",
          lat.toString(),
          lon.toString(),
          metric ? "metric" : "imperial",
        ],
      ),
      null,
    );

    return weather != null
        ? today ? WeatherNowRes.fromJson(json.decode(weather.body)) : ForecastRes.fromJson(json.decode(weather.body))
        : null;
  }

  @override
  String getTableName() {
    return null;
  }

  @override
  Future<List> getViewList({Map<String, dynamic> params, Map<String, dynamic> queries, Map<String, dynamic> headers}) {
    return null;
  }

  @override
  Future<SingleDataResult<SyncResponse>> syncRequest(SyncRequest request) {
    return null;
  }
}
