///Holds all the constant strings in the project, if a string is constant, it belongs here.
///
/// Characters are abbreviated with CHR_, localized strings with str_, parameters with PARAM_, paths with _PATH, tables
/// with _TBL, and database fields with FDN_.

class Consts {
  // base url and apis
  static const String utilities_LOCAL_URL = "http://depo.amonra.com.tr:8223/utilities/";
  static const String utilities_CLOUD_URL = "https://cloud.hotech.systems/utilities/";
  static const String utilities_BETA_URL = "https://beta.hotech.systems/utilities/";
  static const String utilities_XANADU_ISLAND_URL = "http://loyalty.xanadu.com.tr:8223/utilities/";
  static const String HOTECH_URL = "http://hotech.systems";
  static const String GUEST_APP_WEB_URL = "https://hotech.com.tr/cms/6023/guestapp/in/embed=1";
  static const String WEATHER_API_BASE_URL = "https://api.openweathermap.org/";
  static const String WEATHER_API = "data/2.5/%s?APPID=0721392c0ba0af8c410aa9394defa29e&lat=%s&lon=%s&units=%s";
  static const String GOOGLE_MAP_URL = "https://www.google.com/maps/search/?api=1&query=%s,%s";
  static const String WEATHER_IMAGE = "https://openweathermap.org/img/w/%s.png";

  static const String LOGIN_BIRTHDATE = "login_birthDate";
  static const String LOGIN_PASS = "login_pass";

  static const String GRANT_TYPE = "grant_type";
  static const String CLIENT_ID = "client_id";
  static const String CLIENT_SECRET = "client_secret";
  static const String GRANT_TYPE_PASSWORD = "password";
  static const String GRANT_TYPE_REFRESH_TOKEN = "refresh_token";
  static const String CLIENT_SECRET_TOP_SECRET = "top_secret";
  static const String CLIENT_ID_OREST_CLIENT = "orestClient";
  static const String ONAPP = "onapp";
  static const String AUTHORIZATION = "Authorization";
  static const String BEARER = "Bearer ";
  static const String REQTYPE = "ReqType";
  static const String COMPANY = "Company";
  static const String HEADER_ACCEPT = "Accept";
  static const String HEADER_JSON_CONTENT_TYPE = "application/json";
  static const String HEADER_CONTENT_TYPE = "content-type";
  static const String URL_KEY = "URLKEY";

  static const String PLUGINS_SHARED_PREFERENCES = "plugins.flutter.io/shared_preferences";
  static const String SHARED_PREFERENCES_METHOD_GETALL = "getAll";

  //temporary
  static const String TEST = "Test";
  static const String GIFT_EXPLANATION_STRING = "Some description about this item. Some terms and conditions.";
  static const String VIEW_FIELD = "vv";
  static const String STR_BODY_REQUEST = "BodyRequest";
  static const String STR_RESPONSE = "Response";
  static const String STR_HOST = "Host";
  static const String STR_DATE = "Date";
  static const String COLOR_HEX_BLACK = "#000000";
  static const String COLOR_FF_PREFIX = "FF";
  static const String CMS_IMAGE_GID = "{fs}";
  static const String CONTENT_TYPE = "Content-Type";
  static const String CONTENT_LENGTH = "Content-Length";
  static const String XANDU_HOTELGID_KEY = "xandu_hotelgid";
  static const String GUESTAPP_COMMON_CODE = "GUESTAPP.";

  static const String GUESTAPP_HOTEL_CODE = "GUESTAPP.HOTEL";
  static const String GUESTAPP_NEARBY_CODE = "GUESTAPP.NEARBY";
  static const String GUESTAPP_FAQ_CODE = "GUESTAPP.FAQ";

  static const String GUESTAPP_EVENT_DESCRIPTION = "EVENT_DESC";
  static const String GUESTAPP_EVENT_IMAGE_01_CODE = "EVENT_PHOTO_01";
  static const String GUESTAPP_EVENT_IMAGE_CODE = "EVENT_PHOTO_%";
  static const String GUESTAPP_GIFT_IMAGE_01_CODE = "GIFT_PHOTO_01";
  static const String GUESTAPP_GIFT_IMAGE_CODE = "GIFT_PHOTO_%";
  static const String GUESTAPP_SLIDER_SCORE_CODE = "SLIDER_SCORE_";

  static const String PREF_KEY_FILE = "guest_app_pref_";
  static const String PREF_KEY_SYNC_URL = "sync_url";
  static const String PREF_KEY_DARK_MODE = "isDark";
  static const String PREF_KEY_TEMP_METRIC = "tempMetric";
  static const String PREF_KEY_SHOW_MY_REQUESTS = "showMyRequests";
  static const String PREF_KEY_HOTELREFNO = "hotelrefno";
  static const String PREF_KEY_REMEMBER_ME = "remeberMe";
  static const String PREF_KEY_USERNAME = "username";
  static const String PREF_KEY_PASSWORD = "password";
  static const String DEMO_EMAIL = "demo@hotech.systems";
  static const String DEMO_PASSWORD = "demo";
  static const String DEMO_DESCRIPTION = "test desc";
  static const String DEMO_CONTENT = "content test";

  static const String PARAM_SETT = "sett";
  static const String PARAM_ST = "st";
  static const String PARAM_COD = "cod";
  static const String PARAM_CNT = "cnt";
  static const String PARAM_LOCAL_CLEAR = "clear_local";
  static const String PARAM_INC_DEF = "inc_def";
  static const String PARAM_PAGE = "page";
  static const String PARAM_NO_LIMIT = "no_limit";
  static const String PARAM_EXC_HOTELREFNO = "exc_hotelrefno";
  static const String PARAM_DEL_WITH_ISDEL = "del_isdel";
  static const String PARAM_SPECIAL_FLAG = "special_flag";
  static const String PARAM_QUERY = "query";
  static const String PARAM_FIELD = "field";
  static const String PARAM_TEXT = "text";
  static const String PARAM_LIMIT = "limit";
  static const String PARAM_START = "start";
  static const String PARAM_CONTAIN = "contain";
  static const String PARAM_TABLE = "table";
  static const String PARAM_SECTION = "section";
  static const String PARAM_BASE = "base";
  static const String PARAM_MAIN = "main";
  static const String PARAM_DT = "dt";
  static const String PARAM_ID = "id";
  static const String PARAM_DAY = "day";
  static const String PARAM_MIN = "min";
  static const String PARAM_MAX = "max";
  static const String PARAM_EVE = "eve";
  static const String PARAM_MORN = "morn";
  static const String PARAM_COUNTRY = "country";
  static const String PARAM_POPULATION = "population";
  static const String PARAM_TIMEZONE = "timezone";
  static const String PARAM_NAME = "name";
  static const String PARAM_CLOUDS = "clouds";
  static const String PARAM_SUNRISE = "sunrise";
  static const String PARAM_SUNSET = "sunset";
  static const String PARAM_HUMIDITY = "humidity";
  static const String PARAM_TEMP = "temp";
  static const String PARAM_PRESSURE = "pressure";
  static const String PARAM_TEMP_MIN = "temp_min";
  static const String PARAM_TEMP_MAX = "temp_max";
  static const String PARAM_TEMP_MAIN = "temp_main";
  static const String PARAM_DESCRIPTION = "description";
  static const String PARAM_ICON = "icon";
  static const String PARAM_LIST = "list";
  static const String PARAM_CITY = "city";
  static const String PARAM_KEY = "key";
  static const String PARAM_INCDONE = "incdone";
  static const String PARAM_UPLOAD = "upload";
  static const String PARAM_CLEAR = "clear";
  static const String PARAM_COUNT = "count";
  static const String PARAM_WEATHER = "weather";
  static const String PARAM_STAT = "stat";
  static const String PARAM_STATE = "state";
  static const String PARAM_MULTI = "multi";
  static const String PARAM_DOWNLOAD = "download";
  static const String PARAM_WORKLINE = DBConst.TBL_WORKLINE;
  static const String PARAM_MIDINFO = "midinfo";
  static const String PARAM_VERIFY = "verify";
  static const String PARAM_PASSWD = "passwd";
  static const String PARAM_LOGOUT = "logout";
  static const String PARAM_LOGIN = "login";
  static const String PARAM_LOCALCURR = "localcurr";
  static const String PARAM_NOW = "now";
  static const String PARAM_TILLNOW = "tillnow";
  static const String PARAM_DATE = "date";
  static const String PARAM_PHONE = "phone";
  static const String PARAM_DESC = "desc";
  static const String PARAM_INFO = "info";
  static const String PARAM_MY = "my";
  static const String PARAM_API = "api";
  static const String PARAM_GEOCODE = "geocode";
  static const String PARAM_JSON = "json";
  static const String PARAM_STATUS = "status";
  static const String PARAM_NOTE = "note";
  static const String PARAM_INS = "ins";
  static const String PARAM_LAST = "last";
  static const String PARAM_EMP = "emp";
  static const String PARAM_BARCODE = "barcode";
  static const String PARAM_ACC = "acc";
  static const String PARAM_CONFIRM = "confirm";
  static const String PARAM_REJECT = "reject";
  static const String PARAM_TRANSLINE = "transline";
  static const String PARAM_TRANSLIST = "translist";
  static const String PARAM_AUTH = "auth";
  static const String PARAM_RACK = "rack";
  static const String PARAM_ACCLIST = "acclist";
  static const String PARAM_CALENDAR = "calendar";
  static const String PARAM_BADGE = "badge";
  static const String PARAM_GET = "get";
  static const String PARAM_DEF = "def";
  static const String PARAM_VIEW = "view";
  static const String PARAM_REFNO = "refno";
  static const String PARAM_SUPER = "super";
  static const String PARAM_SYNC = "sync";
  static const String PARAM_CHAINLIST = "chainlist";
  static const String PARAM_OODAY = "ooday";
  static const String PARAM_LINKED = "linked";
  static const String PARAM_ALL = "all";
  static const String PARAM_MAID = "maid";
  static const String PARAM_HASOPEN = "hasopen";
  static const String PARAM_TOUR = "tour";
  static const String PARAM_MENTIONS = "mentions";
  static const String PARAM_MAINSTORE = "mainstore";
  static const String PARAM_PROCESS = "process";
  static const String PARAM_SETZEROAMOUNT = "setzeroamount";
  static const String PARAM_SETWAYBILL = "setwaybill";
  static const String PARAM_GIFT = "gift";
  static const String PARAM_SENT = "sent";
  static const String PARAM_NETWORKCACHE = "network_cache";
  static const String PARAM_SURVEY = "survey";
  static const String PARAM_SCORE = "score";

  //Service Constants
  static const String PATH_SYNC = "/" + PARAM_SYNC;
  static const String PATH_GIFT = "/" + PARAM_GIFT;
  static const String PATH_SENT = "/" + PARAM_SENT;
  static const String PATH_VIEW = "/" + PARAM_VIEW;
  static const String PATH_REFNO = "/" + PARAM_REFNO;
  static const String PATH_SUPER = "/" + PARAM_SUPER;
  static const String PATH_DEF = "/" + PARAM_DEF;
  static const String PATH_LIST = "/" + PARAM_LIST;
  static const String PATH_GET = "/" + PARAM_GET;
  static const String PATH_BADGE = "/" + PARAM_BADGE;
  static const String PATH_CALENDAR = "/" + PARAM_CALENDAR;
  static const String PATH_VIEW_LIST = PATH_VIEW + PATH_LIST;
  static const String PATH_GIFT_LIST = PATH_GIFT + PATH_LIST;
  static const String PATH_GIFT_SENT = PATH_GIFT + PATH_SENT;
  static const String PATH_FORECAST_DAY =
      "/" + DBConst.TBL_RESERVAT + "/" + DBConst.FDN_FORECAST + "/" + DBConst.FDN_DAY;
  static const String PATH_TSTRANS_STAT_EMP = "/${DBConst.TBL_TSTRANS}/$PARAM_STAT/$PARAM_EMP";
  static const String PATH_REMINDER_STAT_EMP = "/${DBConst.TBL_REMINDER}/$PARAM_STAT/$PARAM_EMP";

  static const String PATH_REFNO_SUPER = PATH_REFNO + PATH_SUPER;
  static const String PATH_LIST_GET = PATH_LIST + PATH_GET;
  static const String PATH_VIEW_LIST_GET = PATH_VIEW_LIST + PATH_GET;
  static const String PATH_ACC = "/" + PARAM_ACC;
  static const String PATH_INS = "/" + PARAM_INS;
  static const String PATH_UPLOAD = "/" + PARAM_UPLOAD;
  static const String PATH_DOWNLOAD = "/" + PARAM_DOWNLOAD;
  static const String PATH_MULTI_UPLOAD = "/" + PARAM_MULTI + PARAM_UPLOAD;
  static const String PATH_ACCLIST = "/" + PARAM_ACCLIST;
  static const String PATH_RACK = "/" + PARAM_RACK;
  static const String PATH_AUTH = "/" + PARAM_AUTH;
  static const String PATH_TRANSLIST = "/" + PARAM_TRANSLIST;
  static const String PATH_TRANSLINE = "/" + PARAM_TRANSLINE;
  static const String PATH_REJECT = "/" + PARAM_REJECT;
  static const String PATH_CONFIRM = "/" + PARAM_CONFIRM;
  static const String PATH_BARCODE = "/" + PARAM_BARCODE;
  static const String DYNAMIC_PATH_BARCODE = "/{" + PARAM_BARCODE + "}";
  static const String DYNAMIC_PATH_FIELD = "/{" + PARAM_FIELD + "}";
  static const String DYNAMIC_PATH_FILENAME = "/{" + DBConst.FDN_TABLENAME + "}";
  static const String PATH_EMP_LAST = "/" + PARAM_EMP + "/" + PARAM_LAST;
  static const String PATH_NOTE = "/" + PARAM_NOTE;
  static const String PATH_STATUS = "/" + PARAM_STATUS;
  static const String DYNAMIC_PATH_STATUS_TYPE = "/" + "{" + DBConst.FDN_STATUS + "}";
  static const String PATH_MAID = "/" + PARAM_MAID;
  static const String PATH_MY = "/" + PARAM_MY;
  static const String PATH_INFO = "/" + PARAM_INFO;
  static const String PATH_PHONE_DESC = "/" + PARAM_PHONE + "/" + PARAM_DESC;
  static const String PATH_TOOLS_DATE = DBConst.FDN_TOOLS + "/" + PARAM_DATE;
  static const String PATH_NOW = "/" + PARAM_NOW;
  static const String PATH_TILLNOW = "/" + PARAM_TILLNOW;
  static const String PATH_API_GEOCODE_JSON = "/" + PARAM_API + "/" + PARAM_GEOCODE + "/" + PARAM_JSON;
  static const String PATH_TABLE_SECTION_KEY_PARAM =
      "/" + "{" + PARAM_TABLE + "}" + "/" + "{" + PARAM_SECTION + "}" + "/" + "{" + PARAM_KEY + "}";
  static const String PATH_SETT_LOCALCURR = "/" + PARAM_SETT + "/" + PARAM_LOCALCURR;
  static const String PATH_LOGIN = "/" + PARAM_LOGIN;
  static const String PATH_EMAIL_PARAM = "/" + "{" + DBConst.FDN_EMAIL + "}";
  static const String PATH_PASSWORD_PARAM = "/" + "{" + DBConst.FDN_PASSWORD + "}";
  static const String PATH_LOGOUT = "/" + PARAM_LOGOUT;
  static const String PATH_PASSWD = "/" + PARAM_PASSWD;
  static const String PATH_VERIFY = "/" + PARAM_VERIFY;
  static const String PATH_MIDINFO = "/" + PARAM_MIDINFO;
  static const String PATH_GID_PARAM = "/" + "{" + DBConst.FDN_GID + "}";
  static const String PATH_STAT = "/" + PARAM_STAT;
  static const String PATH_STATE = "/" + PARAM_STATE;
  static const String DYNAMIC_MASTERTABLE_PARAM = "{" + DBConst.FDN_MASTERTABLE + "}";
  static const String PATH_CLEAR = "/" + PARAM_CLEAR;
  static const String PATH_COUNT = "/" + PARAM_COUNT;
  static const String PATH_WORKLINE = "/" + PARAM_WORKLINE;
  static const String PATH_CHAINLIST = "/" + PARAM_CHAINLIST;
  static const String PATH_OODAY = "/" + PARAM_OODAY;
  static const String PATH_LINKED = "/" + PARAM_LINKED;
  static const String PATH_ISFOUND = "/" + DBConst.FDN_ISFOUND;
  static const String PATH_ISLOST = "/" + DBConst.FDN_ISLOST;
  static const String PATH_HISTORY = "/" + DBConst.FDN_HISTORY;
  static const String PATH_LINE = "/" + DBConst.FDN_LINE;
  static const String PATH_SYS_DB = DBConst.FDN_SYS + "/" + DBConst.FDN_DB;
  static const String PATH_SYS_DB_CODE = PATH_SYS_DB + "/" + DBConst.FDN_CODE;
  static const String PATH_MULTIFLDS = "/" + DBConst.FDN_MULTIFLDS;
  static const String PATH_ALL = "/" + PARAM_ALL;
  static const String PATH_VISIT_END = "/" + DBConst.FDN_VISITEND;
  static const String PATH_LAST_LOGIN = "/" + DBConst.FDN_LASTLOGIN;
  static const String PATH_FOLLOWUP = "/" + DBConst.FDN_FOLLOWUP;
  static const String PATH_FIELDS = "/" + DBConst.FDN_FIELDS;
  static const String PATH_PK = "/" + DBConst.FDN_PK;
  static const String PATH_HOTEL_LIST = "/" + DBConst.TBL_HOTEL + "/" + PARAM_LIST;
  static const String PATH_RESETCHK = "/" + DBConst.FDN_RESETCHK;
  static const String PATH_SEARCH = "/" + DBConst.FDN_SEARCH;
  static const String PATH_CAN = "/" + DBConst.FDN_CAN;
  static const String PATH_CASH = "/" + DBConst.FDN_CASH;
  static const String PATH_NOPE = "/" + DBConst.FDN_NOPE;
  static const String PATH_SHIFT = "/" + DBConst.FDN_SHIFT;
  static const String PATH_UPD = "/" + DBConst.FDN_UPD;
  static const String PATH_COPYTOST = "/" + DBConst.FDN_COPYTOST;
  static const String PATH_DEL = "/" + DBConst.FDN_DEL;
  static const String PATH_STORE = "/" + DBConst.FDN_STORE;
  static const String PATH_ITEM = "/" + DBConst.FDN_ITEM;
  static const String PATH_EMP = "/" + PARAM_EMP;
  static const String PATH_HASOPEN = "/" + PARAM_HASOPEN;
  static const String PATH_TOUR = "/" + PARAM_TOUR;
  static const String PATH_VIEW_MENTIONS = PATH_VIEW + "/" + PARAM_MENTIONS;
  static const String PATH_TASK = "/" + DBConst.FDN_TASK;
  static const String PATH_NOTIF = "/" + DBConst.FDN_NOTIF;
  static const String PATH_ST = "/" + PARAM_ST;
  static const String PATH_MAINSTORE = "/" + PARAM_MAINSTORE;
  static const String PATH_PROCESS = "/" + PARAM_PROCESS;
  static const String PATH_ISCLOSED = "/" + DBConst.FDN_ISCLOSED;
  static const String PATH_SETZEROAMOUNT = "/" + PARAM_SETZEROAMOUNT;
  static const String PATH_SETWAYBILL = "/" + PARAM_SETWAYBILL;
  static const String PATH_SURVEY_SCORE = "/" + PARAM_SCORE;

  static const String STR_GET = "GET";
  static const String STR_POST = "POST";

  static const int SUPER_HOTELREFNO = 999999;
  static const int HOTELREFNO_DEMO = 999984; //todo temp
  static const int HOTELMID_DEMO = 135363; //todo temp
  static const int XANADU_HOTELREFNO = 6023;
  //todo agency/view/list doesn't return anything when quering with id:6023 from non 999999 hotelrefno
  static const String XANADU_GID = "CB269A36-719A-4DD3-A2E0-8481A1005559";
  static const String HOTEL_DEMO_GID = "EA6EB310-5CE4-4106-AA7C-D9D67B1F7A66";
}

///
/// this class will include widget keys
///
class WidgetKeys {
  static const String WK_JUST_LOOKING_BUTTON = "justLookingButton";
  static const String WK_SIGN_IN_BUTTON = "signInButton";
  static const String WK_USERNAME_TV = "usernameTextview";
  static const String WK_EMAIL_TV = "emailTextview";
  static const String WK_PASSWORD_TV = "passwordTextview";
  static const String WK_MORE_BUTTON = "moreButton";
  static const String WK_LOGIN_BUTTON = "loginButton";
  static const String WK_ACTIVITY_BUTTON = "activityButton";
  static const String WK_NEARBY_TAB = "nearbyTab";
  static const String WK_HOTELEVENTS_TAB = "hoteleventsTab";
  static const String WK_WEEKLY_TAB = "weeklyTab";
  static const String WK_WEEKLY_CONTENT = "weeklyContent";
  static const String WK_SNACK_BAR = "snackBar";
  static const String WK_GIFTS_BUTTON = "giftButton";
  static const String WK_BACK_BUTTON = "backButton";
  static const String WK_FAQ_BUTTON = "faqButton";
  static const String WK_LOYALTY_CARD = "loyaltyCard";
  static const String SHOW_RECEIVED_GIFT = "showReceivedGifts";
  static const String WK_VIEW_ALL_BTN = "viewAllButton";
  static const String WK_HOTEL_INFO = "hotelInfoBottom";
  static const String WK_HOTEL_INFO_TITLE = "hotelInfoTitle";
  static const String WK_SLIDER_CARD = "sliderCard";
  static const String WK_HOTELINFO_LIST = "hotelInfoListKey";
  static const String WK_CARD_BTN = "cardButton";
  static const String WK_FAQ_SCREEN = "faqScreen";
  static const String WK_FAQ_HEADER = "faqHeaders";
  static const String WK_FAQ_LIST = "faqList";
  static const String WK_FAQ_CONTENT_ITEM = "faqItemContent";
}

///
/// this class will include only the DATABASE related constants
///
class DBConst {
  //Table Definitions
  static const String TBL_ABILITY = "ability";
  static const String TBL_ACCBL = "accbl";
  static const String TBL_ACCBLTYPE = "accbltype";
  static const String TBL_ACCDEPOSIT = "accdeposit";
  static const String TBL_ACCMASTER = "accmaster";
  static const String TBL_ACCSTATUS = "accstatus";
  static const String TBL_ACCTRANS = "acctrans";
  static const String TBL_ACTIONS = "actions";
  static const String TBL_AGENCY = "agency";
  static const String TBL_AGENCYCHAIN = "agencychain";
  static const String TBL_AGENCYLICENSE = "agencylicense";
  static const String TBL_AGENCYMESSAGE = "agencymessage";
  static const String TBL_AGENCYSTAT = "agencystat";
  static const String TBL_AGENCYSUB = "agencysub";
  static const String TBL_AGENCYTYPE = "agencytype";
  static const String TBL_AIRPORT = "airport";
  static const String TBL_AIRPORTHOTEL = "airporthotel";
  static const String TBL_AIRPORTRATE = "airportrate";
  static const String TBL_AIRPORTYPE = "airportype";
  static const String TBL_ALLBADGE = "allbadge";
  static const String TBL_ALLACC = "allacc";
  static const String TBL_ALLEMAIL = "allemail";
  static const String TBL_ALLPHONE = "allphone";
  static const String TBL_ALLOTCHT = "allotcht";
  static const String TBL_ALLOTMNT = "allotmnt";
  static const String TBL_APIAUTH = "apiauth";
  static const String TBL_APINAME = "apiname";
  static const String TBL_APIPROVIDER = "apiprovider";
  static const String TBL_APISCOPE = "apiscope";
  static const String TBL_APITABLE = "apitable";
  static const String TBL_APTALBRANCH = "aptalbranch";
  static const String TBL_APTALTERM = "aptalterm";
  static const String TBL_APTALUSER = "aptaluser";
  static const String TBL_APTAXWHCODE = "aptaxwhcode";
  static const String TBL_APTCARD = "aptcard";
  static const String TBL_APTCOMPANY = "aptcompany";
  static const String TBL_APTCOSTLOC = "aptcostloc";
  static const String TBL_APTCOSTLOCGRP = "aptcostlocgrp";
  static const String TBL_APTDEPSALEGRCODE = "aptdepsalegrcode";
  static const String TBL_APTEXCRATE = "aptexcrate";
  static const String TBL_APTFRAME = "aptframe";
  static const String TBL_APTGROUP = "aptgroup";
  static const String TBL_APTGRPITEM = "aptgrpitem";
  static const String TBL_APTGRPMAIN = "aptgrpmain";
  static const String TBL_APTLINE = "aptline";
  static const String TBL_APTPAYDATE = "aptpaydate";
  static const String TBL_APTPLAN = "aptplan";
  static const String TBL_APTRANS = "aptrans";
  static const String TBL_APTSGRCODE = "aptsgrcode";
  static const String TBL_APTTERM = "aptterm";
  static const String TBL_APTTERMACC = "apttermacc";
  static const String TBL_APTYPE = "aptype";
  static const String TBL_AUTHLOG = "authlog";
  static const String TBL_BANK = "bank";
  static const String TBL_BANKBIN = "bankbin";
  static const String TBL_BANKBRANCH = "bankbranch";
  static const String TBL_BANKCHQ = "bankchq";
  static const String TBL_BANKCHQLOG = "bankchqlog";
  static const String TBL_BANKNAME = "bankname";
  static const String TBL_BANKPOS = "bankpos";
  static const String TBL_BGEXCRATE = "bgexcrate";
  static const String TBL_BGFIELD = "bgfield";
  static const String TBL_BGITEM = "bgitem";
  static const String TBL_BGITEMDET = "bgitemdet";
  static const String TBL_BGITEMGROUP = "bgitemgroup";
  static const String TBL_BGITEMSTOCK = "bgitemstock";
  static const String TBL_BGLINE = "bgline";
  static const String TBL_BGMASTER = "bgmaster";
  static const String TBL_BGTYPE = "bgtype";
  static const String TBL_BGUSER = "bguser";
  static const String TBL_BGVALUE = "bgvalue";
  static const String TBL_BLREASON = "blreason";
  static const String TBL_BOARDTYPE = "boardtype";
  static const String TBL_BONUSCOUPON = "bonuscoupon";
  static const String TBL_BONUSLVL = "bonuslvl";
  static const String TBL_BONUSTPL = "bonustpl";
  static const String TBL_BONUSTPLDEP = "bonustpldep";
  static const String TBL_BONUSTPLINE = "bonustpline";
  static const String TBL_BONUSTPLROOMTYPE = "bonustplroomtype";
  static const String TBL_BONUSTPLTYPE = "bonustpltype";
  static const String TBL_BONUSTRANS = "bonustrans";
  static const String TBL_CALENDAR = "calendar";
  static const String TBL_CARD = "card";
  static const String TBL_CARDTYPE = "cardtype";
  static const String TBL_CARDVISITACC = "cardvisitacc";
  static const String TBL_CASHBOX = "cashbox";
  static const String TBL_CASHCOUNT = "cashcount";
  static const String TBL_CASHIFT = "cashift";
  static const String TBL_CASHIFTLOG = "cashiftlog";
  static const String TBL_CCARD = "ccard";
  static const String TBL_CCARDINST = "ccardinst";
  static const String TBL_CCNETWORK = "ccnetwork";
  static const String TBL_CCPAYTRANS = "ccpaytrans";
  static const String TBL_CCTYPE = "cctype";
  static const String TBL_CHDRATE = "chdrate";
  static const String TBL_CHDRTABLE = "chdrtable";
  static const String TBL_CITY = "city";
  static const String TBL_CLIENT = "client";
  static const String TBL_CLIENTGR = "clientgr";
  static const String TBL_CLIENTREM = "clientrem";
  static const String TBL_CLIENTREQ = "clientreq";
  static const String TBL_CLIENTREQTYPE = "clientreqtype";
  static const String TBL_CLIENTRFM = "clientrfm";
  static const String TBL_CLIENTSAL = "clientsal";
  static const String TBL_CLIENTSTAT = "clientstat";
  static const String TBL_CLNSCHBL = "clnschbl";
  static const String TBL_CLNTCOMM = "clntcomm";
  static const String TBL_CLNTJOB = "clntjob";
  static const String TBL_CLNTLIST = "clntlist";
  static const String TBL_CMSCONTENT = "cmscontent";
  static const String TBL_CMSCONTENTCAT = "cmscontentcat";
  static const String TBL_CMSGALLERY = "cmsgallery";
  static const String TBL_CMSGALLERYITEM = "cmsgalleryitem";
  static const String TBL_CMSLAYOUT = "cmslayout";
  static const String TBL_CMSLAYOUTACTION = "cmslayoutaction";
  static const String TBL_CMSLAYOUTBLOCK = "cmslayoutblock";
  static const String TBL_CMSLAYOUTBLPROP = "cmslayoutblprop";
  static const String TBL_CMSLAYOUTITEM = "cmslayoutitem";
  static const String TBL_CMSMENU = "cmsmenu";
  static const String TBL_CMSMENUPRIV = "cmsmenupriv";
  static const String TBL_CMSMODULE = "cmsmodule";
  static const String TBL_CMSMODULEPROP = "cmsmoduleprop";
  static const String TBL_CMSPOLL = "cmspoll";
  static const String TBL_CMSPOLLANSWER = "cmspollanswer";
  static const String TBL_CMSPOLLITEM = "cmspollitem";
  static const String TBL_CMSSLIDER = "cmsslider";
  static const String TBL_CMSSLIDERITEM = "cmsslideritem";
  static const String TBL_CMSTHEME = "cmstheme";
  static const String TBL_CMSTHEMESKIN = "cmsthemeskin";
  static const String TBL_CMSWIDGET = "cmswidget";
  static const String TBL_COMM = "comm";
  static const String TBL_COMMENTCAT = "commentcat";
  static const String TBL_COMMENTEMP = "commentemp";
  static const String TBL_COMMENTGRP = "commentgrp";
  static const String TBL_COMMENTLINE = "commentline";
  static const String TBL_COMMENTYPE = "commentype";
  static const String TBL_COMMLINEDET = "commlinedet";
  static const String TBL_COMPANY = "company";
  static const String TBL_COMPANYACC = "companyacc";
  static const String TBL_COMPET = "compet";
  static const String TBL_CONTACT = "contact";
  static const String TBL_CONTACTBL = "contactbl";
  static const String TBL_CONTACTYPE = "contactype";
  static const String TBL_CONTMASTER = "contmaster";
  static const String TBL_CONTRACT = "contract";
  static const String TBL_COUNTRY = "country";
  static const String TBL_CSHTRANS = "cshtrans";
  static const String TBL_CSHTROLD = "cshtrold";
  static const String TBL_CURRENCY = "currency";
  static const String TBL_CURRENCYQTY = "currencyqty";
  static const String TBL_DEPART = "depart";
  static const String TBL_DEPOSITYPE = "depositype";
  static const String TBL_DEPSTAT = "depstat";
  static const String TBL_DESCREPO = "descrepo";
  static const String TBL_DISTRICT = "district";
  static const String TBL_DMGCAT = "dmgcat";
  static const String TBL_DMGREASON = "dmgreason";
  static const String TBL_DMGTRANS = "dmgtrans";
  static const String TBL_DMGTYPE = "dmgtype";
  static const String TBL_DOCLOCATION = "doclocation";
  static const String TBL_DOCONTRACT = "docontract";
  static const String TBL_DOCSERIE = "docserie";
  static const String TBL_DOCSERIECHQ = "docseriechq";
  static const String TBL_DOCSTATUS = "docstatus";
  static const String TBL_DOCSTATUSLOG = "docstatuslog";
  static const String TBL_DOCTYPE = "doctype";
  static const String TBL_DOWINT = "dowint";
  static const String TBL_DUAL = "dual";
  static const String TBL_EDUTYPE = "edutype";
  static const String TBL_EINVSTATUSLOG = "einvstatuslog";
  static const String TBL_EMAILACN = "emailacn";
  static const String TBL_EMAILACNTRANS = "emailacntrans";
  static const String TBL_EMAILBOUNCE = "emailbounce";
  static const String TBL_EMAILGROUP = "emailgroup";
  static const String TBL_EMAILSEP = "emailsep";
  static const String TBL_EMAILTRACK = "emailtrack";
  static const String TBL_EMPABILITY = "empability";
  static const String TBL_EMPACC = "empacc";
  static const String TBL_EMPALNOTETYPE = "empalnotetype";
  static const String TBL_EMPAPTBRANCH = "empaptbranch";
  static const String TBL_EMPBRANCH = "empbranch";
  static const String TBL_EMPBRPOS = "empbrpos";
  static const String TBL_EMPCV = "empcv";
  static const String TBL_EMPCVAPR = "empcvapr";
  static const String TBL_EMPCVSTATUS = "empcvstatus";
  static const String TBL_EMPDEPART = "empdepart";
  static const String TBL_EMPEDU = "empedu";
  static const String TBL_EMPFRTRTYPE = "empfrtrtype";
  static const String TBL_EMPHOTEL = "emphotel";
  static const String TBL_EMPHOTELSUB = "emphotelsub";
  static const String TBL_EMPLANG = "emplang";
  static const String TBL_EMPLOYEE = "employee";
  static const String TBL_EMPPOS = "emppos";
  static const String TBL_EMPPOSLVL = "empposlvl";
  static const String TBL_EMPPOSABILITY = "empposability";
  static const String TBL_EMPPOSAPRORD = "empposaprord";
  static const String TBL_EMPPOSTASKPR = "emppostaskpr";
  static const String TBL_EMPREF = "empref";
  static const String TBL_EMPREFTYPE = "empreftype";
  static const String TBL_EMPSERV = "empserv";
  static const String TBL_EMPSHIFT = "empshift";
  static const String TBL_EMPSHIFTYPE = "empshiftype";
  static const String TBL_EMPWORK = "empwork";
  static const String TBL_EVENTANIMATION = "eventanimation";
  static const String TBL_EVENTDECOR = "eventdecor";
  static const String TBL_EVENTIME = "eventime";
  static const String TBL_EVENTLOC = "eventloc";
  static const String TBL_EVENTLOCPLAN = "eventlocplan";
  static const String TBL_EVENTMENU = "eventmenu";
  static const String TBL_EVENTMUSIC = "eventmusic";
  static const String TBL_EVENTYPE = "eventype";
  static const String TBL_EVENTYPELOC = "eventypeloc";
  static const String TBL_EVLOCGRP = "evlocgrp";
  static const String TBL_EVLOCSERV = "evlocserv";
  static const String TBL_EVRESRCLINE = "evresrcline";
  static const String TBL_EXRATES = "exrates";
  static const String TBL_EXRTYPE = "exrtype";
  static const String TBL_EXTRADISC = "extradisc";
  static const String TBL_FIELDCOLOR = "fieldcolor";
  static const String TBL_FINGROUP = "fingroup";
  static const String TBL_FINREQAPTLINE = "finreqaptline";
  static const String TBL_FINREQAUTHLOG = "finreqauthlog";
  static const String TBL_FINREQCASHAUTO = "finreqcashauto";
  static const String TBL_FINREQLINE = "finreqline";
  static const String TBL_FINREQTRANS = "finreqtrans";
  static const String TBL_FINTYPE = "fintype";
  static const String TBL_FLYTRANSFER = "flytransfer";
  static const String TBL_FOLIO = "folio";
  static const String TBL_FOLIOOLD = "folioold";
  static const String TBL_FOLIOPAX = "foliopax";
  static const String TBL_FOLIOSUB = "foliosub";
  static const String TBL_FOLTRANS = "foltrans";
  static const String TBL_FOLTREDIR = "foltredir";
  static const String TBL_FOLTRFERLOG = "foltrferlog";
  static const String TBL_FOLTRLINE = "foltrline";
  static const String TBL_FOLTROLD = "foltrold";
  static const String TBL_FRATEDET = "fratedet";
  static const String TBL_FTSTABLE = "ftstable";
  static const String TBL_GEOLOC = "geoloc";
  static const String TBL_GEOLOG = "geolog";
  static const String TBL_HCMCAT = "hcmcat";
  static const String TBL_HCMFACT = "hcmfact";
  static const String TBL_HCMFACTATTR = "hcmfactattr";
  static const String TBL_HCMIMGSIZE = "hcmimgsize";
  static const String TBL_HCMITEM = "hcmitem";
  static const String TBL_HCMITEMFACT = "hcmitemfact";
  static const String TBL_HCMITEMIMG = "hcmitemimg";
  static const String TBL_HCMITEMIMGSIZE = "hcmitemimgsize";
  static const String TBL_HCMITEMINS = "hcmitemins";
  static const String TBL_HCMITEMTXT = "hcmitemtxt";
  static const String TBL_HCMITEMTXTPAR = "hcmitemtxtpar";
  static const String TBL_HCMITEMVID = "hcmitemvid";
  static const String TBL_HCMITEMVIDSIZE = "hcmitemvidsize";
  static const String TBL_HCMTXTSEC = "hcmtxtsec";
  static const String TBL_HCMVIDSIZE = "hcmvidsize";
  static const String TBL_HOLIDAY = "holiday";
  static const String TBL_HOTEL = "hotel";
  static const String TBL_HOTELMODULE = "hotelmodule";
  static const String TBL_HOTELREG = "hotelreg";
  static const String TBL_HOTELREGLINE = "hotelregline";
  static const String TBL_HOTELTYPE = "hoteltype";
  static const String TBL_HSAGE = "hsage";
  static const String TBL_HSDEST = "hsdest";
  static const String TBL_HSDESTLINK = "hsdestlink";
  static const String TBL_HSPENDING = "hspending";
  static const String TBL_HSREASON = "hsreason";
  static const String TBL_HSVISITOR = "hsvisitor";
  static const String TBL_IDTYPE = "idtype";
  static const String TBL_INI = "ini";
  static const String TBL_INITABLE = "initable";
  static const String TBL_INTDOMWORK = "intdomwork";
  static const String TBL_INTLOG = "intlog";
  static const String TBL_INVETYPE = "invetype";
  static const String TBL_INVFOLTR = "invfoltr";
  static const String TBL_INVLINE = "invline";
  static const String TBL_INVLINEPAY = "invlinepay";
  static const String TBL_INVOICE = "invoice";
  static const String TBL_INVPRINT = "invprint";
  static const String TBL_INVXREASON = "invxreason";
  static const String TBL_LFSTATUS = "lfstatus";
  static const String TBL_LOCPLAN = "locplan";
  static const String TBL_LOCRESRAGENCY = "locresragency";
  static const String TBL_LOCRESRLOC = "locresrloc";
  static const String TBL_LOCRESRULE = "locresrule";
  static const String TBL_LOCTABLE = "loctable";
  static const String TBL_LOGINFO = "loginfo";
  static const String TBL_LOGTRANS = "logtrans";
  static const String TBL_LOGTRLINE = "logtrline";
  static const String TBL_LOSTFOUND = "lostfound";
  static const String TBL_LTPTASK = "ltptask";
  static const String TBL_LUDRIVER = "ludriver";
  static const String TBL_MAIDROOM = "maidroom";
  static const String TBL_MANSTDET = "manstdet";
  static const String TBL_MEDSTATUS = "medstatus";
  static const String TBL_MEDTRANS = "medtrans";
  static const String TBL_MEDTYPE = "medtype";
  static const String TBL_MEMCARD = "memcard";
  static const String TBL_MEMPERIOD = "memperiod";
  static const String TBL_MEMPOST = "mempost";
  static const String TBL_MEMSHIP = "memship";
  static const String TBL_MEMSHIPSTATUS = "memshipstatus";
  static const String TBL_MEMSHIPTYPE = "memshiptype";
  static const String TBL_MEMTIMETPL = "memtimetpl";
  static const String TBL_MERGELOG = "mergelog";
  static const String TBL_METFORM = "metform";
  static const String TBL_METFORMFLD = "metformfld";
  static const String TBL_METFORMTPL = "metformtpl";
  static const String TBL_METRANS = "metrans";
  static const String TBL_METRANSLINE = "metransline";
  static const String TBL_METYPE = "metype";
  static const String TBL_MSGBOX = "msgbox";
  static const String TBL_MSGEVENT = "msgevent";
  static const String TBL_MSGFILE = "msgfile";
  static const String TBL_MSGLOG = "msglog";
  static const String TBL_MSGSMTPLOG = "msgsmtplog";
  static const String TBL_MSGTEMPLATE = "msgtemplate";
  static const String TBL_MSGTEMPSQL = "msgtempsql";
  static const String TBL_NARCASHBOX = "narcashbox";
  static const String TBL_NAREPORT = "nareport";
  static const String TBL_NARFOLIO = "narfolio";
  static const String TBL_NARFORECAST = "narforecast";
  static const String TBL_NARSURVEY = "narsurvey";
  static const String TBL_NATION = "nation";
  static const String TBL_NOTECAT = "notecat";
  static const String TBL_NOTETYPE = "notetype";
  static const String TBL_NULLTBL = "nulltbl";
  static const String TBL_OCCUPANCYSTAT = "occupancystat";
  static const String TBL_OFFERLIC = "offerlic";
  static const String TBL_ORSEVENT = "orsevent";
  static const String TBL_ORSFORECAST = "orsforecast";
  static const String TBL_ORSGALLERY = "orsgallery";
  static const String TBL_ORSINBOX = "orsinbox";
  static const String TBL_ORSPAYMENT = "orspayment";
  static const String TBL_ORSRESERVAT = "orsreservat";
  static const String TBL_ORSRESMASTER = "orsresmaster";
  static const String TBL_ORSSTAT = "orsstat";
  static const String TBL_ORSTRANSFER = "orstransfer";
  static const String TBL_PAXTYPE = "paxtype";
  static const String TBL_PAUTH = "pauth";
  static const String TBL_PAUTHLINE = "pauthline";
  static const String TBL_PAYLESS = "payless";
  static const String TBL_PAYTYPE = "paytype";
  static const String TBL_PBOOK = "pbook";
  static const String TBL_PHONEDESC = "phonedesc";
  static const String TBL_POLIST = "polist";
  static const String TBL_POSLINE = "posline";
  static const String TBL_POSLNOLD = "poslnold";
  static const String TBL_POSMAIN = "posmain";
  static const String TBL_POSMNOLD = "posmnold";
  static const String TBL_POSPAX = "pospax";
  static const String TBL_POSPAYMENT = "pospayment";
  static const String TBL_POSPRODUCT = "posproduct";
  static const String TBL_POSPROPS = "posprops";
  static const String TBL_POSPROPSPRICE = "pospropsprice";
  static const String TBL_POSTATUS = "postatus";
  static const String TBL_POSXREASON = "posxreason";
  static const String TBL_PRVTYPE = "prvtype";
  static const String TBL_RACOLOR = "racolor";
  static const String TBL_RACOUNTER = "racounter";
  static const String TBL_RADICT = "radict";
  static const String TBL_RAEVENT = "raevent";
  static const String TBL_RAFILE = "rafile";
  static const String TBL_RAFILEPRIV = "rafilepriv";
  static const String TBL_RAFILESAVED = "rafilesaved";
  static const String TBL_RAFOLDER = "rafolder";
  static const String TBL_RAFORM = "raform";
  static const String TBL_RALANG = "ralang";
  static const String TBL_RAMISC = "ramisc";
  static const String TBL_RAMISCONF = "ramisconf";
  static const String TBL_RAMODULE = "ramodule";
  static const String TBL_RAMODULEGRP = "ramodulegrp";
  static const String TBL_RAMODULEPKG = "ramodulepkg";
  static const String TBL_RANOTE = "ranote";
  static const String TBL_RAPACKAGE = "rapackage";
  static const String TBL_RAPROJECT = "raproject";
  static const String TBL_RAPROP = "raprop";
  static const String TBL_RASESSION = "rasession";
  static const String TBL_RASESSIONLOG = "rasessionlog";
  static const String TBL_RASOURCE = "rasource";
  static const String TBL_RATAG = "ratag";
  static const String TBL_RATASK = "ratask";
  static const String TBL_RATASKLINK = "ratasklink";
  static const String TBL_RATASKLOG = "ratasklog";
  static const String TBL_RATEXT = "ratext";
  static const String TBL_RATIMEINFO = "ratimeinfo";
  static const String TBL_RAVOLUME = "ravolume";
  static const String TBL_RAXLOG = "raxlog";
  static const String TBL_RAXLOGMSG = "raxlogmsg";
  static const String TBL_RAXLUCODE = "raxlucode";
  static const String TBL_RAXLUFIELD = "raxlufield";
  static const String TBL_RAXLUTYPE = "raxlutype";
  static const String TBL_RAXSERVER = "raxserver";
  static const String TBL_RAXTRANS = "raxtrans";
  static const String TBL_RBLOCK = "rblock";
  static const String TBL_RCREASON = "rcreason";
  static const String TBL_REGIONLOC = "regionloc";
  static const String TBL_RELSHIP = "relship";
  static const String TBL_RELSHTYPE = "relshtype";
  static const String TBL_REMARK = "remark";
  static const String TBL_REMARKGR = "remarkgr";
  static const String TBL_REMINDER = "reminder";
  static const String TBL_REMINDERSTAT = "reminderstat";
  static const String TBL_RESACTION = "resaction";
  static const String TBL_RESBACKDISC = "resbackdisc";
  static const String TBL_RESBACKDISCLINE = "resbackdiscline";
  static const String TBL_RESBREAK = "resbreak";
  static const String TBL_RESBREAKLINE = "resbreakline";
  static const String TBL_RESCHD = "reschd";
  static const String TBL_RESCLIENTGRP = "resclientgrp";
  static const String TBL_RESDAYS = "resdays";
  static const String TBL_RESDEFINIT = "resdefinit";
  static const String TBL_RESEASON = "reseason";
  static const String TBL_RESEASONTYPE = "reseasontype";
  static const String TBL_RESERVAT = "reservat";
  static const String TBL_RESEVENT = "resevent";
  static const String TBL_RESEVENTLOC = "reseventloc";
  static const String TBL_RESEVENTMASTER = "reseventmaster";
  static const String TBL_RESFORLOG = "resforlog";
  static const String TBL_RESGROUP = "resgroup";
  static const String TBL_RESINDUSTRY = "resindustry";
  static const String TBL_RESIREASON = "resireason";
  static const String TBL_RESIREASONLIST = "resireasonlist";
  static const String TBL_RESMARCOUNTRY = "resmarcountry";
  static const String TBL_RESMARKET = "resmarket";
  static const String TBL_RESMARKETCAT = "resmarketcat";
  static const String TBL_RESMASTER = "resmaster";
  static const String TBL_RESNAME = "resname";
  static const String TBL_RESOREASON = "resoreason";
  static const String TBL_RESOREASONLIST = "resoreasonlist";
  static const String TBL_RESPAYTRANS = "respaytrans";
  static const String TBL_RESRATE = "resrate";
  static const String TBL_RESSEGMENT = "ressegment";
  static const String TBL_RESSEGMENTCAT = "ressegmentcat";
  static const String TBL_RESSOURCE = "ressource";
  static const String TBL_RESSOURCECAT = "ressourcecat";
  static const String TBL_RESTYPE = "restype";
  static const String TBL_RESXACC = "resxacc";
  static const String TBL_RESXREASON = "resxreason";
  static const String TBL_RESXREASONLIST = "resxreasonlist";
  static const String TBL_REVCAT = "revcat";
  static const String TBL_REVPORCAT = "revporcat";
  static const String TBL_REVPORCATRANS = "revporcatrans";
  static const String TBL_REVPORHOTEL = "revporhotel";
  static const String TBL_REVPORTAL = "revportal";
  static const String TBL_REVPORTRANS = "revportrans";
  static const String TBL_REVTRANS = "revtrans";
  static const String TBL_RFLOOR = "rfloor";
  static const String TBL_RFMLIMIT = "rfmlimit";
  static const String TBL_ROOM = "room";
  static const String TBL_ROOMATTR = "roomattr";
  static const String TBL_ROOMBT = "roombt";
  static const String TBL_ROOMCHNG = "roomchng";
  static const String TBL_ROOMHK = "roomhk";
  static const String TBL_ROOMHKEMP = "roomhkemp";
  static const String TBL_ROOMHKLOC = "roomhkloc";
  static const String TBL_ROOMHKTASK = "roomhktask";
  static const String TBL_ROOMPLAN = "roomplan";
  static const String TBL_ROOMPAXRATE = "roompaxrate";
  static const String TBL_ROOMPROP = "roomprop";
  static const String TBL_ROOMQUE = "roomque";
  static const String TBL_ROOMRACK = "roomrack";
  static const String TBL_ROOMRATE = "roomrate";
  static const String TBL_ROOMSHARE = "roomshare";
  static const String TBL_ROOMST = "roomst";
  static const String TBL_ROOMTYPE = "roomtype";
  static const String TBL_ROOMTYPEGRP = "roomtypegrp";
  static const String TBL_RPTMAIL = "rptmail";
  static const String TBL_RPTMAILFILES = "rptmailfiles";
  static const String TBL_RPTMAILJOB = "rptmailjob";
  static const String TBL_RPTMAILRECEIVERS = "rptmailreceivers";
  static const String TBL_RSTOPSALE = "rstopsale";
  static const String TBL_SALECALL = "salecall";
  static const String TBL_SALEDISC = "saledisc";
  static const String TBL_SALEGRP = "salegrp";
  static const String TBL_SALEPACK = "salepack";
  static const String TBL_SALEPACKLINE = "salepackline";
  static const String TBL_SALEPIPE = "salepipe";
  static const String TBL_SALEPIPECNT = "salepipecnt";
  static const String TBL_SALEPIPECET = "salepipecet";
  static const String TBL_SALEPIPEMP = "salepipemp";
  static const String TBL_SALEPIPERES = "salepiperes";
  static const String TBL_SALEREASON = "salereason";
  static const String TBL_SALESTAGE = "salestage";
  static const String TBL_SASSET = "sasset";
  static const String TBL_SASSETCHK = "sassetchk";
  static const String TBL_SASSETEMPLOG = "sassetemplog";
  static const String TBL_SASSETGRP = "sassetgrp";
  static const String TBL_SASSETSTLOG = "sassetstlog";
  static const String TBL_SBALANCE = "sbalance";
  static const String TBL_SBALOLD = "sbalold";
  static const String TBL_SBARCODE = "sbarcode";
  static const String TBL_SBRAND = "sbrand";
  static const String TBL_SCONTLINE = "scontline";
  static const String TBL_SCONTRACT = "scontract";
  static const String TBL_SCOUNT = "scount";
  static const String TBL_SCOUNTQTY = "scountqty";
  static const String TBL_SCPERIOD = "scperiod";
  static const String TBL_SEARCHFIELDS = "searchfields";
  static const String TBL_SGROUP = "sgroup";
  static const String TBL_SITEMBRAND = "sitembrand";
  static const String TBL_SITEMS = "sitems";
  static const String TBL_SMINMAX = "sminmax";
  static const String TBL_SPGROUP = "spgroup";
  static const String TBL_SPRLINES = "sprlines";
  static const String TBL_SPRMENUDEPART = "sprmenudepart";
  static const String TBL_SPRMENUITEM = "sprmenuitem";
  static const String TBL_SPRMENUSET = "sprmenuset";
  static const String TBL_SPRMENUTREE = "sprmenutree";
  static const String TBL_SPRODUCT = "sproduct";
  static const String TBL_SPROPERTY = "sproperty";
  static const String TBL_SPROPS = "sprops";
  static const String TBL_SPRSTORE = "sprstore";
  static const String TBL_SPSALEDISC = "spsaledisc";
  static const String TBL_SPSPRICE = "spsprice";
  static const String TBL_SPTLINE = "sptline";
  static const String TBL_SPTLNOLD = "sptlnold";
  static const String TBL_SPTRANS = "sptrans";
  static const String TBL_SPTRNOLD = "sptrnold";
  static const String TBL_SPTYPE = "sptype";
  static const String TBL_SQLOG = "sqlog";
  static const String TBL_SQTY = "sqty";
  static const String TBL_SQTYRATIO = "sqtyratio";
  static const String TBL_SSFUNCAT = "ssfuncat";
  static const String TBL_SSFUNCTION = "ssfunction";
  static const String TBL_STATS = "stats";
  static const String TBL_STHALERTLOG = "sthalertlog";
  static const String TBL_STHAUTHLOG = "sthauthlog";
  static const String TBL_STHELPER = "sthelper";
  static const String TBL_STHLINK = "sthlink";
  static const String TBL_STHLPLINE = "sthlpline";
  static const String TBL_STHSUPPLIER = "sthsupplier";
  static const String TBL_STHTRACE = "sthtrace";
  static const String TBL_STLINE = "stline";
  static const String TBL_STLINEPAY = "stlinepay";
  static const String TBL_STLNOLD = "stlnold";
  static const String TBL_STORE = "store";
  static const String TBL_STRECEIPTTYPE = "streceipttype";
  static const String TBL_STTRANS = "sttrans";
  static const String TBL_STTRNOLD = "sttrnold";
  static const String TBL_SUPPLIER = "supplier";
  static const String TBL_SUPPSGROUP = "suppsgroup";
  static const String TBL_SUREVPORTRANS = "surevportrans";
  static const String TBL_SURVEY = "survey";
  static const String TBL_SURVEYANSWER = "surveyanswer";
  static const String TBL_SURVEYLOC = "surveyloc";
  static const String TBL_SURVEYSET = "surveyset";
  static const String TBL_SURVEYSETQS = "surveysetqs";
  static const String TBL_SURVEYTRANS = "surveytrans";
  static const String TBL_SURVEYTREE = "surveytree";
  static const String TBL_SURVEYTYP = "surveytyp";
  static const String TBL_SYNCDEV = "syncdev";
  static const String TBL_SYNCDEVLOG = "syncdevlog";
  static const String TBL_SYNCLOG = "synclog";
  static const String TBL_SYNCLOCALOG = "synclocalog";
  static const String TBL_SYNCLOCAL = "synclocal";
  static const String TBL_SYS = "sys";
  static const String TBL_SYSDBFIELD = "sysdbfield";
  static const String TBL_TASKINST = "taskinst";
  static const String TBL_TASKINSTHIDE = "taskinsthide";
  static const String TBL_TASKINSTLINE = "taskinstline";
  static const String TBL_TASKLINK = "tasklink";
  static const String TBL_TASKRATING = "taskrating";
  static const String TBL_TASKSTAT = "taskstat";
  static const String TBL_TASKTYPE = "tasktype";
  static const String TBL_TAXOFFICE = "taxoffice";
  static const String TBL_TAXRATE = "taxrate";
  static const String TBL_TAXTYPE = "taxtype";
  static const String TBL_TERRITORY = "territory";
  static const String TBL_TIMESHARE = "timeshare";
  static const String TBL_TOWN = "town";
  static const String TBL_TRACELOG = "tracelog";
  static const String TBL_TRANSTYPE = "transtype";
  static const String TBL_TSCATEGORY = "tscategory";
  static const String TBL_TSDESC = "tsdesc";
  static const String TBL_TSDESCSOL = "tsdescsol";
  static const String TBL_TSLINE = "tsline";
  static const String TBL_TSLOCATION = "tslocation";
  static const String TBL_TSNOTIWAY = "tsnotiway";
  static const String TBL_TSOLTYPE = "tsoltype";
  static const String TBL_TSOLUTION = "tsolution";
  static const String TBL_TSOUTSRV = "tsoutsrv";
  static const String TBL_TSPRIORITY = "tspriority";
  static const String TBL_TSREASON = "tsreason";
  static const String TBL_TSSOURCE = "tssource";
  static const String TBL_TSSREASON = "tssreason";
  static const String TBL_TSSTATUS = "tsstatus";
  static const String TBL_TSTASK = "tstask";
  static const String TBL_TSTRANS = "tstrans";
  static const String TBL_TSTRANSOL = "tstransol";
  static const String TBL_TSTRANSSQL = "tstranssql";
  static const String TBL_TSTYPE = "tstype";
  static const String TBL_TSTYPEMP = "tstypemp";
  static const String TBL_TTSSLOG = "ttsslog";
  static const String TBL_TTLOG = "ttlog";
  static const String TBL_UACCESS = "uaccess";
  static const String TBL_USERAL = "useral";
  static const String TBL_USERDEPART = "userdepart";
  static const String TBL_USERFAV = "userfav";
  static const String TBL_USERGROUP = "usergroup";
  static const String TBL_USERINBOX = "userinbox";
  static const String TBL_USERINBOXLOG = "userinboxlog";
  static const String TBL_USERINBOXRULE = "userinboxrule";
  static const String TBL_USERINBOXSTAT = "userinboxstat";
  static const String TBL_USERMENU = "usermenu";
  static const String TBL_USERRAXTRANS = "userraxtrans";
  static const String TBL_USERSIGN = "usersign";
  static const String TBL_USERSTORE = "userstore";
  static const String TBL_VEHICLE = "vehicle";
  static const String TBL_VEHICLETYPE = "vehicletype";
  static const String TBL_VISIT = "visit";
  static const String TBL_VISITGATE = "visitgate";
  static const String TBL_VISITLINE = "visitline";
  static const String TBL_VISITTYPE = "visittype";
  static const String TBL_WAKEUP = "wakeup";
  static const String TBL_WAKEUPDAY = "wakeupday";
  static const String TBL_WORKLINE = "workline";
  static const String TBL_WORKTYPE = "worktype";

  //Those are all the fields defined in our DB
  static const String FDN__NEW = "_new";
  static const String FDN_ABILITY = "ability";
  static const String FDN_ABILITYCODE = "abilitycode";
  static const String FDN_ABILITYDESC = "abilitydesc";
  static const String FDN_ABILITYID = "abilityid";
  static const String FDN_ABILITYLEVEL = "abilitylevel";
  static const String FDN_ACC = "acc";
  static const String FDN_ACCBALANCE = "accbalance";
  static const String FDN_ACCBANK = "accbank";
  static const String FDN_ACCBANKBRANCH = "accbankbranch";
  static const String FDN_ACCBANKBRANCHID = "accbankbranchid";
  static const String FDN_ACCBANKBRANCHNAME = "accbankbranchname";
  static const String FDN_ACCBANKNAME = "accbankname";
  static const String FDN_ACCBLTYPECODE = "accbltypecode";
  static const String FDN_ACCBLTYPEDESC = "accbltypedesc";
  static const String FDN_ACCBLTYPEID = "accbltypeid";
  static const String FDN_ACCCODE = "acccode";
  static const String FDN_ACCCODELIST = "acccodelist";
  static const String FDN_ACCCONTACT = "acccontact";
  static const String FDN_ACCDESC = "accdesc";
  static const String FDN_ACCEPTLEVEL = "acceptlevel";
  static const String FDN_ACCESS_TOKEN = "access_token";
  static const String FDN_ACCESSTOKEN = "accesstoken";
  static const String FDN_ACCIBAN = "acciban";
  static const String FDN_ACCID = "accid";
  static const String FDN_ACCISACTIVE = "accisactive";
  static const String FDN_ACCLEVEL = "acclevel";
  static const String FDN_ACCMASTERID = "accmasterid";
  static const String FDN_ACCMID = "accmid";
  static const String FDN_ACCNAME = "accname";
  static const String FDN_ACCNAMELIST = "accnamelist";
  static const String FDN_ACCNO = "accno";
  static const String FDN_ACCOUNTING = "accounting";
  static const String FDN_ACCOUNTNO = "accountno";
  static const String FDN_ACCOUNTNONEXPIRED = "accountnonexpired";
  static const String FDN_ACCOUNTNONLOCKED = "accountnonlocked";
  static const String FDN_ACCPLANCODE = "accplancode";
  static const String FDN_ACCSHORT = "accshort";
  static const String FDN_ACCSTATUS = "accstatus";
  static const String FDN_ACCSTATUSCODE = "accstatuscode";
  static const String FDN_ACCSTATUSDESC = "accstatusdesc";
  static const String FDN_ACCSTATUSID = "accstatusid";
  static const String FDN_ACCTABLE = "acctable";
  static const String FDN_ACCTAXNO = "acctaxno";
  static const String FDN_ACCTAXNUMBER = "acctaxnumber";
  static const String FDN_ACCTAXOFFICE = "acctaxoffice";
  static const String FDN_ACCTRANSNO = "acctransno";
  static const String FDN_ACCTYPE = "acctype";
  static const String FDN_ACCTYPEDESC = "acctypedesc";
  static const String FDN_ACCVISITCALL = "accvisitcall";
  static const String FDN_ACCVISITCALLLASTYEARLY = "accvisitcalllastyearly";
  static const String FDN_ACCVISITCALLMONTHLY = "accvisitcallmonthly";
  static const String FDN_ACCVISITCALLWEEKLY = "accvisitcallweekly";
  static const String FDN_ACCVISITCALLYEARLY = "accvisitcallyearly";
  static const String FDN_ACTBALANCE = "actbalance";
  static const String FDN_ACTIONCODE = "actioncode";
  static const String FDN_ACTIONDAY = "actionday";
  static const String FDN_ACTIONID = "actionid";
  static const String FDN_ACTIONSTOTAL = "actionstotal";
  static const String FDN_ACTIONSTR = "actionstr";
  static const String FDN_ACTIONTYPE = "actiontype";
  static const String FDN_ACTIVERATE = "activerate";
  static const String FDN_ACTUALBGAMOUNT = "actualbgamount";
  static const String FDN_ACTUALBGAMOUNTCURR = "actualbgamountcurr";
  static const String FDN_ACTUALBGTAXTOTAL = "actualbgtaxtotal";
  static const String FDN_ACTUALBGTAXTOTALCURR = "actualbgtaxtotalcurr";
  static const String FDN_ACTUALDATE = "actualdate";
  static const String FDN_ACTUALFINISH = "actualfinish";
  static const String FDN_ACTUALSTART = "actualstart";
  static const String FDN_ADATE = "adate";
  static const String FDN_ADATESTR = "adatestr";
  static const String FDN_ADATETIME = "adatetime";
  static const String FDN_ADAY = "aday";
  static const String FDN_ADAYSTR = "adaystr";
  static const String FDN_ADDRESS = "address";
  static const String FDN_ADDRESS1 = "address1";
  static const String FDN_ADDRESS2 = "address2";
  static const String FDN_ADDRESSTXT = "addresstxt";
  static const String FDN_ADDTEXT = "addtext";
  static const String FDN_ADVPAYAMOUNT = "advpayamount";
  static const String FDN_ADVPAYCURR = "advpaycurr";
  static const String FDN_ADVPAYCURRCODE = "advpaycurrcode";
  static const String FDN_ADVPAYCURRDESC = "advpaycurrdesc";
  static const String FDN_ADVPAYCURRID = "advpaycurrid";
  static const String FDN_ADVPAYDATE = "advpaydate";
  static const String FDN_ADVPAYNOTE = "advpaynote";
  static const String FDN_ADVPAYTYPE = "advpaytype";
  static const String FDN_AFTERHTML = "afterhtml";
  static const String FDN_AGE = "age";
  static const String FDN_AGECAT = "agecat";
  static const String FDN_AGECODE = "agecode";
  static const String FDN_AGEID = "ageid";
  static const String FDN_AGENCY = "agency";
  static const String FDN_AGENCYCODE = "agencycode";
  static const String FDN_AGENCYDESC = "agencydesc";
  static const String FDN_AGENCYDISCRATE = "agencydiscrate";
  static const String FDN_AGENCYEMAIL = "agencyemail";
  static const String FDN_AGENCYFAX = "agencyfax";
  static const String FDN_AGENCYGID = "agencygid";
  static const String FDN_AGENCYID = "agencyid";
  static const String FDN_AGENCYINVTITLE = "agencyinvtitle";
  static const String FDN_AGENCYISACTIVE = "agencyisactive";
  static const String FDN_AGENCYMID = "agencymid";
  static const String FDN_AGENCYMOBILETEL = "agencymobiletel";
  static const String FDN_AGENCYNOTE = "agencynote";
  static const String FDN_AGENCYOB = "agencyob";
  static const String FDN_AGENCYOBRTYPE = "agencyobrtype";
  static const String FDN_AGENCYSUB = "agencysub";
  static const String FDN_AGENCYSUBCODE = "agencysubcode";
  static const String FDN_AGENCYSUBDESC = "agencysubdesc";
  static const String FDN_AGENCYSUBID = "agencysubid";
  static const String FDN_AGENCYTEL = "agencytel";
  static const String FDN_AGENCYTEL2 = "agencytel2";
  static const String FDN_AGENCYTOTAL = "agencytotal";
  static const String FDN_AGENCYTYPE = "agencytype";
  static const String FDN_AGENCYTYPECODE = "agencytypecode";
  static const String FDN_AGENCYTYPEDESC = "agencytypedesc";
  static const String FDN_AGENCYTYPEID = "agencytypeid";
  static const String FDN_AGENCYWEB = "agencyweb";
  static const String FDN_AGERATE = "agerate";
  static const String FDN_AGESTR = "agestr";
  static const String FDN_AGEYEAR = "ageyear";
  static const String FDN_AHOUR = "ahour";
  static const String FDN_AI = "ai";
  static const String FDN_AIDIFF = "aidiff";
  static const String FDN_AIRATIO = "airatio";
  static const String FDN_AIRLINE = "airline";
  static const String FDN_AIRPORT = "airport";
  static const String FDN_AIRPORTCODE = "airportcode";
  static const String FDN_AIRPORTDESC = "airportdesc";
  static const String FDN_AIRPORTID = "airportid";
  static const String FDN_ALERTDATE = "alertdate";
  static const String FDN_ALIAS = "alias";
  static const String FDN_ALIGN = "align";
  static const String FDN_ALLHOTELS = "allhotels";
  static const String FDN_ALLLEVELS = "alllevels";
  static const String FDN_ALLOTLEFT = "allotleft";
  static const String FDN_ALLOTMENT = "allotment";
  static const String FDN_ALLOTTOTAL = "allottotal";
  static const String FDN_ALLOTTYPE = "allottype";
  static const String FDN_ALLOWANCETOTAL = "allowancetotal";
  static const String FDN_ALLOWENCEPERCENT = "allowencepercent";
  static const String FDN_ALLOWENCETOTAL = "allowencetotal";
  static const String FDN_AMILLISECOND = "amillisecond";
  static const String FDN_AMIN = "amin";
  static const String FDN_AMINUTE = "aminute";
  static const String FDN_AMONREFNO = "amonrefno";
  static const String FDN_AMONTH = "amonth";
  static const String FDN_AMOUNT = "amount";
  static const String FDN_AMOUNT_AVGDAY = "amount_avgday";
  static const String FDN_AMOUNT_TURNOVER = "amount_turnover";
  static const String FDN_AMOUNTHOMECURR = "amounthomecurr";
  static const String FDN_ANIMCAKECODE = "animcakecode";
  static const String FDN_ANIMCAKEID = "animcakeid";
  static const String FDN_ANIMCAKENOTE = "animcakenote";
  static const String FDN_ANIMFIRSTDANCECODE = "animfirstdancecode";
  static const String FDN_ANIMFIRSTDANCEID = "animfirstdanceid";
  static const String FDN_ANIMFIRSTDANCENOTE = "animfirstdancenote";
  static const String FDN_ANIMINTROCODE = "animintrocode";
  static const String FDN_ANIMINTROID = "animintroid";
  static const String FDN_ANIMINTRONOTE = "animintronote";
  static const String FDN_ANIMNOTE = "animnote";
  static const String FDN_ANSDESC = "ansdesc";
  static const String FDN_ANSWER = "answer";
  static const String FDN_ANSWERALIGN = "answeralign";
  static const String FDN_ANSWERCOUNT = "answercount";
  static const String FDN_ANSWERDESC = "answerdesc";
  static const String FDN_ANSWERID = "answerid";
  static const String FDN_ANSWERPERCENT = "answerpercent";
  static const String FDN_ANSWERNOTE = "answernote";
  static const String FDN_ANSWER_NOTE = "answer_note";
  static const String FDN_APIKEY = "apikey";
  static const String FDN_APIPASS = "apipass";
  static const String FDN_APIURL = "apiurl";
  static const String FDN_APIUSER = "apiuser";
  static const String FDN_APP = "app";
  static const String FDN_APPDOC = "appdoc";
  static const String FDN_APPDOMAIN = "appdomain";
  static const String FDN_APPFULLTITLE = "appfulltitle";
  static const String FDN_APPLYONSTAY = "applyonstay";
  static const String FDN_APPNAME = "appname";
  static const String FDN_APPSEC = "appsec";
  static const String FDN_APPTITLE = "apptitle";
  static const String FDN_APPVER = "appver";
  static const String FDN_APP_NAME = "app_name";
  static const String FDN_APPURL = "appurl";
  static const String FDN_APRATE = "aprate";
  static const String FDN_APRDATETIME = "aprdatetime";
  static const String FDN_APRDEP = "aprdep";
  static const String FDN_APRDEPID = "aprdepid";
  static const String FDN_APREMPID = "aprempid";
  static const String FDN_APREMPNAME = "aprempname";
  static const String FDN_APREMPPOSID = "aprempposid";
  static const String FDN_APRLEVEL = "aprlevel";
  static const String FDN_APRNOTE = "aprnote";
  static const String FDN_APRPOS = "aprpos";
  static const String FDN_APRPOSCODE = "aprposcode";
  static const String FDN_APRPOSDESC = "aprposdesc";
  static const String FDN_APRPOSID = "aprposid";
  static const String FDN_APRSALARY = "aprsalary";
  static const String FDN_APRSTARTDATE = "aprstartdate";
  static const String FDN_APTBALANCEDCHECK = "aptbalancedcheck";
  static const String FDN_APTBALANCEDCTYPE = "aptbalancedctype";
  static const String FDN_APTCODE = "aptcode";
  static const String FDN_APTCODEPFX = "aptcodepfx";
  static const String FDN_APTDCHECK = "aptdcheck";
  static const String FDN_APTDCTYPE = "aptdctype";
  static const String FDN_APTDESC = "aptdesc";
  static const String FDN_APTFRAMECODE = "aptframecode";
  static const String FDN_APTFRAMEDESC = "aptframedesc";
  static const String FDN_APTFRAMEID = "aptframeid";
  static const String FDN_APTFULLDESC = "aptfulldesc";
  static const String FDN_APTGROUPCODE = "aptgroupcode";
  static const String FDN_APTGROUPDESC = "aptgroupdesc";
  static const String FDN_APTGROUPID = "aptgroupid";
  static const String FDN_APTID = "aptid";
  static const String FDN_APTLINEID = "aptlineid";
  static const String FDN_APTRANSNO = "aptransno";
  static const String FDN_APTYPECODE = "aptypecode";
  static const String FDN_APTYPEDESC = "aptypedesc";
  static const String FDN_APTYPEID = "aptypeid";
  static const String FDN_ASECOND = "asecond";
  static const String FDN_ASSETAMOUNT = "assetamount";
  static const String FDN_ASSETCODE = "assetcode";
  static const String FDN_ASSETDESC = "assetdesc";
  static const String FDN_ASSETGROUP = "assetgroup";
  static const String FDN_ASSETGROUPDESC = "assetgroupdesc";
  static const String FDN_ASSETGROUPID = "assetgroupid";
  static const String FDN_ASSETID = "assetid";
  static const String FDN_ASSETTYPE = "assettype";
  static const String FDN_ASSETTYPECODE = "assettypecode";
  static const String FDN_ASSETTYPEDESC = "assettypedesc";
  static const String FDN_ASSETTYPEID = "assettypeid";
  static const String FDN_ASSETTYPENAME = "assettypename";
  static const String FDN_ASSETYEAR = "assetyear";
  static const String FDN_ASSIGNCOUNT = "assigncount";
  static const String FDN_ATIME = "atime";
  static const String FDN_ATIMESTR = "atimestr";
  static const String FDN_ATTDURMIN = "attdurmin";
  static const String FDN_ATTID = "attid";
  static const String FDN_ATTNAME = "attname";
  static const String FDN_ATTPID = "attpid";
  static const String FDN_ATTREMADDRESS = "attremaddress";
  static const String FDN_ATTREMOTEPID = "attremotepid";
  static const String FDN_ATTREMPID = "attrempid";
  static const String FDN_ATTREMPROCESS = "attremprocess";
  static const String FDN_ATTREMPROTOCOL = "attremprotocol";
  static const String FDN_ATTRNAME = "attrname";
  static const String FDN_ATTRVAL = "attrval";
  static const String FDN_ATTSERVERPID = "attserverpid";
  static const String FDN_ATTSTARTDT = "attstartdt";
  static const String FDN_ATTUSER = "attuser";
  static const String FDN_ATTUSERNAME = "attusername";
  static const String FDN_AUDITOR = "auditor";
  static const String FDN_AUDITORCODE = "auditorcode";
  static const String FDN_AUDITORDESC = "auditordesc";
  static const String FDN_AUDITORID = "auditorid";
  static const String FDN_AUTH = "auth";
  static const String FDN_AUTH00_TRANSDATE = "auth00_transdate";
  static const String FDN_AUTH00_TRANSTIME = "auth00_transtime";
  static const String FDN_AUTH00_USERCODE = "auth00_usercode";
  static const String FDN_AUTH00_USERID = "auth00_userid";
  static const String FDN_AUTH00_USERNAME = "auth00_username";
  static const String FDN_AUTH01_TRANSDATE = "auth01_transdate";
  static const String FDN_AUTH01_TRANSTIME = "auth01_transtime";
  static const String FDN_AUTH01_USERCODE = "auth01_usercode";
  static const String FDN_AUTH01_USERID = "auth01_userid";
  static const String FDN_AUTH01_USERNAME = "auth01_username";
  static const String FDN_AUTH02_TRANSDATE = "auth02_transdate";
  static const String FDN_AUTH02_TRANSTIME = "auth02_transtime";
  static const String FDN_AUTH02_USERCODE = "auth02_usercode";
  static const String FDN_AUTH02_USERID = "auth02_userid";
  static const String FDN_AUTH02_USERNAME = "auth02_username";
  static const String FDN_AUTH03_TRANSDATE = "auth03_transdate";
  static const String FDN_AUTH03_TRANSTIME = "auth03_transtime";
  static const String FDN_AUTH03_USERCODE = "auth03_usercode";
  static const String FDN_AUTH03_USERID = "auth03_userid";
  static const String FDN_AUTH03_USERNAME = "auth03_username";
  static const String FDN_AUTH04_TRANSDATE = "auth04_transdate";
  static const String FDN_AUTH04_TRANSTIME = "auth04_transtime";
  static const String FDN_AUTH04_USERCODE = "auth04_usercode";
  static const String FDN_AUTH04_USERID = "auth04_userid";
  static const String FDN_AUTH04_USERNAME = "auth04_username";
  static const String FDN_AUTH05_TRANSDATE = "auth05_transdate";
  static const String FDN_AUTH05_TRANSTIME = "auth05_transtime";
  static const String FDN_AUTH05_USERCODE = "auth05_usercode";
  static const String FDN_AUTH05_USERID = "auth05_userid";
  static const String FDN_AUTH05_USERNAME = "auth05_username";
  static const String FDN_AUTH06_TRANSDATE = "auth06_transdate";
  static const String FDN_AUTH06_TRANSTIME = "auth06_transtime";
  static const String FDN_AUTH06_USERCODE = "auth06_usercode";
  static const String FDN_AUTH06_USERID = "auth06_userid";
  static const String FDN_AUTH06_USERNAME = "auth06_username";
  static const String FDN_AUTH07_TRANSDATE = "auth07_transdate";
  static const String FDN_AUTH07_TRANSTIME = "auth07_transtime";
  static const String FDN_AUTH07_USERCODE = "auth07_usercode";
  static const String FDN_AUTH07_USERID = "auth07_userid";
  static const String FDN_AUTH07_USERNAME = "auth07_username";
  static const String FDN_AUTH08_TRANSDATE = "auth08_transdate";
  static const String FDN_AUTH08_TRANSTIME = "auth08_transtime";
  static const String FDN_AUTH08_USERCODE = "auth08_usercode";
  static const String FDN_AUTH08_USERID = "auth08_userid";
  static const String FDN_AUTH08_USERNAME = "auth08_username";
  static const String FDN_AUTH09_TRANSDATE = "auth09_transdate";
  static const String FDN_AUTH09_TRANSTIME = "auth09_transtime";
  static const String FDN_AUTH09_USERCODE = "auth09_usercode";
  static const String FDN_AUTH09_USERID = "auth09_userid";
  static const String FDN_AUTH09_USERNAME = "auth09_username";
  static const String FDN_AUTHCODE = "authcode";
  static const String FDN_AUTHCOUNT = "authcount";
  static const String FDN_AUTHDATE = "authdate";
  static const String FDN_AUTHID = "authid";
  static const String FDN_AUTHLEVEL = "authlevel";
  static const String FDN_AUTHLEVELFR = "authlevelfr";
  static const String FDN_AUTHLEVELSO = "authlevelso";
  static const String FDN_AUTHLEVELSR = "authlevelsr";
  static const String FDN_AUTHNAME = "authname";
  static const String FDN_AUTHNO = "authno";
  static const String FDN_AUTHORITIES = "authorities";
  static const String FDN_AUTHTIME = "authtime";
  static const String FDN_AUTHUSER = "authuser";
  static const String FDN_AUTHUSERDEPART = "authuserdepart";
  static const String FDN_AUTHUSERDEPARTNAME = "authuserdepartname";
  static const String FDN_AUTHUSERLEVEL = "authuserlevel";
  static const String FDN_AUTHUSERNAME = "authusername";
  static const String FDN_AUTHUSERPOS = "authuserpos";
  static const String FDN_AUTOLOAD = "autoload";
  static const String FDN_AUTOPOSTTOTAL = "autoposttotal";
  static const String FDN_AUTOSAVE = "autosave";
  static const String FDN_AUTOSENDINTERVAL = "autosendinterval";
  static const String FDN_AUTOSENDTYPE = "autosendtype";
  static const String FDN_AVAIL = "avail";
  static const String FDN_AVGCOST = "avgcost";
  static const String FDN_AVGDAY = "avgday";
  static const String FDN_AVGEXTRA = "avgextra";
  static const String FDN_AVGMONTH = "avgmonth";
  static const String FDN_AVGPRICE = "avgprice";
  static const String FDN_AVGPRICECOST = "avgpricecost";
  static const String FDN_AVGPRICECOSTTAXED = "avgpricecosttaxed";
  static const String FDN_AVGRATE = "avgrate";
  static const String FDN_AVGRATING = "avgrating";
  static const String FDN_AVGYEAR = "avgyear";
  static const String FDN_AWEEK = "aweek";
  static const String FDN_AWEEKSTART = "aweekstart";
  static const String FDN_AYEAR = "ayear";
  static const String FDN_BABY = "baby";
  static const String FDN_BABYAGE = "babyage";
  static const String FDN_BABYRATE = "babyrate";
  static const String FDN_BABYTEXT = "babytext";
  static const String FDN_BACKCASHBOX = "backcashbox";
  static const String FDN_BACKCOLOR = "backcolor";
  static const String FDN_BACKDISCAMOUNT = "backdiscamount";
  static const String FDN_BACKDISCRATE = "backdiscrate";
  static const String FDN_BACKDISCREFCODE = "backdiscrefcode";
  static const String FDN_BACKDISCSOURCE = "backdiscsource";
  static const String FDN_BACKDISCTOTAL = "backdisctotal";
  static const String FDN_BACKUPSTATE = "backupstate";
  static const String FDN_BALANCE = "balance";
  static const String FDN_BALANCE0 = "balance0";
  static const String FDN_BALANCE1 = "balance1";
  static const String FDN_BALANCE2 = "balance2";
  static const String FDN_BALANCE3 = "balance3";
  static const String FDN_BALANCE4 = "balance4";
  static const String FDN_BALANCE5 = "balance5";
  static const String FDN_BALANCEAMOUNT = "balanceamount";
  static const String FDN_BALANCECOST = "balancecost";
  static const String FDN_BALANCEDCALLPERCENTLASTYEARLY = "balancedcallpercentlastyearly";
  static const String FDN_BALANCEDCALLPERCENTMONTHLY = "balancedcallpercentmonthly";
  static const String FDN_BALANCEDCALLPERCENTWEEKLY = "balancedcallpercentweekly";
  static const String FDN_BALANCEDCALLPERCENTYEARLY = "balancedcallpercentyearly";
  static const String FDN_BALANCEDHOTELLASTYEARLY = "balancedhotellastyearly";
  static const String FDN_BALANCEDHOTELMONTHLY = "balancedhotelmonthly";
  static const String FDN_BALANCEDHOTELWEEKLY = "balancedhotelweekly";
  static const String FDN_BALANCEDHOTELYEARLY = "balancedhotelyearly";
  static const String FDN_BALANCEHOMECURR = "balancehomecurr";
  static const String FDN_BALANCELASTYEARLY = "balancelastyearly";
  static const String FDN_BALANCEMONTHLY = "balancemonthly";
  static const String FDN_BALANCEOK = "balanceok";
  static const String FDN_BALANCEPAYOFF = "balancepayoff";
  static const String FDN_BALANCETOTAL = "balancetotal";
  static const String FDN_BALANCEVISIT = "balancevisit";
  static const String FDN_BALANCEVISITMIN = "balancevisitmin";
  static const String FDN_BALANCEWEEKLY = "balanceweekly";
  static const String FDN_BALANCEYEARLY = "balanceyearly";
  static const String FDN_BALANCE_AMOUNT = "balance_amount";
  static const String FDN_BALANCE_TOTAL = "balance_total";
  static const String FDN_BALANCE_TRANS_TOTAL = "balance_trans_total";
  static const String FDN_BALANCEVALUE = "balancevalue";
  static const String FDN_BALTARGETTOTAL = "baltargettotal";
  static const String FDN_BALTOTALCURR = "baltotalcurr";
  static const String FDN_BANK = "bank";
  static const String FDN_BANKACCCODE = "bankacccode";
  static const String FDN_BANKACCDESC = "bankaccdesc";
  static const String FDN_BANKACCID = "bankaccid";
  static const String FDN_BANKACCNO = "bankaccno";
  static const String FDN_BANKBRANCH = "bankbranch";
  static const String FDN_BANKBRANCHCODE = "bankbranchcode";
  static const String FDN_BANKBRANCHDESC = "bankbranchdesc";
  static const String FDN_BANKBRANCHID = "bankbranchid";
  static const String FDN_BANKBRANCHMAPCODE = "bankbranchmapcode";
  static const String FDN_BANKBRANCHNAME = "bankbranchname";
  static const String FDN_BANKCHQID = "bankchqid";
  static const String FDN_BANKCLIENTID = "bankclientid";
  static const String FDN_BANKCODE = "bankcode";
  static const String FDN_BANKCOLL = "bankcoll";
  static const String FDN_BANKDESC = "bankdesc";
  static const String FDN_BANKIBAN = "bankiban";
  static const String FDN_BANKID = "bankid";
  static const String FDN_BANKNAME = "bankname";
  static const String FDN_BANKNAMECODE = "banknamecode";
  static const String FDN_BANKNAMEDESC = "banknamedesc";
  static const String FDN_BANKNAMEID = "banknameid";
  static const String FDN_BANKPOSID = "bankposid";
  static const String FDN_BANKTRANSNO = "banktransno";
  static const String FDN_BANKUSERID = "bankuserid";
  static const String FDN_BANQUESTRES = "banquestres";
  static const String FDN_BARCODE = "barcode";
  static const String FDN_BASEGRPCODE = "basegrpcode";
  static const String FDN_BASEGRPDESC = "basegrpdesc";
  static const String FDN_BASEGRPID = "basegrpid";
  static const String FDN_BASEQTY = "baseqty";
  static const String FDN_BASEQTYID = "baseqtyid";
  static const String FDN_BB = "bb";
  static const String FDN_BBDIFF = "bbdiff";
  static const String FDN_BBRATIO = "bbratio";
  static const String FDN_BDAY = "bday";
  static const String FDN_BEDNIGHT = "bednight";
  static const String FDN_BEDPAX = "bedpax";
  static const String FDN_BEDRESNIGHT = "bedresnight";
  static const String FDN_BEDTYPE = "bedtype";
  static const String FDN_BEDTYPEID = "bedtypeid";
  static const String FDN_BEFOREHTML = "beforehtml";
  static const String FDN_BEVCOST = "bevcost";
  static const String FDN_BEVERAGE = "beverage";
  static const String FDN_BEVREV = "bevrev";
  static const String FDN_BEVSTORE = "bevstore";
  static const String FDN_BEVSTORECODE = "bevstorecode";
  static const String FDN_BEVSTOREDESC = "bevstoredesc";
  static const String FDN_BEVSTOREID = "bevstoreid";
  static const String FDN_BEVTOTAL = "bevtotal";
  static const String FDN_BGBALANCE = "bgbalance";
  static const String FDN_BGBALANCECURR = "bgbalancecurr";
  static const String FDN_BGBALANCETAXTOTAL = "bgbalancetaxtotal";
  static const String FDN_BGBALANCETAXTOTALCURR = "bgbalancetaxtotalcurr";
  static const String FDN_BGCODE = "bgcode";
  static const String FDN_BGCODELIST = "bgcodelist";
  static const String FDN_BGCOLOR = "bgcolor";
  static const String FDN_BGDESC = "bgdesc";
  static const String FDN_BGDESCRIPTION = "bgdescription";
  static const String FDN_BGFIELD = "bgfield";
  static const String FDN_BGID = "bgid";
  static const String FDN_BGITEM = "bgitem";
  static const String FDN_BGITEMCODE = "bgitemcode";
  static const String FDN_BGITEMDESC = "bgitemdesc";
  static const String FDN_BGITEMGROUP = "bgitemgroup";
  static const String FDN_BGITEMGROUPDESC = "bgitemgroupdesc";
  static const String FDN_BGITEMGROUPID = "bgitemgroupid";
  static const String FDN_BGITEMID = "bgitemid";
  static const String FDN_BGLINEAMOUNT = "bglineamount";
  static const String FDN_BGLINEAMOUNTCURR = "bglineamountcurr";
  static const String FDN_BGLINECODE = "bglinecode";
  static const String FDN_BGLINEID = "bglineid";
  static const String FDN_BGMASTER = "bgmaster";
  static const String FDN_BGMASTERDESC = "bgmasterdesc";
  static const String FDN_BGPER = "bgper";
  static const String FDN_BGREVAMOUNT = "bgrevamount";
  static const String FDN_BGREVAMOUNTCURR = "bgrevamountcurr";
  static const String FDN_BGREVTAXTOTAL = "bgrevtaxtotal";
  static const String FDN_BGREVTAXTOTALCURR = "bgrevtaxtotalcurr";
  static const String FDN_BGSTDTYPE = "bgstdtype";
  static const String FDN_BGTYPE = "bgtype";
  static const String FDN_BGTYPECODE = "bgtypecode";
  static const String FDN_BGTYPEDESC = "bgtypedesc";
  static const String FDN_BGTYPEID = "bgtypeid";
  static const String FDN_BINCODE = "bincode";
  static const String FDN_BIRIM = "birim";
  static const String FDN_BIRTHAGE = "birthage";
  static const String FDN_BIRTHDATE = "birthdate";
  static const String FDN_BIRTHDAY = "birthday";
  static const String FDN_BIRTHPLACE = "birthplace";
  static const String FDN_BLHTACTHTPERCENTLASTYEARLY = "blhtacthtpercentlastyearly";
  static const String FDN_BLHTACTHTPERCENTMONTHLY = "blhtacthtpercentmonthly";
  static const String FDN_BLHTACTHTPERCENTWEEKLY = "blhtacthtpercentweekly";
  static const String FDN_BLHTACTHTPERCENTYEARLY = "blhtacthtpercentyearly";
  static const String FDN_BLOCKCODE = "blockcode";
  static const String FDN_BLOCKDESC = "blockdesc";
  static const String FDN_BLOCKID = "blockid";
  static const String FDN_BLOODGRP = "bloodgrp";
  static const String FDN_BLREASON = "blreason";
  static const String FDN_BLREASONCODE = "blreasoncode";
  static const String FDN_BLREASONDESC = "blreasondesc";
  static const String FDN_BLREASONID = "blreasonid";
  static const String FDN_BLREASONTYPE = "blreasontype";
  static const String FDN_BLREASONTYPEDESC = "blreasontypedesc";
  static const String FDN_BMONTH = "bmonth";
  static const String FDN_BOARD = "board";
  static const String FDN_BOARDCURR = "boardcurr";
  static const String FDN_BOARDEXCRATEOK = "boardexcrateok";
  static const String FDN_BOARDINCLUDED = "boardincluded";
  static const String FDN_BOARDPAYMENT = "boardpayment";
  static const String FDN_BOARDRATE = "boardrate";
  static const String FDN_BOARDRATEHOMECURR = "boardratehomecurr";
  static const String FDN_BOARDREV = "boardrev";
  static const String FDN_BOARDREVCURR = "boardrevcurr";
  static const String FDN_BOARDREVENUE = "boardrevenue";
  static const String FDN_BOARDREVENUEABG = "boardrevenueabg";
  static const String FDN_BOARDREVENUECURR = "boardrevenuecurr";
  static const String FDN_BOARDREVENUEFT = "boardrevenueft";
  static const String FDN_BOARDREVENUEFTCURR = "boardrevenueftcurr";
  static const String FDN_BOARDREVENUEHC = "boardrevenuehc";
  static const String FDN_BOARDREVNET = "boardrevnet";
  static const String FDN_BOARDTYPE = "boardtype";
  static const String FDN_BONDCOLL = "bondcoll";
  static const String FDN_BONDPAY = "bondpay";
  static const String FDN_BONUSAMOUNT = "bonusamount";
  static const String FDN_BONUSEXPIRED = "bonusexpired";
  static const String FDN_BONUSFIELD = "bonusfield";
  static const String FDN_BONUSGAINED = "bonusgained";
  static const String FDN_BONUSGAINER = "bonusgainer";
  static const String FDN_BONUSGAINERDESC = "bonusgainerdesc";
  static const String FDN_BONUSHOMECURR = "bonushomecurr";
  static const String FDN_BONUSKEYFIELD = "bonuskeyfield";
  static const String FDN_BONUSLEFT = "bonusleft";
  static const String FDN_BONUSLEVEL = "bonuslevel";
  static const String FDN_BONUSMIN = "bonusmin";
  static const String FDN_BONUSRATE = "bonusrate";
  static const String FDN_BONUSREQ = "bonusreq";
  static const String FDN_BONUSTABLE = "bonustable";
  static const String FDN_BONUSTDTYPE = "bonustdtype";
  static const String FDN_BONUSTDTYPEDESC = "bonustdtypedesc";
  static const String FDN_BONUSTOTAL = "bonustotal";
  static const String FDN_BONUSTPLCODE = "bonustplcode";
  static const String FDN_BONUSTPLDESC = "bonustpldesc";
  static const String FDN_BONUSTPLID = "bonustplid";
  static const String FDN_BONUSTYPE = "bonustype";
  static const String FDN_BONUSTYPEDESC = "bonustypedesc";
  static const String FDN_BONUSUSED = "bonusused";
  static const String FDN_BOOKEDCIOSTR = "bookedciostr";
  static const String FDN_BOOKEDCLIENTID = "bookedclientid";
  static const String FDN_BOOKEDCLIENTMID = "bookedclientmid";
  static const String FDN_BOOKEDCLIENTNAME = "bookedclientname";
  static const String FDN_BOOKEDRESERVNO = "bookedreservno";
  static const String FDN_BOOKEDRTYPE = "bookedrtype";
  static const String FDN_BOOKEDRTYPEID = "bookedrtypeid";
  static const String FDN_BOOKEDRTYPEPRICE = "bookedrtypeprice";
  static const String FDN_BOOKEDTOTALPAX = "bookedtotalpax";
  static const String FDN_BOOKERACCTYPE = "bookeracctype";
  static const String FDN_BOOKERCODE = "bookercode";
  static const String FDN_BOOKEDRTYPECODE = "bookedrtypecode";
  static const String FDN_BOOKEDRTYPEDESC = "bookedrtypedesc";
  static const String FDN_BOOKERID = "bookerid";
  static const String FDN_BOOKERNAME = "bookername";
  static const String FDN_BOOKLEVEL = "booklevel";
  static const String FDN_BOOKSTATE = "bookstate";
  static const String FDN_BOOLINTFIELD = "boolintfield";
  static const String FDN_BOOLSTRFIELD = "boolstrfield";
  static const String FDN_BRANCH = "branch";
  static const String FDN_BRANCHCODE = "branchcode";
  static const String FDN_BRANCHDESC = "branchdesc";
  static const String FDN_BRANCHID = "branchid";
  static const String FDN_BRANCHNAME = "branchname";
  static const String FDN_BRANDNAME = "brandname";
  static const String FDN_BRANDNAMECODE = "brandnamecode";
  static const String FDN_BRANDNAMEDESC = "brandnamedesc";
  static const String FDN_BRANDNAMEID = "brandnameid";
  static const String FDN_BRANDNAMES = "brandnames";
  static const String FDN_BREAKDATE = "breakdate";
  static const String FDN_BRIDECLIENTID = "brideclientid";
  static const String FDN_BRIDENAME = "bridename";
  static const String FDN_BROWSERDESC = "browserdesc";
  static const String FDN_BULKROOM = "bulkroom";
  static const String FDN_BULKROOMDISC = "bulkroomdisc";
  static const String FDN_BUYAPTCODE = "buyaptcode";
  static const String FDN_BUYBACKAPTCODE = "buybackaptcode";
  static const String FDN_BUYITEMCODE = "buyitemcode";
  static const String FDN_BVAL = "bval";
  static const String FDN_BYEAR = "byear";
  static const String FDN_CALAMOUNT = "calamount";
  static const String FDN_CALCRULE = "calcrule";
  static const String FDN_CALDAY = "calday";
  static const String FDN_CALIBDAY = "calibday";
  static const String FDN_CALIBPERIODTYPE = "calibperiodtype";
  static const String FDN_CALLEDNUMBER = "callednumber";
  static const String FDN_CALLERID = "callerid";
  static const String FDN_CALLINK = "callink";
  static const String FDN_CALMONTH = "calmonth";
  static const String FDN_CALOFFDAY = "caloffday";
  static const String FDN_CALWEEK = "calweek";
  static const String FDN_CALWORKDAY = "calworkday";
  static const String FDN_CALYEAR = "calyear";
  static const String FDN_CAMPAING = "campaing";
  static const String FDN_CAN = "can";
  static const String FDN_CANACCESS = "canaccess";
  static const String FDN_CANBOOK = "canbook";
  static const String FDN_CANCELDATE = "canceldate";
  static const String FDN_CANCELDT = "canceldt";
  static const String FDN_CANCELMUSER = "cancelmuser";
  static const String FDN_CANCELNAME = "cancelname";
  static const String FDN_CANCELNOTE = "cancelnote";
  static const String FDN_CANCELTIME = "canceltime";
  static const String FDN_CANCELUSER = "canceluser";
  static const String FDN_CANCELUSERCODE = "cancelusercode";
  static const String FDN_CANCELUSERID = "canceluserid";
  static const String FDN_CANCELUSERNAME = "cancelusername";
  static const String FDN_CANCI = "canci";
  static const String FDN_CANCOMMENT = "cancomment";
  static const String FDN_CANDELETE = "candelete";
  static const String FDN_CANDESIGN = "candesign";
  static const String FDN_CANEDIT = "canedit";
  static const String FDN_CANONLINESALE = "canonlinesale";
  static const String FDN_CANOPEN = "canopen";
  static const String FDN_CAPACITY = "capacity";
  static const String FDN_CAPTION = "caption";
  static const String FDN_CARDCOUNT = "cardcount";
  static const String FDN_CARDHOLDER = "cardholder";
  static const String FDN_CARDID = "cardid";
  static const String FDN_CARDNO = "cardno";
  static const String FDN_CARDNOMASK = "cardnomask";
  static const String FDN_CARDTYPE = "cardtype";
  static const String FDN_CARDTYPEBONUSMIN = "cardtypebonusmin";
  static const String FDN_CARDTYPECODE = "cardtypecode";
  static const String FDN_CARDTYPEDESC = "cardtypedesc";
  static const String FDN_CARDTYPEID = "cardtypeid";
  static const String FDN_CARDTYPEISEXT = "cardtypeisext";
  static const String FDN_CARDTYPEISSTD = "cardtypeisstd";
  static const String FDN_CASESENSITIVE = "casesensitive";
  static const String FDN_CASH = "cash";
  static const String FDN_CASHBEV = "cashbev";
  static const String FDN_CASHBOX = "cashbox";
  static const String FDN_CASHBOXACCPLANCODE = "cashboxaccplancode";
  static const String FDN_CASHBOXCODE = "cashboxcode";
  static const String FDN_CASHBOXDESC = "cashboxdesc";
  static const String FDN_CASHBOXID = "cashboxid";
  static const String FDN_CASHBOXPLANCODE = "cashboxplancode";
  static const String FDN_CASHCOLL = "cashcoll";
  static const String FDN_CASHFOOD = "cashfood";
  static const String FDN_CASHIFTCODE = "cashiftcode";
  static const String FDN_CASHIFTDESC = "cashiftdesc";
  static const String FDN_CASHIFTID = "cashiftid";
  static const String FDN_CASHINSTANT = "cashinstant";
  static const String FDN_CASHNONFB = "cashnonfb";
  static const String FDN_CASHPAY = "cashpay";
  static const String FDN_CASHPAYMENT = "cashpayment";
  static const String FDN_CASHTOTAL = "cashtotal";
  static const String FDN_CASHTYPE = "cashtype";
  static const String FDN_CATALOGREV = "catalogrev";
  static const String FDN_CATCODE = "catcode";
  static const String FDN_CATCODELIST = "catcodelist";
  static const String FDN_CATDESC = "catdesc";
  static const String FDN_CATEGORY = "category";
  static const String FDN_CATEGORIES = "categories";
  static const String FDN_CATEGORYCODE = "categorycode";
  static const String FDN_CATEGORYID = "categoryid";
  static const String FDN_CATEGORYINENG = "categoryineng";
  static const String FDN_CATID = "catid";
  static const String FDN_CATPARENTID = "catparentid";
  static const String FDN_CBCURR = "cbcurr";
  static const String FDN_CBLINK = "cblink";
  static const String FDN_CCACCPLANCODE = "ccaccplancode";
  static const String FDN_CCARDDESC = "ccarddesc";
  static const String FDN_CCINSTID = "ccinstid";
  static const String FDN_CCINTRATE = "ccintrate";
  static const String FDN_CCNETCODE = "ccnetcode";
  static const String FDN_CCNETDESC = "ccnetdesc";
  static const String FDN_CCNETID = "ccnetid";
  static const String FDN_CCTYPE = "cctype";
  static const String FDN_CCTYPECODE = "cctypecode";
  static const String FDN_CCTYPEDESC = "cctypedesc";
  static const String FDN_CCTYPEID = "cctypeid";
  static const String FDN_CELLTYPE = "celltype";
  static const String FDN_CENTCODE = "centcode";
  static const String FDN_CENTDESCRIPTION = "centdescription";
  static const String FDN_CHAINCODE = "chaincode";
  static const String FDN_CHAINID = "chainid";
  static const String FDN_CHANGE = "change";
  static const String FDN_CHARGEAMOUNT = "chargeamount";
  static const String FDN_CHARSETID = "charsetid";
  static const String FDN_CHARTCOLOR = "chartcolor";
  static const String FDN_CHARTHEIGHT = "chartheight";
  static const String FDN_CHARTSTYLE = "chartstyle";
  static const String FDN_CHARTVISIBLE = "chartvisible";
  static const String FDN_CHARTWIDTH = "chartwidth";
  static const String FDN_CHD1AGE = "chd1age";
  static const String FDN_CHD2AGE = "chd2age";
  static const String FDN_CHD2SUPP = "chd2supp";
  static const String FDN_CHDAGE = "chdage";
  static const String FDN_CHDAGECAT = "chdagecat";
  static const String FDN_CHDBOARDDISC = "chdboarddisc";
  static const String FDN_CHDDISC = "chddisc";
  static const String FDN_CHDNO = "chdno";
  static const String FDN_CHDRATE = "chdrate";
  static const String FDN_CHDRATEID = "chdrateid";
  static const String FDN_CHDTABLERATE = "chdtablerate";
  static const String FDN_CHECKIN = "checkin";
  static const String FDN_CHECKEDURL = "checkedUrl";
  static const String FDN_CHECKINNOTE = "checkinnote";
  static const String FDN_CHECKINOK = "checkinok";
  static const String FDN_CHECKLIMIT = "checklimit";
  static const String FDN_CHECKONCE = "checkonce";
  static const String FDN_CHECKOUT = "checkout";
  static const String FDN_CHECKOUTDAY = "checkoutday";
  static const String FDN_CHECKOUTMONTH = "checkoutmonth";
  static const String FDN_CHECKOUTNOTE = "checkoutnote";
  static const String FDN_CHECKOUTYEAR = "checkoutyear";
  static const String FDN_CHECKSMTP = "checksmtp";
  static const String FDN_CHEQUECOLL = "chequecoll";
  static const String FDN_CHEQUEPAY = "chequepay";
  static const String FDN_CHILD = "child";
  static const String FDN_CHILD1 = "child1";
  static const String FDN_CHILD2 = "child2";
  static const String FDN_CHILD2RATE = "child2rate";
  static const String FDN_CHILD2TEXT = "child2text";
  static const String FDN_CHILDRATE = "childrate";
  static const String FDN_CHILDTEXT = "childtext";
  static const String FDN_CHQSTATUS = "chqstatus";
  static const String FDN_CHQSTATUSDESC = "chqstatusdesc";
  static const String FDN_CHQTYPE = "chqtype";
  static const String FDN_CHQTYPEDESC = "chqtypedesc";
  static const String FDN_CIBABY = "cibaby";
  static const String FDN_CICHD = "cichd";
  static const String FDN_CICHD1 = "cichd1";
  static const String FDN_CICHD2 = "cichd2";
  static const String FDN_CIDAY = "ciday";
  static const String FDN_CIMONTH = "cimonth";
  static const String FDN_CIOSTR = "ciostr";
  static const String FDN_CIPAX = "cipax";
  static const String FDN_CIROOM = "ciroom";
  static const String FDN_CISTR = "cistr";
  static const String FDN_CITIME = "citime";
  static const String FDN_CITY = "city";
  static const String FDN_CITYCODE = "citycode";
  static const String FDN_CITYDESC = "citydesc";
  static const String FDN_CITYID = "cityid";
  static const String FDN_CIYEAR = "ciyear";
  static const String FDN_CLASSNAME = "classname";
  static const String FDN_CLEARTRK = "cleartrk";
  static const String FDN_CLIENT = "client";
  static const String FDN_CLIENTAGE = "clientage";
  static const String FDN_CLIENTBONUSTOTAL = "clientbonustotal";
  static const String FDN_CLIENTCODE = "clientcode";
  static const String FDN_CLIENTCOUNT = "clientcount";
  static const String FDN_CLIENTEMAILRATE = "clientemailrate";
  static const String FDN_CLIENTEMPGENDER = "clientempgender";
  static const String FDN_CLIENTEVENTEMPID = "clienteventempid";
  static const String FDN_CLIENTFIRSTNAME = "clientfirstname";
  static const String FDN_CLIENTFOLIONO = "clientfoliono";
  static const String FDN_CLIENTGRCODE = "clientgrcode";
  static const String FDN_CLIENTGRID = "clientgrid";
  static const String FDN_CLIENTGRISBLACK = "clientgrisblack";
  static const String FDN_CLIENTGRISVIP = "clientgrisvip";
  static const String FDN_CLIENTGRNAME = "clientgrname";
  static const String FDN_CLIENTGRNEEDWARN = "clientgrneedwarn";
  static const String FDN_CLIENTGROUP = "clientgroup";
  static const String FDN_CLIENTGROUPID = "clientgroupid";
  static const String FDN_CLIENTHOTELNAME = "clienthotelname";
  static const String FDN_CLIENTHOTELREFNO = "clienthotelrefno";
  static const String FDN_CLIENTID = "clientid";
  static const String FDN_CLIENT_ID = "client_id";
  static const String FDN_CLIENTLASTNAME = "clientlastname";
  static const String FDN_CLIENTLEVEL = "clientlevel";
  static const String FDN_CLIENTMID = "clientmid";
  static const String FDN_CLIENTNAME = "clientname";
  static const String FDN_CLIENTPASS = "clientpass";
  static const String FDN_CLIENTPUBRATE = "clientpubrate";
  static const String FDN_CLIENTREFID = "clientrefid";
  static const String FDN_CLIENTREFCODE = "clientrefcode";
  static const String FDN_CLIENTSALEEMPID = "clientsaleempid";
  static const String FDN_CLIENT_SECRET = "client_secret";
  static const String FDN_CLIENTTYPE = "clienttype";
  static const String FDN_CLIENTYPE = "clientype";
  static const String FDN_CLOSEDATE = "closedate";
  static const String FDN_CLOSEDNOTIWAYCODE = "closednotiwaycode";
  static const String FDN_CLOSEDNOTIWAYDESC = "closednotiwaydesc";
  static const String FDN_CLOSEDNOTIWAYID = "closednotiwayid";
  static const String FDN_CLOSEDNOTIWAYISVISIT = "closednotiwayisvisit";
  static const String FDN_CLOSEDT = "closedt";
  static const String FDN_CLOSETIME = "closetime";
  static const String FDN_COBABY = "cobaby";
  static const String FDN_COCHD = "cochd";
  static const String FDN_COCHD1 = "cochd1";
  static const String FDN_COCHD2 = "cochd2";
  static const String FDN_CODAY = "coday";
  static const String FDN_CODE = "code";
  static const String FDN_CODEDESC = "codedesc";
  static const String FDN_CODEFORMAT = "codeformat";
  static const String FDN_CODEID = "codeid";
  static const String FDN_CODENG = "codeng";
  static const String FDN_CODESTR = "codestr";
  static const String FDN_CONTACTTITLE = "contacttitle";
  static const String FDN_COLLACCBANKBRANCH = "collaccbankbranch";
  static const String FDN_COLLACCBANKBRANCHID = "collaccbankbranchid";
  static const String FDN_COLLACCBANKNAME = "collaccbankname";
  static const String FDN_COLLACCBANKNAMEDESC = "collaccbanknamedesc";
  static const String FDN_COLLACCBANKNAMEID = "collaccbanknameid";
  static const String FDN_COLLACCCODE = "collacccode";
  static const String FDN_COLLACCDESC = "collaccdesc";
  static const String FDN_COLLACCID = "collaccid";
  static const String FDN_COLLACCLONGDESC = "collacclongdesc";
  static const String FDN_COLLEDCALLPERCENTLASTYEARLY = "colledcallpercentlastyearly";
  static const String FDN_COLLEDCALLPERCENTMONTHLY = "colledcallpercentmonthly";
  static const String FDN_COLLEDCALLPERCENTWEEKLY = "colledcallpercentweekly";
  static const String FDN_COLLEDCALLPERCENTYEARLY = "colledcallpercentyearly";
  static const String FDN_COLLTARGETTOTAL = "colltargettotal";
  static const String FDN_COLLTOTAL = "colltotal";
  static const String FDN_COLLTOTALCURR = "colltotalcurr";
  static const String FDN_COLLTOTALLASTYEARLY = "colltotallastyearly";
  static const String FDN_COLLTOTALMONTHLY = "colltotalmonthly";
  static const String FDN_COLLTOTALWEEKLY = "colltotalweekly";
  static const String FDN_COLLTOTALYEARLY = "colltotalyearly";
  static const String FDN_COLLVISITCALL = "collvisitcall";
  static const String FDN_COLLVISITCALLLASTYEARLY = "collvisitcalllastyearly";
  static const String FDN_COLLVISITCALLMONTHLY = "collvisitcallmonthly";
  static const String FDN_COLLVISITCALLWEEKLY = "collvisitcallweekly";
  static const String FDN_COLLVISITCALLYEARLY = "collvisitcallyearly";
  static const String FDN_COLOR = "color";
  static const String FDN_COLORFIELD = "colorfield";
  static const String FDN_COLORLEVEL = "colorlevel";
  static const String FDN_COMISSION = "comission";
  static const String FDN_COMMAMOUNT = "commamount";
  static const String FDN_COMMCURR = "commcurr";
  static const String FDN_COMMENTCOUNT = "commentcount";
  static const String FDN_COMMENTDISLIKECOUNT = "commentdislikecount";
  static const String FDN_COMMENTDISLIKEDEMPLIST = "commentdislikedemplist";
  static const String FDN_COMMENTLIKECOUNT = "commentlikecount";
  static const String FDN_COMMENTLIKEDEMPLIST = "commentlikedemplist";
  static const String FDN_COMMENTRECOMMENDCOUNT = "commentrecommendcount";
  static const String FDN_COMMENTTYPELIST = "commenttypelist";
  static const String FDN_COMMENTTYPELISTFULL = "commenttypelistfull";
  static const String FDN_COMMENTYPECODE = "commentypecode";
  static const String FDN_COMMENTYPEDESC = "commentypedesc";
  static const String FDN_COMMENTYPEID = "commentypeid";
  static const String FDN_COMMLINEID = "commlineid";
  static const String FDN_COMMRATE = "commrate";
  static const String FDN_COMMTOTAL = "commtotal";
  static const String FDN_COMMTYPE = "commtype";
  static const String FDN_COMMTYPEDESC = "commtypedesc";
  static const String FDN_COMONTH = "comonth";
  static const String FDN_COMPANY = "company";
  static const String FDN_COMPANYCODE = "companycode";
  static const String FDN_COMPANYDESC = "companydesc";
  static const String FDN_COMPANYID = "companyid";
  static const String FDN_COMPANYTYPECODE = "companytypecode";
  static const String FDN_COMPANYTYPEDESC = "companytypedesc";
  static const String FDN_COMPANYTYPEID = "companytypeid";
  static const String FDN_COMPBABY = "compbaby";
  static const String FDN_COMPCHD = "compchd";
  static const String FDN_COMPCHD1 = "compchd1";
  static const String FDN_COMPCHD2 = "compchd2";
  static const String FDN_COMPETCODE = "competcode";
  static const String FDN_COMPETDESC = "competdesc";
  static const String FDN_COMPETID = "competid";
  static const String FDN_COMPLAINT = "complaint";
  static const String FDN_COMPPAX = "comppax";
  static const String FDN_COMPROOM = "comproom";
  static const String FDN_COMPUTERNAME = "computername";
  static const String FDN_COMTYPECODE = "comtypecode";
  static const String FDN_COMTYPEDESC = "comtypedesc";
  static const String FDN_COMTYPEID = "comtypeid";
  static const String FDN_CONDATETIME = "condatetime";
  static const String FDN_CONDURMIN = "condurmin";
  static const String FDN_CONFID = "confid";
  static const String FDN_CONFIRMDATE = "confirmdate";
  static const String FDN_CONFIRMDT = "confirmdt";
  static const String FDN_CONFIRMDURATION = "confirmduration";
  static const String FDN_CONFIRMDURATIONMIN = "confirmdurationmin";
  static const String FDN_CONFIRMNAME = "confirmname";
  static const String FDN_CONFIRMNOTE = "confirmnote";
  static const String FDN_CONFIRMTIME = "confirmtime";
  static const String FDN_CONFIRMUSER = "confirmuser";
  static const String FDN_CONFIRMUSERCODE = "confirmusercode";
  static const String FDN_CONFIRMUSEREMAIL = "confirmuseremail";
  static const String FDN_CONFIRMUSERID = "confirmuserid";
  static const String FDN_CONFIRMUSERNAME = "confirmusername";
  static const String FDN_CONFLICTS = "conflicts";
  static const String FDN_CONID = "conid";
  static const String FDN_CONNAME = "conname";
  static const String FDN_CONOTE = "conote";
  static const String FDN_CONSUMPITEMPRICE = "consumpitemprice";
  static const String FDN_CONTACT = "contact";
  static const String FDN_CONTACTACCCODE = "contactacccode";
  static const String FDN_CONTACTACCDESC = "contactaccdesc";
  static const String FDN_CONTACTACCID = "contactaccid";
  static const String FDN_CONTACTADDRESS1 = "contactaddress1";
  static const String FDN_CONTACTADDRESS2 = "contactaddress2";
  static const String FDN_CONTACTCLIENTID = "contactclientid";
  static const String FDN_CONTACTCOUNT = "contactcount";
  static const String FDN_CONTACTEL = "contactel";
  static const String FDN_CONTACTELNO = "contactelno";
  static const String FDN_CONTACTEMAIL = "contactemail";
  static const String FDN_CONTACTFAX = "contactfax";
  static const String FDN_CONTACTID = "contactid";
  static const String FDN_CONTACTMANADDRESS = "contactmanaddress";
  static const String FDN_CONTACTNAME = "contactname";
  static const String FDN_CONTACTPOS = "contactpos";
  static const String FDN_CONTACTTEL = "contacttel";
  static const String FDN_CONTACTTYPE = "contacttype";
  static const String FDN_CONTACTTYPECODE = "contacttypecode";
  static const String FDN_CONTACTTYPEDESC = "contacttypedesc";
  static const String FDN_CONTACTTYPEID = "contacttypeid";
  static const String FDN_CONTACTTYPESHORTCODE = "contacttypeshortcode";
  static const String FDN_CONTACTWEB = "contactweb";
  static const String FDN_CONTENT = "content";
  static const String FDN_CONTMASTERCODE = "contmastercode";
  static const String FDN_CONTMASTERDESC = "contmasterdesc";
  static const String FDN_CONTMASTERID = "contmasterid";
  static const String FDN_CONTMASTERMAPCODE = "contmastermapcode";
  static const String FDN_CONTRACTAMOUNT = "contractamount";
  static const String FDN_CONTRACTDATE = "contractdate";
  static const String FDN_CONTRACTID = "contractid";
  static const String FDN_CONTRACTNO = "contractno";
  static const String FDN_CONTRACTTOTAL = "contracttotal";
  static const String FDN_CONTROLLER = "controller";
  static const String FDN_CONTROLLERCODE = "controllercode";
  static const String FDN_COOKDURATION = "cookduration";
  static const String FDN_COOKDURATIONMIN = "cookdurationmin";
  static const String FDN_COOKTEXT = "cooktext";
  static const String FDN_COPAX = "copax";
  static const String FDN_COPYTOST = "copytost";
  static const String FDN_COROOM = "coroom";
  static const String FDN_CORRECTION = "correction";
  static const String FDN_COSTLOCGRPCODE = "costlocgrpcode";
  static const String FDN_COSTLOCGRPDESC = "costlocgrpdesc";
  static const String FDN_COSTLOCGRPID = "costlocgrpid";
  static const String FDN_COSTNET = "costnet";
  static const String FDN_COSTPRICE = "costprice";
  static const String FDN_COSTPRICELAST = "costpricelast";
  static const String FDN_COSTR = "costr";
  static const String FDN_COSTRATE = "costrate";
  static const String FDN_COSTTOTAL = "costtotal";
  static const String FDN_COSTTOTALTAXED = "costtotaltaxed";
  static const String FDN_COTIME = "cotime";
  static const String FDN_COUNT = "count";
  static const String FDN_COUNTED = "counted";
  static const String FDN_COUNTEDCOST = "countedcost";
  static const String FDN_COUNTEDPACK = "countedpack";
  static const String FDN_COUNTEDRECEIPT = "countedreceipt";
  static const String FDN_COUNTEDRECIPE = "countedrecipe";
  static const String FDN_COUNTED_AMOUNT = "counted_amount";
  static const String FDN_COUNTED_TOTAL = "counted_total";
  static const String FDN_COUNTER = "counter";
  static const String FDN_COUNTERPFX = "counterpfx";
  static const String FDN_COUNTERTEXT = "countertext";
  static const String FDN_COUNTERTRANSINFO = "countertransinfo";
  static const String FDN_COUNTRY = "country";
  static const String FDN_COUNTRYCODE = "countrycode";
  static const String FDN_COUNTRYDESC = "countrydesc";
  static const String FDN_COUNTRYID = "countryid";
  static const String FDN_COUPONID = "couponid";
  static const String FDN_COUPONCODE = "couponcode";
  static const String FDN_COUPONDESC = "coupondesc";
  static const String FDN_COURSENO = "courseno";
  static const String FDN_COYEAR = "coyear";
  static const String FDN_CRCARD = "crcard";
  static const String FDN_CRCARDBANK = "crcardbank";
  static const String FDN_CRCARDBEV = "crcardbev";
  static const String FDN_CRCARDCOLL = "crcardcoll";
  static const String FDN_CRCARDCVC = "crcardcvc";
  static const String FDN_CRCARDEXPIREDATE = "crcardexpiredate";
  static const String FDN_CRCARDEXPIREMONTH = "crcardexpiremonth";
  static const String FDN_CRCARDEXPIREYEAR = "crcardexpireyear";
  static const String FDN_CRCARDFOOD = "crcardfood";
  static const String FDN_CRCARDHOLDER = "crcardholder";
  static const String FDN_CRCARDINSTANT = "crcardinstant";
  static const String FDN_CRCARDNO = "crcardno";
  static const String FDN_CRCARDNONFB = "crcardnonfb";
  static const String FDN_CRCARDPAYMENT = "crcardpayment";
  static const String FDN_CRCARDTOTAL = "crcardtotal";
  static const String FDN_CRCARDTYPE = "crcardtype";
  static const String FDN_CREATIONDATE = "creationdate";
  static const String FDN_CREATIONDT = "creationdt";
  static const String FDN_CREDENTIALSNONEXPIRED = "credentialsnonexpired";
  static const String FDN_CREDIT = "credit";
  static const String FDN_CREDITBALANCE = "creditbalance";
  static const String FDN_CREDITLEFT = "creditleft";
  static const String FDN_CREDITLIMIT = "creditlimit";
  static const String FDN_CREDITTOTAL = "credittotal";
  static const String FDN_CROSSDURATION = "crossduration";
  static const String FDN_CROSSDURATIONMIN = "crossdurationmin";
  static const String FDN_CROSSDURATIONSTR = "crossdurationstr";
  static const String FDN_CROSSMIN = "crossmin";
  static const String FDN_CRM = "crm";
  static const String FDN_CSHTRANSCOUNT = "cshtranscount";
  static const String FDN_CSHTRANSCOUNTTOTAL = "cshtranscounttotal";
  static const String FDN_CSID = "csid";
  static const String FDN_CSSCLASS = "cssclass";
  static const String FDN_CSSSTYLE = "cssstyle";
  static const String FDN_CURR = "curr";
  static const String FDN_CURR1CORRECTION = "curr1correction";
  static const String FDN_CURR1LYMONTHUTD = "curr1lymonthutd";
  static const String FDN_CURR1LYPPREVENUE = "curr1lypprevenue";
  static const String FDN_CURR1LYPRREVENUE = "curr1lyprrevenue";
  static const String FDN_CURR1LYREVENUE = "curr1lyrevenue";
  static const String FDN_CURR1LYYEARUTD = "curr1lyyearutd";
  static const String FDN_CURR1MONTHUTD = "curr1monthutd";
  static const String FDN_CURR1PAYMENT = "curr1payment";
  static const String FDN_CURR1PPREVENUE = "curr1pprevenue";
  static const String FDN_CURR1PRREVENUE = "curr1prrevenue";
  static const String FDN_CURR1REVENUE = "curr1revenue";
  static const String FDN_CURR1YEARUTD = "curr1yearutd";
  static const String FDN_CURRACCBALANCE = "curraccbalance";
  static const String FDN_CURRAGENCYTOTAL = "curragencytotal";
  static const String FDN_CURRAMOUNT = "curramount";
  static const String FDN_CURRATEDATE = "curratedate";
  static const String FDN_CURRBALANCE = "currbalance";
  static const String FDN_CURRCARDTYPECODE = "currcardtypecode";
  static const String FDN_CURRCASHTOTAL = "currcashtotal";
  static const String FDN_CURRCODE = "currcode";
  static const String FDN_CURRCRCARDTOTAL = "currcrcardtotal";
  static const String FDN_CURRCREDIT = "currcredit";
  static const String FDN_CURRCREDITBALANCE = "currcreditbalance";
  static const String FDN_CURRCREDITLEFT = "currcreditleft";
  static const String FDN_CURRCREDITTOTAL = "currcredittotal";
  static const String FDN_CURRDATE = "currdate";
  static const String FDN_CURRDEBIT = "currdebit";
  static const String FDN_CURRDEBITBALANCE = "currdebitbalance";
  static const String FDN_CURRDEBITLEFT = "currdebitleft";
  static const String FDN_CURRDEBITTOTAL = "currdebittotal";
  static const String FDN_CURRDESC = "currdesc";
  static const String FDN_CURRDISCTOTAL = "currdisctotal";
  static const String FDN_CURRENCY = "currency";
  static const String FDN_CURRENCYCODE = "currencycode";
  static const String FDN_CURRENCYDESC = "currencydesc";
  static const String FDN_CURRENCYID = "currencyid";
  static const String FDN_CURRENTAGE = "currentage";
  static const String FDN_CURRENTAGEDAY = "currentageday";
  static const String FDN_CURRENTHOTELREFNO = "currenthotelrefno";
  static const String FDN_CURRENTID = "currentid";
  static const String FDN_CURRID = "currid";
  static const String FDN_CURRINITIALBALANCE = "currinitialbalance";
  static const String FDN_CURRINITIALCREDIT = "currinitialcredit";
  static const String FDN_CURRINITIALDEBIT = "currinitialdebit";
  static const String FDN_CURRISACTIVE = "currisactive";
  static const String FDN_CURRLASTBALANCE = "currlastbalance";
  static const String FDN_CURRLASTCREDIT = "currlastcredit";
  static const String FDN_CURRLASTDEBIT = "currlastdebit";
  static const String FDN_CURRLEVEL = "currlevel";
  static const String FDN_CURRLINENO = "currlineno";
  static const String FDN_CURRPAYAMOUNT = "currpayamount";
  static const String FDN_CURRPAYMENT = "currpayment";
  static const String FDN_CURRQTYCODE = "currqtycode";
  static const String FDN_CURRQTYDESC = "currqtydesc";
  static const String FDN_CURRQTYID = "currqtyid";
  static const String FDN_CURRRATE = "currrate";
  static const String FDN_CURRRATE1 = "currrate1";
  static const String FDN_CURRRATE2 = "currrate2";
  static const String FDN_CURRREVENUE = "currrevenue";
  static const String FDN_CURRREVENUENET = "currrevenuenet";
  static const String FDN_CURRSUBTOTAL = "currsubtotal";
  static const String FDN_CURRSYMBOL = "currsymbol";
  static const String FDN_CURRTAXTOTAL = "currtaxtotal";
  static const String FDN_CURRTOTAL = "currtotal";
  static const String FDN_CURRTOTALEB = "currtotaleb";
  static const String FDN_CURRTOTALNOEB = "currtotalnoeb";
  static const String FDN_CURRTOTALTAXED = "currtotaltaxed";
  static const String FDN_CURRTRANSBALANCE = "currtransbalance";
  static const String FDN_CURRVAT = "currvat";
  static const String FDN_CURRVATTOTAL = "currvattotal";
  static const String FDN_CUSTOMCODE = "customcode";
  static const String FDN_CUSTOMCODEID = "customcodeid";
  static const String FDN_CUSTOMCSSID = "customcssid";
  static const String FDN_CUSTOMERALIAS = "customeralias";
  static const String FDN_CUSTOMERBUILDINGNUMBER = "customerbuildingnumber";
  static const String FDN_CUSTOMERCITYNAME = "customercityname";
  static const String FDN_CUSTOMERCITYSUBDIVISIONNAME = "customercitysubdivisionname";
  static const String FDN_CUSTOMERCOUNTRYNAME = "customercountryname";
  static const String FDN_CUSTOMEREMAIL = "customeremail";
  static const String FDN_CUSTOMERFAX = "customerfax";
  static const String FDN_CUSTOMERID = "customerid";
  static const String FDN_CUSTOMERNAME = "customername";
  static const String FDN_CUSTOMERPOSTALZONE = "customerpostalzone";
  static const String FDN_CUSTOMERSTREETNAME = "customerstreetname";
  static const String FDN_CUSTOMERTAXSCHEMENAME = "customertaxschemename";
  static const String FDN_CUSTOMERTEL = "customertel";
  static const String FDN_CUSTOMERWEBSITEURI = "customerwebsiteuri";
  static const String FDN_CUSTOMID = "customid";
  static const String FDN_CUSTOMVALUE = "customvalue";
  static const String FDN_CVDESC = "cvdesc";
  static const String FDN_CXBABY = "cxbaby";
  static const String FDN_CXCHD = "cxchd";
  static const String FDN_CXCHD1 = "cxchd1";
  static const String FDN_CXCHD2 = "cxchd2";
  static const String FDN_CXPAX = "cxpax";
  static const String FDN_CXROOM = "cxroom";
  static const String FDN_D01 = "d01";
  static const String FDN_D02 = "d02";
  static const String FDN_D03 = "d03";
  static const String FDN_D04 = "d04";
  static const String FDN_D05 = "d05";
  static const String FDN_D06 = "d06";
  static const String FDN_D07 = "d07";
  static const String FDN_D08 = "d08";
  static const String FDN_D09 = "d09";
  static const String FDN_D10 = "d10";
  static const String FDN_D11 = "d11";
  static const String FDN_D12 = "d12";
  static const String FDN_D13 = "d13";
  static const String FDN_D14 = "d14";
  static const String FDN_D15 = "d15";
  static const String FDN_D16 = "d16";
  static const String FDN_D17 = "d17";
  static const String FDN_D18 = "d18";
  static const String FDN_D19 = "d19";
  static const String FDN_D20 = "d20";
  static const String FDN_D21 = "d21";
  static const String FDN_D22 = "d22";
  static const String FDN_D23 = "d23";
  static const String FDN_D24 = "d24";
  static const String FDN_D25 = "d25";
  static const String FDN_D26 = "d26";
  static const String FDN_D27 = "d27";
  static const String FDN_D28 = "d28";
  static const String FDN_D29 = "d29";
  static const String FDN_D30 = "d30";
  static const String FDN_D31 = "d31";
  static const String FDN_DAILYAVERAGE = "dailyaverage";
  static const String FDN_DAILYBOARD = "dailyboard";
  static const String FDN_DAILYEXTRA = "dailyextra";
  static const String FDN_DAILYFREE = "dailyfree";
  static const String FDN_DAILYFREEMANUAL = "dailyfreemanual";
  static const String FDN_DAILYFREETOTAL = "dailyfreetotal";
  static const String FDN_DAILYHOMECURR = "dailyhomecurr";
  static const String FDN_DAILYNETHOMECURR = "dailynethomecurr";
  static const String FDN_DAILYNETPRICE = "dailynetprice";
  static const String FDN_DAILYPRICE = "dailyprice";
  static const String FDN_DAILYRATE = "dailyrate";
  static const String FDN_DAILYRATECURR = "dailyratecurr";
  static const String FDN_DAILYRATEHOMECURR = "dailyratehomecurr";
  static const String FDN_DAILYRATEINFO = "dailyrateinfo";
  static const String FDN_DAILYROOM = "dailyroom";
  static const String FDN_DAILYTIMES = "dailytimes";
  static const String FDN_DAILYTOTAL = "dailytotal";
  static const String FDN_DAILYTOTALHOMECURR = "dailytotalhomecurr";
  static const String FDN_DATA = "data";
  static const String FDN_DATAFIELD = "datafield";
  static const String FDN_DATAIDX = "dataidx";
  static const String FDN_DATASETNAME = "datasetname";
  static const String FDN_DATATYPE = "datatype";
  static const String FDN_DATE = "date";
  static const String FDN_DATERANGESTR = "daterangestr";
  static const String FDN_DATESTR = "datestr";
  static const String FDN_DATETYPE = "datetype";
  static const String FDN_DAYCOUNT = "daycount";
  static const String FDN_DAYCOUNTER = "daycounter";
  static const String FDN_DAYOVER = "dayover";
  static const String FDN_DAY = "day";
  static const String FDN_DAYS = "days";
  static const String FDN_DAYSBEFORE = "daysbefore";
  static const String FDN_DAYSLEFT = "daysleft";
  static const String FDN_DAYSTR = "daystr";
  static const String FDN_DB = "db";
  static const String FDN_DBCONID = "dbconid";
  static const String FDN_DBININAME = "dbininame";
  static const String FDN_DBNAME = "dbname";
  static const String FDN_DBTYPE = "dbtype";
  static const String FDN_DEADLINE = "deadline";
  static const String FDN_DEBIT = "debit";
  static const String FDN_DEBITBALANCE = "debitbalance";
  static const String FDN_DEBITLEFT = "debitleft";
  static const String FDN_DEBITTOTAL = "debittotal";
  static const String FDN_DECDAYSFROM = "decdaysfrom";
  static const String FDN_DECORNOTE = "decornote";
  static const String FDN_DEEDATE = "deedate";
  static const String FDN_DEEDNOTE = "deednote";
  static const String FDN_DEFAULTHOTELREFNO = "defaulthotelrefno";
  static const String FDN_DEFCOSTLOCCODE = "defcostloccode";
  static const String FDN_DEFCOSTLOCDESC = "defcostlocdesc";
  static const String FDN_DEFCOSTLOCGRPCODE = "defcostlocgrpcode";
  static const String FDN_DEFCOSTLOCGRPDESC = "defcostlocgrpdesc";
  static const String FDN_DEFCOSTLOCGRPID = "defcostlocgrpid";
  static const String FDN_DEFCOSTLOCID = "defcostlocid";
  static const String FDN_DEFEMP = "defemp";
  static const String FDN_DEFEMPCODE = "defempcode";
  static const String FDN_DEFEMPDEPCODE = "defempdepcode";
  static const String FDN_DEFEMPDEPDESC = "defempdepdesc";
  static const String FDN_DEFEMPDEPID = "defempdepid";
  static const String FDN_DEFEMPID = "defempid";
  static const String FDN_DEFEMPNAME = "defempname";
  static const String FDN_DEFEMPPOSCODE = "defempposcode";
  static const String FDN_DEFEMPPOSDESC = "defempposdesc";
  static const String FDN_DEFEMPDEPARTID = "defempdepartid";
  static const String FDN_DEFEMPDEPART = "defempdepart";
  static const String FDN_DEFEMPDEPARTDESC = "defempdepartdesc";
  static const String FDN_DEFEMPPOSID = "defempposid";
  static const String FDN_DEFEMPTYPE = "defemptype";
  static const String FDN_DEFEMPTYPEDESC = "defemptypedesc";
  static const String FDN_DEFGRPITEMCODE = "defgrpitemcode";
  static const String FDN_DEFGRPITEMDESC = "defgrpitemdesc";
  static const String FDN_DEFGRPITEMID = "defgrpitemid";
  static const String FDN_DEFIMAGEID = "defimageid";
  static const String FDN_DEFINITCODE = "definitcode";
  static const String FDN_DEFINITDESC = "definitdesc";
  static const String FDN_DEFINITID = "definitid";
  static const String FDN_DEFPERIODAMOUNT = "defperiodamount";
  static const String FDN_DEFPERIODTYPE = "defperiodtype";
  static const String FDN_DEFPERIODTYPEDESC = "defperiodtypedesc";
  static const String FDN_DEFSTATUSCODE = "defstatuscode";
  static const String FDN_DEFSTATUSID = "defstatusid";
  static const String FDN_DEFVALUE = "defvalue";
  static const String FDN_DEMOEMPID = "demoempid";
  static const String FDN_DEMOEMPODE = "demoempode";
  static const String FDN_DEMOEMPNAME = "demoempname";
  static const String FDN_DEL = "del";
  static const String FDN_DELAYFWMIN = "delayfwmin";
  static const String FDN_DELAYMIN = "delaymin";
  static const String FDN_DELETES = "deletes";
  static const String FDN_DELIVEREDBY = "deliveredby";
  static const String FDN_DELIVEREDON = "deliveredon";
  static const String FDN_DELIVEREDTO = "deliveredto";
  static const String FDN_DELTADURATION = "deltaduration";
  static const String FDN_DELTADURMIN = "deltadurmin";
  static const String FDN_DELTAMAX = "deltamax";
  static const String FDN_DELTAMIN = "deltamin";
  static const String FDN_DEPART = "depart";
  static const String FDN_DEPARTCODE = "departcode";
  static const String FDN_DEPARTDESC = "departdesc";
  static const String FDN_DEPARTGROUPNO = "departgroupno";
  static const String FDN_DEPARTID = "departid";
  static const String FDN_DEPARTLIST = "departlist";
  static const String FDN_DEPARTMENT = "department";
  static const String FDN_DEPARTMENTCODE = "departmentcode";
  static const String FDN_DEPARTMENTDESC = "departmentdesc";
  static const String FDN_DEPARTMENTID = "departmentid";
  static const String FDN_DEPARTMENTLONG = "departmentlong";
  static const String FDN_DEPARTNAME = "departname";
  static const String FDN_DEPARTNO = "departNo";
  static const String FDN_DEPARTTO = "departto";
  static const String FDN_DEPARTTYPE = "departtype";
  static const String FDN_DEPENDENT = "dependent";
  static const String FDN_DEPENDENTTYPE = "dependenttype";
  static const String FDN_DEPENDENT_TYPE = "dependent_type";
  static const String FDN_DEPENDENT_TYPE_STR = "dependent_type_str";
  static const String FDN_DEPENDON = "dependon";
  static const String FDN_DEPENDONTYPE = "dependontype";
  static const String FDN_DEPENDSON = "dependson";
  static const String FDN_DEPENDS_ON_TYPE_STR = "depends_on_type_str";
  static const String FDN_DEPEND_ON_TYPE = "depend_on_type";
  static const String FDN_DEPENTONFIELD = "depentonfield";
  static const String FDN_DEPOSITTODAY = "deposittoday";
  static const String FDN_DEPOSITTOTAL = "deposittotal";
  static const String FDN_DEPOSITYPE = "depositype";
  static const String FDN_DEPOSITYPECODE = "depositypecode";
  static const String FDN_DEPOSITYPEDESC = "depositypedesc";
  static const String FDN_DEPOSITYPEID = "depositypeid";
  static const String FDN_DEPTAXRATE = "deptaxrate";
  static const String FDN_DEPTOTAL = "deptotal";
  static const String FDN_DESCEXP = "descexp";
  static const String FDN_DESCFONTSIZE = "descfontsize";
  static const String FDN_DESCINENG = "descineng";
  static const String FDN_DESCRIPTION = "description";
  static const String FDN_DESTCODE = "destcode";
  static const String FDN_DESTDESC = "destdesc";
  static const String FDN_DESTID = "destid";
  static const String FDN_DETAILTEMPID = "detailtempid";
  static const String FDN_DEVICECODE = "devicecode";
  static const String FDN_DEVICEDESC = "devicedesc";
  static const String FDN_DEVICEGID = "devicegid";
  static const String FDN_DEVICEID = "deviceid";
  static const String FDN_DEVICEPOWER = "devicepower";
  static const String FDN_DEVID = "devid";
  static const String FDN_DIAGDATE = "diagdate";
  static const String FDN_DIAGNOSIS = "diagnosis";
  static const String FDN_DIAGNOTE = "diagnote";
  static const String FDN_DIALCODE = "dialcode";
  static const String FDN_DIFFAMOUNT = "diffamount";
  static const String FDN_DIFFBALTOTALCURR = "diffbaltotalcurr";
  static const String FDN_DIFFCOLLTOTALCURR = "diffcolltotalcurr";
  static const String FDN_DIFFCOST = "diffcost";
  static const String FDN_DIFFEXCRATE = "diffexcrate";
  static const String FDN_DIFFPAYTOTALCURR = "diffpaytotalcurr";
  static const String FDN_DIFFRPTEXCRATE = "diffrptexcrate";
  static const String FDN_DIFFSUCC = "diffsucc";
  static const String FDN_DIFFTOTAL = "difftotal";
  static const String FDN_DIFFTOTALCURR = "difftotalcurr";
  static const String FDN_DIFFTOTALHOMECURR = "difftotalhomecurr";
  static const String FDN_DIFF_AMOUNT = "diff_amount";
  static const String FDN_DIFF_TOTAL = "diff_total";
  static const String FDN_DIFF_TRANS_AVG_TOTAL = "diff_trans_avg_total";
  static const String FDN_DIFF_TRANS_TOTAL = "diff_trans_total";
  static const String FDN_DINNER = "dinner";
  static const String FDN_DINNERRATE = "dinnerrate";
  static const String FDN_DINNERTEXT = "dinnertext";
  static const String FDN_DISC = "disc";
  static const String FDN_DISCAMOUNT = "discamount";
  static const String FDN_DISCAMOUNT1 = "discamount1";
  static const String FDN_DISCAMOUNT2 = "discamount2";
  static const String FDN_DISCAMOUNT3 = "discamount3";
  static const String FDN_DISCAMOUNTHOMECURR = "discamounthomecurr";
  static const String FDN_DISCASAMOUNT = "discasamount";
  static const String FDN_DISCEDTOTAL = "discedtotal";
  static const String FDN_DISCEDTOTALDAY = "discedtotalday";
  static const String FDN_DISCNOTE = "discnote";
  static const String FDN_DISCONGROSS = "discongross";
  static const String FDN_DISCOUNT = "discount";
  static const String FDN_DISCRATE = "discrate";
  static const String FDN_DISCRATE2 = "discrate2";
  static const String FDN_DISCRATE3 = "discrate3";
  static const String FDN_DISCRATEPP = "discratepp";
  static const String FDN_DISCSOURCE = "discsource";
  static const String FDN_DISCTOTAL = "disctotal";
  static const String FDN_DISCTOTAL1 = "disctotal1";
  static const String FDN_DISCTOTAL2 = "disctotal2";
  static const String FDN_DISCTOTAL3 = "disctotal3";
  static const String FDN_DISCTYPE = "disctype";
  static const String FDN_DISPLAYFIELD = "displayfield";
  static const String FDN_DISTRICT = "district";
  static const String FDN_DISTRICTCODE = "districtcode";
  static const String FDN_DISTRICTDESC = "districtdesc";
  static const String FDN_DMGCOST = "dmgcost";
  static const String FDN_DISTRICTID = "districtid";
  static const String FDN_DMGPAY = "dmgpay";
  static const String FDN_DMGTRANSCOUNT = "dmgtranscount";
  static const String FDN_DND = "dnd";
  static const String FDN_DOCID = "docid";
  static const String FDN_DOCLINK = "doclink";
  static const String FDN_DOCLOCCODE = "docloccode";
  static const String FDN_DOCLOCDESC = "doclocdesc";
  static const String FDN_DOCLOCID = "doclocid";
  static const String FDN_DOCSERIEID = "docserieid";
  static const String FDN_DOCSERIETYPE = "docserietype";
  static const String FDN_DOCSERIETYPEDESC = "docserietypedesc";
  static const String FDN_DOCSTASTUSCODE = "docstastuscode";
  static const String FDN_DOCSTATUSCODE = "docstatuscode";
  static const String FDN_DOCSTATUSDESC = "docstatusdesc";
  static const String FDN_DOCSTATUSID = "docstatusid";
  static const String FDN_DOCTYPECODE = "doctypecode";
  static const String FDN_DOCTYPEDESC = "doctypedesc";
  static const String FDN_DOCTYPEID = "doctypeid";
  static const String FDN_DOCUMENTCURRENCYCODE = "documentcurrencycode";
  static const String FDN_DOMAINNAME = "domainname";
  static const String FDN_DONENOTECOUNT = "donenotecount";
  static const String FDN_DOUBLERATE = "doublerate";
  static const String FDN_DOUBLETEXT = "doubletext";
  static const String FDN_DOWINT = "dowint";
  static const String FDN_DOWSTR = "dowstr";
  static const String FDN_DRIVERLIC = "driverlic";
  static const String FDN_DRIVERLICDATE = "driverlicdate";
  static const String FDN_DRIVERLICEXPIRE = "driverlicexpire";
  static const String FDN_DRIVERLOC = "driverloc";
  static const String FDN_DUEDATE = "duedate";
  static const String FDN_DUEDATEDAY = "duedateday";
  static const String FDN_DUEDATEMONTH = "duedatemonth";
  static const String FDN_DUEDATEYEAR = "duedateyear";
  static const String FDN_DUEDT = "duedt";
  static const String FDN_DUEDUSER = "dueduser";
  static const String FDN_DUEDUSERCODE = "duedusercode";
  static const String FDN_DUEDUSERID = "dueduserid";
  static const String FDN_DUEDUSERNAME = "duedusername";
  static const String FDN_DUEPAST = "duepast";
  static const String FDN_DUETIME = "duetime";
  static const String FDN_DUETYPECODE = "duetypecode";
  static const String FDN_DUETYPEID = "duetypeid";
  static const String FDN_DUMMY = "dummy";
  static const String FDN_DUPID = "dupid";
  static const String FDN_DURATION = "duration";
  static const String FDN_DURATIONASTIME = "durationastime";
  static const String FDN_DURATIONEXP = "durationexp";
  static const String FDN_DURATIONEXPSTR = "durationexpstr";
  static const String FDN_DURATIONHOUR = "durationhour";
  static const String FDN_DURATIONMIN = "durationmin";
  static const String FDN_DURATIONPER = "durationper";
  static const String FDN_DURATIONSEC = "durationsec";
  static const String FDN_DURATIONTOTAL = "durationtotal";
  static const String FDN_DURATIONTOTALSTR = "durationtotalstr";
  static const String FDN_DURDAY = "durday";
  static const String FDN_DURMIN = "durmin";
  static const String FDN_DURSEC = "dursec";
  static const String FDN_DURSTRHOUR = "durstrhour";
  static const String FDN_DURSTRMIN = "durstrmin";
  static const String FDN_EBRATE = "ebrate";
  static const String FDN_EDOCSTATUS = "edocstatus";
  static const String FDN_EDUDESC = "edudesc";
  static const String FDN_EDUID = "eduid";
  static const String FDN_EDUSOURCE = "edusource";
  static const String FDN_EDUTYPE = "edutype";
  static const String FDN_EDUTYPECODE = "edutypecode";
  static const String FDN_EDUTYPEDESC = "edutypedesc";
  static const String FDN_EDUTYPEID = "edutypeid";
  static const String FDN_EINVDATE = "einvdate";
  static const String FDN_EINVID = "einvid";
  static const String FDN_EINVINBOX = "einvinbox";
  static const String FDN_EINVSTATUS = "einvstatus";
  static const String FDN_EINVSTATUSDESC = "einvstatusdesc";
  static const String FDN_EINVTYPE = "einvtype";
  static const String FDN_EINVTYPEDESC = "einvtypedesc";
  static const String FDN_ELAPSED = "elapsed";
  static const String FDN_ELAPTIME = "elaptime";
  static const String FDN_EMAIL = "email";
  static const String FDN_EMAILACNID = "emailacnid";
  static const String FDN_EMAILAPI = "emailapi";
  static const String FDN_EMAILCLICKRATE = "emailclickrate";
  static const String FDN_EMAILCOUNT = "emailcount";
  static const String FDN_EMAILGROUPCODE = "emailgroupcode";
  static const String FDN_EMAILGROUPDESC = "emailgroupdesc";
  static const String FDN_EMAILGROUPID = "emailgroupid";
  static const String FDN_EMAILNOTE = "emailnote";
  static const String FDN_EMAILOPENRATE = "emailopenrate";
  static const String FDN_EMAILREV = "emailrev";
  static const String FDN_EMP = "emp";
  static const String FDN_EMPAPRID = "empaprid";
  static const String FDN_EMPBONUSTPLCODE = "empbonustplcode";
  static const String FDN_EMPBONUSTPLID = "empbonustplid";
  static const String FDN_EMPBRANCH = "empbranch";
  static const String FDN_EMPBRANCHID = "empbranchid";
  static const String FDN_EMPCODE = "empcode";
  static const String FDN_EMPCOUNT = "empcount";
  static const String FDN_EMPCVID = "empcvid";
  static const String FDN_EMPCVSTATUS = "empcvstatus";
  static const String FDN_EMPCVSTATUSCODE = "empcvstatuscode";
  static const String FDN_EMPCVSTATUSDESC = "empcvstatusdesc";
  static const String FDN_EMPCVSTATUSID = "empcvstatusid";
  static const String FDN_EMPDEPART = "empdepart";
  static const String FDN_EMPDEPARTCODE = "empdepartcode";
  static const String FDN_EMPDEPARTDESC = "empdepartdesc";
  static const String FDN_EMPDEPARTGID = "empdepartgid";
  static const String FDN_EMPDEPARTID = "empdepartid";
  static const String FDN_EMPDEPARTNAME = "empdepartname";
  static const String FDN_EMPDEPARTMID = "empdepartmid";
  static const String FDN_EMPDEPCODE = "empdepcode";
  static const String FDN_EMPDEPDESC = "empdepdesc";
  static const String FDN_EMPDEPID = "empdepid";
  static const String FDN_EMPDEPLIST = "empdeplist";
  static const String FDN_EMPDESC = "empdesc";
  static const String FDN_EMPEDUID = "empeduid";
  static const String FDN_EMPEMAIL = "empemail";
  static const String FDN_EMPFULLNAME = "empfullname";
  static const String FDN_EMPGENDER = "empgender";
  static const String FDN_EMPGROUPCODE = "empgroupcode";
  static const String FDN_EMPHOTELIDS = "emphotelids";
  static const String FDN_EMPID = "empid";
  static const String FDN_EMPISACTIVE = "empisactive";
  static const String FDN_EMPLIST = "emplist";
  static const String FDN_EMPLOCKUSERID = "emplockuserid";
  static const String FDN_EMPMID = "empmid";
  static const String FDN_EMPMOBILE = "empmobile";
  static const String FDN_EMPMOBILETEL = "empmobiletel";
  static const String FDN_EMPNAME = "empname";
  static const String FDN_EMPPOS = "emppos";
  static const String FDN_EMPPOSCODE = "empposcode";
  static const String FDN_EMPPOSDESC = "empposdesc";
  static const String FDN_EMPPOSGID = "empposgid";
  static const String FDN_EMPPOSID = "empposid";
  static const String FDN_EMPPOSLVLCODE = "empposlvlcode";
  static const String FDN_EMPPOSLVLID = "empposlvlid";
  static const String FDN_EMPPOSMID = "empposmid";
  static const String FDN_EMPPRICE = "empprice";
  static const String FDN_EMPRESID = "empresid";
  static const String FDN_EMPSHIFTID = "empshiftid";
  static const String FDN_EMPSHIFTIMEID = "empshiftimeid";
  static const String FDN_EMPSHIFTTIMECODE = "empshifttimecode";
  static const String FDN_EMPSHIFTTIMEDESC = "empshifttimedesc";
  static const String FDN_EMPSHIFTTIMEID = "empshifttimeid";
  static const String FDN_EMPSHORTCODE = "empshortcode";
  static const String FDN_EMPTASKCOUNT = "emptaskcount";
  static const String FDN_EMPTEL = "emptel";
  static const String FDN_EMPTEL2 = "emptel2";
  static const String FDN_EMPTYPE = "emptype";
  static const String FDN_EMPTYPEDESC = "emptypedesc";
  static const String FDN_EMPWEB = "empweb";
  static const String FDN_ENABLED = "enabled";
  static const String FDN_ENDACCEMP = "endaccemp";
  static const String FDN_ENDCOUNT = "endcount";
  static const String FDN_ENDDATE = "enddate";
  static const String FDN_ENDDATEDAY = "enddateday";
  static const String FDN_ENDDATEMONTH = "enddatemonth";
  static const String FDN_ENDDATEPREV = "enddateprev";
  static const String FDN_ENDDATEYEAR = "enddateyear";
  static const String FDN_ENDDAY = "endday";
  static const String FDN_ENDDELAYMIN = "enddelaymin";
  static const String FDN_ENDDT = "enddt";
  static const String FDN_ENDDTABS = "enddtabs";
  static const String FDN_ENDDTL = "enddtl";
  static const String FDN_ENDDURATION = "endduration";
  static const String FDN_ENDDURATIONMIN = "enddurationmin";
  static const String FDN_ENDEMPCODE = "endempcode";
  static const String FDN_ENDEMPID = "endempid";
  static const String FDN_ENDEMPNAME = "endempname";
  static const String FDN_ENDIDX = "endidx";
  static const String FDN_ENDKM = "endkm";
  static const String FDN_ENDLOC = "endloc";
  static const String FDN_ENDMONTH = "endmonth";
  static const String FDN_ENDNAME = "endname";
  static const String FDN_ENDNO = "endno";
  static const String FDN_ENDTIME = "endtime";
  static const String FDN_ENDUSER = "enduser";
  static const String FDN_ENDUSERCODE = "endusercode";
  static const String FDN_ENDUSERID = "enduserid";
  static const String FDN_ENDUSERNAME = "endusername";
  static const String FDN_ENDYEAR = "endyear";
  static const String FDN_ENTIDNO = "entidno";
  static const String FDN_ENTRANCEDATE = "entrancedate";
  static const String FDN_ENTRANCEGATE = "entrancegate";
  static const String FDN_ENTRYDATE = "entrydate";
  static const String FDN_ENTRYTIME = "entrytime";
  static const String FDN_ENTTITLE = "enttitle";
  static const String FDN_ERRORLOG = "errorlog";
  static const String FDN_ESDATE = "esdate";
  static const String FDN_EVENTDECORCODE = "eventdecorcode";
  static const String FDN_EVENTDECORID = "eventdecorid";
  static const String FDN_EVENTEMPCODE = "eventempcode";
  static const String FDN_EVENTEMPID = "eventempid";
  static const String FDN_EVENTEMPNAME = "eventempname";
  static const String FDN_EVENTLOC = "eventloc";
  static const String FDN_EVENTLOCID = "eventlocid";
  static const String FDN_EVENTLOCSTD = "eventlocstd";
  static const String FDN_EVENTMENU = "eventmenu";
  static const String FDN_EVENTMENUDESC = "eventmenudesc";
  static const String FDN_EVENTMENUID = "eventmenuid";
  static const String FDN_EVENTMESSAGE = "eventmessage";
  static const String FDN_EVENTMUSICCODE = "eventmusiccode";
  static const String FDN_EVENTMUSICID = "eventmusicid";
  static const String FDN_EVENTRESTYPE = "eventrestype";
  static const String FDN_EVENTSERVICE = "eventservice";
  static const String FDN_EVENTSERVICEDESC = "eventservicedesc";
  static const String FDN_EVENTSERVICEID = "eventserviceid";
  static const String FDN_EVENTSERVICEPRICE = "eventserviceprice";
  static const String FDN_EVENTSERVICEPRICECURR = "eventservicepricecurr";
  static const String FDN_EVENTSTATE = "eventstate";
  static const String FDN_EVENTTIMEID = "eventtimeid";
  static const String FDN_EVENTTYPE = "eventtype";
  static const String FDN_EVENTTYPEID = "eventtypeid";
  static const String FDN_EVENTYPE = "eventype";
  static const String FDN_EVENTDECORDESC = "eventdecordesc";
  static const String FDN_EVENTMUSICDESC = "eventmusicdesc";
  static const String FDN_MENUCODEDESC = "menucodedesc";
  static const String FDN_EVLOCGRPCODE = "evlocgrpcode";
  static const String FDN_EVLOCGRPDESC = "evlocgrpdesc";
  static const String FDN_EVLOCGRPID = "evlocgrpid";
  static const String FDN_EVRESRCDESCLIST = "evresrcdesclist";
  static const String FDN_EXISTS = "exists";
  static const String FDN_EXACTDAYMATCH = "exactdaymatch";
  static const String FDN_EXCBACKUP = "excbackup";
  static const String FDN_EXCBALWARN = "excbalwarn";
  static const String FDN_EXCEXTRADAYS = "excextradays";
  static const String FDN_EXCLUSIVEDISC = "exclusivedisc";
  static const String FDN_EXCRATE = "excrate";
  static const String FDN_EXCRATEABG = "excrateabg";
  static const String FDN_EXCRATEDAY = "excrateday";
  static const String FDN_EXCRATEFT = "excrateft";
  static const String FDN_EXCRATEOK = "excrateok";
  static const String FDN_EXCRATERATIO = "excrateratio";
  static const String FDN_EXCRATESAFE = "excratesafe";
  static const String FDN_EXCRATETYPE = "excratetype";
  static const String FDN_EXCRATETYPECODE = "excratetypecode";
  static const String FDN_EXCRATETYPEDESC = "excratetypedesc";
  static const String FDN_EXCRATETYPEID = "excratetypeid";
  static const String FDN_EXECMINUTE = "execminute";
  static const String FDN_EXPBABY = "expbaby";
  static const String FDN_EXPBOARDTYPE = "expboardtype";
  static const String FDN_EXPCHD = "expchd";
  static const String FDN_EXPCLIENTNAME = "expclientname";
  static const String FDN_EXPDATE = "expdate";
  static const String FDN_EXPDESC = "expdesc";
  static const String FDN_EXPDT = "expdt";
  static const String FDN_EXPDURATION = "expduration";
  static const String FDN_EXPDURATIONMIN = "expdurationmin";
  static const String FDN_EXPDURMIN = "expdurmin";
  static const String FDN_EXPDURMINOVER = "expdurminover";
  static const String FDN_EXPDUROVERPER = "expduroverper";
  static const String FDN_EXPENDDT = "expenddt";
  static const String FDN_EXPGROUPNAME = "expgroupname";
  static const String FDN_EXPIREDATE = "expiredate";
  static const String FDN_EXPIREDAY = "expireday";
  static const String FDN_EXPIREDT = "expiredt";
  static const String FDN_EXPIRES_IN = "expires_in";
  static const String FDN_EXPLANATION = "explanation";
  static const String FDN_EXPNATION = "expnation";
  static const String FDN_EXPPAX = "exppax";
  static const String FDN_EXPR = "expr";
  static const String FDN_EXPSALARY = "expsalary";
  static const String FDN_EXPSOURCE = "expsource";
  static const String FDN_EXPSTARTDATE = "expstartdate";
  static const String FDN_EXPSTARTDT = "expstartdt";
  static const String FDN_EXPSTARTTIME = "expstarttime";
  static const String FDN_EXPSTR = "expstr";
  static const String FDN_EXPTASKVALUE = "exptaskvalue";
  static const String FDN_EXPTIME = "exptime";
  static const String FDN_EXPTOTALBABY = "exptotalbaby";
  static const String FDN_EXPTOTALCHD = "exptotalchd";
  static const String FDN_EXPTOTALPAX = "exptotalpax";
  static const String FDN_EXPVISITDELTA = "expvisitdelta";
  static const String FDN_EXPVISITDURATION = "expvisitduration";
  static const String FDN_EXPVISITDURATIONSTR = "expvisitdurationstr";
  static const String FDN_EXPVISITPERCENT = "expvisitpercent";
  static const String FDN_EXPVISITWORKPERCENT = "expvisitworkpercent";
  static const String FDN_EXPWORKDAY = "expworkday";
  static const String FDN_EXPYEAR = "expyear";
  static const String FDN_EXTALIAS = "extalias";
  static const String FDN_EXTCODE = "extcode";
  static const String FDN_EXTCONTROLLER = "extcontroller";
  static const String FDN_EXTENSION = "extension";
  static const String FDN_EXTENSIONCLOSED = "extensionclosed";
  static const String FDN_EXTENTION = "extention";
  static const String FDN_EXTENTIONCLOSED = "extentionclosed";
  static const String FDN_EXTPRICE = "extprice";
  static const String FDN_EXTRA = "extra";
  static const String FDN_EXTRA1 = "extra1";
  static const String FDN_EXTRA2 = "extra2";
  static const String FDN_EXTRA2RATE = "extra2rate";
  static const String FDN_EXTRA2SUPP = "extra2supp";
  static const String FDN_EXTRA2TEXT = "extra2text";
  static const String FDN_EXTRA3SUPP = "extra3supp";
  static const String FDN_EXTRA4SUPP = "extra4supp";
  static const String FDN_EXTRAADR = "extraadr";
  static const String FDN_EXTRAAPP = "extraapp";
  static const String FDN_EXTRABED = "extrabed";
  static const String FDN_EXTRACORRECTION = "extracorrection";
  static const String FDN_EXTRADISC = "extradisc";
  static const String FDN_EXTRANONFBTOTAL = "extranonfbtotal";
  static const String FDN_EXTRAPAB = "extrapab";
  static const String FDN_EXTRAPAR = "extrapar";
  static const String FDN_EXTRAPAX = "extrapax";
  static const String FDN_EXTRARATE = "extrarate";
  static const String FDN_EXTRAREV = "extrarev";
  static const String FDN_EXTRAREVCURR = "extrarevcurr";
  static const String FDN_EXTRAREVENUE = "extrarevenue";
  static const String FDN_EXTRAREVENUEABG = "extrarevenueabg";
  static const String FDN_EXTRAREVENUECURR = "extrarevenuecurr";
  static const String FDN_EXTRAREVENUEFT = "extrarevenueft";
  static const String FDN_EXTRAREVENUEFTCURR = "extrarevenueftcurr";
  static const String FDN_EXTRAREVENUEHC = "extrarevenuehc";
  static const String FDN_EXTRAREVGROSS = "extrarevgross";
  static const String FDN_EXTRAREVGROSSRPT1 = "extrarevgrossrpt1";
  static const String FDN_EXTRAREVNET = "extrarevnet";
  static const String FDN_EXTRAREVNETRPT1 = "extrarevnetrpt1";
  static const String FDN_EXTRAREVPP = "extrarevpp";
  static const String FDN_EXTRAREVPR = "extrarevpr";
  static const String FDN_EXTRASIT = "extrasit";
  static const String FDN_EXTRATAXRATE = "extrataxrate";
  static const String FDN_EXTRATEXT = "extratext";
  static const String FDN_EXTVIEW = "extview";
  static const String FDN_EXTVIEWMODAL = "extviewmodal";
  static const String FDN_FACTCODE = "factcode";
  static const String FDN_FACTDESC = "factdesc";
  static const String FDN_FACTID = "factid";
  static const String FDN_FALLBACK = "fallback";
  static const String FDN_FAQS = "faqs";
  static const String FDN_FATHERNAME = "fathername";
  static const String FDN_FATURANO = "faturano";
  static const String FDN_FAX = "fax";
  static const String FDN_FB = "fb";
  static const String FDN_FBDIFF = "fbdiff";
  static const String FDN_FBRATIO = "fbratio";
  static const String FDN_FBREVGROSS = "fbrevgross";
  static const String FDN_FBREVGROSSRPT1 = "fbrevgrossrpt1";
  static const String FDN_FBREVNET = "fbrevnet";
  static const String FDN_FBREVNETRPT1 = "fbrevnetrpt1";
  static const String FDN_FGCOLOR = "fgcolor";
  static const String FDN_FIELD = "field";
  static const String FDN_FIELDCAPTION = "fieldcaption";
  static const String FDN_FIELDCHARSET = "fieldcharset";
  static const String FDN_FIELDCOUNT = "fieldcount";
  static const String FDN_FIELDDESC = "fielddesc";
  static const String FDN_FIELDID = "fieldid";
  static const String FDN_FIELDLEN = "fieldlen";
  static const String FDN_FIELDLENGTH = "fieldlength";
  static const String FDN_FIELDNAME = "fieldname";
  static const String FDN_FIELDNAMES = "fieldnames";
  static const String FDN_FIELDNEWVALUE = "fieldnewvalue";
  static const String FDN_FIELDOLDVALUE = "fieldoldvalue";
  static const String FDN_FIELDOPERATOR = "fieldoperator";
  static const String FDN_FIELDPOS = "fieldpos";
  static const String FDN_FIELDPRECISION = "fieldprecision";
  static const String FDN_FIELDS = "fields";
  static const String FDN_FIELDSCALE = "fieldscale";
  static const String FDN_FIELDSUBTYPE = "fieldsubtype";
  static const String FDN_FIELDTYPE = "fieldtype";
  static const String FDN_FIELDTYPEDESC = "fieldtypedesc";
  static const String FDN_FIELDTYPENAME = "fieldtypename";
  static const String FDN_FIELDVALUE = "fieldvalue";
  static const String FDN_FIELD_NAME = "field_name";
  static const String FDN_FILE = "file";
  static const String FDN_FILECAPTION = "filecaption";
  static const String FDN_FILECODE = "filecode";
  static const String FDN_FILECOUNT = "filecount";
  static const String FDN_FILEDATA = "filedata";
  static const String FDN_FILEDESC = "filedesc";
  static const String FDN_FILEID = "fileid";
  static const String FDN_FILELEN = "filelen";
  static const String FDN_FILENAME = "filename";
  static const String FDN_FILENAMEFULL = "filenamefull";
  static const String FDN_FILENAMEUPPER = "filenameupper";
  static const String FDN_FILEPARENTID = "fileparentid";
  static const String FDN_FILEPATH = "filepath";
  static const String FDN_CACHE_FILEPATH = "filePath";
  static const String FDN_FILETYPE = "filetype";
  static const String FDN_FILEURL = "fileurl";
  static const String FDN_FILEVER = "filever";
  static const String FDN_FILES = "files";
  static const String FDN_FILTERSTR = "filterstr";
  static const String FDN_FINGROUPCODE = "fingroupcode";
  static const String FDN_FINGROUPDESC = "fingroupdesc";
  static const String FDN_FINGROUPID = "fingroupid";
  static const String FDN_FINGROUPLONGDESC = "fingrouplongdesc";
  static const String FDN_FINISHDATETIME = "finishdatetime";
  static const String FDN_FINNOTE = "finnote";
  static const String FDN_FINNOTEFULL = "finnotefull";
  static const String FDN_FINREQTYPE = "finreqtype";
  static const String FDN_FINREQTYPEDESC = "finreqtypedesc";
  static const String FDN_FINTYPECODE = "fintypecode";
  static const String FDN_FINTYPEDESC = "fintypedesc";
  static const String FDN_FINTYPEID = "fintypeid";
  static const String FDN_FINTYPELONGDESC = "fintypelongdesc";
  static const String FDN_FIRSTENTDATE = "firstentdate";
  static const String FDN_FIRSTINVDATE = "firstinvdate";
  static const String FDN_FIRSTNAME = "firstname";
  static const String FDN_FIRSTPRICE = "firstprice";
  static const String FDN_FIRSTUSER = "firstuser";
  static const String FDN_FIRSTUSERID = "firstuserid";
  static const String FDN_FIRSTUSERNAME = "firstusername";
  static const String FDN_FIXED = "fixed";
  static const String FDN_FIXEDDAYS = "fixeddays";
  static const String FDN_FIXEDDAYSTYPE = "fixeddaystype";
  static const String FDN_FIXEDISPP = "fixedispp";
  static const String FDN_FKFIELD = "fkfield";
  static const String FDN_FKIDFIELD = "fkidfield";
  static const String FDN_FKINDEX = "fkindex";
  static const String FDN_FKNAME = "fkname";
  static const String FDN_FKTABLE = "fktable";
  static const String FDN_FLAGPHOTO = "flagphoto";
  static const String FDN_FLDCOLOR = "fldcolor";
  static const String FDN_FLDLIST = "fldlist";
  static const String FDN_FLDNAME = "fldname";
  static const String FDN_FLDPOS = "fldpos";
  static const String FDN_FLDTYPE = "fldtype";
  static const String FDN_FLDVALUE = "fldvalue";
  static const String FDN_FLEXIPAY = "flexipay";
  static const String FDN_FLIGHTNO = "flightno";
  static const String FDN_FLOORCODE = "floorcode";
  static const String FDN_FLOORDESC = "floordesc";
  static const String FDN_FLOOREMPCODE = "floorempcode";
  static const String FDN_FLOOREMPID = "floorempid";
  static const String FDN_FLOOREMPNAME = "floorempname";
  static const String FDN_FLOORID = "floorid";
  static const String FDN_FLYDATE = "flydate";
  static const String FDN_FLYFROM = "flyfrom";
  static const String FDN_FLYPLACE = "flyplace";
  static const String FDN_FLYTIME = "flytime";
  static const String FDN_FMR = "fmr";
  static const String FDN_FOLDER = "folder";
  static const String FDN_FOLDERID = "folderid";
  static const String FDN_FOLIO = "folio";
  static const String FDN_FOLIOBALANCE = "foliobalance";
  static const String FDN_FOLIOCREDIT = "foliocredit";
  static const String FDN_FOLIODEBIT = "foliodebit";
  static const String FDN_FOLIOLIST = "foliolist";
  static const String FDN_FOLIONO = "foliono";
  static const String FDN_FOLIONONPOSTOTAL = "foliononpostotal";
  static const String FDN_FOLIONOTE = "folionote";
  static const String FDN_FOLIOPAX = "foliopax";
  static const String FDN_FOLIOPAYMENT = "foliopayment";
  static const String FDN_FOLIOPOSTOTAL = "foliopostotal";
  static const String FDN_FOLIOSUBNO = "foliosubno";
  static const String FDN_FOLIOTOTALCHD = "foliototalchd";
  static const String FDN_FOLIOTRANSNO = "foliotransno";
  static const String FDN_FOLIOTYPE = "foliotype";
  static const String FDN_FOLLOWUP = "followup";
  static const String FDN_FOLROOMNO = "folroomno";
  static const String FDN_FOLTRANSCOUNT = "foltranscount";
  static const String FDN_FOLTRANSCOUNTTOTAL = "foltranscounttotal";
  static const String FDN_FOLTRANSNO = "foltransno";
  static const String FDN_FOLTROK = "foltrok";
  static const String FDN_FOLTRTOTAL = "foltrtotal";
  static const String FDN_FOOD = "food";
  static const String FDN_FOODCOST = "foodcost";
  static const String FDN_FOODREV = "foodrev";
  static const String FDN_FOODSTORE = "foodstore";
  static const String FDN_FOODSTORECODE = "foodstorecode";
  static const String FDN_FOODSTOREDESC = "foodstoredesc";
  static const String FDN_FOODSTOREID = "foodstoreid";
  static const String FDN_FOODTOTAL = "foodtotal";
  static const String FDN_FORCE = "force";
  static const String FDN_FORCESWRITES = "forceswrites";
  static const String FDN_FORECAST = "forecast";
  static const String FDN_FORECOLOR = "forecolor";
  static const String FDN_FORMACTION = "formaction";
  static const String FDN_FORMCLASS = "formclass";
  static const String FDN_FORMID = "formid";
  static const String FDN_FORMNAME = "formname";
  static const String FDN_FORMTYPE = "formtype";
  static const String FDN_FORMURL = "formurl";
  static const String FDN_FORONLY = "foronly";
  static const String FDN_FOUNDBY = "foundby";
  static const String FDN_FOUNDCOUNT = "foundcount";
  static const String FDN_FOUNDDATE = "founddate";
  static const String FDN_FOUNDLOCCODE = "foundloccode";
  static const String FDN_FOUNDLOCDESC = "foundlocdesc";
  static const String FDN_FOUNDLOCID = "foundlocid";
  static const String FDN_FOUNDON = "foundon";
  static const String FDN_FREE = "free";
  static const String FDN_FREEAMOUNT = "freeamount";
  static const String FDN_FREEINCBOARD = "freeincboard";
  static const String FDN_FREEINCURR = "freeincurr";
  static const String FDN_FREEINPAX = "freeinpax";
  static const String FDN_FREEINROOM = "freeinroom";
  static const String FDN_FREEZEDAYS = "freezedays";
  static const String FDN_FREQ = "freq";
  static const String FDN_FREQ2 = "freq2";
  static const String FDN_FREQ3 = "freq3";
  static const String FDN_FREQ4 = "freq4";
  static const String FDN_FREQ5 = "freq5";
  static const String FDN_FREQAVGMAXDIFF = "freqavgmaxdiff";
  static const String FDN_FREQAVGVISIT = "freqavgvisit";
  static const String FDN_FREQID = "freqid";
  static const String FDN_FREQMAXVISIT = "freqmaxvisit";
  static const String FDN_FREQMINAVGDIFF = "freqminavgdiff";
  static const String FDN_FREQMINMAXDIFF = "freqminmaxdiff";
  static const String FDN_FREQMINVISIT = "freqminvisit";
  static const String FDN_FRI = "fri";
  static const String FDN_FRKEY = "frkey";
  static const String FDN_FRLINEID = "frlineid";
  static const String FDN_FRM = "frm";
  static const String FDN_FRMCLASSNAME = "frmclassname";
  static const String FDN_FROMACCCODE = "fromacccode";
  static const String FDN_FROMACCDESC = "fromaccdesc";
  static const String FDN_FROMACCID = "fromaccid";
  static const String FDN_FROMAGENCY = "fromagency";
  static const String FDN_FROMCLIENTNAME = "fromclientname";
  static const String FDN_FROMCODE = "fromcode";
  static const String FDN_FROMDESC = "fromdesc";
  static const String FDN_FROMEMAIL = "fromemail";
  static const String FDN_FROMFOLIO = "fromfolio";
  static const String FDN_FROMFOLIONO = "fromfoliono";
  static const String FDN_FROMNAME = "fromname";
  static const String FDN_FROMID = "fromid";
  static const String FDN_FROMROOMNO = "fromroomno";
  static const String FDN_FROMSTATUSCODE = "fromstatuscode";
  static const String FDN_FROMTASKDATE = "fromtaskdate";
  static const String FDN_FROMTASKTIME = "fromtasktime";
  static const String FDN_FROMTRANSTYPEDESC = "fromtranstypedesc";
  static const String FDN_FROM_AMOUNT = "from_amount";
  static const String FDN_FROM_CONSUMP_AMOUNT = "from_consump_amount";
  static const String FDN_FROM_CONSUMP_TOTAL = "from_consump_total";
  static const String FDN_FROM_EXIT_AMOUNT = "from_exit_amount";
  static const String FDN_FROM_EXIT_TOTAL = "from_exit_total";
  static const String FDN_FROM_LOSS_AMOUNT = "from_loss_amount";
  static const String FDN_FROM_LOSS_TOTAL = "from_loss_total";
  static const String FDN_FROM_PRICE = "from_price";
  static const String FDN_FROM_RETURN_AMOUNT = "from_return_amount";
  static const String FDN_FROM_RETURN_TOTAL = "from_return_total";
  static const String FDN_FROM_TOTAL = "from_total";
  static const String FDN_FROM_TRANSFER_AMOUNT = "from_transfer_amount";
  static const String FDN_FROM_TRANSFER_TOTAL = "from_transfer_total";
  static const String FDN_FULLDESC = "fulldesc";
  static const String FDN_FULLNAME = "fullname";
  static const String FDN_FULLNAME1 = "fullname1";
  static const String FDN_FUNCNAME = "funcname";
  static const String FDN_FUNCTIONNAME = "functionname";
  static const String FDN_GAINERCODE = "gainercode";
  static const String FDN_GAINERID = "gainerid";
  static const String FDN_GAINERTYPE = "gainertype";
  static const String FDN_GAINERTYPEDESC = "gainertypedesc";
  static const String FDN_GALLERYID = "galleryid";
  static const String FDN_GCFLAG = "gcflag";
  static const String FDN_GCODE = "gcode";
  static const String FDN_GENCYCODE = "gencycode";
  static const String FDN_GENDER = "gender";
  static const String FDN_GENDERDESC = "genderdesc";
  static const String FDN_GENERATORNAME = "generatorname";
  static const String FDN_GENNAME = "genname";
  static const String FDN_GENOB = "genob";
  static const String FDN_GENOBRTYPE = "genobrtype";
  static const String FDN_GENVALUE = "genvalue";
  static const String FDN_GIATAID = "giataid";
  static const String FDN_GID = "gid";
  static const String FDN_GIDSTR = "gidstr";
  static const String FDN_GIVEN1 = "given1";
  static const String FDN_GIVEN2 = "given2";
  static const String FDN_GIVEN3 = "given3";
  static const String FDN_GIVEN4 = "given4";
  static const String FDN_GIVENEMPCODE = "givenempcode";
  static const String FDN_GIVENEMPID = "givenempid";
  static const String FDN_GIVENEMPNAME = "givenempname";
  static const String FDN_GRADDATE = "graddate";
  static const String FDN_GRADIENT = "gradient";
  static const String FDN_GRADLEVEL = "gradlevel";
  static const String FDN_GRANT_TYPE = "grant_type";
  static const String FDN_GRFONTSIZE = "grfontsize";
  static const String FDN_GRIDSTYLE = "gridstyle";
  static const String FDN_GRLEVEL = "grlevel";
  static const String FDN_GROOMCLIENTID = "groomclientid";
  static const String FDN_GROOMNAME = "groomname";
  static const String FDN_GROSSBALANCE = "grossbalance";
  static const String FDN_GROSSCREDIT = "grosscredit";
  static const String FDN_GROSSCURRBALANCE = "grosscurrbalance";
  static const String FDN_GROSSCURRCREDIT = "grosscurrcredit";
  static const String FDN_GROSSCURRDEBIT = "grosscurrdebit";
  static const String FDN_GROSSDEBIT = "grossdebit";
  static const String FDN_GROSSDISCAMOUNT = "grossdiscamount";
  static const String FDN_GROSSDISCRATE = "grossdiscrate";
  static const String FDN_GROSSPRICE = "grossprice";
  static const String FDN_GROSSTOTAL = "grosstotal";
  static const String FDN_GROSSTOTALDISCRATE = "grosstotaldiscrate";
  static const String FDN_GROUPBY = "groupby";
  static const String FDN_GROUPCODE = "groupcode";
  static const String FDN_GROUPDESC = "groupdesc";
  static const String FDN_GROUPID = "groupid";
  static const String FDN_GROUPNAME = "groupname";
  static const String FDN_GROUPNO = "groupno";
  static const String FDN_GROUPORDERNO = "grouporderno";
  static const String FDN_GROUPTOTALS = "grouptotals";
  static const String FDN_GRPCODE = "grpcode";
  static const String FDN_GRPCODELIST = "grpcodelist";
  static const String FDN_GRPDESC = "grpdesc";
  static const String FDN_GRPID = "grpid";
  static const String FDN_GRPITEMCODE = "grpitemcode";
  static const String FDN_GRPITEMDESC = "grpitemdesc";
  static const String FDN_GRPITEMID = "grpitemid";
  static const String FDN_GRPMAINCODE = "grpmaincode";
  static const String FDN_GRPMAINDESC = "grpmaindesc";
  static const String FDN_GRPMAINID = "grpmainid";
  static const String FDN_GRUPADI = "grupadi";
  static const String FDN_GVAL = "gval";
  static const String FDN_HASACCTRANS = "hasacctrans";
  static const String FDN_HASANDRO = "hasandro";
  static const String FDN_HASBIRTHDAY = "hasbirthday";
  static const String FDN_HASBONUS = "hasbonus";
  static const String FDN_HASBOOKER = "hasbooker";
  static const String FDN_HASBREAK = "hasbreak";
  static const String FDN_HASCHEQUE = "hascheque";
  static const String FDN_HASCL = "hascl";
  static const String FDN_HASCLIENTINFOPAGE = "hasclientinfopage";
  static const String FDN_HASCOMMENT = "hascomment";
  static const String FDN_HASCONSUMPPAGE = "hasconsumppage";
  static const String FDN_HASCONTACT = "hascontact";
  static const String FDN_HASDATE = "hasdate";
  static const String FDN_HASDEED = "hasdeed";
  static const String FDN_HASDISC = "hasdisc";
  static const String FDN_HASDMG = "hasdmg";
  static const String FDN_HASDOC = "hasdoc";
  static const String FDN_HASENTITY = "hasentity";
  static const String FDN_HASERVICE = "haservice";
  static const String FDN_HASEVENT = "hasevent";
  static const String FDN_HASEXC = "hasexc";
  static const String FDN_HASFOLIO = "hasfolio";
  static const String FDN_HASFOLTRANS = "hasfoltrans";
  static const String FDN_HASINHOUSELIST = "hasinhouselist";
  static const String FDN_HASINV = "hasinv";
  static const String FDN_HASIPHONE = "hasiphone";
  static const String FDN_HASLF = "haslf";
  static const String FDN_HASLOCATIONPAGE = "haslocationpage";
  static const String FDN_HASLOGIN = "haslogin";
  static const String FDN_HASMEDTRANS = "hasmedtrans";
  static const String FDN_HASMENUPAGE = "hasmenupage";
  static const String FDN_HASRESNAME = "hasresname";
  static const String FDN_HASMULTIHOTEL = "hasmultihotel";
  static const String FDN_HASNOTE = "hasnote";
  static const String FDN_HASNOTEPAGE = "hasnotepage";
  static const String FDN_HASPARTICER = "hasparticer";
  static const String FDN_HASPB = "haspb";
  static const String FDN_HASPOLIST = "haspolist";
  static const String FDN_HASPOS = "haspos";
  static const String FDN_HASPRICEPAGE = "haspricepage";
  static const String FDN_HASPROXY = "hasproxy";
  static const String FDN_HASREM = "hasrem";
  static const String FDN_HASRENTPAGE = "hasrentpage";
  static const String FDN_HASREPLY = "hasreply";
  static const String FDN_HASRES = "hasres";
  static const String FDN_HASRESERV = "hasreserv";
  static const String FDN_HASRESEVENT = "hasresevent";
  static const String FDN_HASRESRATE = "hasresrate";
  static const String FDN_HASREVIEW = "hasreview";
  static const String FDN_HASROOM = "hasroom";
  static const String FDN_HASROUTING = "hasrouting";
  static const String FDN_HASSALEPAGE = "hassalepage";
  static const String FDN_HASSPECIALPRICE = "hasspecialprice";
  static const String FDN_HASSTOPSALE = "hasstopsale";
  static const String FDN_HASSTTRANS = "hassttrans";
  static const String FDN_HASSUCCER = "hassuccer";
  static const String FDN_HASSUPPREQ = "hassuppreq";
  static const String FDN_HASSURVEY = "hassurvey";
  static const String FDN_HASTASK = "hastask";
  static const String FDN_HASTASKPAGE = "hastaskpage";
  static const String FDN_HASTATPAGE = "hastatpage";
  static const String FDN_HASTESTD = "hastestd";
  static const String FDN_HASTESTCUSTOM = "hastestcustom";
  static const String FDN_HASTIME = "hastime";
  static const String FDN_HASTRANSFER = "hastransfer";
  static const String FDN_HASTRANSFERRETURN = "hastransferreturn";
  static const String FDN_HASTS = "hasts";
  static const String FDN_HASWEB = "hasweb";
  static const String FDN_HASWEDDING = "haswedding";
  static const String FDN_HASWEDDINGPAGE = "hasweddingpage";
  static const String FDN_HB = "hb";
  static const String FDN_HBDIFF = "hbdiff";
  static const String FDN_HBRATIO = "hbratio";
  static const String FDN_HCID = "hcid";
  static const String FDN_HEADCODE = "headcode";
  static const String FDN_HEADEMAIL = "heademail";
  static const String FDN_HEADID = "headid";
  static const String FDN_HEADNAME = "headname";
  static const String FDN_HEALTHINFO = "healthinfo";
  static const String FDN_HECKIN = "heckin";
  static const String FDN_HEXCODE = "hexcode";
  static const String FDN_HGRPORTAL = "hgrportal";
  static const String FDN_HGRPORTALDESC = "hgrportaldesc";
  static const String FDN_HKEMPID = "hkempid";
  static const String FDN_HKSTATE = "hkstate";
  static const String FDN_HKSTATEID = "hkstateid";
  static const String FDN_HKSCORE = "hkscore";
  static const String FDN_HKRATING = "hkrating";
  static const String FDN_HKTASKNO = "hktaskno";
  static const String FDN_HISTORY = "history";
  static const String FDN_HOBBY = "hobby";
  static const String FDN_HOLIDAYTYPE = "holidaytype";
  static const String FDN_HOMECURR = "homecurr";
  static const String FDN_HOMECURRTOTAL = "homecurrtotal";
  static const String FDN_HOSPITALCODE = "hospitalcode";
  static const String FDN_HOSPITALID = "hospitalid";
  static const String FDN_HOTELCODE = "hotelcode";
  static const String FDN_HOTELCOUNTMONTHLY = "hotelcountmonthly";
  static const String FDN_HOTELCOUNTWEEKLY = "hotelcountweekly";
  static const String FDN_HOTELCOUNTYEARLY = "hotelcountyearly";
  static const String FDN_HOTELDESC = "hoteldesc";
  static const String FDN_HOTELDOCROOT = "hoteldocroot";
  static const String FDN_HOTELGIDSTR = "hotelgidstr";
  static const String FDN_HOTELID = "hotelid";
  static const String FDN_HOTELINI = "hotelini";
  static const String FDN_HOTELKEY = "hotelkey";
  static const String FDN_HOTELAT = "hotelat";
  static const String FDN_HOTELLOGO = "hotellogo";
  static const String FDN_HOTELMID = "hotelmid";
  static const String FDN_HOTELNAME = "hotelname";
  static const String FDN_HOTELNG = "hotelng";
  static const String FDN_HOTELPID = "hotelpid";
  static const String FDN_HOTELRACKNO = "hotelrackno";
  static const String FDN_HOTELREFNO = "hotelrefno";
  static const String FDN_HOTELREGID = "hotelregid";
  static const String FDN_HOTELTOPID = "hoteltopid";
  static const String FDN_HOTELTYPE = "hoteltype";
  static const String FDN_HOTELTYPECODE = "hoteltypecode";
  static const String FDN_HOTELTYPEDESC = "hoteltypedesc";
  static const String FDN_HOTELTYPEID = "hoteltypeid";
  static const String FDN_HOURQUOTA = "hourquota";
  static const String FDN_HREFNO = "hrefno";
  static const String FDN_HTMLID = "htmlid";
  static const String FDN_HTMLNAME = "htmlname";
  static const String FDN_HUBABY = "hubaby";
  static const String FDN_HUCHD = "huchd";
  static const String FDN_HUCHD1 = "huchd1";
  static const String FDN_HUCHD2 = "huchd2";
  static const String FDN_HUPAX = "hupax";
  static const String FDN_HUROOM = "huroom";
  static const String FDN_HUSE = "huse";
  static const String FDN_HVAL = "hval";
  static const String FDN_IANA = "iana";
  static const String FDN_IBAN = "iban";
  static const String FDN_IBANCODE = "ibancode";
  static const String FDN_ICAOCODE = "icaocode";
  static const String FDN_ICON = "icon";
  static const String FDN_ICONCLS = "iconcls";
  static const String FDN_ICONCODE = "iconcode";
  static const String FDN_ID = "id";
  static const String FDN_IDCITY = "idcity";
  static const String FDN_IDDATE = "iddate";
  static const String FDN_IDDISTRICT = "iddistrict";
  static const String FDN_IDFAMILYNO = "idfamilyno";
  static const String FDN_IDNO = "idno";
  static const String FDN_IDORDERNO = "idorderno";
  static const String FDN_IDPLACEOFISSUE = "idplaceofissue";
  static const String FDN_IDTOWN = "idtown";
  static const String FDN_IDTYPE = "idtype";
  static const String FDN_IDVOLUMENO = "idvolumeno";
  static const String FDN_IDXNAME = "idxname";
  static const String FDN_IDXREADS = "idxreads";
  static const String FDN_IMAGEFOLDER = "imagefolder";
  static const String FDN_IMAGEID = "imageid";
  static const String FDN_IMAGEINDEX = "imageindex";
  static const String FDN_IMAGEURL = "imageurl";
  static const String FDN_IMGFILESIZE = "imgfilesize";
  static const String FDN_IMGHEIGHT = "imgheight";
  static const String FDN_IMGTYPE = "imgtype";
  static const String FDN_IMGURL = "imgurl";
  static const String FDN_IMGWIDTH = "imgwidth";
  static const String FDN_INBOUND = "inbound";
  static const String FDN_INBOX = "inbox";
  static const String FDN_INBOXNAME = "inboxname";
  static const String FDN_INCBFAST = "incbfast";
  static const String FDN_INCBOARDTYPE = "incboardtype";
  static const String FDN_INCCOMP = "inccomp";
  static const String FDN_INCCOST = "inccost";
  static const String FDN_INCDINNER = "incdinner";
  static const String FDN_INCEXCHANGE = "incexchange";
  static const String FDN_INCEXCRATE = "incexcrate";
  static const String FDN_INCEXTRA = "incextra";
  static const String FDN_INCFRC = "incfrc";
  static const String FDN_INCHAIN = "inchain";
  static const String FDN_INCINVOICE = "incinvoice";
  static const String FDN_INCLEAPYEAR = "incleapyear";
  static const String FDN_INCLUNCHCI = "inclunchci";
  static const String FDN_INCLUNCHCO = "inclunchco";
  static const String FDN_INCLY = "incly";
  static const String FDN_INCMONTHEND = "incmonthend";
  static const String FDN_INCOCC = "incocc";
  static const String FDN_INCOCCNATION = "incoccnation";
  static const String FDN_INCOCCPAYTYPE = "incoccpaytype";
  static const String FDN_INCOCCROOMTYPE = "incoccroomtype";
  static const String FDN_INCPAYMENT = "incpayment";
  static const String FDN_INCRATE = "incrate";
  static const String FDN_INCREG = "increg";
  static const String FDN_INCREV = "increv";
  static const String FDN_INCREVFB = "increvfb";
  static const String FDN_INCREVTOTAL = "increvtotal";
  static const String FDN_INCSEARCH = "incsearch";
  static const String FDN_INCSGROUP = "incsgroup";
  static const String FDN_INCSHIPCOST = "incshipcost";
  static const String FDN_INCTAX = "inctax";
  static const String FDN_INDENTSTR = "indentstr";
  static const String FDN_INDEXNAME = "indexname";
  static const String FDN_INDEXTYPE = "indextype";
  static const String FDN_INENG = "ineng";
  static const String FDN_INFDISC = "infdisc";
  static const String FDN_INFOBONUSPRICE = "infobonusprice";
  static const String FDN_INFOBONUSRATE = "infobonusrate";
  static const String FDN_INFOBONUSTOTAL = "infobonustotal";
  static const String FDN_INFOBONUSTPLCODE = "infobonustplcode";
  static const String FDN_INFOBONUSTPLID = "infobonustplid";
  static const String FDN_INFOEMPCODE = "infoempcode";
  static const String FDN_INFOEMPID = "infoempid";
  static const String FDN_INFOEMPNAME = "infoempname";
  static const String FDN_INFONOTE = "infonote";
  static const String FDN_INFOOK = "infook";
  static const String FDN_INFRE = "infre";
  static const String FDN_INGER = "inger";
  static const String FDN_INHOUSE = "inhouse";
  static const String FDN_INHOUSEREV = "inhouserev";
  static const String FDN_INIFILE = "inifile";
  static const String FDN_INIFILEUPPER = "inifileupper";
  static const String FDN_INIKEY = "inikey";
  static const String FDN_INIKEYUPPER = "inikeyupper";
  static const String FDN_INISECTION = "inisection";
  static const String FDN_INISECTIONPFX = "inisectionpfx";
  static const String FDN_INISECTIONUPPER = "inisectionupper";
  static const String FDN_INITABLE = "initable";
  static const String FDN_INITDURATION = "initduration";
  static const String FDN_INITDURATIONMIN = "initdurationmin";
  static const String FDN_INITIALBALANCE = "initialbalance";
  static const String FDN_INITIALCOST = "initialcost";
  static const String FDN_INITIALCREDIT = "initialcredit";
  static const String FDN_INITIALCURRBALANCE = "initialcurrbalance";
  static const String FDN_INITIALDATE = "initialdate";
  static const String FDN_INITIALDEBIT = "initialdebit";
  static const String FDN_INITIALPRICE = "initialprice";
  static const String FDN_INITIALTIME = "initialtime";
  static const String FDN_INITIALTOTAL = "initialtotal";
  static const String FDN_INITIALUSERCODE = "initialusercode";
  static const String FDN_INITIALUSERID = "initialuserid";
  static const String FDN_INITIAL_AMOUNT = "initial_amount";
  static const String FDN_INITIAL_TOTAL = "initial_total";
  static const String FDN_INIVALUE = "inivalue";
  static const String FDN_INIVALUEINT = "inivalueint";
  static const String FDN_INIVALUESTRING = "inivaluestring";
  static const String FDN_INIVALUEDOUBLE = "inivaluedouble";
  static const String FDN_INIVALUEBOOLEAN = "inivalueboolean";
  static const String FDN_INIVALUEUPPER = "inivalueupper";
  static const String FDN_INPUTWIDTH = "inputwidth";
  static const String FDN_INSDATE = "insdate";
  static const String FDN_INSDATETIME = "insdatetime";
  static const String FDN_INSDT = "insdt";
  static const String FDN_INSTCOUNT = "instcount";
  static const String FDN_INSTID = "instid";
  static const String FDN_INSTIME = "instime";
  static const String FDN_INSTLINECODE = "instlinecode";
  static const String FDN_INSTLINEDESC = "instlinedesc";
  static const String FDN_INSTLINEID = "instlineid";
  static const String FDN_INSTLINEWORKTYPECODE = "instlineworktypecode";
  static const String FDN_INSTLINEWORKTYPEDESC = "instlineworktypedesc";
  static const String FDN_INSTLINEWORKTYPEID = "instlineworktypeid";
  static const String FDN_INSTNOTECOUNT = "instnotecount";
  static const String FDN_INSTYPE = "instype";
  static const String FDN_INSTYPEDESC = "instypedesc";
  static const String FDN_INSURDATE = "insurdate";
  static const String FDN_INSURERCODE = "insurercode";
  static const String FDN_INSURERID = "insurerid";
  static const String FDN_INSURNOTE = "insurnote";
  static const String FDN_INSUSERCODE = "insusercode";
  static const String FDN_INSUSERDESC = "insuserdesc";
  static const String FDN_INSUSERID = "insuserid";
  static const String FDN_INSUSERNAME = "insusername";
  static const String FDN_INSUSERSHORT = "insusershort";
  static const String FDN_INTERESTOTAL = "interestotal";
  static const String FDN_INTERNALSERIALNO = "internalserialno";
  static const String FDN_INTERVALRESLIMIT = "intervalreslimit";
  static const String FDN_INTRATE = "intrate";
  static const String FDN_INVADDRESS = "invaddress";
  static const String FDN_INVAGENCY = "invagency";
  static const String FDN_INVBALANCE = "invbalance";
  static const String FDN_INVBALDIFF = "invbaldiff";
  static const String FDN_INVCLIENT = "invclient";
  static const String FDN_INVCOLLPERCENTLASTYEARLY = "invcollpercentlastyearly";
  static const String FDN_INVCOLLPERCENTMONTHLY = "invcollpercentmonthly";
  static const String FDN_INVCOLLPERCENTWEEKLY = "invcollpercentweekly";
  static const String FDN_INVCOLLPERCENTYEARLY = "invcollpercentyearly";
  static const String FDN_INVCURR = "invcurr";
  static const String FDN_INVDATE = "invdate";
  static const String FDN_INVDISCAMOUNT = "invdiscamount";
  static const String FDN_INVDISCOUNT = "invdiscount";
  static const String FDN_INVDISCOUNT2 = "invdiscount2";
  static const String FDN_INVDISCRATE = "invdiscrate";
  static const String FDN_INVEXCRATE = "invexcrate";
  static const String FDN_INVFO = "invfo";
  static const String FDN_INVID = "invid";
  static const String FDN_INVLINETOTAL = "invlinetotal";
  static const String FDN_INVNETAMOUNT = "invnetamount";
  static const String FDN_INVNETTOTAL = "invnettotal";
  static const String FDN_INVNONSRVNOW = "invnonsrvnow";
  static const String FDN_INVNONSRVPREV = "invnonsrvprev";
  static const String FDN_INVOICENO = "invoiceno";
  static const String FDN_INVOICETYPE = "invoicetype";
  static const String FDN_INVOICETYPECODE = "invoicetypecode";
  static const String FDN_INVPAYMENT = "invpayment";
  static const String FDN_INVRATE = "invrate";
  static const String FDN_INVSALEGRP = "invsalegrp";
  static const String FDN_INVSRVNOW = "invsrvnow";
  static const String FDN_INVSRVPREV = "invsrvprev";
  static const String FDN_INVSUBTOTAL = "invsubtotal";
  static const String FDN_INVSUPP = "invsupp";
  static const String FDN_INVTAXAMOUNT = "invtaxamount";
  static const String FDN_INVTESTNO = "invtestno";
  static const String FDN_INVTITLE = "invtitle";
  static const String FDN_INVTOTAL = "invtotal";
  static const String FDN_INVTOTALCURR = "invtotalcurr";
  static const String FDN_INVTOTALLASTYEARLY = "invtotallastyearly";
  static const String FDN_INVTOTALMONTHLY = "invtotalmonthly";
  static const String FDN_INVTOTALWEEKLY = "invtotalweekly";
  static const String FDN_INVTOTALYEARLY = "invtotalyearly";
  static const String FDN_INVTRANSDATE = "invtransdate";
  static const String FDN_INVTRANSNO = "invtransno";
  static const String FDN_INVTRANSNOSTR = "invtransnostr";
  static const String FDN_INVTRANSTIME = "invtranstime";
  static const String FDN_INVTYPE = "invtype";
  static const String FDN_INVTYPECODE = "invtypecode";
  static const String FDN_INVTYPEDESC = "invtypedesc";
  static const String FDN_INVTYPEID = "invtypeid";
  static const String FDN_INVUSERID = "invuserid";
  static const String FDN_INVVAT = "invvat";
  static const String FDN_INVVAT0 = "invvat0";
  static const String FDN_INVVAT0AMOUNT = "invvat0amount";
  static const String FDN_INVVAT0RATE = "invvat0rate";
  static const String FDN_INVVAT1 = "invvat1";
  static const String FDN_INVVAT18 = "invvat18";
  static const String FDN_INVVAT18AMOUNT = "invvat18amount";
  static const String FDN_INVVAT1AMOUNT = "invvat1amount";
  static const String FDN_INVVAT1RATE = "invvat1rate";
  static const String FDN_INVVAT8 = "invvat8";
  static const String FDN_INVVAT8AMOUNT = "invvat8amount";
  static const String FDN_INVVAT8RATE = "invvat8rate";
  static const String FDN_INVWAITING = "invwaiting";
  static const String FDN_INVYEARTOTAL = "invyeartotal";
  static const String FDN_IOC = "ioc";
  static const String FDN_IPADDR = "ipaddr";
  static const String FDN_IPADDRESS = "ipaddress";
  static const String FDN_IPCOUNTRY = "ipcountry";
  static const String FDN_IS = "is";
  static const String FDN_ISACADEMIC = "isacademic";
  static const String FDN_ISACC = "isacc";
  static const String FDN_ISACCLOGIN = "isacclogin";
  static const String FDN_ISACCWAITING = "isaccwaiting";
  static const String FDN_ISACTIVE = "isactive";
  static const String FDN_ISACTIVEALL = "isactiveall";
  static const String FDN_ISACTIVEEMP = "isactiveemp";
  static const String FDN_ISACTIVEFROM = "isactivefrom";
  static const String FDN_ISACTIVELESS = "isactiveless";
  static const String FDN_ISACTIVEMP = "isactivemp";
  static const String FDN_ISACTIVENON = "isactivenon";
  static const String FDN_ISACTIVETO = "isactiveto";
  static const String FDN_ISACTIVITY = "isactivity";
  static const String FDN_ISADDRESS = "isaddress";
  static const String FDN_ISALCOHOL = "isalcohol";
  static const String FDN_ISALLLINE = "isallline";
  static const String FDN_ISALLOTMENT = "isallotment";
  static const String FDN_ISAPPROVED = "isapproved";
  static const String FDN_ISAPRED = "isapred";
  static const String FDN_ISAPRSTATUS = "isaprstatus";
  static const String FDN_ISARCHIVE = "isarchive";
  static const String FDN_ISARCHIVED = "isarchived";
  static const String FDN_ISASP = "isasp";
  static const String FDN_ISAUTH = "isauth";
  static const String FDN_ISAUTHALL = "isauthall";
  static const String FDN_ISAUTHLESS = "isauthless";
  static const String FDN_ISAUTHNON = "isauthnon";
  static const String FDN_ISAUTO = "isauto";
  static const String FDN_ISAUTOCOMMIT = "isautocommit";
  static const String FDN_ISAUTOPOST = "isautopost";
  static const String FDN_ISAUTOUNDO = "isautoundo";
  static const String FDN_ISAVAIL = "isavail";
  static const String FDN_ISBALTR = "isbaltr";
  static const String FDN_ISBANKCASH = "isbankcash";
  static const String FDN_ISBANQUET = "isbanquet";
  static const String FDN_ISBEV = "isbev";
  static const String FDN_ISBGREV = "isbgrev";
  static const String FDN_ISBINDING = "isbinding";
  static const String FDN_ISBIZADV = "isbizadv";
  static const String FDN_ISBLACK = "isblack";
  static const String FDN_ISBLOCK = "isblock";
  static const String FDN_ISBLOCKED = "isblocked";
  static const String FDN_ISBOARDING = "isboarding";
  static const String FDN_ISBONUS = "isbonus";
  static const String FDN_ISBOOKED = "isbooked";
  static const String FDN_ISBOOKER = "isbooker";
  static const String FDN_ISBRANCH = "isbranch";
  static const String FDN_ISBUSY = "isbusy";
  static const String FDN_ISCACHE = "iscache";
  static const String FDN_ISCAL = "iscal";
  static const String FDN_ISCALC = "iscalc";
  static const String FDN_ISCALCLOCKED = "iscalclocked";
  static const String FDN_ISCALLNOTE = "iscallnote";
  static const String FDN_ISCANCEL = "iscancel";
  static const String FDN_ISCASH = "iscash";
  static const String FDN_ISCB = "iscb";
  static const String FDN_ISCDEF = "iscdef";
  static const String FDN_ISCHAIN = "ischain";
  static const String FDN_ISCHARGED = "ischarged";
  static const String FDN_ISCHDNOINCAT = "ischdnoincat";
  static const String FDN_ISCHEQUE = "ischeque";
  static const String FDN_ISCI = "isci";
  static const String FDN_ISCLIENT = "isclient";
  static const String FDN_ISCLOSE = "isclose";
  static const String FDN_ISCLOSED = "isclosed";
  static const String FDN_ISCO = "isco";
  static const String FDN_ISCOLL = "iscoll";
  static const String FDN_ISCOMM = "iscomm";
  static const String FDN_ISCOMPLAINT = "iscomplaint";
  static const String FDN_ISCOMPUTED = "iscomputed";
  static const String FDN_ISCONACTIVE = "isconactive";
  static const String FDN_ISCONFIRMED = "isconfirmed";
  static const String FDN_ISCONT = "iscont";
  static const String FDN_ISCONTACT = "iscontact";
  static const String FDN_ISCONTEXT = "iscontext";
  static const String FDN_ISCRCARD = "iscrcard";
  static const String FDN_ISCREDIT = "iscredit";
  static const String FDN_ISCRM = "iscrm";
  static const String FDN_ISCURR = "iscurr";
  static const String FDN_ISCURRENCY = "iscurrency";
  static const String FDN_ISCUSTOM = "iscustom";
  static const String FDN_ISCUSTOMENU = "iscustomenu";
  static const String FDN_ISDAILY = "isdaily";
  static const String FDN_ISDEBIT = "isdebit";
  static const String FDN_ISDEELIVERED = "isdeelivered";
  static const String FDN_ISDEF = "isdef";
  static const String FDN_ISDEFBANQUET = "isdefbanquet";
  static const String FDN_ISDEFINIT = "isdefinit";
  static const String FDN_ISDEFLOCRES = "isdeflocres";
  static const String FDN_ISDEFSOL = "isdefsol";
  static const String FDN_ISDEFSPA = "isdefspa";
  static const String FDN_ISDEL = "isdel";
  static const String FDN_ISDELIVERED = "isdelivered";
  static const String FDN_ISDEPART = "isdepart";
  static const String FDN_ISDEPFOLIO = "isdepfolio";
  static const String FDN_ISDEPOSIT = "isdeposit";
  static const String FDN_ISDIRECTSALE = "isdirectsale";
  static const String FDN_ISDND = "isdnd";
  static const String FDN_ISDOC = "isdoc";
  static const String FDN_ISDONE = "isdone";
  static const String FDN_ISDROPPED = "isdropped";
  static const String FDN_ISEB = "iseb";
  static const String FDN_ISEI = "isei";
  static const String FDN_ISEINVINBOX = "iseinvinbox";
  static const String FDN_ISEINVSENT = "iseinvsent";
  static const String FDN_ISEINVUSER = "iseinvuser";
  static const String FDN_ISEMAIL = "isemail";
  static const String FDN_ISEMP = "isemp";
  static const String FDN_ISEMPLOCKED = "isemplocked";
  static const String FDN_ISEMPLOYEE = "isemployee";
  static const String FDN_ISEMPSELF = "isempself";
  static const String FDN_ISEMPSHIFT = "isempshift";
  static const String FDN_ISEMPTYLINE = "isemptyline";
  static const String FDN_ISEMPVISITOR = "isempvisitor";
  static const String FDN_ISERROR = "iserror";
  static const String FDN_ISEVENTLOC = "iseventloc";
  static const String FDN_ISEVENTRESRC = "iseventresrc";
  static const String FDN_ISEXC = "isexc";
  static const String FDN_ISEXCLUSIVE = "isexclusive";
  static const String FDN_ISEXCRATELOCK = "isexcratelock";
  static const String FDN_ISEXP = "isexp";
  static const String FDN_ISEXT = "isext";
  static const String FDN_ISFACTCAT = "isfactcat";
  static const String FDN_ISFAV = "isfav";
  static const String FDN_ISFBNOTE = "isfbnote";
  static const String FDN_ISFILE = "isfile";
  static const String FDN_ISFILECHILD = "isfilechild";
  static const String FDN_ISFINREQEMP = "isfinreqemp";
  static const String FDN_ISFIXEDPRICE = "isfixedprice";
  static const String FDN_ISFOLDER = "isfolder";
  static const String FDN_ISFOOD = "isfood";
  static const String FDN_ISFORCEDWRITES = "isforcedwrites";
  static const String FDN_ISFOUND = "isfound";
  static const String FDN_ISFR = "isfr";
  static const String FDN_ISFRAME = "isframe";
  static const String FDN_ISFRONT = "isfront";
  static const String FDN_ISFULLAUTH = "isfullauth";
  static const String FDN_ISGENERATEDEMPVISIT = "isgeneratedempvisit";
  static const String FDN_ISGEO = "isgeo";
  static const String FDN_ISGRAY = "isgray";
  static const String FDN_ISGROSS = "isgross";
  static const String FDN_ISGROUP = "isgroup";
  static const String FDN_ISGROUPMASTER = "isgroupmaster";
  static const String FDN_ISGROUPROOM = "isgrouproom";
  static const String FDN_ISGUID = "isguid";
  static const String FDN_ISGUIDE = "isguide";
  static const String FDN_ISHEAD = "ishead";
  static const String FDN_ISHEALTHNOTE = "ishealthnote";
  static const String FDN_ISHK = "ishk";
  static const String FDN_ISHKTASKNOTE = "ishktasknote";
  static const String FDN_ISHTML = "ishtml";
  static const String FDN_ISHUSE = "ishuse";
  static const String FDN_ISIMGCAT = "isimgcat";
  static const String FDN_ISINHOUSE = "isinhouse";
  static const String FDN_ISINSTART = "isinstart";
  static const String FDN_ISINVADDRESS = "isinvaddress";
  static const String FDN_ISIP = "isip";
  static const String FDN_ISITEMBASEDCOST = "isitembasedcost";
  static const String FDN_ISLARGEBTN = "islargebtn";
  static const String FDN_ISLAST = "islast";
  static const String FDN_ISLEAF = "isleaf";
  static const String FDN_ISLIC = "islic";
  static const String FDN_ISLIKE = "islike";
  static const String FDN_ISLINKED = "islinked";
  static const String FDN_ISLO = "islo";
  static const String FDN_ISLOC = "isloc";
  static const String FDN_ISLOCKED = "islocked";
  static const String FDN_ISLOCRES = "islocres";
  static const String FDN_ISLOGIN = "islogin";
  static const String FDN_ISLOST = "islost";
  static const String FDN_ISMAIDROOM = "ismaidroom";
  static const String FDN_ISMAILSENT = "ismailsent";
  static const String FDN_ISMAIN = "ismain";
  static const String FDN_ISMART = "ismart";
  static const String FDN_ISMENTIONED = "ismentioned";
  static const String FDN_ISMENU = "ismenu";
  static const String FDN_ISMET = "ismet";
  static const String FDN_ISMINALL = "isminall";
  static const String FDN_ISMYROOM = "ismyroom";
  static const String FDN_ISNARPOST = "isnarpost";
  static const String FDN_ISNEG = "isneg";
  static const String FDN_ISNEWVALIDTYPE = "isnewvalidtype";
  static const String FDN_ISNEXTNOW = "isnextnow";
  static const String FDN_ISNIGHTAUDIT = "isnightaudit";
  static const String FDN_ISNOP = "isnop";
  static const String FDN_ISNOTIFYACTIVE = "isnotifyactive";
  static const String FDN_ISNOTNULL = "isnotnull";
  static const String FDN_ISNOTR = "isnotr";
  static const String FDN_ISO2 = "iso2";
  static const String FDN_ISO3 = "iso3";
  static const String FDN_ISOCC = "isocc";
  static const String FDN_ISOD = "isod";
  static const String FDN_ISOFF = "isoff";
  static const String FDN_ISOLATIONMODE = "isolationmode";
  static const String FDN_ISONLINE = "isonline";
  static const String FDN_ISONO = "isono";
  static const String FDN_ISONSITE = "isonsite";
  static const String FDN_ISONACTIVE = "isconactive";
  static const String FDN_ISOOO = "isooo";
  static const String FDN_ISOOS = "isoos";
  static const String FDN_ISOPEN = "isopen";
  static const String FDN_ISOPNOTE = "isopnote";
  static const String FDN_ISORSACTIVE = "isorsactive";
  static const String FDN_ISOUTSIDE = "isoutside";
  static const String FDN_ISOWN = "isown";
  static const String FDN_ISPAID = "ispaid";
  static const String FDN_ISPAIDOUT = "ispaidout";
  static const String FDN_ISPARTIALCO = "ispartialco";
  static const String FDN_ISPASSEMAILED = "ispassemailed";
  static const String FDN_ISPAY = "ispay";
  static const String FDN_ISPAYMENT = "ispayment";
  static const String FDN_ISPERROOM = "isperroom";
  static const String FDN_ISPLAN = "isplan";
  static const String FDN_ISPOS = "ispos";
  static const String FDN_ISPOSDEPART = "isposdepart";
  static const String FDN_ISPOSONLY = "isposonly";
  static const String FDN_ISPOSTABLE = "ispostable";
  static const String FDN_ISPOSTING = "isposting";
  static const String FDN_ISPP = "ispp";
  static const String FDN_ISPREV = "isprev";
  static const String FDN_ISPRICELOCKED = "ispricelocked";
  static const String FDN_ISPRINTABLE = "isprintable";
  static const String FDN_ISPRINTED = "isprinted";
  static const String FDN_ISPRINTEDFTR = "isprintedftr";
  static const String FDN_ISPRINTEDHDR = "isprintedhdr";
  static const String FDN_ISPRINTEDSLIP = "isprintedslip";
  static const String FDN_ISPRIVATE = "isprivate";
  static const String FDN_ISPRODUCT = "isproduct";
  static const String FDN_ISPROVIDER = "isprovider";
  static const String FDN_ISPUBLISHED = "ispublished";
  static const String FDN_ISQUICKLOSTFOUND = "isquicklostfound";
  static const String FDN_ISQUICKTASK = "isquicktask";
  static const String FDN_ISREAD = "isread";
  static const String FDN_ISREADONLY = "isreadonly";
  static const String FDN_ISREC = "isrec";
  static const String FDN_ISRECEIPT = "isreceipt";
  static const String FDN_ISRECOMMENDED = "isrecommended";
  static const String FDN_ISRECURR = "isrecurr";
  static const String FDN_ISRECYEARLY = "isrecyearly";
  static const String FDN_ISREFUNDPART = "isrefundpart";
  static const String FDN_ISREGULAR = "isregular";
  static const String FDN_ISREJSTATUS = "isrejstatus";
  static const String FDN_ISREMID = "isremid";
  static const String FDN_ISREMOTE = "isremote";
  static const String FDN_ISREPEAT = "isrepeat";
  static const String FDN_ISREPLYNOTE = "isreplynote";
  static const String FDN_ISREPLYSALECALL = "isreplysalecall";
  static const String FDN_ISREPORT = "isreport";
  static const String FDN_ISREQ = "isreq";
  static const String FDN_ISREQTYPE = "isreqtype";
  static const String FDN_ISREQWAITING = "isreqwaiting";
  static const String FDN_ISRESDEF = "isresdef";
  static const String FDN_ISRESMASTER = "isresmaster";
  static const String FDN_ISROOM = "isroom";
  static const String FDN_ISROOMDESC = "isroomdesc";
  static const String FDN_ISROOMING = "isrooming";
  static const String FDN_ISROOMINGNOTE = "isroomingnote";
  static const String FDN_ISROOMQTY = "isroomqty";
  static const String FDN_ISROOMSHARED = "isroomshared";
  static const String FDN_ISRUNNING = "isrunning";
  static const String FDN_ISSALE = "issale";
  static const String FDN_ISSALECALL = "issalecall";
  static const String FDN_ISSALETASK = "issaletask";
  static const String FDN_ISSAVED = "issaved";
  static const String FDN_ISSELECTED = "isselected";
  static const String FDN_ISSELF = "isself";
  static const String FDN_ISSEND = "issend";
  static const String FDN_ISSENT = "issent";
  static const String FDN_ISSHAREDMAIN = "issharedmain";
  static const String FDN_ISSHAREDROOM = "issharedroom";
  static const String FDN_ISSHEETCHGTODAY = "issheetchgtoday";
  static const String FDN_ISSHIFTTIME = "isshifttime";
  static const String FDN_ISSIGN = "issign";
  static const String FDN_ISSOCIAL = "issocial";
  static const String FDN_ISSPAEMPTPL = "isspaemptpl";
  static const String FDN_ISSPAINFOEMP = "isspainfoemp";
  static const String FDN_ISSPAINFOTPL = "isspainfotpl";
  static const String FDN_ISSPARES = "isspares";
  static const String FDN_ISSPASALEEMP = "isspasaleemp";
  static const String FDN_ISSPASALETPL = "isspasaletpl";
  static const String FDN_ISSPLIT = "issplit";
  static const String FDN_ISSPLITTED = "issplitted";
  static const String FDN_ISSPTRANS = "issptrans";
  static const String FDN_ISSQL = "issql";
  static const String FDN_ISSTD = "isstd";
  static const String FDN_ISSTH = "issth";
  static const String FDN_ISSUB = "issub";
  static const String FDN_ISSUEDATE = "issuedate";
  static const String FDN_ISSUETIME = "issuetime";
  static const String FDN_ISSUPERHOTEL = "issuperhotel";
  static const String FDN_ISSUPERUSER = "issuperuser";
  static const String FDN_ISSUPPLIER = "issupplier";
  static const String FDN_ISSURVEY = "issurvey";
  static const String FDN_ISSYS = "issys";
  static const String FDN_ISSYSTEM = "issystem";
  static const String FDN_ISTASKTYPE = "istasktype";
  static const String FDN_ISTAX = "istax";
  static const String FDN_ISTEL = "istel";
  static const String FDN_ISTEMP = "istemp";
  static const String FDN_ISTEMPLATE = "istemplate";
  static const String FDN_ISTHEFT = "istheft";
  static const String FDN_ISTODAY = "istoday";
  static const String FDN_ISTODO = "istodo";
  static const String FDN_ISTRIP = "istrip";
  static const String FDN_ISTS = "ists";
  static const String FDN_ISTSBACK = "istsback";
  static const String FDN_ISTSTYPE = "iststype";
  static const String FDN_ISTXTCAT = "istxtcat";
  static const String FDN_ISUNIQUE = "isunique";
  static const String FDN_ISUPGRADE = "isupgrade";
  static const String FDN_ISUSER = "isuser";
  static const String FDN_ISUSERINBOX = "isuserinbox";
  static const String FDN_ISVALID = "isvalid";
  static const String FDN_ISVALUEPP = "isvaluepp";
  static const String FDN_ISVAT = "isvat";
  static const String FDN_ISVC = "isvc";
  static const String FDN_ISVD = "isvd";
  static const String FDN_ISVEHICLE = "isvehicle";
  static const String FDN_ISVERFED = "isverfed";
  static const String FDN_ISVIDCAT = "isvidcat";
  static const String FDN_ISVIEW = "isview";
  static const String FDN_ISVIP = "isvip";
  static const String FDN_ISVISIBLE = "isvisible";
  static const String FDN_ISVISIT = "isvisit";
  static const String FDN_ISVISITNOTE = "isvisitnote";
  static const String FDN_ISWAIT = "iswait";
  static const String FDN_ISWAITER = "iswaiter";
  static const String FDN_ISWAITING = "iswaiting";
  static const String FDN_ISWARN = "iswarn";
  static const String FDN_ISWEB = "isweb";
  static const String FDN_ISWORK = "iswork";
  static const String FDN_ISWORKOFF = "isworkoff";
  static const String FDN_ISWOW = "iswow";
  static const String FDN_ITEM = "item";
  static const String FDN_ITEMAMOUNT = "itemamount";
  static const String FDN_ITEMAUTHLEVEL = "itemauthlevel";
  static const String FDN_ITEMAUTHLEVELSO = "itemauthlevelso";
  static const String FDN_ITEMAUTHLEVELSR = "itemauthlevelsr";
  static const String FDN_ITEMCODE = "itemcode";
  static const String FDN_ITEMCOUNT = "itemcount";
  static const String FDN_ITEMDESC = "itemdesc";
  static const String FDN_ITEMEMPLIST = "itememplist";
  static const String FDN_ITEMGROUP = "itemgroup";
  static const String FDN_ITEMGROUPCODE = "itemgroupcode";
  static const String FDN_ITEMGROUPDESC = "itemgroupdesc";
  static const String FDN_ITEMGROUPID = "itemgroupid";
  static const String FDN_ITEMGROUPLONG = "itemgrouplong";
  static const String FDN_ITEMGROUPNAME = "itemgroupname";
  static const String FDN_ITEMID = "itemid";
  static const String FDN_ITEMINDEX = "itemindex";
  static const String FDN_ITEMINDUSTRY = "itemindustry";
  static const String FDN_ITEMLABELVISIBLE = "itemlabelvisible";
  static const String FDN_ITEMLEVEL = "itemlevel";
  static const String FDN_ITEMLIST = "itemlist";
  static const String FDN_ITEMMID = "itemmid";
  static const String FDN_ITEMNAME = "itemname";
  static const String FDN_ITEMNOTE = "itemnote";
  static const String FDN_ITEMPRICE = "itemprice";
  static const String FDN_ITEMQTY = "itemqty";
  static const String FDN_ITEMQTYID = "itemqtyid";
  static const String FDN_ITEMSQL = "itemsql";
  static const String FDN_ITEMTAXEDRATIO = "itemtaxedratio";
  static const String FDN_ITEMTAXRATE = "itemtaxrate";
  static const String FDN_ITEMTEMP = "itemtemp";
  static const String FDN_ITEMTEXT = "itemtext";
  static const String FDN_ITEMTOTAL = "itemtotal";
  static const String FDN_ITEMTYPE = "itemtype";
  static const String FDN_ITEMTYPEDESC = "itemtypedesc";
  static const String FDN_ITU = "itu";
  static const String FDN_JOBRATE = "jobrate";
  static const String FDN_JQUERYTHEME = "jquerytheme";
  static const String FDN_JS = "js";
  static const String FDN_KDVORANI = "kdvorani";
  static const String FDN_KDVTUTARI = "kdvtutari";
  static const String FDN_KEY = "key";
  static const String FDN_KEYFIELD = "keyfield";
  static const String FDN_KEYFIELDS = "keyfields";
  static const String FDN_KEYTABLE = "keytable";
  static const String FDN_KEYVALUE = "keyvalue";
  static const String FDN_KEYVALUEINT = "keyvalueint";
  static const String FDN_KEYVALUESTR = "keyvaluestr";
  static const String FDN_KEYWORDS = "keywords";
  static const String FDN_LABELCOLOR = "labelcolor";
  static const String FDN_LANG = "lang";
  static const String FDN_LANGCHARSETID = "langcharsetid";
  static const String FDN_LANGCODE = "langcode";
  static const String FDN_LANGDESC = "langdesc";
  static const String FDN_LANGGOOGLECODE = "langgooglecode";
  static const String FDN_LANGID = "langid";
  static const String FDN_LANGLOCALEID = "langlocaleid";
  static const String FDN_LANGSHORT = "langshort";
  static const String FDN_LANGWORDCODE = "langwordcode";
  static const String FDN_LAST = "last";
  static const String FDN_LASTAGENCY = "lastagency";
  static const String FDN_LASTASSIGNDT = "lastassigndt";
  static const String FDN_LASTAUTHDATE = "lastauthdate";
  static const String FDN_LASTAUTHTYPE = "lastauthtype";
  static const String FDN_LASTAUTHUSER = "lastauthuser";
  static const String FDN_LASTBALANCE = "lastbalance";
  static const String FDN_LASTCALL = "lastcall";
  static const String FDN_LASTCALLDATE = "lastcalldate";
  static const String FDN_LASTCHANGE = "lastchange";
  static const String FDN_LASTCI = "lastci";
  static const String FDN_LASTCO = "lastco";
  static const String FDN_LASTCONTACTDT = "lastcontactdt";
  static const String FDN_LASTCOST = "lastcost";
  static const String FDN_LASTCOURSENO = "lastcourseno";
  static const String FDN_LASTCREDIT = "lastcredit";
  static const String FDN_LASTCURRBALANCE = "lastcurrbalance";
  static const String FDN_LASTDATE = "lastdate";
  static const String FDN_LASTDEBIT = "lastdebit";
  static const String FDN_LASTDIGITS = "lastdigits";
  static const String FDN_LASTDISCRATE = "lastdiscrate";
  static const String FDN_LASTDISCRATE2 = "lastdiscrate2";
  static const String FDN_LASTDISCRATE3 = "lastdiscrate3";
  static const String FDN_LASTDT = "lastdt";
  static const String FDN_LASTDUEDATE = "lastduedate";
  static const String FDN_LASTEMAIL = "lastemail";
  static const String FDN_LASTEMAILDATE = "lastemaildate";
  static const String FDN_LASTEMPCODE = "lastempcode";
  static const String FDN_LASTENTDATE = "lastentdate";
  static const String FDN_LASTEXCRATE = "lastexcrate";
  static const String FDN_LASTEXPDATE = "lastexpdate";
  static const String FDN_LASTFILEDT = "lastfiledt";
  static const String FDN_LASTINVDATE = "lastinvdate";
  static const String FDN_LASTLEFT = "lastleft";
  static const String FDN_LASTLOGIN = "lastlogin";
  static const String FDN_LASTLOGINDT = "lastlogindt";
  static const String FDN_LASTNAME = "lastname";
  static const String FDN_LASTNEXTDT = "lastnextdt";
  static const String FDN_LASTNOTE = "lastnote";
  static const String FDN_LASTNOTEDT = "lastnotedt";
  static const String FDN_LASTOFFERDATE = "lastofferdate";
  static const String FDN_LASTOUTSRVSUPP = "lastoutsrvsupp";
  static const String FDN_LASTPAYMENT = "lastpayment";
  static const String FDN_LASTPERIODEND = "lastperiodend";
  static const String FDN_LASTPERIODID = "lastperiodid";
  static const String FDN_LASTPERIODSTART = "lastperiodstart";
  static const String FDN_LASTPING = "lastping";
  static const String FDN_LASTPREVDT = "lastprevdt";
  static const String FDN_LASTPRICE = "lastprice";
  static const String FDN_LASTPRICECOST = "lastpricecost";
  static const String FDN_LASTPRICECOSTTAXED = "lastpricecosttaxed";
  static const String FDN_LASTPRICEDISCED = "lastpricedisced";
  static const String FDN_LASTPRICENET = "lastpricenet";
  static const String FDN_LASTPUBDATE = "lastpubdate";
  static const String FDN_LASTRANSDATE = "lastransdate";
  static const String FDN_LASTRANSDT = "lastransdt";
  static const String FDN_LASTRANSDUR = "lastransdur";
  static const String FDN_LASTRANSMIN = "lastransmin";
  static const String FDN_LASTRANSTIME = "lastranstime";
  static const String FDN_LASTRANSUSER = "lastransuser";
  static const String FDN_LASTRANSUSERID = "lastransuserid";
  static const String FDN_LASTRATEUPD = "lastrateupd";
  static const String FDN_LASTREMINDERDT = "lastreminderdt";
  static const String FDN_LASTRESDATE = "lastresdate";
  static const String FDN_LASTREVDATE = "lastrevdate";
  static const String FDN_LASTROOM = "lastroom";
  static const String FDN_LASTROOMNO = "lastroomno";
  static const String FDN_LASTROOMRATE = "lastroomrate";
  static const String FDN_LASTRPTEXCRATE = "lastrptexcrate";
  static const String FDN_LASTRUN = "lastrun";
  static const String FDN_LASTSALECALLID = "lastsalecallid";
  static const String FDN_LASTSALESNOTE = "lastsalesnote";
  static const String FDN_LASTSCDATE = "lastscdate";
  static const String FDN_LASTSENT = "lastsent";
  static const String FDN_LASTSENTTOTAL = "lastsenttotal";
  static const String FDN_LASTSERVERDTL = "lastserverdtl";
  static const String FDN_LASTSHEETDATE = "lastsheetdate";
  static const String FDN_LASTSTATE = "laststate";
  static const String FDN_LASTSTATUSDT = "laststatusdt";
  static const String FDN_LASTSTATUSUPD = "laststatusupd";
  static const String FDN_LASTSUPPLIER = "lastsupplier";
  static const String FDN_LASTSUPPLIERID = "lastsupplierid";
  static const String FDN_LASTSUPPLIEROUTSRV = "lastsupplieroutsrv";
  static const String FDN_LASTSUPPNAME = "lastsuppname";
  static const String FDN_LASTSYNCDTL = "lastsyncdtl";
  static const String FDN_LASTTIME = "lasttime";
  static const String FDN_LASTTOTALCURR = "lasttotalcurr";
  static const String FDN_LASTTOTALHOMECURR = "lasttotalhomecurr";
  static const String FDN_LASTTRANSDATE = "lasttransdate";
  static const String FDN_LASTTRANSTIME = "lasttranstime";
  static const String FDN_LASTTSDATE = "lasttsdate";
  static const String FDN_LASTUPDATE = "lastupdate";
  static const String FDN_LASTUPDATETIME = "lastupdatetime";
  static const String FDN_LASTUSEDNO = "lastusedno";
  static const String FDN_LASTUSER = "lastuser";
  static const String FDN_LASTUSERCODE = "lastusercode";
  static const String FDN_LAT = "lat";
  static const String FDN_LNG = "lng";
  static const String FDN_LATLNG = "latlng";
  static const String FDN_LAYOUT = "layout";
  static const String FDN_LAYOUTBLOCKID = "layoutblockid";
  static const String FDN_LAYOUTFILEID = "layoutfileid";
  static const String FDN_LAYOUTID = "layoutid";
  static const String FDN_LAYOUTITEMID = "layoutitemid";
  static const String FDN_LEADEMPID = "leadempid";
  static const String FDN_LEADEMPCODE = "leadempcode";
  static const String FDN_LEADEMPNAME = "leadempname";
  static const String FDN_LEAVEDATE = "leavedate";
  static const String FDN_LEAVEREASON = "leavereason";
  static const String FDN_LEFTCOUNT = "leftcount";
  static const String FDN_LESSAMOUNT = "lessamount";
  static const String FDN_LESSCOST = "lesscost";
  static const String FDN_LEVELDELTA = "leveldelta";
  static const String FDN_LEVELINTERVAL = "levelinterval";
  static const String FDN_LEVELPERIOD = "levelperiod";
  static const String FDN_LEVELTOTAL = "leveltotal";
  static const String FDN_LEXCLUSIVE = "lexclusive";
  static const String FDN_LFCOUNT = "lfcount";
  static const String FDN_LICENCE = "licence";
  static const String FDN_LICID = "licid";
  static const String FDN_LICLEVEL = "liclevel";
  static const String FDN_LICPKG = "licpkg";
  static const String FDN_LICPRICE = "licprice";
  static const String FDN_LIMITINRISK = "limitinrisk";
  static const String FDN_LINE = "line";
  static const String FDN_LINEAMOUNT = "lineamount";
  static const String FDN_LINECOUNT = "linecount";
  static const String FDN_LINECOUNTER = "linecounter";
  static const String FDN_LINECOUNTNUMERIC = "linecountnumeric";
  static const String FDN_LINECURRAMOUNT = "linecurramount";
  static const String FDN_LINECURRTOTAL = "linecurrtotal";
  static const String FDN_LINEDESC = "linedesc";
  static const String FDN_LINEDISCAMOUNT = "linediscamount";
  static const String FDN_LINEDISCEDTOTAL = "linediscedtotal";
  static const String FDN_LINEDISCRATE = "linediscrate";
  static const String FDN_LINEDISCTOTAL = "linedisctotal";
  static const String FDN_LINEEXCRATE = "lineexcrate";
  static const String FDN_LINEEXCRATESAFE = "lineexcratesafe";
  static const String FDN_LINEEXTENSIONAMOUNT = "lineextensionamount";
  static const String FDN_LINEID = "lineid";
  static const String FDN_LINEINFO = "lineinfo";
  static const String FDN_LINEMID = "linemid";
  static const String FDN_LINENOTE = "linenote";
  static const String FDN_LINEPRICE = "lineprice";
  static const String FDN_LINEPRICECURR = "linepricecurr";
  static const String FDN_LINEPROCESSED = "lineprocessed";
  static const String FDN_LINERECEIPTDATE = "linereceiptdate";
  static const String FDN_LINERECEIPTNO = "linereceiptno";
  static const String FDN_LINERECEIPTTYPE = "linereceipttype";
  static const String FDN_LINERECEIPTTYPEDESC = "linereceipttypedesc";
  static const String FDN_LINESTR = "linestr";
  static const String FDN_LINETAXAMOUNT = "linetaxamount";
  static const String FDN_LINETAXRATE = "linetaxrate";
  static const String FDN_LINETAXTOTAL = "linetaxtotal";
  static const String FDN_LINETOTAL = "linetotal";
  static const String FDN_LINETOTALACC = "linetotalacc";
  static const String FDN_LINETOTALDISCED = "linetotaldisced";
  static const String FDN_LINETOTALGROSS = "linetotalgross";
  static const String FDN_LINETOTALNET = "linetotalnet";
  static const String FDN_LINETOTALSTR = "linetotalstr";
  static const String FDN_LINETRANSDATE = "linetransdate";
  static const String FDN_LINETYPE = "linetype";
  static const String FDN_LINKEDFROM = "linkedfrom";
  static const String FDN_LINKEDSYNC = "linkedsync";
  static const String FDN_LINKEDTO = "linkedto";
  static const String FDN_LINKEDTSLINEID = "linkedtslineid";
  static const String FDN_LISTALL = "listall";
  static const String FDN_LISTINFO = "listinfo";
  static const String FDN_LISTINFOSHORT = "listinfoshort";
  static const String FDN_LISTLEVEL = "listlevel";
  static const String FDN_LISTTITLE = "listtitle";
  static const String FDN_LMCLK = "lmclk";
  static const String FDN_LMCLKUNQ = "lmclkunq";
  static const String FDN_LMCOMPLAINT = "lmcomplaint";
  static const String FDN_LMHBOUNCE = "lmhbounce";
  static const String FDN_LMOPEN = "lmopen";
  static const String FDN_LMOPENUNQ = "lmopenunq";
  static const String FDN_LMREJECT = "lmreject";
  static const String FDN_LMSBOUNCE = "lmsbounce";
  static const String FDN_LMSENT = "lmsent";
  static const String FDN_LMUNSUB = "lmunsub";
  static const String FDN_LOCALDESC = "localdesc";
  static const String FDN_LOCALEID = "localeid";
  static const String FDN_LOCATION = "location";
  static const String FDN_LOCATIONCODE = "locationcode";
  static const String FDN_LOCATIONDESC = "locationdesc";
  static const String FDN_LOCATIONID = "locationid";
  static const String FDN_LOCATIONNAME = "locationname";
  static const String FDN_LOCCODE = "loccode";
  static const String FDN_LOCDEPARTCODE = "locdepartcode";
  static const String FDN_LOCDEPARTDESC = "locdepartdesc";
  static const String FDN_LOCDEPARTID = "locdepartid";
  static const String FDN_LOCDESC = "locdesc";
  static const String FDN_LOCGRPCODE = "locgrpcode";
  static const String FDN_LOCGRPDESC = "locgrpdesc";
  static const String FDN_LOCGRPID = "locgrpid";
  static const String FDN_LOCID = "locid";
  static const String FDN_LOCKTIMEOUT = "locktimeout";
  static const String FDN_LOCKUSERID = "lockuserid";
  static const String FDN_LOCNAME = "locname";
  static const String FDN_LOCNOTE = "locnote";
  static const String FDN_LOCPLANCODE = "locplancode";
  static const String FDN_LOCPLANDESC = "locplandesc";
  static const String FDN_LOCPLANID = "locplanid";
  static const String FDN_LOCPRICE = "locprice";
  static const String FDN_LOCRES = "locres";
  static const String FDN_LOCRESID = "locresid";
  static const String FDN_LOGBACKUP = "logbackup";
  static const String FDN_LOGCOUNT = "logcount";
  static const String FDN_LOGID = "logid";
  static const String FDN_LOGINTYPE = "logintype";
  static const String FDN_LOGOFILECODE = "logofilecode";
  static const String FDN_LOGONAME = "logoname";
  static const String FDN_LOGOURL = "logourl";
  static const String FDN_LOGTRANSCODE = "logtranscode";
  static const String FDN_LOGTRANSDESC = "logtransdesc";
  static const String FDN_LOGTRANSID = "logtransid";
  static const String FDN_LONGDESC = "longdesc";
  static const String FDN_LONGTEXT = "longtext";
  static const String FDN_LOSTBY = "lostby";
  static const String FDN_LOSTCOUNT = "lostcount";
  static const String FDN_LOSTDATE = "lostdate";
  static const String FDN_LOSTLOCCODE = "lostloccode";
  static const String FDN_LOSTLOCDESC = "lostlocdesc";
  static const String FDN_LOSTLOCID = "lostlocid";
  static const String FDN_LOSTON = "loston";
  static const String FDN_LUCOLS = "lucols";
  static const String FDN_LUFIELDNAME = "lufieldname";
  static const String FDN_LUFIELDS = "lufields";
  static const String FDN_LUFILTER = "lufilter";
  static const String FDN_LUITEMS = "luitems";
  static const String FDN_LUKEYFIELD = "lukeyfield";
  static const String FDN_LULIST = "lulist";
  static const String FDN_LUNCH = "lunch";
  static const String FDN_LUNCHRATE = "lunchrate";
  static const String FDN_LUNCHTEXT = "lunchtext";
  static const String FDN_LUTABLE = "lutable";
  static const String FDN_LUTYPECODE = "lutypecode";
  static const String FDN_LVAL = "lval";
  static const String FDN_LYBALANCE = "lybalance";
  static const String FDN_LYCURRRATE = "lycurrrate";
  static const String FDN_LYCURRRATE1 = "lycurrrate1";
  static const String FDN_LYCURRRATE2 = "lycurrrate2";
  static const String FDN_LYEAREND = "lyearend";
  static const String FDN_LYEARSTART = "lyearstart";
  static const String FDN_LYEND = "lyend";
  static const String FDN_LYHOTELCOUNTUTD = "lyhotelcountutd";
  static const String FDN_LYMONTHBABY = "lymonthbaby";
  static const String FDN_LYMONTHCHD1 = "lymonthchd1";
  static const String FDN_LYMONTHCHD2 = "lymonthchd2";
  static const String FDN_LYMONTHEND = "lymonthend";
  static const String FDN_LYMONTHPAX = "lymonthpax";
  static const String FDN_LYMONTHROOM = "lymonthroom";
  static const String FDN_LYMONTHSTART = "lymonthstart";
  static const String FDN_LYMONTHUTD = "lymonthutd";
  static const String FDN_LYMONTHUTDCURR = "lymonthutdcurr";
  static const String FDN_LYNEWCONTACTPERCENTUTD = "lynewcontactpercentutd";
  static const String FDN_LYNEWCONTACTTARGETUTD = "lynewcontacttargetutd";
  static const String FDN_LYNEWCONTACTUTD = "lynewcontactutd";
  static const String FDN_LYNEWHOTELCOUNTUTD = "lynewhotelcountutd";
  static const String FDN_LYNEWHOTELPERCENTUTD = "lynewhotelpercentutd";
  static const String FDN_LYNEWHOTELTARGETUTD = "lynewhoteltargetutd";
  static const String FDN_LYNEWHOTELUTD = "lynewhotelutd";
  static const String FDN_LYPPREVENUE = "lypprevenue";
  static const String FDN_LYPRREVENUE = "lyprrevenue";
  static const String FDN_LYRATE = "lyrate";
  static const String FDN_LYREVENUE = "lyrevenue";
  static const String FDN_LYSCPHONEPERCENTUTD = "lyscphonepercentutd";
  static const String FDN_LYSCPHONETARGETUTD = "lyscphonetargetutd";
  static const String FDN_LYSCPHONEUTD = "lyscphoneutd";
  static const String FDN_LYSCVISITPERCENTUTD = "lyscvisitpercentutd";
  static const String FDN_LYSCVISITTARGETUTD = "lyscvisittargetutd";
  static const String FDN_LYSCVISITUTD = "lyscvisitutd";
  static const String FDN_LYSTART = "lystart";
  static const String FDN_LYTODAY = "lytoday";
  static const String FDN_LYTOTAL = "lytotal";
  static const String FDN_LYTOTALBABY = "lytotalbaby";
  static const String FDN_LYTOTALCHD1 = "lytotalchd1";
  static const String FDN_LYTOTALCHD2 = "lytotalchd2";
  static const String FDN_LYTOTALCURR = "lytotalcurr";
  static const String FDN_LYTOTALDURATIONUTD = "lytotaldurationutd";
  static const String FDN_LYTOTALONSITEUTD = "lytotalonsiteutd";
  static const String FDN_LYTOTALPAX = "lytotalpax";
  static const String FDN_LYTOTALREMOTEUTD = "lytotalremoteutd";
  static const String FDN_LYTOTALROOM = "lytotalroom";
  static const String FDN_LYTOTALTRIPUTD = "lytotaltriputd";
  static const String FDN_LYTOTALUSERCERTUTD = "lytotalusercertutd";
  static const String FDN_LYTOTALUSERUTD = "lytotaluserutd";
  static const String FDN_LYTRAININGEMPUTD = "lytrainingemputd";
  static const String FDN_LYTRAININGPERSONUTD = "lytrainingpersonutd";
  static const String FDN_LYTRIPPERCENTUTD = "lytrippercentutd";
  static const String FDN_LYVAT = "lyvat";
  static const String FDN_LYYEARBABY = "lyyearbaby";
  static const String FDN_LYYEARCHD1 = "lyyearchd1";
  static const String FDN_LYYEARCHD2 = "lyyearchd2";
  static const String FDN_LYYEAREND = "lyyearend";
  static const String FDN_LYYEARPAX = "lyyearpax";
  static const String FDN_LYYEARROOM = "lyyearroom";
  static const String FDN_LYYEARSTART = "lyyearstart";
  static const String FDN_LYYEARUTD = "lyyearutd";
  static const String FDN_LYYEARUTDCURR = "lyyearutdcurr";
  static const String FDN_MADEBY = "madeby";
  static const String FDN_MAIDEMPCODE = "maidempcode";
  static const String FDN_MAIDEMPID = "maidempid";
  static const String FDN_MAIDEMPNAME = "maidempname";
  static const String FDN_MAIDID = "maidid";
  static const String FDN_MAILORDERCOLL = "mailordercoll";
  static const String FDN_MAILORDERPAY = "mailorderpay";
  static const String FDN_MAINAMOUNT = "mainamount";
  static const String FDN_MAINCODE = "maincode";
  static const String FDN_MAINCOMPANYCODE = "maincompanycode";
  static const String FDN_MAINCOMPANYDESC = "maincompanydesc";
  static const String FDN_MAINCOMPANYID = "maincompanyid";
  static const String FDN_MAINCOMPANYNAME = "maincompanyname";
  static const String FDN_MAINCOMPANYTAXNO = "maincompanytaxno";
  static const String FDN_MAINCOMPANYTAXOFFICE = "maincompanytaxoffice";
  static const String FDN_MAINGRPCODE = "maingrpcode";
  static const String FDN_MAINGRPDESC = "maingrpdesc";
  static const String FDN_MAINGRPID = "maingrpid";
  static const String FDN_MAINID = "mainid";
  static const String FDN_MAINNAME = "mainname";
  static const String FDN_MAINPRICE = "mainprice";
  static const String FDN_MAINQTY = "mainqty";
  static const String FDN_MAINQTYID = "mainqtyid";
  static const String FDN_MALZEMEADI = "malzemeadi";
  static const String FDN_MALZEMEGRUBU = "malzemegrubu";
  static const String FDN_MALZEMEKODU = "malzemekodu";
  static const String FDN_MANITEMCODE = "manitemcode";
  static const String FDN_MANUALPOSTTOTAL = "manualposttotal";
  static const String FDN_MAPCODE = "mapcode";
  static const String FDN_MAPS = "maps";
  static const String FDN_MARITALSTATUS = "maritalstatus";
  static const String FDN_MARITALSTATUSDESC = "maritalstatusdesc";
  static const String FDN_MARITULSTATUS = "maritulstatus";
  static const String FDN_MARKETCODE = "marketcode";
  static const String FDN_MARKETDESC = "marketdesc";
  static const String FDN_MARKETID = "marketid";
  static const String FDN_MASSMAILCOUNT = "massmailcount";
  static const String FDN_MASTERACC = "masteracc";
  static const String FDN_MASTERACCCODE = "masteracccode";
  static const String FDN_MASTERACCDESC = "masteraccdesc";
  static const String FDN_MASTERACCID = "masteraccid";
  static const String FDN_MASTERCODE = "mastercode";
  static const String FDN_MASTERDATE = "masterdate";
  static const String FDN_MASTERDESC = "masterdesc";
  static const String FDN_MASTEREXCRATEOK = "masterexcrateok";
  static const String FDN_MASTERFLD = "masterfld";
  static const String FDN_MASTERFOLIO = "masterfolio";
  static const String FDN_MASTERID = "masterid";
  static const String FDN_MASTERLOGID = "masterlogid";
  static const String FDN_MASTERNO = "masterno";
  static const String FDN_MASTERNOTE = "masternote";
  static const String FDN_MASTERPLACE = "masterplace";
  static const String FDN_MASTERRECEIPTNO = "masterreceiptno";
  static const String FDN_MASTERREFID = "masterrefid";
  static const String FDN_MASTERTABLE = "mastertable";
  static const String FDN_MASTERTASKINSTID = "mastertaskinstid";
  static const String FDN_MASTERTIME = "mastertime";
  static const String FDN_MASTERTYPE = "mastertype";
  static const String FDN_MASTERUSERCODE = "masterusercode";
  static const String FDN_MASTERUSERID = "masteruserid";
  static const String FDN_MASTERUSERNAME = "masterusername";
  static const String FDN_MASTERVAL = "masterval";
  static const String FDN_MATCH = "match";
  static const String FDN_MAXAMOUNT = "maxamount";
  static const String FDN_MAXAUTHLEVEL = "maxauthlevel";
  static const String FDN_MAXBED = "maxbed";
  static const String FDN_MAXCHAR = "maxchar";
  static const String FDN_MAXFILESIZE = "maxfilesize";
  static const String FDN_MAXLIMIT = "maxlimit";
  static const String FDN_MAXMEMALLOC = "maxmemalloc";
  static const String FDN_MAXMEMUSED = "maxmemused";
  static const String FDN_MAXQS = "maxqs";
  static const String FDN_MAXRATEOPEN = "maxrateopen";
  static const String FDN_MAXREADDATE = "maxreaddate";
  static const String FDN_MAXROOM = "maxroom";
  static const String FDN_MAXSCORE = "maxscore";
  static const String FDN_MAXWORD = "maxword";
  static const String FDN_MEDIUM = "medium";
  static const String FDN_MEDTRANSCOUNT = "medtranscount";
  static const String FDN_MEDTYPECODE = "medtypecode";
  static const String FDN_MEDTYPEDESC = "medtypedesc";
  static const String FDN_MEDTYPEID = "medtypeid";
  static const String FDN_MEGABYTE = "megabyte";
  static const String FDN_MEMALLOC = "memalloc";
  static const String FDN_MEMNO = "memno";
  static const String FDN_MEMPERIOD = "memperiod";
  static const String FDN_MEMPERIODCODE = "memperiodcode";
  static const String FDN_MEMPERIODDESC = "memperioddesc";
  static const String FDN_MEMPERIODID = "memperiodid";
  static const String FDN_MEMSHIPID = "memshipid";
  static const String FDN_MEMSHIPSTATUS = "memshipstatus";
  static const String FDN_MEMSHIPTYPE = "memshiptype";
  static const String FDN_MEMSHIPTYPEDESC = "memshiptypedesc";
  static const String FDN_MEMSHIPTYPEID = "memshiptypeid";
  static const String FDN_MEMSHIPTYPECODE = "memshiptypecode";
  static const String FDN_MEMTIMETPL = "memtimetpl";
  static const String FDN_MEMTIMETPLCODE = "memtimetplcode";
  static const String FDN_MEMTIMETPLDESC = "memtimetpldesc";
  static const String FDN_MEMTIMETPLID = "memtimetplid";
  static const String FDN_MEMUSED = "memused";
  static const String FDN_MENU = "menu";
  static const String FDN_MENUCODE = "menucode";
  static const String FDN_MENUCODEID = "menucodeid";
  static const String FDN_MENUDB = "menudb";
  static const String FDN_MENUDESC = "menudesc";
  static const String FDN_MENUID = "menuid";
  static const String FDN_MENUITEMID = "menuitemid";
  static const String FDN_MENULEVEL = "menulevel";
  static const String FDN_MENUNODE = "menunode";
  static const String FDN_MENUPRICE = "menuprice";
  static const String FDN_MENUSET = "menuset";
  static const String FDN_MENUSETDESC = "menusetdesc";
  static const String FDN_MENUSETID = "menusetid";
  static const String FDN_MENUTAG = "menutag";
  static const String FDN_MERSISNO = "mersisno";
  static const String FDN_METFORM = "metform";
  static const String FDN_METFORMCODE = "metformcode";
  static const String FDN_METFORMDESC = "metformdesc";
  static const String FDN_METFORMID = "metformid";
  static const String FDN_METFORMTPLCODE = "metformtplcode";
  static const String FDN_METFORMTPLDESC = "metformtpldesc";
  static const String FDN_METFORMTPLID = "metformtplid";
  static const String FDN_METPLID = "metplid";
  static const String FDN_METRANSID = "metransid";
  static const String FDN_METYPE = "metype";
  static const String FDN_METYPECODE = "metypecode";
  static const String FDN_METYPEDESC = "metypedesc";
  static const String FDN_METYPEID = "metypeid";
  static const String FDN_MFR = "mfr";
  static const String FDN_MID = "mid";
  static const String FDN_MIKTAR = "miktar";
  static const String FDN_MILITARYSTATUS = "militarystatus";
  static const String FDN_MINAMOUNT = "minamount";
  static const String FDN_MINCOMM = "mincomm";
  static const String FDN_MINDAY = "minday";
  static const String FDN_MINLEFT = "minleft";
  static const String FDN_MINPRICE = "minprice";
  static const String FDN_MINREADDATE = "minreaddate";
  static const String FDN_MINREV = "minrev";
  static const String FDN_MINROOM = "minroom";
  static const String FDN_MINSERVICE = "minservice";
  static const String FDN_MINSTAY = "minstay";
  static const String FDN_MINTOTAL = "mintotal";
  static const String FDN_MINVISIT = "minvisit";
  static const String FDN_MLAAMOUNT = "mlaamount";
  static const String FDN_MOBILETEL = "mobiletel";
  static const String FDN_MODE = "mode";
  static const String FDN_MODELNAME = "modelname";
  static const String FDN_MODELNO = "modelno";
  static const String FDN_MODTEXT = "modtext";
  static const String FDN_MODULCODES = "modulcodes";
  static const String FDN_MODULE = "module";
  static const String FDN_MODULECODE = "modulecode";
  static const String FDN_MODULEDESC = "moduledesc";
  static const String FDN_MODULEGRPCODE = "modulegrpcode";
  static const String FDN_MODULEGRPDESC = "modulegrpdesc";
  static const String FDN_MODULEGRPID = "modulegrpid";
  static const String FDN_MODULEID = "moduleid";
  static const String FDN_MODULEPRICE = "moduleprice";
  static const String FDN_MODULESHORTCODE = "moduleshortcode";
  static const String FDN_MODULLIST = "modullist";
  static const String FDN_MON = "mon";
  static const String FDN_MONTHAVG = "monthavg";
  static const String FDN_MONTHBABY = "monthbaby";
  static const String FDN_MONTHBALANCE = "monthbalance";
  static const String FDN_MONTHCHD1 = "monthchd1";
  static const String FDN_MONTHCHD2 = "monthchd2";
  static const String FDN_MONTHCOUNT = "monthcount";
  static const String FDN_MONTHEND = "monthend";
  static const String FDN_MONTHLASTPER = "monthlastper";
  static const String FDN_MONTHLYDAYS = "monthlydays";
  static const String FDN_MONTHLYOCC = "monthlyocc";
  static const String FDN_MONTHLYPERCENT = "monthlypercent";
  static const String FDN_MONTHPAX = "monthpax";
  static const String FDN_MONTHPREV = "monthprev";
  static const String FDN_MONTHPREVSTART = "monthprevstart";
  static const String FDN_MONTHROOM = "monthroom";
  static const String FDN_MONTHSTART = "monthstart";
  static const String FDN_MONTHTOTAL = "monthtotal";
  static const String FDN_MONTHUTD = "monthutd";
  static const String FDN_MONTHUTDCURR = "monthutdcurr";
  static const String FDN_MONTHVAR = "monthvar";
  static const String FDN_MONTHVAT = "monthvat";
  static const String FDN_MONTH_1 = "month_1";
  static const String FDN_MONTH_10 = "month_10";
  static const String FDN_MONTH_11 = "month_11";
  static const String FDN_MONTH_12 = "month_12";
  static const String FDN_MONTH_13 = "month_13";
  static const String FDN_MONTH_14 = "month_14";
  static const String FDN_MONTH_15 = "month_15";
  static const String FDN_MONTH_2 = "month_2";
  static const String FDN_MONTH_3 = "month_3";
  static const String FDN_MONTH_4 = "month_4";
  static const String FDN_MONTH_5 = "month_5";
  static const String FDN_MONTH_6 = "month_6";
  static const String FDN_MONTH_7 = "month_7";
  static const String FDN_MONTH_8 = "month_8";
  static const String FDN_MONTH_9 = "month_9";
  static const String FDN_MONY = "mony";
  static const String FDN_MONY2 = "mony2";
  static const String FDN_MONY3 = "mony3";
  static const String FDN_MONY4 = "mony4";
  static const String FDN_MONY5 = "mony5";
  static const String FDN_MONYAVGMAXDIFF = "monyavgmaxdiff";
  static const String FDN_MONYAVGREV = "monyavgrev";
  static const String FDN_MONYMAXREV = "monymaxrev";
  static const String FDN_MONYMINAVGDIFF = "monyminavgdiff";
  static const String FDN_MONYMINMAXDIFF = "monyminmaxdiff";
  static const String FDN_MONYMINREV = "monyminrev";
  static const String FDN_MOTHERNAME = "mothername";
  static const String FDN_MRF = "mrf";
  static const String FDN_MSG = "msg";
  static const String FDN_MSGACTION = "msgaction";
  static const String FDN_MSGBOXID = "msgboxid";
  static const String FDN_MSGCOUNT = "msgcount";
  static const String FDN_MSGID = "msgid";
  static const String FDN_MSGLOGID = "msglogid";
  static const String FDN_MSGLOG_GID = "msglog_gid";
  static const String FDN_MSGLOG_GIDSTR = "msglog_gidstr";
  static const String FDN_MSGREFCODE = "msgrefcode";
  static const String FDN_MSGTEMPCAPTION = "msgtempcaption";
  static const String FDN_MSGTEMPCODE = "msgtempcode";
  static const String FDN_MSGTEMPDESC = "msgtempdesc";
  static const String FDN_MSGTEMPID = "msgtempid";
  static const String FDN_MSGTEMPLATECAPTION = "msgtemplatecaption";
  static const String FDN_MSGTEMPLATECODE = "msgtemplatecode";
  static const String FDN_MSGTEMPLATEDESC = "msgtemplatedesc";
  static const String FDN_MSGTEMPLATEID = "msgtemplateid";
  static const String FDN_MSGTEXT = "msgtext";
  static const String FDN_MSGTYPE = "msgtype";
  static const String FDN_MSGTYPECODE = "msgtypecode";
  static const String FDN_MULTIFLDS = "multiflds";
  static const String FDN_MULTISELECT = "multiselect";
  static const String FDN_MUSICNOTE = "musicnote";
  static const String FDN_MYLEVEL = "mylevel";
  static const String FDN_NAME = "name";
  static const String FDN_NAMEDESC = "namedesc";
  static const String FDN_NAMEID = "nameid";
  static const String FDN_NANFIELD = "nanfield";
  static const String FDN_NARTOTAL = "nartotal";
  static const String FDN_NATION = "nation";
  static const String FDN_NATIONCODE = "nationcode";
  static const String FDN_NATIONDESC = "nationdesc";
  static const String FDN_NATIONID = "nationid";
  static const String FDN_NATIONPOLID = "nationpolid";
  static const String FDN_NATIONRATE = "nationrate";
  static const String FDN_NATIONS = "nations";
  static const String FDN_NEEDACC = "needacc";
  static const String FDN_NEEDACCTRANS = "needacctrans";
  static const String FDN_NEEDCANCELTIME = "needcanceltime";
  static const String FDN_NEEDCLIENT = "needclient";
  static const String FDN_NEEDCONFIRMTIME = "needconfirmtime";
  static const String FDN_NEEDCUSTOMTIME = "needcustomtime";
  static const String FDN_NEEDEMAIL = "needemail";
  static const String FDN_NEEDEMAILREQ = "needemailreq";
  static const String FDN_NEEDEMAILQA = "needemailqa";
  static const String FDN_NEEDEMP = "needemp";
  static const String FDN_NEEDENDTIME = "needendtime";
  static const String FDN_NEEDFOLIO = "needfolio";
  static const String FDN_NEEDINITIALTIME = "needinitialtime";
  static const String FDN_NEEDINVOICE = "needinvoice";
  static const String FDN_NEEDLOC = "needloc";
  static const String FDN_NEEDOLDTRANS = "needoldtrans";
  static const String FDN_NEEDONE = "needone";
  static const String FDN_NEEDPLANTIME = "needplantime";
  static const String FDN_NEEDQTY = "needqty";
  static const String FDN_NEEDSEC = "needsec";
  static const String FDN_NEEDSTARTTIME = "needstarttime";
  static const String FDN_NEEDSUSPENDTIME = "needsuspendtime";
  static const String FDN_NEEDTESTTIME = "needtesttime";
  static const String FDN_NEEDTIMESHARE = "needtimeshare";
  static const String FDN_NEEDWAITTIME = "needwaittime";
  static const String FDN_NEEDWARN = "needwarn";
  static const String FDN_NETAMOUNT = "netamount";
  static const String FDN_NETBALANCE = "netbalance";
  static const String FDN_NETCORRECTION = "netcorrection";
  static const String FDN_NETCURRTOTAL = "netcurrtotal";
  static const String FDN_NETMIN = "netmin";
  static const String FDN_NETPRICE = "netprice";
  static const String FDN_NETPRICEHOMECURR = "netpricehomecurr";
  static const String FDN_NETRATE = "netrate";
  static const String FDN_NETTOFROM = "nettofrom";
  static const String FDN_NETTOFROMCOST = "nettofromcost";
  static const String FDN_NETTOFROMTRANSCOST = "nettofromtranscost";
  static const String FDN_NETTOTAL = "nettotal";
  static const String FDN_NETTOTALDISCED = "nettotaldisced";
  static const String FDN_NETTOTALEB = "nettotalleb";
  static const String FDN_NETTOTALHC = "nettotalhc";
  static const String FDN_NETTOTALHOMECURR = "nettotalhomecurr";
  static const String FDN_NETTOTALNOEB = "nettotalnoeb";
  static const String FDN_NEWACTHOTELLASTYERLY = "newacthotellastyerly";
  static const String FDN_NEWACTHOTELMONTHLY = "newacthotelmonthly";
  static const String FDN_NEWACTHOTELWEEKLY = "newacthotelweekly";
  static const String FDN_NEWACTHOTELYEARLY = "newacthotelyearly";
  static const String FDN_NEWAUTOMAIL = "newautomail";
  static const String FDN_NEWCONTACTMONTHLY = "newcontactmonthly";
  static const String FDN_NEWCONTACTPERCENTMONTHLY = "newcontactpercentmonthly";
  static const String FDN_NEWCONTACTPERCENTWEEKLY = "newcontactpercentweekly";
  static const String FDN_NEWCONTACTPERCENTYEARLY = "newcontactpercentyearly";
  static const String FDN_NEWCONTACTTARGETMONTHLY = "newcontacttargetmonthly";
  static const String FDN_NEWCONTACTTARGETWEEKLY = "newcontacttargetweekly";
  static const String FDN_NEWCONTACTTARGETYEARLY = "newcontacttargetyearly";
  static const String FDN_NEWCONTACTWEEKLY = "newcontactweekly";
  static const String FDN_NEWCONTACTYEARLY = "newcontactyearly";
  static const String FDN_NEWFOLIONO = "newfoliono";
  static const String FDN_NEWHOTELCOUNTMONTHLY = "newhotelcountmonthly";
  static const String FDN_NEWHOTELCOUNTWEEKLY = "newhotelcountweekly";
  static const String FDN_NEWHOTELCOUNTYEARLY = "newhotelcountyearly";
  static const String FDN_NEWHOTELLASTYEARLY = "newhotellastyearly";
  static const String FDN_NEWHOTELMONTHLY = "newhotelmonthly";
  static const String FDN_NEWHOTELPERCENTMONTHLY = "newhotelpercentmonthly";
  static const String FDN_NEWHOTELPERCENTWEEKLY = "newhotelpercentweekly";
  static const String FDN_NEWHOTELPERCENTYEARLY = "newhotelpercentyearly";
  static const String FDN_NEWHOTELTARGETMONTHLY = "newhoteltargetmonthly";
  static const String FDN_NEWHOTELTARGETWEEKLY = "newhoteltargetweekly";
  static const String FDN_NEWHOTELTARGETYEARLY = "newhoteltargetyearly";
  static const String FDN_NEWHOTELWEEKLY = "newhotelweekly";
  static const String FDN_NEWHOTELYEARLY = "newhotelyearly";
  static const String FDN_NEWROOM = "newroom";
  static const String FDN_NEWROOMNO = "newroomno";
  static const String FDN_NEWROOMTYPE = "newroomtype";
  static const String FDN_NEWTOTALCOPY = "newtotalcopy";
  static const String FDN_NEWVALUES = "newvalues";
  static const String FDN_NEWVALUESSHORT = "newvaluesshort";
  static const String FDN_NEXTBONUSREQ = "nextbonusreq";
  static const String FDN_NEXTBONUSTOTAL = "nextbonustotal";
  static const String FDN_NEXTCARDBONUSREQ = "nextcardbonusreq";
  static const String FDN_NEXTCARDTYPECODE = "nextcardtypecode";
  static const String FDN_NEXTCARDTYPEDESC = "nextcardtypedesc";
  static const String FDN_NEXTCARDTYPEID = "nextcardtypeid";
  static const String FDN_NEXTCODE = "nextcode";
  static const String FDN_NEXTCOUNT = "nextcount";
  static const String FDN_NEXTDATE = "nextdate";
  static const String FDN_NEXTDT = "nextdt";
  static const String FDN_NEXTEXPDATE = "nextexpdate";
  static const String FDN_NEXTINTERVAL = "nextinterval";
  static const String FDN_NEXTPERIOD = "nextperiod";
  static const String FDN_NEXTPERIODDESC = "nextperioddesc";
  static const String FDN_NEXTRANS = "nextrans";
  static const String FDN_NEXTRUN = "nextrun";
  static const String FDN_NEXTSEND = "nextsend";
  static const String FDN_NEXTSHEETDATE = "nextsheetdate";
  static const String FDN_NEXTSTART = "nextstart";
  static const String FDN_NEXTTIME = "nexttime";
  static const String FDN_NEXTTRNS = "nexttrns";
  static const String FDN_NOACTION = "noaction";
  static const String FDN_NOACTIONDAY = "noactionday";
  static const String FDN_NOAUTOPOST = "noautopost";
  static const String FDN_NODELEVEL = "nodelevel";
  static const String FDN_NOEBRATE = "noebrate";
  static const String FDN_NOMINUS = "nominus";
  static const String FDN_NOMINUSONLYPRODUCED = "nominusonlyproduced";
  static const String FDN_NONCONTRACT = "noncontract";
  static const String FDN_NONFB = "nonfb";
  static const String FDN_NONFBCOST = "nonfbcost";
  static const String FDN_NONFBREV = "nonfbrev";
  static const String FDN_NONLAYOUT = "nonlayout";
  static const String FDN_NOPE = "nope";
  static const String FDN_NOPOST = "nopost";
  static const String FDN_NOPREFIX = "noprefix";
  static const String FDN_NOSCAMOUNT = "noscamount";
  static const String FDN_NOSCAMOUNTCURR = "noscamountcurr";
  static const String FDN_NOSCTAXTOTAL = "nosctaxtotal";
  static const String FDN_NOSCTAXTOTALCURR = "nosctaxtotalcurr";
  static const String FDN_NOSS = "noss";
  static const String FDN_NOTDONENOTECOUNT = "notdonenotecount";
  static const String FDN_NOTE = "note";
  static const String FDN_NOTE1 = "note1";
  static const String FDN_NOTEALL = "noteall";
  static const String FDN_NOTECAT = "notecat";
  static const String FDN_NOTECATCODE = "notecatcode";
  static const String FDN_NOTECATDESC = "notecatdesc";
  static const String FDN_NOTECATID = "notecatid";
  static const String FDN_NOTECOUNT = "notecount";
  static const String FDN_NOTEDATE = "notedate";
  static const String FDN_NOTEDURATION = "noteduration";
  static const String FDN_NOTEDURATIONSTR = "notedurationstr";
  static const String FDN_NOTEFULL = "notefull";
  static const String FDN_NOTEHK = "notehk";
  static const String FDN_NOTEID = "noteid";
  static const String FDN_NOTELAST = "notelast";
  static const String FDN_NOTELIST = "notelist";
  static const String FDN_NOTESHORT = "noteshort";
  static const String FDN_NOTESURVEYDESC = "notesurveydesc";
  static const String FDN_NOTESURVEYID = "notesurveyid";
  static const String FDN_NOTETEXT = "notetext";
  static const String FDN_NOTETOTAL = "notetotal";
  static const String FDN_NOTETYPE = "notetype";
  static const String FDN_NOTETYPECODE = "notetypecode";
  static const String FDN_NOTETYPEDESC = "notetypedesc";
  static const String FDN_NOTETYPEID = "notetypeid";
  static const String FDN_NOTIF = "notif";
  static const String FDN_NOTIFYCHECKEXPR = "notifycheckexpr";
  static const String FDN_NOTIFYRECEIVEREXPR = "notifyreceiverexpr";
  static const String FDN_NOTIFYRECEIVERFLD = "notifyreceiverfld";
  static const String FDN_NOTIFYSENDTYPE = "notifysendtype";
  static const String FDN_NOTIFYTABLE = "notifytable";
  static const String FDN_NOTIFYTRIGGER = "notifytrigger";
  static const String FDN_NOTIWAYCODE = "notiwaycode";
  static const String FDN_NOTIWAYDESC = "notiwaydesc";
  static const String FDN_NOTIWAYID = "notiwayid";
  static const String FDN_NOTRECEIPTITEM = "notreceiptitem";
  static const String FDN_NOTTRANSCOUNT = "nottranscount";
  static const String FDN_NSBABY = "nsbaby";
  static const String FDN_NSCHD = "nschd";
  static const String FDN_NSCHD1 = "nschd1";
  static const String FDN_NSCHD2 = "nschd2";
  static const String FDN_NSPAX = "nspax";
  static const String FDN_NSROOM = "nsroom";
  static const String FDN_NULLFLD = "nullfld";
  static const String FDN_NUMBERDESC = "numberdesc";
  static const String FDN_NUMSTR = "numstr";
  static const String FDN_OAUTH = "oauth";
  static const String FDN_OB = "ob";
  static const String FDN_OBDIFF = "obdiff";
  static const String FDN_OBJCLASS = "objclass";
  static const String FDN_OBJNAME = "objname";
  static const String FDN_OBJRESID = "objresid";
  static const String FDN_OBJTYPE = "objtype";
  static const String FDN_OBLIMIT = "oblimit";
  static const String FDN_OBRATIO = "obratio";
  static const String FDN_OBRTYPE = "obrtype";
  static const String FDN_OCC = "occ";
  static const String FDN_OCCROOMTYPE = "occroomtype";
  static const String FDN_OCCUPATION = "occupation";
  static const String FDN_OCCUPATIONCODE = "occupationcode";
  static const String FDN_OCCUPATIONDESC = "occupationdesc";
  static const String FDN_OCCUPATIONID = "occupationid";
  static const String FDN_OD = "od";
  static const String FDN_ODSMAJOR = "odsmajor";
  static const String FDN_ODSVER = "odsver";
  static const String FDN_ODS_MINOR = "ods_minor";
  static const String FDN_OFFCODE = "offcode";
  static const String FDN_OFFCOUNT = "offcount";
  static const String FDN_OFFDURATION = "offduration";
  static const String FDN_OFFDURATIONMIN = "offdurationmin";
  static const String FDN_OFFDURATIONSTR = "offdurationstr";
  static const String FDN_OFFDURMIN = "offdurmin";
  static const String FDN_OFFER = "offer";
  static const String FDN_OFFERCOLOR = "offercolor";
  static const String FDN_OFFERREQAUTHLEVEL = "offerreqauthlevel";
  static const String FDN_OFFERREQISACTIVE = "offerreqisactive";
  static const String FDN_OFFERREQISACTIVENON = "offerreqisactivenon";
  static const String FDN_OFFERREQISAUTH = "offerreqisauth";
  static const String FDN_OFFERREQISAUTHNON = "offerreqisauthnon";
  static const String FDN_OFFERTYPE = "offertype";
  static const String FDN_OFFREGNO = "offregno";
  static const String FDN_OLDESTACTIVE = "oldestactive";
  static const String FDN_OLDESTACTIVETRNS = "oldestactivetrns";
  static const String FDN_OLDESTRANS = "oldestrans";
  static const String FDN_OLDESTSS = "oldestss";
  static const String FDN_OLDESTTRNS = "oldesttrns";
  static const String FDN_OLDFOLIONO = "oldfoliono";
  static const String FDN_OLDROOM = "oldroom";
  static const String FDN_OLDROOMTYPE = "oldroomtype";
  static const String FDN_OLDVALUES = "oldvalues";
  static const String FDN_OLDVALUESSHORT = "oldvaluesshort";
  static const String FDN_ONDELETE = "ondelete";
  static const String FDN_ONSITEDURHOUR = "onsitedurhour";
  static const String FDN_ONSITEHOTEL = "onsitehotel";
  static const String FDN_ONSITEPERSON = "onsiteperson";
  static const String FDN_ONSITESESSION = "onsitesession";
  static const String FDN_ONUPDATE = "onupdate";
  static const String FDN_OOO = "ooo";
  static const String FDN_OOS = "oos";
  static const String FDN_OPENDATE = "opendate";
  static const String FDN_OPENDT = "opendt";
  static const String FDN_OPENING = "opening";
  static const String FDN_OPENNEW = "opennew";
  static const String FDN_OPENTIME = "opentime";
  static const String FDN_OPERATION = "operation";
  static const String FDN_OPTCLASSNAME = "optclassname";
  static const String FDN_OPTIONANSWERPERCENT = "optionanswerpercent";
  static const String FDN_OPTIONDATE = "optiondate";
  static const String FDN_OPTIONFONTSIZE = "optionfontsize";
  static const String FDN_OPTIONS = "options";
  static const String FDN_OPTIONSCOREPERCENT = "optionscorepercent";
  static const String FDN_ORDERBY = "orderby";
  static const String FDN_ORDERID = "orderid";
  static const String FDN_ORDERNO = "orderno";
  static const String FDN_ORDERRECEIPTNO = "orderreceiptno";
  static const String FDN_ORIGINAGENCY = "originagency";
  static const String FDN_ORIGINAGENCYID = "originagencyid";
  static const String FDN_ORIGINALCODE = "originalcode";
  static const String FDN_ORIGINAMOUNT = "originamount";
  static const String FDN_ORIGINCHECKIN = "origincheckin";
  static const String FDN_ORIGINCHECKOUT = "origincheckout";
  static const String FDN_ORIGINCLIENTNAME = "originclientname";
  static const String FDN_ORIGINCREDIT = "origincredit";
  static const String FDN_ORIGINDEBIT = "origindebit";
  static const String FDN_ORIGINFOLIONO = "originfoliono";
  static const String FDN_ORIGINFOLIOTYPE = "originfoliotype";
  static const String FDN_ORIGINRESERVNO = "originreservno";
  static const String FDN_ORIGINRESMASTERNO = "originresmasterno";
  static const String FDN_ORIGINROOMNO = "originroomno";
  static const String FDN_ORIGINROOMTYPE = "originroomtype";
  static const String FDN_ORIGINTRANSNO = "origintransno";
  static const String FDN_ORSACTION = "orsaction";
  static const String FDN_ORSCLIENTID = "orsclientid";
  static const String FDN_ORSPAYTYPE = "orspaytype";
  static const String FDN_ORSREFCODE = "orsrefcode";
  static const String FDN_OSDESC = "osdesc";
  static const String FDN_OSVER = "osver";
  static const String FDN_OTHERCASHBOXID = "othercashboxid";
  static const String FDN_OTHERSTORE = "otherstore";
  static const String FDN_OTHERSTOREDESC = "otherstoredesc";
  static const String FDN_OTHERTRANSNO = "othertransno";
  static const String FDN_OTHERVISITCALL = "othervisitcall";
  static const String FDN_OTHERVISITCALLLASTYEARLY = "othervisitcalllastyearly";
  static const String FDN_OTHERVISITCALLMONTHLY = "othervisitcallmonthly";
  static const String FDN_OTHERVISITCALLWEEKLY = "othervisitcallweekly";
  static const String FDN_OTHERVISITCALLYEARLY = "othervisitcallyearly";
  static const String FDN_OUT_STR = "out_str";
  static const String FDN_OVERAMOUNT = "overamount";
  static const String FDN_OVERCOST = "overcost";
  static const String FDN_OVERDAY = "overday";
  static const String FDN_OVERDISCRATE = "overdiscrate";
  static const String FDN_PACKAGECODE = "packagecode";
  static const String FDN_PACKDESC = "packdesc";
  static const String FDN_PACKQTY = "packqty";
  static const String FDN_PACKQTYCODE = "packqtycode";
  static const String FDN_PACKQTYDESC = "packqtydesc";
  static const String FDN_PACKQTYID = "packqtyid";
  static const String FDN_PACKRATIO = "packratio";
  static const String FDN_PAGEBUFFERS = "pagebuffers";
  static const String FDN_PAGEFETCHES = "pagefetches";
  static const String FDN_PAGEMARKS = "pagemarks";
  static const String FDN_PAGENO = "pageno";
  static const String FDN_PAGEREADS = "pagereads";
  static const String FDN_PAGESIZE = "pagesize";
  static const String FDN_PAGESTOTAL = "pagestotal";
  static const String FDN_PAGEWRITES = "pagewrites";
  static const String FDN_PAID1 = "paid1";
  static const String FDN_PAID2 = "paid2";
  static const String FDN_PAID3 = "paid3";
  static const String FDN_PAID4 = "paid4";
  static const String FDN_PAIDAMOUNT = "paidamount";
  static const String FDN_PAIDDATE = "paiddate";
  static const String FDN_PAIDOUT = "paidout";
  static const String FDN_PARAMETERS = "parameters";
  static const String FDN_PARAMNAME = "paramname";
  static const String FDN_PARAMS = "params";
  static const String FDN_PARAMTYPE = "paramtype";
  static const String FDN_PARENT = "parent";
  static const String FDN_PARENTCODE = "parentcode";
  static const String FDN_PARENTDESC = "parentdesc";
  static const String FDN_PARENTID = "parentid";
  static const String FDN_PARENTLEVEL = "parentlevel";
  static const String FDN_PASS = "pass";
  static const String FDN_PASSAUTOMAIL = "passautomail";
  static const String FDN_PASSHASH = "passhash";
  static const String FDN_PASSTOTALCOPY = "passtotalcopy";
  static const String FDN_PASSWORD = "password";
  static const String FDN_PATH = "path";
  static const String FDN_PATHID = "pathid";
  static const String FDN_PAX = "pax";
  static const String FDN_PAXCAP = "paxcap";
  static const String FDN_PAXNAMES = "paxnames";
  static const String FDN_PAXNO = "paxno";
  static const String FDN_PAXRATE = "paxrate";
  static const String FDN_PAXTYPECODE = "paxtypecode";
  static const String FDN_PAXTYPEDESC = "paxtypedesc";
  static const String FDN_PAXTYPEID = "paxtypeid";
  static const String FDN_PAXTYPESTR = "paxtypestr";
  static const String FDN_PAYABLEAMOUNT = "payableamount";
  static const String FDN_PAYABLEROUNDINGAMOUNT = "payableroundingamount";
  static const String FDN_PAYACCACCOUNTNO = "payaccaccountno";
  static const String FDN_PAYACCBANKBRANCH = "payaccbankbranch";
  static const String FDN_PAYACCBANKBRANCHDESC = "payaccbankbranchdesc";
  static const String FDN_PAYACCBANKBRANCHID = "payaccbankbranchid";
  static const String FDN_PAYACCBANKBRANCHMAPCODE = "payaccbankbranchmapcode";
  static const String FDN_PAYACCBANKNAME = "payaccbankname";
  static const String FDN_PAYACCBANKNAMEDESC = "payaccbanknamedesc";
  static const String FDN_PAYACCBANKNAMEID = "payaccbanknameid";
  static const String FDN_PAYACCCODE = "payacccode";
  static const String FDN_PAYACCDESC = "payaccdesc";
  static const String FDN_PAYACCIBAN = "payacciban";
  static const String FDN_PAYACCID = "payaccid";
  static const String FDN_PAYAMOUNT = "payamount";
  static const String FDN_PAYAMOUNTCURR = "payamountcurr";
  static const String FDN_PAYBALANCE = "paybalance";
  static const String FDN_PAYBALANCECURR = "paybalancecurr";
  static const String FDN_PAYBALANCETAXTOTAL = "paybalancetaxtotal";
  static const String FDN_PAYBALANCETAXTOTALCURR = "paybalancetaxtotalcurr";
  static const String FDN_PAYCOUNT = "paycount";
  static const String FDN_PAYCURR = "paycurr";
  static const String FDN_PAYCURRCODE = "paycurrcode";
  static const String FDN_PAYCURRDESC = "paycurrdesc";
  static const String FDN_PAYCURRID = "paycurrid";
  static const String FDN_PAYDATE = "paydate";
  static const String FDN_PAYDAY = "payday";
  static const String FDN_PAYEXCRATE = "payexcrate";
  static const String FDN_PAYINCURR = "payincurr";
  static const String FDN_PAYLESSBEV = "paylessbev";
  static const String FDN_PAYLESSFOOD = "paylessfood";
  static const String FDN_PAYLESSLIMIT = "paylesslimit";
  static const String FDN_PAYLESSNONFB = "paylessnonfb";
  static const String FDN_PAYLESSSALETOTAL = "paylesssaletotal";
  static const String FDN_PAYMENT = "payment";
  static const String FDN_PAYMENTAMOUNT = "paymentamount";
  static const String FDN_PAYMENTLEFT = "paymentleft";
  static const String FDN_PAYMENTOTAL = "paymentotal";
  static const String FDN_PAYMENTTOTAL = "paymenttotal";
  static const String FDN_PAYMENTTYPE = "paymenttype";
  static const String FDN_PAYMID = "paymid";
  static const String FDN_PAYMODEL = "paymodel";
  static const String FDN_PAYNOTE = "paynote";
  static const String FDN_PAYRATE = "payrate";
  static const String FDN_PAYTARGETTOTAL = "paytargettotal";
  static const String FDN_PAYTAXTOTAL = "paytaxtotal";
  static const String FDN_PAYTAXTOTALCURR = "paytaxtotalcurr";
  static const String FDN_PAYTOTAL = "paytotal";
  static const String FDN_PAYTOTALCURR = "paytotalcurr";
  static const String FDN_PAYTPYE = "paytpye";
  static const String FDN_PAYTYPE = "paytype";
  static const String FDN_PAYTYPECODE = "paytypecode";
  static const String FDN_PAYTYPEDESC = "paytypedesc";
  static const String FDN_PAYTYPEID = "paytypeid";
  static const String FDN_PAYTYPESTR = "paytypestr";
  static const String FDN_PCKCODE = "pckcode";
  static const String FDN_PCODE = "pcode";
  static const String FDN_PDESC = "pdesc";
  static const String FDN_PEERADDR = "peeraddr";
  static const String FDN_PENALTYTOTAL = "penaltytotal";
  static const String FDN_PERBALCURR = "perbalcurr";
  static const String FDN_PERCENT = "percent";
  static const String FDN_PERCOLLCURR = "percollcurr";
  static const String FDN_PERDIFFBALCURR = "perdiffbalcurr";
  static const String FDN_PERDIFFCOLLCURR = "perdiffcollcurr";
  static const String FDN_PERDIFFPAYCURR = "perdiffpaycurr";
  static const String FDN_PERFPER = "perfper";
  static const String FDN_PERIODAMOUNT = "periodamount";
  static const String FDN_PERIODENDDATE = "periodenddate";
  static const String FDN_PERIODENDTIME = "periodendtime";
  static const String FDN_PERIODINTERVAL = "periodinterval";
  static const String FDN_PERIODNAME = "periodname";
  static const String FDN_PERIODRATE = "periodrate";
  static const String FDN_PERIODSTARTDATE = "periodstartdate";
  static const String FDN_PERIODSTARTTIME = "periodstarttime";
  static const String FDN_PERIODTYPE = "periodtype";
  static const String FDN_PERIODTYPEDESC = "periodtypedesc";
  static const String FDN_PERPAYCURR = "perpaycurr";
  static const String FDN_PERUSERPRICE = "peruserprice";
  static const String FDN_PFX = "pfx";
  static const String FDN_PHONECALL = "phonecall";
  static const String FDN_PHONECALLLASTYEARLY = "phonecalllastyearly";
  static const String FDN_PHONECALLMONTHLY = "phonecallmonthly";
  static const String FDN_PHONECALLWEEKLY = "phonecallweekly";
  static const String FDN_PHONECALLYEARLY = "phonecallyearly";
  static const String FDN_PHONENUMBER = "phonenumber";
  static const String FDN_PHONETYPE = "phonetype";
  static const String FDN_PID = "pid";
  static const String FDN_PINGDT = "pingdt";
  static const String FDN_PIPEDEPART = "pipedepart";
  static const String FDN_PIPEDESC = "pipedesc";
  static const String FDN_PIPEEMP = "pipeemp";
  static const String FDN_PIPEID = "pipeid";
  static const String FDN_PIPESTAGE = "pipestage";
  static const String FDN_PITEMINDEX = "pitemindex";
  static const String FDN_PK = "pk";
  static const String FDN_PKGCODE = "pkgcode";
  static const String FDN_PKGDESC = "pkgdesc";
  static const String FDN_PKGDISCRATE = "pkgdiscrate";
  static const String FDN_PKGFREEAMOUNT = "pkgfreeamount";
  static const String FDN_PKGID = "pkgid";
  static const String FDN_PLANDATE = "plandate";
  static const String FDN_PLANGID = "plangid";
  static const String FDN_PLANID = "planid";
  static const String FDN_PLANSCORE = "planscore";
  static const String FDN_PLANTIME = "plantime";
  static const String FDN_PLANUSERCODE = "planusercode";
  static const String FDN_PLANUSERID = "planuserid";
  static const String FDN_PLATENO = "plateno";
  static const String FDN_PLATFORMINFO = "platforminfo";
  static const String FDN_PLBEVERAGE = "plbeverage";
  static const String FDN_PLFOOD = "plfood";
  static const String FDN_PLNONFB = "plnonfb";
  static const String FDN_PLOTBL = "plotbl";
  static const String FDN_PLOTCODE = "plotcode";
  static const String FDN_PLOTSEC = "plotsec";
  static const String FDN_PMS = "pms";
  static const String FDN_POLID = "polid";
  static const String FDN_POLLID = "pollid";
  static const String FDN_POLLTYPE = "polltype";
  static const String FDN_PORT = "port";
  static const String FDN_PORTALCODE = "portalcode";
  static const String FDN_PORTALID = "portalid";
  static const String FDN_PORTALMAXSCORE = "portalmaxscore";
  static const String FDN_PORTALWEB = "portalweb";
  static const String FDN_POS = "pos";
  static const String FDN_POSCOUNTER = "poscounter";
  static const String FDN_POSGID = "posgid";
  static const String FDN_POSGIDSTR = "posgidstr";
  static const String FDN_POSLEVEL = "poslevel";
  static const String FDN_POSLEVELCODE = "poslevelcode";
  static const String FDN_POSLEVELDESC = "posleveldesc";
  static const String FDN_POSMAINDISCAMOUNT = "posmaindiscamount";
  static const String FDN_POSMAINDISCRATE = "posmaindiscrate";
  static const String FDN_POSMAINTOTAL = "posmaintotal";
  static const String FDN_POSMAINSERVRATE = "posmainservrate";
  static const String FDN_POSMAINSUBTOTAL = "posmainsubtotal";
  static const String FDN_POSNEG = "posneg";
  static const String FDN_POSNONPAYLESTOTAL = "posnonpaylestotal";
  static const String FDN_POSPAXID = "pospaxid";
  static const String FDN_POSPAYLESTOTAL = "pospaylestotal";
  static const String FDN_POSTATUS = "postatus";
  static const String FDN_POSTATUSID = "postatusid";
  static const String FDN_POSTATUSCODE = "postatuscode";
  static const String FDN_POSTATUSDESC = "postatusdesc";
  static const String FDN_POSTING = "posting";
  static const String FDN_POSTOTAL = "postotal";
  static const String FDN_POSTPERROOMINMASTER = "postperroominmaster";
  static const String FDN_POSTRANSNO = "postransno";
  static const String FDN_POSTRECURR = "postrecurr";
  static const String FDN_POSTTOTAL = "posttotal";
  static const String FDN_POSTYPE = "postype";
  static const String FDN_POSTYPEDESC = "postypedesc";
  static const String FDN_PP = "pp";
  static const String FDN_PPRATE = "pprate";
  static const String FDN_PPREVENUE = "pprevenue";
  static const String FDN_PPTOTAL = "pptotal";
  static const String FDN_PRCODE = "prcode";
  static const String FDN_PRCODEDESC = "prcodedesc";
  static const String FDN_PRCODEID = "prcodeid";
  static const String FDN_PRCOLOR = "prcolor";
  static const String FDN_PRDESC = "prdesc";
  static const String FDN_PREDL = "predl";
  static const String FDN_PREFGID = "prefgid";
  static const String FDN_PREFORMATTED = "preformatted";
  static const String FDN_PREPAYMENT = "prepayment";
  static const String FDN_PREPDURATION = "prepduration";
  static const String FDN_PREPDURATIONMIN = "prepdurationmin";
  static const String FDN_PREPTEXT = "preptext";
  static const String FDN_PREPTPL = "preptpl";
  static const String FDN_PREVCARDTYPECODE = "prevcardtypecode";
  static const String FDN_PREVCOUNT = "prevcount";
  static const String FDN_PREVCOUNTED = "prevcounted";
  static const String FDN_PREVDATE = "prevdate";
  static const String FDN_PREVIOUSEXISTS = "previousexists";
  static const String FDN_PREVISACTIVE = "previsactive";
  static const String FDN_PREVLEVEL = "prevlevel";
  static const String FDN_PRICE = "price";
  static const String FDN_PRICEBONUS = "pricebonus";
  static const String FDN_PRICECURR = "pricecurr";
  static const String FDN_PRICECURRCODE = "pricecurrcode";
  static const String FDN_PRICECURRDESC = "pricecurrdesc";
  static const String FDN_PRICECURRID = "pricecurrid";
  static const String FDN_PRICEDIFF = "pricediff";
  static const String FDN_PRICEGROSS = "pricegross";
  static const String FDN_PRICEINTERVAL = "priceinterval";
  static const String FDN_PRICENET = "pricenet";
  static const String FDN_PRICENOTE = "pricenote";
  static const String FDN_PRICEOFFERED = "priceoffered";
  static const String FDN_PRICEPERIOD = "priceperiod";
  static const String FDN_PRICEPMDISCED = "pricepmdisced";
  static const String FDN_PRICERATIO = "priceratio";
  static const String FDN_PRICINGCURRENCYCODE = "pricingcurrencycode";
  static const String FDN_PRILEVEL = "prilevel";
  static const String FDN_PRIORITY = "priority";
  static const String FDN_PRIORITYCODE = "prioritycode";
  static const String FDN_PRIORITYDESC = "prioritydesc";
  static const String FDN_PRIORITYID = "priorityid";
  static const String FDN_PRIVATEEMAIL = "privateemail";
  static const String FDN_PRIVATETEL = "privatetel";
  static const String FDN_PRIVATEWEB = "privateweb";
  static const String FDN_PRLEVEL = "prlevel";
  static const String FDN_PROCESSNAME = "processname";
  static const String FDN_PROCNAME = "procname";
  static const String FDN_PRODUCEDATE = "producedate";
  static const String FDN_PRODUCTCODE = "productcode";
  static const String FDN_PRODUCTCODEDESC = "productcodedesc";
  static const String FDN_PRODUCTCODEID = "productcodeid";
  static const String FDN_PRODUCTDESC = "productdesc";
  static const String FDN_PRODUCTDESCINENG = "productdescineng";
  static const String FDN_PRODUCTID = "productid";
  static const String FDN_PRODUCTNAME = "productname";
  static const String FDN_PRODUCTTYPE = "producttype";
  static const String FDN_PRODUCTTYPEID = "producttypeid";
  static const String FDN_PRODUCTTYPECODE = "producttypecode";
  static const String FDN_PRODUCTTYPEDESC = "producttypedesc";
  static const String FDN_PROJECTCODE = "projectcode";
  static const String FDN_PROJECTDESC = "projectdesc";
  static const String FDN_PROJECTID = "projectid";
  static const String FDN_PROPAMOUNT = "propamount";
  static const String FDN_PROPCODE = "propcode";
  static const String FDN_PROPCODEID = "propcodeid";
  static const String FDN_PROPID = "propid";
  static const String FDN_PROPIMAGESTR = "propimagestr";
  static const String FDN_PROPNAME = "propname";
  static const String FDN_PROPQTY = "propqty";
  static const String FDN_PROPTYPE = "proptype";
  static const String FDN_PROPVALUE = "propvalue";
  static const String FDN_PROVIDERCODE = "providercode";
  static const String FDN_PROVIDERDESC = "providerdesc";
  static const String FDN_PROVIDERID = "providerid";
  static const String FDN_PROVIDERSHORTCODE = "providershortcode";
  static const String FDN_PRPER = "prper";
  static const String FDN_PRQTY = "prqty";
  static const String FDN_PRREVENUE = "prrevenue";
  static const String FDN_PRTOTAL = "prtotal";
  static const String FDN_PRTYPECODE = "prtypecode";
  static const String FDN_PRTYPEDESC = "prtypedesc";
  static const String FDN_PRTYPEID = "prtypeid";
  static const String FDN_PRVCLIENTID = "prvclientid";
  static const String FDN_PRVLEVEL = "prvlevel";
  static const String FDN_PRVPRICE = "prvprice";
  static const String FDN_PRVSECRET = "prvsecret";
  static const String FDN_PRVTYPECODE = "prvtypecode";
  static const String FDN_PRVTYPEID = "prvtypeid";
  static const String FDN_PRVTYPEDESC = "prvtypedesc";
  static const String FDN_PTABLENO = "ptableno";
  static const String FDN_PUBLISHDATE = "publishdate";
  static const String FDN_PURCHAMOUNT = "purchamount";
  static const String FDN_PURCHPRICE = "purchprice";
  static const String FDN_QASCORE = "qascore";
  static const String FDN_QITEMINDEX = "qitemindex";
  static const String FDN_QSDESC = "qsdesc";
  static const String FDN_QSFONTSIZE = "qsfontsize";
  static const String FDN_QSGROUPDESC = "qsgroupdesc";
  static const String FDN_QSGROUPID = "qsgroupid";
  static const String FDN_QSGROUPNAME = "qsgroupname";
  static const String FDN_QSID = "qsid";
  static const String FDN_QSORDERNO = "qsorderno";
  static const String FDN_QSTYPE = "qstype";
  static const String FDN_QTY = "qty";
  static const String FDN_QTYCODE = "qtycode";
  static const String FDN_QTYDESC = "qtydesc";
  static const String FDN_QTYID = "qtyid";
  static const String FDN_QUADRATE = "quadrate";
  static const String FDN_QUADTEXT = "quadtext";
  static const String FDN_QUANTITY = "quantity";
  static const String FDN_QUERY = "query";
  static const String FDN_QUESTION = "question";
  static const String FDN_QUESTIONDESC = "questiondesc";
  static const String FDN_QUESTIONID = "questionid";
  static const String FDN_QUESTIONNOTE = "questionnote";
  static const String FDN_QUEUEDURATION = "queueduration";
  static const String FDN_RACKCOL = "rackcol";
  static const String FDN_RACKCOLORINT = "rackcolorint";
  static const String FDN_RACKNO = "rackno";
  static const String FDN_RACKPIVOT = "rackpivot";
  static const String FDN_RACKROW = "rackrow";
  static const String FDN_RACODE = "racode";
  static const String FDN_RAFILEID = "rafileid";
  static const String FDN_RAMODULEID = "ramoduleid";
  static const String FDN_RANOTEID = "ranoteid";
  static const String FDN_RAPACKAGE = "rapackage";
  static const String FDN_RATE = "rate";
  static const String FDN_RATEDATE = "ratedate";
  static const String FDN_RATEDAY = "rateday";
  static const String FDN_RATEDAYTYPE = "ratedaytype";
  static const String FDN_RATEDAYTYPEDESC = "ratedaytypedesc";
  static const String FDN_RATEDELTA = "ratedelta";
  static const String FDN_RATEFOLIONO = "ratefoliono";
  static const String FDN_RATESURVEYID = "ratesurveyid";
  static const String FDN_RATESURVEYDESC = "ratesurveydesc";
  static const String FDN_RATETEXT = "ratetext";
  static const String FDN_RATETYPE = "ratetype";
  static const String FDN_RATETYPECODE = "ratetypecode";
  static const String FDN_RATETYPEDESC = "ratetypedesc";
  static const String FDN_RATETYPEID = "ratetypeid";
  static const String FDN_RATIMEPERIOD = "ratimeperiod";
  static const String FDN_RATINGDELTA = "ratingdelta";
  static const String FDN_RATINGLIST = "ratinglist";
  static const String FDN_RATIO = "ratio";
  static const String FDN_RAXID = "raxid";
  static const String FDN_RAXLOGID = "raxlogid";
  static const String FDN_RAXLSEXTMENU = "raxlsextmenu";
  static const String FDN_RAXLUFIELDID = "raxlufieldid";
  static const String FDN_RAXLUTYPEID = "raxlutypeid";
  static const String FDN_RAXTAG = "raxtag";
  static const String FDN_RAXTRANSID = "raxtransid";
  static const String FDN_RAXTRANSNO = "raxtransno";
  static const String FDN_RBLOCK = "rblock";
  static const String FDN_RBLOCKCODE = "rblockcode";
  static const String FDN_RBLOCKDESC = "rblockdesc";
  static const String FDN_RBLOCKID = "rblockid";
  static const String FDN_RBLOCKMID = "rblockmid";
  static const String FDN_RDOUBLE = "rdouble";
  static const String FDN_READDATE = "readdate";
  static const String FDN_READLEVEL = "readlevel";
  static const String FDN_READONLY = "readonly";
  static const String FDN_READTIME = "readtime";
  static const String FDN_REASON = "reason";
  static const String FDN_REASONCODE = "reasoncode";
  static const String FDN_REASONDESC = "reasondesc";
  static const String FDN_REASONID = "reasonid";
  static const String FDN_RECBACKOUTS = "recbackouts";
  static const String FDN_RECCODE = "reccode";
  static const String FDN_RECDATE = "recdate";
  static const String FDN_RECDELETES = "recdeletes";
  static const String FDN_RECEIPTAMOUNT = "receiptamount";
  static const String FDN_RECEIPTCOUNT = "receiptcount";
  static const String FDN_RECEIPTDATE = "receiptdate";
  static const String FDN_RECEIPTNO = "receiptno";
  static const String FDN_RECEIPTQTY = "receiptqty";
  static const String FDN_RECEIPTQTYID = "receiptqtyid";
  static const String FDN_RECEIPTRATIO = "receiptratio";
  static const String FDN_RECEIPTTYPE = "receipttype";
  static const String FDN_RECEIPTTYPEDESC = "receipttypedesc";
  static const String FDN_RECEIVERACCCODE = "receiveracccode";
  static const String FDN_RECEIVERACCID = "receiveraccid";
  static const String FDN_RECEIVEREMAIL = "receiveremail";
  static const String FDN_RECEIVERID = "receiverid";
  static const String FDN_RECEIVERMID = "receivermid";
  static const String FDN_RECEIVERNAME = "receivername";
  static const String FDN_RECEIVERPHONE = "receiverphone";
  static const String FDN_RECEIVERSQLID = "receiversqlid";
  static const String FDN_RECEXPUNGES = "recexpunges";
  static const String FDN_RECID = "recid";
  static const String FDN_RECINSERTS = "recinserts";
  static const String FDN_RECOMMENDATION = "recommendation";
  static const String FDN_RECPURGES = "recpurges";
  static const String FDN_RECRATE = "recrate";
  static const String FDN_RECRATEDELTA = "recratedelta";
  static const String FDN_RECTYPE = "rectype";
  static const String FDN_RECUPDATES = "recupdates";
  static const String FDN_RECURRENCEINDEX = "recurrenceindex";
  static const String FDN_RECURRENCEINFO = "recurrenceinfo";
  static const String FDN_RECY = "recy";
  static const String FDN_RECY2 = "recy2";
  static const String FDN_RECY3 = "recy3";
  static const String FDN_RECY4 = "recy4";
  static const String FDN_RECY5 = "recy5";
  static const String FDN_RECYAVGLVDATE = "recyavglvdate";
  static const String FDN_RECYAVGLVDAY = "recyavglvday";
  static const String FDN_RECYAVGMAXDIFF = "recyavgmaxdiff";
  static const String FDN_RECYDAY2 = "recyday2";
  static const String FDN_RECYDAY3 = "recyday3";
  static const String FDN_RECYDAY4 = "recyday4";
  static const String FDN_RECYDAY5 = "recyday5";
  static const String FDN_RECYMAXLVDATE = "recymaxlvdate";
  static const String FDN_RECYMAXLVDAY = "recymaxlvday";
  static const String FDN_RECYMINAVGDIFF = "recyminavgdiff";
  static const String FDN_RECYMINLVDATE = "recyminlvdate";
  static const String FDN_RECYMINLVDAY = "recyminlvday";
  static const String FDN_RECYMINMAXDIFF = "recyminmaxdiff";
  static const String FDN_REFAMOUNT = "refamount";
  static const String FDN_REFCODE = "refcode";
  static const String FDN_REFCOUNTER = "refcounter";
  static const String FDN_REFCURRRATE = "refcurrrate";
  static const String FDN_REFDATE = "refdate";
  static const String FDN_REFFILEID = "reffileid";
  static const String FDN_REFFOLDERID = "reffolderid";
  static const String FDN_REFGID = "refgid";
  static const String FDN_REFID = "refid";
  static const String FDN_REFINFO = "refinfo";
  static const String FDN_REFINFOSHORT = "refinfoshort";
  static const String FDN_REFLINECOUNTER = "reflinecounter";
  static const String FDN_REFLINEID = "reflineid";
  static const String FDN_REFMSGCODE = "refmsgcode";
  static const String FDN_REFMSGID = "refmsgid";
  static const String FDN_REFNAME = "refname";
  static const String FDN_REFNO = "refno";
  static const String FDN_REFNOTEID = "refnoteid";
  static const String FDN_REFPRLEVEL = "refprlevel";
  static const String FDN_REFQSID = "refqsid";
  static const String FDN_REFRESERVNO = "refreservno";
  static const String FDN_REFRESHTOKEN = "refreshtoken";
  static const String FDN_REFRESH_TOKEN = "refresh_token";
  static const String FDN_REFSENTDT = "refsentdt";
  static const String FDN_REFTABLE = "reftable";
  static const String FDN_REFTRANSDATE = "reftransdate";
  static const String FDN_REFTRANSNO = "reftransno";
  static const String FDN_REFTSLINEID = "reftslineid";
  static const String FDN_REFTYPE = "reftype";
  static const String FDN_REFTYPEID = "reftypeid";
  static const String FDN_REFURL = "refurl";
  static const String FDN_REGCODE = "regcode";
  static const String FDN_REGIONCODE = "regioncode";
  static const String FDN_REGIONDESC = "regiondesc";
  static const String FDN_REGIONID = "regionid";
  static const String FDN_REGIONLOC = "regionloc";
  static const String FDN_REGIONLOCCODE = "regionloccode";
  static const String FDN_REGIONLOCDESC = "regionlocdesc";
  static const String FDN_REGIONLOCID = "regionlocid";
  static const String FDN_REGLBNO = "reglbno";
  static const String FDN_REGNO = "regno";
  static const String FDN_REJECTDATE = "rejectdate";
  static const String FDN_REJECTNOTE = "rejectnote";
  static const String FDN_REJECTTIME = "rejecttime";
  static const String FDN_REJECTUSERCODE = "rejectusercode";
  static const String FDN_REJECTUSEREMAIL = "rejectuseremail";
  static const String FDN_REJECTUSERNAME = "rejectusername";
  static const String FDN_RELCODE = "relcode";
  static const String FDN_RELEASEDAY = "releaseday";
  static const String FDN_RELFIRSTNAME = "relfirstname";
  static const String FDN_RELID = "relid";
  static const String FDN_RELLASTNAME = "rellastname";
  static const String FDN_RELNAME = "relname";
  static const String FDN_RELPATH = "relpath";
  static const String FDN_RELSHIPTYPE = "relshiptype";
  static const String FDN_RELSHIPTYPEDESC = "relshiptypedesc";
  static const String FDN_RELSHIPTYPEID = "relshiptypeid";
  static const String FDN_RELSHLEVEL = "relshlevel";
  static const String FDN_RELSHTYPECODE = "relshtypecode";
  static const String FDN_RELSHTYPEDESC = "relshtypedesc";
  static const String FDN_RELSHTYPEID = "relshtypeid";
  static const String FDN_REMADDRESS = "remaddress";
  static const String FDN_REMAININGTIME = "remainingtime";
  static const String FDN_REMARK = "remark";
  static const String FDN_REMARKCODE = "remarkcode";
  static const String FDN_REMARKCOUNT = "remarkcount";
  static const String FDN_REMARKDESC = "remarkdesc";
  static const String FDN_REMARKDESCDATE = "remarkdescdate";
  static const String FDN_REMARKGRCODE = "remarkgrcode";
  static const String FDN_REMARKGRDESC = "remarkgrdesc";
  static const String FDN_REMARKGRID = "remarkgrid";
  static const String FDN_REMARKID = "remarkid";
  static const String FDN_REMARKNOTE = "remarknote";
  static const String FDN_REMARKSTR = "remarkstr";
  static const String FDN_REMDATE = "remdate";
  static const String FDN_REMID = "remid";
  static const String FDN_REMINDERCOUNT = "remindercount";
  static const String FDN_REMINDERDATE = "reminderdate";
  static const String FDN_REMINDERMAIL = "remindermail";
  static const String FDN_REMINDERMINUTES = "reminderminutes";
  static const String FDN_REMOTEDURHOUR = "remotedurhour";
  static const String FDN_REMOTEHOTEL = "remotehotel";
  static const String FDN_REMOTEIP = "remoteip";
  static const String FDN_REMOTEPERSON = "remoteperson";
  static const String FDN_REMOTEPID = "remotepid";
  static const String FDN_REMOTEPROCESS = "remoteprocess";
  static const String FDN_REMOTEPROTOCOL = "remoteprotocol";
  static const String FDN_REMOTESESSION = "remotesession";
  static const String FDN_REMPID = "rempid";
  static const String FDN_REMPROCESS = "remprocess";
  static const String FDN_REMPROTOCOL = "remprotocol";
  static const String FDN_REMTIME = "remtime";
  static const String FDN_REMVER = "remver";
  static const String FDN_RENTALPMDISCED = "rentalpmdisced";
  static const String FDN_RENTITEMPRICE = "rentitemprice";
  static const String FDN_REPEATRATE = "repeatrate";
  static const String FDN_REPLYCOUNT = "replycount";
  static const String FDN_REPLYTOEMAIL = "replytoemail";
  static const String FDN_REPORTEDTO = "reportedto";
  static const String FDN_REPORTEDTODEP = "reportedtodep";
  static const String FDN_REPORTEDTOEMP = "reportedtoemp";
  static const String FDN_REPORTEDTOPOS = "reportedtopos";
  static const String FDN_REPORTID = "reportid";
  static const String FDN_REPORTMODULE = "reportmodule";
  static const String FDN_REPORTNAME = "reportname";
  static const String FDN_REQBYDEPCODE = "reqbydepcode";
  static const String FDN_REQBYDEPDESC = "reqbydepdesc";
  static const String FDN_REQBYDEPID = "reqbydepid";
  static const String FDN_REQBYPOSCODE = "reqbyposcode";
  static const String FDN_REQBYPOSDESC = "reqbyposdesc";
  static const String FDN_REQBYPOSID = "reqbyposid";
  static const String FDN_REQCONF = "reqconf";
  static const String FDN_REQDATE = "reqdate";
  static const String FDN_REQDOUBLE = "reqdouble";
  static const String FDN_REQEXP = "reqexp";
  static const String FDN_REQEXTRAPAX = "reqextrapax";
  static const String FDN_REQGID = "reqgid";
  static const String FDN_REQGIDSTR = "reqgidstr";
  static const String FDN_REQID = "reqid";
  static const String FDN_REQISACTIVE = "reqisactive";
  static const String FDN_REQNOTE = "reqnote";
  static const String FDN_REQQUAD = "reqquad";
  static const String FDN_REQSINGLE = "reqsingle";
  static const String FDN_REQSSENT = "reqssent";
  static const String FDN_REQSTATUS = "reqstatus";
  static const String FDN_REQSTATUSDESC = "reqstatusdesc";
  static const String FDN_REQSTORE = "reqstore";
  static const String FDN_REQSTORENAME = "reqstorename";
  static const String FDN_REQTOTALROOM = "reqtotalroom";
  static const String FDN_REQTRANS = "reqtrans";
  static const String FDN_REQTRIPLE = "reqtriple";
  static const String FDN_REQTYPE = "reqtype";
  static const String FDN_REQTYPEID = "reqtypeid";
  static const String FDN_REQUESTED = "requested";
  static const String FDN_REQUESTEDBY = "requestedby";
  static const String FDN_REQUESTEDBYCODE = "requestedbycode";
  static const String FDN_REQUESTEDBYDEPART = "requestedbydepart";
  static const String FDN_REQUESTEDBYDEPCODE = "requestedbydepcode";
  static const String FDN_REQUESTEDBYDEPDESC = "requestedbydepdesc";
  static const String FDN_REQUESTEDBYDEPID = "requestedbydepid";
  static const String FDN_REQUESTEDBYID = "requestedbyid";
  static const String FDN_REQUESTEDBYPOSCODE = "requestedbyposcode";
  static const String FDN_REQUESTEDBYPOSDESC = "requestedbyposdesc";
  static const String FDN_REQUESTEDBYPOSID = "requestedbyposid";
  static const String FDN_REQUIRED = "required";
  static const String FDN_REQXML = "reqxml";
  static const String FDN_RES = "res";
  static const String FDN_RESACTION = "resaction";
  static const String FDN_RESADVPAY = "resadvpay";
  static const String FDN_RESAGENCY = "resagency";
  static const String FDN_RESAGENCYID = "resagencyid";
  static const String FDN_RESAVGDAILYRATE = "resavgdailyrate";
  static const String FDN_RESAVGPP = "resavgpp";
  static const String FDN_RESBACKDISCID = "resbackdiscid";
  static const String FDN_RESBREAKCODE = "resbreakcode";
  static const String FDN_RESBREAKDESC = "resbreakdesc";
  static const String FDN_RESBREAKID = "resbreakid";
  static const String FDN_RESCHAR = "reschar";
  static const String FDN_RESCITIME = "rescitime";
  static const String FDN_RESCLIENTID = "resclientid";
  static const String FDN_RESCLIENTNAME = "resclientname";
  static const String FDN_RESCODE = "rescode";
  static const String FDN_RESCOTIME = "rescotime";
  static const String FDN_RESCOUNT = "rescount";
  static const String FDN_RESCOUNTRY = "rescountry";
  static const String FDN_RESCOUNTRYCODE = "rescountrycode";
  static const String FDN_RESCOUNTRYDESC = "rescountrydesc";
  static const String FDN_RESCOUNTRYID = "rescountryid";
  static const String FDN_RESDATE = "resdate";
  static const String FDN_RESDAY = "resday";
  static const String FDN_RESDEFINIT = "resdefinit";
  static const String FDN_RESDEFINITCODE = "resdefinitcode";
  static const String FDN_RESDEFINITDESC = "resdefinitdesc";
  static const String FDN_RESDEFINITID = "resdefinitid";
  static const String FDN_RESDISCRATE = "resdiscrate";
  static const String FDN_RESDOMAIN = "resdomain";
  static const String FDN_RESDT = "resdt";
  static const String FDN_RESDURATION = "resduration";
  static const String FDN_RESEND = "resend";
  static const String FDN_RESENDCODE = "resendcode";
  static const String FDN_RESENDCOLOR = "resendcolor";
  static const String FDN_RESENDDATE = "resenddate";
  static const String FDN_RESENDID = "resendid";
  static const String FDN_RESENDMID = "resendmid";
  static const String FDN_RESERVESPACE = "reservespace";
  static const String FDN_RESERVE_SPACE = "reserve_space";
  static const String FDN_RESERVNO = "reservno";
  static const String FDN_RESETCHK = "resetchk";
  static const String FDN_RESEVENTPRICE = "reseventprice";
  static const String FDN_RESEXCRATE = "resexcrate";
  static const String FDN_RESFIXED = "resfixed";
  static const String FDN_RESFULL = "resfull";
  static const String FDN_RESGID = "resgid";
  static const String FDN_RESGROUPID = "resgroupid";
  static const String FDN_RESHOTELNAME = "reshotelname";
  static const String FDN_RESHOTELREFNO = "reshotelrefno";
  static const String FDN_RESID = "resid";
  static const String FDN_RESINDUSTRY = "resindustry";
  static const String FDN_RESINDUSTRYCODE = "resindustrycode";
  static const String FDN_RESINDUSTRYDESC = "resindustrydesc";
  static const String FDN_RESINDUSTRYID = "resindustryid";
  static const String FDN_RESINTERVAL = "resinterval";
  static const String FDN_RESLEFT = "resleft";
  static const String FDN_RESLIST = "reslist";
  static const String FDN_RESLOCAL = "reslocal";
  static const String FDN_RESMARKET = "resmarket";
  static const String FDN_RESMARKETCATCODE = "resmarketcatcode";
  static const String FDN_RESMARKETCATDESC = "resmarketcatdesc";
  static const String FDN_RESMARKETCATID = "resmarketcatid";
  static const String FDN_RESMARKETCODE = "resmarketcode";
  static const String FDN_RESMARKETDESC = "resmarketdesc";
  static const String FDN_RESMARKETID = "resmarketid";
  static const String FDN_RESMASTERAGENCY = "resmasteragency";
  static const String FDN_RESMASTERCI = "resmasterci";
  static const String FDN_RESMASTERCO = "resmasterco";
  static const String FDN_RESMASTEREND = "resmasterend";
  static const String FDN_RESMASTERNAME = "resmastername";
  static const String FDN_RESMASTERNO = "resmasterno";
  static const String FDN_RESMASTERSTART = "resmasterstart";
  static const String FDN_RESMID = "resmid";
  static const String FDN_RESMIN = "resmin";
  static const String FDN_RESMONTH = "resmonth";
  static const String FDN_RESNOTE = "resnote";
  static const String FDN_RESOURCECOLOR = "resourcecolor";
  static const String FDN_RESOURCE_COLOR = "resource_color";
  static const String FDN_RESOURCEDESC = "resourcedesc";
  static const String FDN_RESOURCEID = "resourceid";
  static const String FDN_RESOURCE_GRP = "resource_grp";
  static const String FDN_RESOURCE_ID = "resource_id";
  static const String FDN_RESOURCEIMAGEINDEX = "resourceimageindex";
  static const String FDN_RESOURCE_IMAGE_INDEX = "resource_image_index";
  static const String FDN_RESPAXRATE = "respaxrate";
  static const String FDN_RESPAXRATIO = "respaxratio";
  static const String FDN_RESPAXSTR = "respaxstr";
  static const String FDN_RESPAXTYPE = "respaxtype";
  static const String FDN_RESPAYTRANSNO = "respaytransno";
  static const String FDN_RESPAYTYPE = "respaytype";
  static const String FDN_RESPONSIBLE = "responsible";
  static const String FDN_RESRATEID = "resrateid";
  static const String FDN_RESREFID = "resrefid";
  static const String FDN_RESREFCODE = "resrefcode";
  static const String FDN_RESROOMNO = "resroomno";
  static const String FDN_RESROOMTYPE = "resroomtype";
  static const String FDN_RESSEGMENT = "ressegment";
  static const String FDN_RESSEGMENTCODE = "ressegmentcode";
  static const String FDN_RESSEGMENTDESC = "ressegmentdesc";
  static const String FDN_RESSEGMENTID = "ressegmentid";
  static const String FDN_RESSHORTCODE = "resshortcode";
  static const String FDN_RESSOURCE = "ressource";
  static const String FDN_RESSOURCECATCODE = "ressourcecatcode";
  static const String FDN_RESSOURCECATDESC = "ressourcecatdesc";
  static const String FDN_RESSOURCECATID = "ressourcecatid";
  static const String FDN_RESSOURCECODE = "ressourcecode";
  static const String FDN_RESSOURCEDESC = "ressourcedesc";
  static const String FDN_RESSOURCEID = "ressourceid";
  static const String FDN_RESSTARTCODE = "resstartcode";
  static const String FDN_RESSTARTCOLOR = "resstartcolor";
  static const String FDN_RESSTARTDATE = "resstartdate";
  static const String FDN_RESSTARTID = "resstartid";
  static const String FDN_RESSTARTMID = "resstartmid";
  static const String FDN_RESSTATUS = "resstatus";
  static const String FDN_RESSTATUSDESC = "resstatusdesc";
  static const String FDN_RESSTR = "resstr";
  static const String FDN_RESSTRLOCAL = "resstrlocal";
  static const String FDN_RESSUBTOTAL = "ressubtotal";
  static const String FDN_RESSUCC = "ressucc";
  static const String FDN_RESTEXT = "restext";
  static const String FDN_RESTIME = "restime";
  static const String FDN_RESTIMESTR = "restimestr";
  static const String FDN_RESTOREDBY = "restoredby";
  static const String FDN_RESTOREDON = "restoredon";
  static const String FDN_RESTOTAL = "restotal";
  static const String FDN_RESTOTALAVG = "restotalavg";
  static const String FDN_RESAVG = "resavg";
  static const String FDN_RESTOTALALL = "restotalall";
  static const String FDN_RESTOTALBABY = "restotalbaby";
  static const String FDN_RESTOTALCHD = "restotalchd";
  static const String FDN_RESTOTALCHD1 = "restotalchd1";
  static const String FDN_RESTOTALCHD2 = "restotalchd2";
  static const String FDN_RESTOTALPAX = "restotalpax";
  static const String FDN_RESTOTALROOM = "restotalroom";
  static const String FDN_RESTYPE = "restype";
  static const String FDN_RESTYPEID = "restypeid";
  static const String FDN_RESTYPECODE = "restypecode";
  static const String FDN_RESTYPEDESC = "restypedesc";
  static const String FDN_RESULTNOTE = "resultnote";
  static const String FDN_RESULTTABLEHEIGHT = "resulttableheight";
  static const String FDN_RESULTTABLEVISIBLE = "resulttablevisible";
  static const String FDN_RESULTTABLEWIDTH = "resulttablewidth";
  static const String FDN_RESUSER = "resuser";
  static const String FDN_RESXREASONID = "resxreasonid";
  static const String FDN_RESYEAR = "resyear";
  static const String FDN_RETURNSCOLL = "returnscoll";
  static const String FDN_RETURNSPAY = "returnspay";
  static const String FDN_REVADR = "revadr";
  static const String FDN_REVAPP = "revapp";
  static const String FDN_REVCATID = "revcatid";
  static const String FDN_REVCOUNTDELTA = "revcountdelta";
  static const String FDN_REVDISCRATE = "revdiscrate";
  static const String FDN_REVEMAILRATE = "revemailrate";
  static const String FDN_REVENUE = "revenue";
  static const String FDN_REVENUENET = "revenuenet";
  static const String FDN_REVENUEX = "revenuex";
  static const String FDN_REVEXCRATE = "revexcrate";
  static const String FDN_REVID = "revid";
  static const String FDN_REVIEWCOUNT = "reviewcount";
  static const String FDN_REVINV = "revinv";
  static const String FDN_REVISIONNO = "revisionno";
  static const String FDN_REVNOTE = "revnote";
  static const String FDN_REVPAB = "revpab";
  static const String FDN_REVPAR = "revpar";
  static const String FDN_REVPARALL = "revparall";
  static const String FDN_REVPARROOMING = "revparrooming";
  static const String FDN_REVPARTOTAL = "revpartotal";
  static const String FDN_REVPORTALID = "revportalid";
  static const String FDN_REVPUBRATE = "revpubrate";
  static const String FDN_REVSOURCECODE = "revsourcecode";
  static const String FDN_REVSOURCEDESC = "revsourcedesc";
  static const String FDN_REVSOURCEID = "revsourceid";
  static const String FDN_REVSTATUS = "revstatus";
  static const String FDN_REVSTATUSCODE = "revstatuscode";
  static const String FDN_REVSTATUSDESC = "revstatusdesc";
  static const String FDN_REVTITLE = "revtitle";
  static const String FDN_REVTYPE = "revtype";
  static const String FDN_RFLOORMID = "rfloormid";
  static const String FDN_RFM = "rfm";
  static const String FDN_RFMVAL = "rfmval";
  static const String FDN_RMF = "rmf";
  static const String FDN_ROOMATTR = "roomattr";
  static const String FDN_ROOMATTRCODE = "roomattrcode";
  static const String FDN_ROOMATTRDESC = "roomattrdesc";
  static const String FDN_ROOMATTRID = "roomattrid";
  static const String FDN_ROOMCAP = "roomcap";
  static const String FDN_ROOMCAT = "roomcat";
  static const String FDN_ROOMCLASS = "roomclass";
  static const String FDN_ROOMCODE = "roomcode";
  static const String FDN_ROOMCORRECTION = "roomcorrection";
  static const String FDN_ROOMDESC = "roomdesc";
  static const String FDN_ROOMGID = "roomgid";
  static const String FDN_ROOMID = "roomid";
  static const String FDN_ROOMING = "rooming";
  static const String FDN_ROOMINGDISC = "roomingdisc";
  static const String FDN_ROOMINGNOTE = "roomingnote";
  static const String FDN_ROOMINGOK = "roomingok";
  static const String FDN_ROOMINGREV = "roomingrev";
  static const String FDN_ROOMINGREVENUE = "roomingrevenue";
  static const String FDN_ROOMINGREVENUEABG = "roomingrevenueabg";
  static const String FDN_ROOMINGREVENUECURR = "roomingrevenuecurr";
  static const String FDN_ROOMINGREVENUEFT = "roomingrevenueft";
  static const String FDN_ROOMINGREVENUEFTCURR = "roomingrevenueftcurr";
  static const String FDN_ROOMINGREVENUEHC = "roomingrevenuehc";
  static const String FDN_ROOMINGREVNET = "roomingrevnet";
  static const String FDN_ROOMINGREVPP = "roomingrevpp";
  static const String FDN_ROOMINGREVPR = "roomingrevpr";
  static const String FDN_ROOMINGTOTAL = "roomingtotal";
  static const String FDN_ROOMNIGHT = "roomnight";
  static const String FDN_ROOMNO = "roomno";
  static const String FDN_ROOMQTY = "roomqty";
  static const String FDN_ROOMRATE = "roomrate";
  static const String FDN_ROOMRATEID = "roomrateid";
  static const String FDN_ROOMRATEHOMECURR = "roomratehomecurr";
  static const String FDN_ROOMRESNIGHT = "roomresnight";
  static const String FDN_ROOMREV = "roomrev";
  static const String FDN_ROOMREVCURR = "roomrevcurr";
  static const String FDN_ROOMREVENUE = "roomrevenue";
  static const String FDN_ROOMREVENUEABG = "roomrevenueabg";
  static const String FDN_ROOMREVENUECURR = "roomrevenuecurr";
  static const String FDN_ROOMREVENUEFT = "roomrevenueft";
  static const String FDN_ROOMREVENUEFTCURR = "roomrevenueftcurr";
  static const String FDN_ROOMREVENUEHC = "roomrevenuehc";
  static const String FDN_ROOMREVGROSS = "roomrevgross";
  static const String FDN_ROOMREVGROSSRPT1 = "roomrevgrossrpt1";
  static const String FDN_ROOMREVNET = "roomrevnet";
  static const String FDN_ROOMREVNETRPT1 = "roomrevnetrpt1";
  static const String FDN_ROOMSTATE = "roomstate";
  static const String FDN_ROOMSTATEBOOKED = "roomstatebooked";
  static const String FDN_ROOMSTATECODE = "roomstatecode";
  static const String FDN_ROOMSTATECOLOR = "roomstatecolor";
  static const String FDN_ROOMSTATEDESC = "roomstatedesc";
  static const String FDN_ROOMSTATEFO = "roomstatefo";
  static const String FDN_ROOMSTATEHK = "roomstatehk";
  static const String FDN_ROOMSTATEICON = "roomstateicon";
  static const String FDN_ROOMSTATEID = "roomstateid";
  static const String FDN_ROOMSTATUS = "roomstatus";
  static const String FDN_ROOMSTATUSMID = "roomstatusmid";
  static const String FDN_ROOMSTATUSOK = "roomstatusok";
  static const String FDN_ROOMTAXRATE = "roomtaxrate";
  static const String FDN_ROOMTELNO = "roomtelno";
  static const String FDN_ROOMTYPE = "roomtype";
  static const String FDN_ROOMTYPECODE = "roomtypecode";
  static const String FDN_ROOMTYPEDESC = "roomtypedesc";
  static const String FDN_ROOMTYPEEMPTY = "roomtypeempty";
  static const String FDN_ROOMTYPEID = "roomtypeid";
  static const String FDN_ROOMTYPEMID = "roomtypemid";
  static const String FDN_ROOMTYPEOCC = "roomtypeocc";
  static const String FDN_ROOMTYPEPRICE = "roomtypeprice";
  static const String FDN_ROOMTYPES = "roomtypes";
  static const String FDN_ROOMVIEW = "roomview";
  static const String FDN_ROOTID = "rootid";
  static const String FDN_ROUNDAMOUNT = "roundamount";
  static const String FDN_ROUNDEDTOTAL = "roundedtotal";
  static const String FDN_RPT1CURR = "rpt1curr";
  static const String FDN_RPT1EXCRATE = "rpt1excrate";
  static const String FDN_RPT1RATE = "rpt1rate";
  static const String FDN_RPT2CURR = "rpt2curr";
  static const String FDN_RPT2RATE = "rpt2rate";
  static const String FDN_RPTASBODY = "rptasbody";
  static const String FDN_RPTCURR = "rptcurr";
  static const String FDN_RPTCURRCODE = "rptcurrcode";
  static const String FDN_RPTCURRDESC = "rptcurrdesc";
  static const String FDN_RPTCURR2 = "rptcurr2";
  static const String FDN_RPTCURR2RATE = "rptcurr2rate";
  static const String FDN_RPTCURRID = "rptcurrid";
  static const String FDN_RPTENDDATE = "rptenddate";
  static const String FDN_RPTEXCRATE = "rptexcrate";
  static const String FDN_RPTMAILDESC = "rptmaildesc";
  static const String FDN_RPTMAILID = "rptmailid";
  static const String FDN_RPTPARAMS = "rptparams";
  static const String FDN_RPTSTARTDATE = "rptstartdate";
  static const String FDN_RQUAD = "rquad";
  static const String FDN_RSINGLE = "rsingle";
  static const String FDN_RTRIPLE = "rtriple";
  static const String FDN_RTYPE = "rtype";
  static const String FDN_RULEID = "ruleid";
  static const String FDN_RVAL = "rval";
  static const String FDN_SALARYAMOUNT = "salaryamount";
  static const String FDN_SALARYCURR = "salarycurr";
  static const String FDN_SALARYCURRCODE = "salarycurrcode";
  static const String FDN_SALARYCURRDESC = "salarycurrdesc";
  static const String FDN_SALARYCURRID = "salarycurrid";
  static const String FDN_SALARYDAY = "salaryday";
  static const String FDN_SALE = "sale";
  static const String FDN_SALEAGE = "saleage";
  static const String FDN_SALEAMOUNT = "saleamount";
  static const String FDN_SALEAPTCODE = "saleaptcode";
  static const String FDN_SALEBACKAPTCODE = "salebackaptcode";
  static const String FDN_SALEBONUSPRICE = "salebonusprice";
  static const String FDN_SALEBONUSRATE = "salebonusrate";
  static const String FDN_SALEBONUSTOTAL = "salebonustotal";
  static const String FDN_SALEBONUSTPLCODE = "salebonustplcode";
  static const String FDN_SALEBONUSTPLID = "salebonustplid";
  static const String FDN_SALEDATE = "saledate";
  static const String FDN_SALEDISCID = "salediscid";
  static const String FDN_SALEEMPCODE = "saleempcode";
  static const String FDN_SALEEMPID = "saleempid";
  static const String FDN_SALEEMPNAME = "saleempname";
  static const String FDN_SALEGRNAME = "salegrname";
  static const String FDN_SALEGROUP = "salegroup";
  static const String FDN_SALEGROUPCODE = "salegroupcode";
  static const String FDN_SALEGROUPDESC = "salegroupdesc";
  static const String FDN_SALEGROUPID = "salegroupid";
  static const String FDN_SALEGROUPLONG = "salegrouplong";
  static const String FDN_SALEGROUPNAME = "salegroupname";
  static const String FDN_SALEGRP = "salegrp";
  static const String FDN_SALEGRPCODE = "salegrpcode";
  static const String FDN_SALEGRPDESC = "salegrpdesc";
  static const String FDN_SALEGRPFULL = "salegrpfull";
  static const String FDN_SALEGRPID = "salegrpid";
  static const String FDN_SALEGRPNAME = "salegrpname";
  static const String FDN_SALEPACKCODE = "salepackecode";
  static const String FDN_SALEPACKDESC = "salepackedesc";
  static const String FDN_SALEPACKELID = "salepackelid";
  static const String FDN_SALEPACKID = "salepackid";
  static const String FDN_SALEPER = "saleper";
  static const String FDN_SALEPRICE = "saleprice";
  static const String FDN_SALEPRPRICE = "saleprprice";
  static const String FDN_SALESGRPDESC = "salesgrpdesc";
  static const String FDN_SALESLEVEL = "saleslevel";
  static const String FDN_SALESNOTE = "salesnote";
  static const String FDN_SALESVISITCALL = "salesvisitcall";
  static const String FDN_SALESVISITCALLLASTYEARLY = "salesvisitcalllastyearly";
  static const String FDN_SALESVISITCALLMONTHLY = "salesvisitcallmonthly";
  static const String FDN_SALESVISITCALLWEEKLY = "salesvisitcallweekly";
  static const String FDN_SALESVISITCALLYEARLY = "salesvisitcallyearly";
  static const String FDN_SALETARGET = "saletarget";
  static const String FDN_SALETARGETRATE = "saletargetrate";
  static const String FDN_SALETOTAL = "saletotal";
  static const String FDN_SALETOTALTAXED = "saletotaltaxed";
  static const String FDN_SALEYEAR = "saleyear";
  static const String FDN_SALUTATION = "salutation";
  static const String FDN_SAMPLEID = "sampleid";
  static const String FDN_SASSETGROUP = "sassetgroup";
  static const String FDN_SASSETGROUPNAME = "sassetgroupname";
  static const String FDN_SASSETID = "sassetid";
  static const String FDN_SAT = "sat";
  static const String FDN_SATICIADI = "saticiadi";
  static const String FDN_SATICIKODU = "saticikodu";
  static const String FDN_SATIRTOPLAM = "satirtoplam";
  static const String FDN_SATISRATE = "satisrate";
  static const String FDN_SCAMOUNT = "scamount";
  static const String FDN_SCAMOUNTCURR = "scamountcurr";
  static const String FDN_SCDATE = "scdate";
  static const String FDN_SCDELAYAVG = "scdelayavg";
  static const String FDN_SCDELAYFWAVG = "scdelayfwavg";
  static const String FDN_SCDELAYFWMIN = "scdelayfwmin";
  static const String FDN_SCDELAYFWTOTAL = "scdelayfwtotal";
  static const String FDN_SCDELAYMIN = "scdelaymin";
  static const String FDN_SCDELAYMINAVG = "scdelayminavg";
  static const String FDN_SCDELAYTOTAL = "scdelaytotal";
  static const String FDN_SCDURATIONMIN = "scdurationmin";
  static const String FDN_SCHOOLNAME = "schoolname";
  static const String FDN_SCHOOLPLACE = "schoolplace";
  static const String FDN_SCONTMID = "scontmid";
  static const String FDN_SCONTRACT = "scontract";
  static const String FDN_SCONTRACTDESC = "scontractdesc";
  static const String FDN_SCONTRACTID = "scontractid";
  static const String FDN_SCOPE = "scope";
  static const String FDN_SCOPEID = "scopeid";
  static const String FDN_SCOPELINK = "scopelink";
  static const String FDN_SCOPENAME = "scopename";
  static const String FDN_SCOPENOTE = "scopenote";
  static const String FDN_SCORE = "score";
  static const String FDN_SCOREDUR = "scoredur";
  static const String FDN_SCOREFULL = "scorefull";
  static const String FDN_SCOREMIN = "scoremin";
  static const String FDN_SCOREPER = "scoreper";
  static const String FDN_SCOREPERCENT = "scorepercent";
  static const String FDN_SCORETOTAL = "scoretotal";
  static const String FDN_SCOUNTER = "scounter";
  static const String FDN_SCOUNTID = "scountid";
  static const String FDN_SCPHONEMONTHLY = "scphonemonthly";
  static const String FDN_SCPHONEPERCENTMONTHLY = "scphonepercentmonthly";
  static const String FDN_SCPHONEPERCENTWEEKLY = "scphonepercentweekly";
  static const String FDN_SCPHONEPERCENTYEARLY = "scphonepercentyearly";
  static const String FDN_SCPHONETARGETMONTHLY = "scphonetargetmonthly";
  static const String FDN_SCPHONETARGETWEEKLY = "scphonetargetweekly";
  static const String FDN_SCPHONETARGETYEARLY = "scphonetargetyearly";
  static const String FDN_SCPHONEWEEKLY = "scphoneweekly";
  static const String FDN_SCPHONEYEARLY = "scphoneyearly";
  static const String FDN_SCREENPOS = "screenpos";
  static const String FDN_SCRIPTCODE = "scriptcode";
  static const String FDN_SCRIPTID = "scriptid";
  static const String FDN_SCTAXTOTAL = "sctaxtotal";
  static const String FDN_SCTAXTOTALCURR = "sctaxtotalcurr";
  static const String FDN_SCTOTAL = "sctotal";
  static const String FDN_SCVISITLIST = "scvisitlist";
  static const String FDN_SCVISITMONTHLY = "scvisitmonthly";
  static const String FDN_SCVISITPERCENTMONTHLY = "scvisitpercentmonthly";
  static const String FDN_SCVISITPERCENTWEEKLY = "scvisitpercentweekly";
  static const String FDN_SCVISITPERCENTYEARLY = "scvisitpercentyearly";
  static const String FDN_SCVISITTARGETMONTHLY = "scvisittargetmonthly";
  static const String FDN_SCVISITTARGETWEEKLY = "scvisittargetweekly";
  static const String FDN_SCVISITTARGETYEARLY = "scvisittargetyearly";
  static const String FDN_SCVISITTOTAL = "scvisittotal";
  static const String FDN_SCVISITWEEKLY = "scvisitweekly";
  static const String FDN_SCVISITYEARLY = "scvisityearly";
  static const String FDN_SEARCH = "search";
  static const String FDN_SEASON = "season";
  static const String FDN_SEATDATE = "seatdate";
  static const String FDN_SECCODE = "seccode";
  static const String FDN_SECDESC = "secdesc";
  static const String FDN_SECID = "secid";
  static const String FDN_SECREFCODE = "secrefcode";
  static const String FDN_SEGMENTCODE = "segmentcode";
  static const String FDN_SEGMENTDESC = "segmentdesc";
  static const String FDN_SEGMENTID = "segmentid";
  static const String FDN_SELFISH = "selfish";
  static const String FDN_SELLERITEMCODE = "selleritemcode";
  static const String FDN_SENDCLIENTMAIL = "sendclientmail";
  static const String FDN_SENDCOUNTER = "sendcounter";
  static const String FDN_SENDDATE = "senddate";
  static const String FDN_SENDERACCCODE = "senderacccode";
  static const String FDN_SENDERACCID = "senderaccid";
  static const String FDN_SENDERDESC = "senderdesc";
  static const String FDN_SENDEREMAIL = "senderemail";
  static const String FDN_SENDERID = "senderid";
  static const String FDN_SENDERIP = "senderip";
  static const String FDN_SENDERNAME = "sendername";
  static const String FDN_SENDERSQL = "sendersql";
  static const String FDN_SENDSEPARATELY = "sendseparately";
  static const String FDN_SENDTIME = "sendtime";
  static const String FDN_SENDTIMEDATEFLD = "sendtimedatefld";
  static const String FDN_SENDTIMEINTERVAL = "sendtimeinterval";
  static const String FDN_SENDTIMETYPE = "sendtimetype";
  static const String FDN_SENTLOC = "sentloc";
  static const String FDN_SENTMONTH = "sentmonth";
  static const String FDN_SENTTOTAL = "senttotal";
  static const String FDN_SENTWEEK = "sentweek";
  static const String FDN_SEPARATELYMAIL = "separatelymail";
  static const String FDN_SEPEMAILS = "sepemails";
  static const String FDN_SEPTEXT = "septext";
  static const String FDN_SEQREADS = "seqreads";
  static const String FDN_SERIALNO = "serialno";
  static const String FDN_SERVAMOUNT = "servamount";
  static const String FDN_SERVBONUSPRICE = "servbonusprice";
  static const String FDN_SERVBONUSRATE = "servbonusrate";
  static const String FDN_SERVBONUSTOTAL = "servbonustotal";
  static const String FDN_SERVEMPCODE = "servempcode";
  static const String FDN_SERVEMPID = "servempid";
  static const String FDN_SERVEMPNAME = "servempname";
  static const String FDN_SERVERDATE = "serverdate";
  static const String FDN_SERVERDATETIME = "serverdatetime";
  static const String FDN_SERVERDT = "serverdt";
  static const String FDN_SERVERDTL = "serverdtl";
  static const String FDN_SERVERPID = "serverpid";
  static const String FDN_SERVERTIME = "servertime";
  static const String FDN_SERVICE = "service";
  static const String FDN_SERVICECLOSED = "serviceclosed";
  static const String FDN_SERVICECOUNT = "servicecount";
  static const String FDN_SERVICEDAY = "serviceday";
  static const String FDN_SERVICELEFT = "serviceleft";
  static const String FDN_SERVICEPERIODTYPE = "serviceperiodtype";
  static const String FDN_SERVICEPRICE = "serviceprice";
  static const String FDN_SERVICEPRICEHOMECURR = "servicepricehomecurr";
  static const String FDN_SERVICETOTAL = "servicetotal";
  static const String FDN_SERVICEUSED = "serviceused";
  static const String FDN_SERVRATE = "servrate";
  static const String FDN_SESSIDSTR = "sessidstr";
  static const String FDN_SESSIONID = "sessionid";
  static const String FDN_SETDOWNTIME = "setdowntime";
  static const String FDN_SETDOWNTIMEMIN = "setdowntimemin";
  static const String FDN_SETDOWNASTIME = "setdownastime";
  static const String FDN_SETUPTIME = "setuptime";
  static const String FDN_SETUPTIMEMIN = "setuptimemin";
  static const String FDN_SETUPASTIME = "setupastime";
  static const String FDN_SEX = "sex";
  static const String FDN_SGACCPLANCODE = "sgaccplancode";
  static const String FDN_SGROUP = "sgroup";
  static const String FDN_SGROUPCODE = "sgroupcode";
  static const String FDN_SGROUPDESC = "sgroupdesc";
  static const String FDN_SGROUPID = "sgroupid";
  static const String FDN_SHARENO = "shareno";
  static const String FDN_SHIFT = "shift";
  static const String FDN_SHIFTCODE = "shiftcode";
  static const String FDN_SHIFTCOUNT = "shiftcount";
  static const String FDN_SHIFTDESC = "shiftdesc";
  static const String FDN_SHIFTID = "shiftid";
  static const String FDN_SHIFTINTERVAL = "shiftinterval";
  static const String FDN_SHIFTPERIOD = "shiftperiod";
  static const String FDN_SHIFTPERIODDESC = "shiftperioddesc";
  static const String FDN_SHIFTTIMECODE = "shifttimecode";
  static const String FDN_SHIFTTIMEDESC = "shifttimedesc";
  static const String FDN_SHIFTTIMEID = "shifttimeid";
  static const String FDN_SHIFTTYPECODE = "shifttypecode";
  static const String FDN_SHIFTTYPEID = "shifttypeid";
  static const String FDN_SHIFTYPECODE = "shiftypecode";
  static const String FDN_SHIFTYPEDESC = "shiftypedesc";
  static const String FDN_SHIFTYPEID = "shiftypeid";
  static const String FDN_SHIPDAYS = "shipdays";
  static const String FDN_SHORTCODE = "shortcode";
  static const String FDN_SHORTCOUNT = "shortcount";
  static const String FDN_SHORTDESC = "shortdesc";
  static const String FDN_SHORTTEXT = "shorttext";
  static const String FDN_SHOWCOMMENT = "showcomment";
  static const String FDN_SHOWINCHART = "showinchart";
  static const String FDN_SHOWLUITEMVALUE = "showluitemvalue";
  static const String FDN_SHOWPRINT = "showprint";
  static const String FDN_SHOWRAMOBILE = "showramobile";
  static const String FDN_SHOWRESULT = "showresult";
  static const String FDN_SHOWSHARE = "showshare";
  static const String FDN_SHUTDOWNMODE = "shutdownmode";
  static const String FDN_SIGNEDBY = "signedby";
  static const String FDN_SIMRATE = "simrate";
  static const String FDN_SINGLERATE = "singlerate";
  static const String FDN_SINGLETEXT = "singletext";
  static const String FDN_SITEMCODE = "sitemcode";
  static const String FDN_SITEMID = "sitemid";
  static const String FDN_SITEMNAME = "sitemname";
  static const String FDN_SITEMPFXLEN = "sitempfxlen";
  static const String FDN_SIZECODE = "sizecode";
  static const String FDN_SIZEDESC = "sizedesc";
  static const String FDN_SIZEID = "sizeid";
  static const String FDN_SLAMOUNT = "slamount";
  static const String FDN_SLAMOUNTCURR = "slamountcurr";
  static const String FDN_SLIDERID = "sliderid";
  static const String FDN_SLIPCOUNT = "slipcount";
  static const String FDN_SLIPNO = "slipno";
  static const String FDN_SLIPTYPE = "sliptype";
  static const String FDN_SLTAXTOTAL = "sltaxtotal";
  static const String FDN_SLTAXTOTALCURR = "sltaxtotalcurr";
  static const String FDN_SMINIMUM = "sminimum";
  static const String FDN_SNGSUPP = "sngsupp";
  static const String FDN_SOCSECURITYNO = "socsecurityno";
  static const String FDN_SOPTIMUM = "soptimum";
  static const String FDN_SORT = "sort";
  static const String FDN_SOURCECODE = "sourcecode";
  static const String FDN_SOURCEDESC = "sourcedesc";
  static const String FDN_SOURCEID = "sourceid";
  static const String FDN_SOURCEISAUTO = "sourceisauto";
  static const String FDN_SOURCEISCRM = "sourceiscrm";
  static const String FDN_SOURCEISOPCENTER = "sourceisopcenter";
  static const String FDN_SOURCEISSALE = "sourceissale";
  static const String FDN_SOURCEISSURVEY = "sourceissurvey";
  static const String FDN_SOURCERATE = "sourcerate";
  static const String FDN_SOURCETYPE = "sourcetype";
  static const String FDN_SOURCETYPEDESC = "sourcetypedesc";
  static const String FDN_SOURCEURL = "sourceurl";
  static const String FDN_SPARES = "spares";
  static const String FDN_SPARESPRICE = "sparesprice";
  static const String FDN_SPENDINGCODE = "spendingcode";
  static const String FDN_SPENDINGID = "spendingid";
  static const String FDN_SPGROUP = "spgroup";
  static const String FDN_SPGROUPCODE = "spgroupcode";
  static const String FDN_SPGROUPDESC = "spgroupdesc";
  static const String FDN_SPGROUPID = "spgroupid";
  static const String FDN_SPGROUPLONG = "spgrouplong";
  static const String FDN_SPGROUPNAME = "spgroupname";
  static const String FDN_SPLITORIGINTRANSNO = "splitorigintransno";
  static const String FDN_SPMID = "spmid";
  static const String FDN_SPRODUCTID = "sproductid";
  static const String FDN_SPSALEDISCAMOUNT = "spsalediscamount";
  static const String FDN_SPURIOUSPARAMETERS = "spurious-parameters";
  static const String FDN_SQL = "sql";
  static const String FDN_SQLDIALECT = "sqldialect";
  static const String FDN_SQLOP = "sqlop";
  static const String FDN_SQLPARAMS = "sqlparams";
  static const String FDN_SQLSTR = "sqlstr";
  static const String FDN_SQLTEXT = "sqltext";
  static const String FDN_SRCCOL = "srccol";
  static const String FDN_SRCLANGCODE = "srclangcode";
  static const String FDN_SRCLANGDESC = "srclangdesc";
  static const String FDN_SRCLANGID = "srclangid";
  static const String FDN_SRCLINE = "srcline";
  static const String FDN_SRCWORD = "srcword";
  static const String FDN_SRCWORDUPPER = "srcwordupper";
  static const String FDN_SRVEMPID = "srvempid";
  static const String FDN_SRVEMPCODE = "srvempcode";
  static const String FDN_SRVEMPDESC = "srvempdesc";
  static const String FDN_SRVSHIFTCODE = "srvshiftcode";
  static const String FDN_SRVSHIFTDESC = "srvshiftdesc";
  static const String FDN_SRVSHIFTID = "srvshiftid";
  static const String FDN_STAFF = "staff";
  static const String FDN_STAGEID = "stageid";
  static const String FDN_STAGECODE = "stagecode";
  static const String FDN_STAGECOLOR = "stagecolor";
  static const String FDN_STAGEDESC = "stagedesc";
  static const String FDN_STARREV = "starrev";
  static const String FDN_STARTACCEMP = "startaccemp";
  static const String FDN_STARTDATE = "startdate";
  static const String FDN_STARTDATEDAY = "startdateday";
  static const String FDN_STARTDATEMONTH = "startdatemonth";
  static const String FDN_STARTDATEPREV = "startdateprev";
  static const String FDN_STARTDATETIME = "startdatetime";
  static const String FDN_STARTDATEYEAR = "startdateyear";
  static const String FDN_STARTDAY = "startday";
  static const String FDN_STARTDELAYMIN = "startdelaymin";
  static const String FDN_STARTDT = "startdt";
  static const String FDN_STARTDTL = "startdtl";
  static const String FDN_STARTDURATION = "startduration";
  static const String FDN_STARTDURATIONMIN = "startdurationmin";
  static const String FDN_STARTEMPCODE = "startempcode";
  static const String FDN_STARTEMPID = "startempid";
  static const String FDN_STARTEMPNAME = "startempname";
  static const String FDN_STARTIDX = "startidx";
  static const String FDN_STARTKM = "startkm";
  static const String FDN_STARTLOC = "startloc";
  static const String FDN_STARTMONTH = "startmonth";
  static const String FDN_STARTNAME = "startname";
  static const String FDN_STARTNO = "startno";
  static const String FDN_STARTRATE = "startrate";
  static const String FDN_STARTRATEDATE = "startratedate";
  static const String FDN_STARTTIME = "starttime";
  static const String FDN_STARTUSER = "startuser";
  static const String FDN_STARTUSERCODE = "startusercode";
  static const String FDN_STARTUSERID = "startuserid";
  static const String FDN_STARTUSERNAME = "startusername";
  static const String FDN_STARTYEAR = "startyear";
  static const String FDN_STAT = "stat";
  static const String FDN_STATDESC = "statdesc";
  static const String FDN_STATE = "state";
  static const String FDN_STATGRP = "statgrp";
  static const String FDN_STATGRPNAME = "statgrpname";
  static const String FDN_STATID = "statid";
  static const String FDN_STATISACTIVE = "statisactive";
  static const String FDN_STATTYPE = "stattype";
  static const String FDN_STATUS = "status";
  static const String FDN_STATUSCODE = "statuscode";
  static const String FDN_STATUSCOLOR = "statuscolor";
  static const String FDN_STATUSCOUNT = "statuscount";
  static const String FDN_STATUSDESC = "statusdesc";
  static const String FDN_STATUSID = "statusid";
  static const String FDN_STATUSOK = "statusok";
  static const String FDN_STATVALUE = "statvalue";
  static const String FDN_STCODE = "stcode";
  static const String FDN_STDAGENCY = "stdagency";
  static const String FDN_STDCODE = "stdcode";
  static const String FDN_STDESC = "stdesc";
  static const String FDN_STDID = "stdid";
  static const String FDN_STHELPERTRANSNO = "sthelpertransno";
  static const String FDN_STHELPERCHANGED = "sthelperchanged";
  static const String FDN_STHLINECOUNTER = "sthlinecounter";
  static const String FDN_STLINECOUNTER = "stlinecounter";
  static const String FDN_STMNTDURMIN = "stmntdurmin";
  static const String FDN_STMNTID = "stmntid";
  static const String FDN_STMNTSTARTDT = "stmntstartdt";
  static const String FDN_STMTDATETIME = "stmtdatetime";
  static const String FDN_STOCKCODE = "stockcode";
  static const String FDN_STOCKCODEDESC = "stockcodedesc";
  static const String FDN_STOCKCODEID = "stockcodeid";
  static const String FDN_STOCKID = "stockid";
  static const String FDN_STOCKITEM = "stockitem";
  static const String FDN_STOCKITEMCODE = "stockitemcode";
  static const String FDN_STOCKITEMDESC = "stockitemdesc";
  static const String FDN_STOCKITEMID = "stockitemid";
  static const String FDN_STOCKITEMLONG = "stockitemlong";
  static const String FDN_STOPMAIL = "stopmail";
  static const String FDN_STORE = "store";
  static const String FDN_STORECODE = "storecode";
  static const String FDN_STOREDESC = "storedesc";
  static const String FDN_STOREDIRDATE = "storedirdate";
  static const String FDN_STOREDIRTO = "storedirto";
  static const String FDN_STOREDIRTOCODE = "storedirtocode";
  static const String FDN_STOREDIRTODESC = "storedirtodesc";
  static const String FDN_STOREDIRTOID = "storedirtoid";
  static const String FDN_STOREDIRTONAME = "storedirtoname";
  static const String FDN_STOREFROM = "storefrom";
  static const String FDN_STOREFROMBAL = "storefrombal";
  static const String FDN_STOREFROMCODE = "storefromcode";
  static const String FDN_STOREFROMDESC = "storefromdesc";
  static const String FDN_STOREFROMID = "storefromid";
  static const String FDN_STOREFROMLONG = "storefromlong";
  static const String FDN_STOREFROMLONGDESC = "storefromlongdesc";
  static const String FDN_STOREFROMNAME = "storefromname";
  static const String FDN_STOREID = "storeid";
  static const String FDN_STOREKEY = "storekey";
  static const String FDN_STORENAME = "storename";
  static const String FDN_STOREPARENTCODE = "storeparentcode";
  static const String FDN_STOREPARENTDESC = "storeparentdesc";
  static const String FDN_STOREPARENTFROM = "storeparentfrom";
  static const String FDN_STOREPARENTFROMID = "storeparentfromid";
  static const String FDN_STOREPARENTTO = "storeparentto";
  static const String FDN_STOREPARENTTOID = "storeparenttoid";
  static const String FDN_STORETO = "storeto";
  static const String FDN_STORETOBAL = "storetobal";
  static const String FDN_STORETOCODE = "storetocode";
  static const String FDN_STORETODESC = "storetodesc";
  static const String FDN_STORETOID = "storetoid";
  static const String FDN_STORETOLONG = "storetolong";
  static const String FDN_STORETOLONGDESC = "storetolongdesc";
  static const String FDN_STORETONAME = "storetoname";
  static const String FDN_STRECEIPTNO = "streceiptno";
  static const String FDN_STTRANSNO = "sttransno";
  static const String FDN_SUCCESS = "success";
  static const String FDN_SUBGROUPNAME = "subgroupname";
  static const String FDN_SUBGRPCODE = "subgrpcode";
  static const String FDN_SUBGRPDESC = "subgrpdesc";
  static const String FDN_SUBGRPID = "subgrpid";
  static const String FDN_SUBJECT = "subject";
  static const String FDN_SUBLINEDISCAMOUNT = "sublinediscamount";
  static const String FDN_SUBLINEDISCRATE = "sublinediscrate";
  static const String FDN_SUBLINEDISCTOTAL = "sublinedisctotal";
  static const String FDN_SUBNO = "subno";
  static const String FDN_SUBPRICEPMDISCED = "subpricepmdisced";
  static const String FDN_SUBRENTALPMDISCED = "subrentalpmdisced";
  static const String FDN_SUBTOTAL = "subtotal";
  static const String FDN_SUBTOTALHOMECURR = "subtotalhomecurr";
  static const String FDN_SUN = "sun";
  static const String FDN_SUPERVISOR = "supervisor";
  static const String FDN_SUPPADDRESS1 = "suppaddress1";
  static const String FDN_SUPPADDRESS2 = "suppaddress2";
  static const String FDN_SUPPCITY = "suppcity";
  static const String FDN_SUPPCODE = "suppcode";
  static const String FDN_SUPPDESC = "suppdesc";
  static const String FDN_SUPPID = "suppid";
  static const String FDN_SUPPLIER = "supplier";
  static const String FDN_SUPPLIERCODE = "suppliercode";
  static const String FDN_SUPPLIERDESC = "supplierdesc";
  static const String FDN_SUPPLIERID = "supplierid";
  static const String FDN_SUPPLIERLONG = "supplierlong";
  static const String FDN_SUPPLIEROFFERID = "supplierofferid";
  static const String FDN_SUPPLIERTOTAL = "suppliertotal";
  static const String FDN_SUPPMID = "suppmid";
  static const String FDN_SUPPNAME = "suppname";
  static const String FDN_SUPPTAXNO = "supptaxno";
  static const String FDN_SUPPTAXNUMBER = "supptaxnumber";
  static const String FDN_SUPPTAXOFFICE = "supptaxoffice";
  static const String FDN_SURVEYANSWERCOUNT = "surveyanswercount";
  static const String FDN_SURVEYANSWERID = "surveyanswerid";
  static const String FDN_SURVEYCOUNT = "surveycount";
  static const String FDN_SURVEYDESC = "surveydesc";
  static const String FDN_SURVEYHASH = "surveyhash";
  static const String FDN_SURVEYID = "surveyid";
  static const String FDN_SURVEYLOCCODE = "surveyloccode";
  static const String FDN_SURVEYLOCDESC = "surveylocdesc";
  static const String FDN_SURVEYLOCID = "surveylocid";
  static const String FDN_SURVEYSETDESC = "surveysetdesc";
  static const String FDN_SURVEYSETID = "surveysetid";
  static const String FDN_SURVEYTRANSNO = "surveytransno";
  static const String FDN_SVAL = "sval";
  static const String FDN_SWEEPINTERVAL = "sweepinterval";
  static const String FDN_SWIFTCODE = "swiftcode";
  static const String FDN_SYNCDTL = "syncdtl";
  static const String FDN_SYNCENDTIME = "syncendtime";
  static const String FDN_SYNCGID = "syncgid";
  static const String FDN_SYNCIDFIELD = "syncidfield";
  static const String FDN_SYNCPAGE = "syncpage";
  static const String FDN_SYNCSTARTTIME = "syncstarttime";
  static const String FDN_SYNCSTATUS = "syncstatus";
  static const String FDN_SYNCURI = "syncuri";
  static const String FDN_SYS = "sys";
  static const String FDN_SYSDATETIME = "sysdatetime";
  static const String FDN_SYSINFO = "sysinfo";
  static const String FDN_SYSNOT = "sysnot";
  static const String FDN_SYSNOTE = "sysnote";
  static const String FDN_TABLEMAX = "tablemax";
  static const String FDN_TABLENAME = "tablename";
  static const String FDN_TABLENO = "tableno";
  static const String FDN_TABLESTATE = "tablestate";
  static const String FDN_TABLEURI = "tableuri";
  static const String FDN_TABLEVIEW = "tableview";
  static const String FDN_TAGLEVEL = "taglevel";
  static const String FDN_TARGETCURR = "targetcurr";
  static const String FDN_TARGETDATE = "targetdate";
  static const String FDN_TARGETDOMAIN = "targetdomain";
  static const String FDN_TARGETEXTRAREV = "targetextrarev";
  static const String FDN_TARGETPAX = "targetpax";
  static const String FDN_TARGETPRICE = "targetprice";
  static const String FDN_TARGETROOM = "targetroom";
  static const String FDN_TARGETROOMREV = "targetroomrev";
  static const String FDN_TARGETSUCC = "targetsucc";
  static const String FDN_TARGETURL = "targeturl";
  static const String FDN_TARGETYPE = "targetype";
  static const String FDN_TARGETVALUE = "targetvalue";
  static const String FDN_TARIH = "tarih";
  static const String FDN_TASK = "task";
  static const String FDN_TASKALIAS = "taskalias";
  static const String FDN_TASKCLOSED = "taskclosed";
  static const String FDN_TASKDATE = "taskdate";
  static const String FDN_TASKDESC = "taskdesc";
  static const String FDN_TASKDURATION = "taskduration";
  static const String FDN_TASKDURATIONSTR = "taskdurationstr";
  static const String FDN_TASKEMPDEPLIST = "taskempdeplist";
  static const String FDN_TASKEMPLIST = "taskemplist";
  static const String FDN_TASKID = "taskid";
  static const String FDN_TASKINSERTED = "taskinserted";
  static const String FDN_TASKINSTCODE = "taskinstcode";
  static const String FDN_TASKINSTDESC = "taskinstdesc";
  static const String FDN_TASKINSTID = "taskinstid";
  static const String FDN_TASKINSTLINECODE = "taskinstlinecode";
  static const String FDN_TASKINSTLINEDESC = "taskinstlinedesc";
  static const String FDN_TASKINSTLINEGID = "taskinstlinegid";
  static const String FDN_TASKINSTLINEID = "taskinstlineid";
  static const String FDN_TASKINSTLINEMID = "taskinstlinemid";
  static const String FDN_TASKINSTLINENOTE = "taskinstlinenote";
  static const String FDN_TASKINSTLINEWORKTYPECODE = "taskinstlineworktypecode";
  static const String FDN_TASKINSTLINEWORKTYPEDESC = "taskinstlineworktypedesc";
  static const String FDN_TASKINSTLINEWORKTYPEID = "taskinstlineworktypeid";
  static const String FDN_TASKINSTMID = "taskinstmid";
  static const String FDN_TASKINSTPID = "taskinstpid";
  static const String FDN_TASKINTERVAL = "taskinterval";
  static const String FDN_TASKMID = "taskmid";
  static const String FDN_TASKNOTE = "tasknote";
  static const String FDN_TASKNOTED = "tasknoted";
  static const String FDN_TASKNOTELIST = "tasknotelist";
  static const String FDN_TASKNOTELISTSHORT = "tasknotelistshort";
  static const String FDN_TASKPERIOD = "taskperiod";
  static const String FDN_TASKRATED = "taskrated";
  static const String FDN_TASKRATING = "taskrating";
  static const String FDN_TASKRATINGLIST = "taskratinglist";
  static const String FDN_TASKRATINGLISTSHORT = "taskratinglistshort";
  static const String FDN_TASKREFCODE = "taskrefcode";
  static const String FDN_TASKSTARTED = "taskstarted";
  static const String FDN_TASKTIME = "tasktime";
  static const String FDN_TASKTOTALNOTE = "tasktotalnote";
  static const String FDN_TASKTOTALTRANS = "tasktotaltrans";
  static const String FDN_TASKTRANSED = "tasktransed";
  static const String FDN_TASKTYPE = "tasktype";
  static const String FDN_TASKTYPECODE = "tasktypecode";
  static const String FDN_TASKTYPEDESC = "tasktypedesc";
  static const String FDN_TASKTYPEID = "tasktypeid";
  static const String FDN_TASKVALUE = "taskvalue";
  static const String FDN_TAXABLEAMOUNT = "taxableamount";
  static const String FDN_TAXAMOUNT = "taxamount";
  static const String FDN_TAXBALANCE = "taxbalance";
  static const String FDN_TAXDESC = "taxdesc";
  static const String FDN_TAXEDRATIO = "taxedratio";
  static const String FDN_TAXEXCLUSIVEAMOUNT = "taxexclusiveamount";
  static const String FDN_TAXEXCTOTAL = "taxexctotal";
  static const String FDN_TAXINCLUSIVEAMOUNT = "taxinclusiveamount";
  static const String FDN_TAXNO = "taxno";
  static const String FDN_TAXNOWHAMOUNT = "taxnowhamount";
  static const String FDN_TAXNOWHTOTAL = "taxnowhtotal";
  static const String FDN_TAXNUMBER = "taxnumber";
  static const String FDN_TAXOCODE = "taxocode";
  static const String FDN_TAXODESC = "taxodesc";
  static const String FDN_TAXOFFICE = "taxoffice";
  static const String FDN_TAXOID = "taxoid";
  static const String FDN_TAXPAYMENT = "taxpayment";
  static const String FDN_TAXPERCENT = "taxpercent";
  static const String FDN_TAXRATE = "taxrate";
  static const String FDN_TAXRATIO = "taxratio";
  static const String FDN_TAXTOTAL = "taxtotal";
  static const String FDN_TAXTOTALCURR = "taxtotalcurr";
  static const String FDN_TAXTOTALDISCED = "taxtotaldisced";
  static const String FDN_TAXTOTALHOMECURR = "taxtotalhomecurr";
  static const String FDN_TAXWHAMOUNT = "taxwhamount";
  static const String FDN_TAXWHRATE = "taxwhrate";
  static const String FDN_TAXWHTOTAL = "taxwhtotal";
  static const String FDN_TEL = "tel";
  static const String FDN_TEL2 = "tel2";
  static const String FDN_TELCOUNT = "telcount";
  static const String FDN_TELEXT = "telext";
  static const String FDN_TELNO = "telno";
  static const String FDN_TEMPLATEFILE = "templatefile";
  static const String FDN_TEMPLATEIMAGE = "templateimage";
  static const String FDN_TMPGID = "tmpgid";
  static const String FDN_TERMCODE = "termcode";
  static const String FDN_TERMDESC = "termdesc";
  static const String FDN_TERMID = "termid";
  static const String FDN_TERMINALCOUNT = "terminalcount";
  static const String FDN_TERMINALID = "terminalid";
  static const String FDN_TERMINALUSERID = "terminaluserid";
  static const String FDN_TERMNAME = "termname";
  static const String FDN_TERRITORY = "territory";
  static const String FDN_TERRITORYCODE = "territorycode";
  static const String FDN_TERRITORYDESC = "territorydesc";
  static const String FDN_TERRITORYID = "territoryid";
  static const String FDN_TESTBACKCOLOR = "testbackcolor";
  static const String FDN_TESTCONTENT = "testcontent";
  static const String FDN_TESTDATE = "testdate";
  static const String FDN_TESTHEIGHT = "testheight";
  static const String FDN_TESTLAYOUT = "testlayout";
  static const String FDN_TESTTIME = "testtime";
  static const String FDN_TESTUSERCODE = "testusercode";
  static const String FDN_TESTUSERID = "testuserid";
  static const String FDN_THEMEID = "themeid";
  static const String FDN_THU = "thu";
  static const String FDN_THUMBIMAGE = "thumbimage";
  static const String FDN_THUMBNAIL = "thumbnail";
  static const String FDN_THUMBURL = "thumburl";
  static const String FDN_TIME = "time";
  static const String FDN_TIMESHAREID = "timeshareid";
  static const String FDN_TITLE = "title";
  static const String FDN_TMPCOUPONCODE = "tmpcouponcode";
  static const String FDN_TMPPAYMENTAMOUNT = "tmppaymentamount";
  static const String FDN_TMPPAYTYPE = "tmppaytype";
  static const String FDN_TOACCCODE = "toacccode";
  static const String FDN_TOACCDESC = "toaccdesc";
  static const String FDN_TOACCID = "toaccid";
  static const String FDN_TOAGENCY = "toagency";
  static const String FDN_TOCLIENTNAME = "toclientname";
  static const String FDN_TOCODE = "tocode";
  static const String FDN_TODAYVAR = "todayvar";
  static const String FDN_TODESC = "todesc";
  static const String FDN_TOFOLIO = "tofolio";
  static const String FDN_TOFOLIONO = "tofoliono";
  static const String FDN_TOID = "toid";
  static const String FDN_TOKEN_TYPE = "token_type";
  static const String FDN_TOKENTYPE = "tokentype";
  static const String FDN_TOL = "tol";
  static const String FDN_TOOLS = "tools";
  static const String FDN_TOPCODE = "topcode";
  static const String FDN_TOPDESC = "topdesc";
  static const String FDN_TOPID = "topid";
  static const String FDN_TOPPID = "toppid";
  static const String FDN_TOPTRANS = "toptrans";
  static const String FDN_TOROOMNO = "toroomno";
  static const String FDN_TOSTATUSCODE = "tostatuscode";
  static const String FDN_TOTAL = "total";
  static const String FDN_TOTALOFFER = "totaloffer";
  static const String FDN_TOTALACCOPEN = "totalaccopen";
  static const String FDN_TOTALACCWAITING = "totalaccwaiting";
  static const String FDN_TOTALACTIVE = "totalactive";
  static const String FDN_TOTALADULT = "totaladult";
  static const String FDN_TOTALALL = "totalall";
  static const String FDN_TOTALALLINC = "totalallinc";
  static const String FDN_TOTALALLOT = "totalallot";
  static const String FDN_TOTALAMOUNT = "totalamount";
  static const String FDN_TOTALANSWER = "totalanswer";
  static const String FDN_TOTALAVAIL = "totalavail";
  static const String FDN_TOTALBABY = "totalbaby";
  static const String FDN_TOTALBABYFO = "totalbabyfo";
  static const String FDN_TOTALBABYHK = "totalbabyhk";
  static const String FDN_TOTALBABYLYMONTHUTD = "totalbabylymonthutd";
  static const String FDN_TOTALBABYLYTODAY = "totalbabylytoday";
  static const String FDN_TOTALBABYLYYEARUTD = "totalbabylyyearutd";
  static const String FDN_TOTALBABYMONTHUTD = "totalbabymonthutd";
  static const String FDN_TOTALBABYYEARUTD = "totalbabyyearutd";
  static const String FDN_TOTALBALANCE = "totalbalance";
  static const String FDN_TOTALBANKTRANS = "totalbanktrans";
  static const String FDN_TOTALBED = "totalbed";
  static const String FDN_TOTALBFAST = "totalbfast";
  static const String FDN_TOTALBOARD = "totalboard";
  static const String FDN_TOTALBONUS = "totalbonus";
  static const String FDN_TOTALCALL = "totalcall";
  static const String FDN_TOTALCALLLASTYEARLY = "totalcalllastyearly";
  static const String FDN_TOTALCALLMONTHLY = "totalcallmonthly";
  static const String FDN_TOTALCALLWEEKLY = "totalcallweekly";
  static const String FDN_TOTALCALLYEARLY = "totalcallyearly";
  static const String FDN_TOTALCANCEL = "totalcancel";
  static const String FDN_TOTALCAP = "totalcap";
  static const String FDN_TOTALCASH = "totalcash";
  static const String FDN_TOTALCHARGE = "totalcharge";
  static const String FDN_TOTALCHD = "totalchd";
  static const String FDN_TOTALCHD1 = "totalchd1";
  static const String FDN_TOTALCHD1LYMONTHUTD = "totalchd1lymonthutd";
  static const String FDN_TOTALCHD1LYTODAY = "totalchd1lytoday";
  static const String FDN_TOTALCHD1LYYEARUTD = "totalchd1lyyearutd";
  static const String FDN_TOTALCHD1MONTHUTD = "totalchd1monthutd";
  static const String FDN_TOTALCHD1YEARUTD = "totalchd1yearutd";
  static const String FDN_TOTALCHD2 = "totalchd2";
  static const String FDN_TOTALCHD2LYMONTHUTD = "totalchd2lymonthutd";
  static const String FDN_TOTALCHD2LYTODAY = "totalchd2lytoday";
  static const String FDN_TOTALCHD2LYYEARUTD = "totalchd2lyyearutd";
  static const String FDN_TOTALCHD2MONTHUTD = "totalchd2monthutd";
  static const String FDN_TOTALCHD2YEARUTD = "totalchd2yearutd";
  static const String FDN_TOTALCHDBABY = "totalchdbaby";
  static const String FDN_TOTALCI = "totalci";
  static const String FDN_TOTALCIADULT = "totalciadult";
  static const String FDN_TOTALCIBABY = "totalcibaby";
  static const String FDN_TOTALCICHD = "totalcichd";
  static const String FDN_TOTALCICHD1 = "totalcichd1";
  static const String FDN_TOTALCICHD2 = "totalcichd2";
  static const String FDN_TOTALCITYLEDGER = "totalcityledger";
  static const String FDN_TOTALCLICK = "totalclick";
  static const String FDN_TOTALCLIENT = "totalclient";
  static const String FDN_TOTALCLIENTEMAIL = "totalclientemail";
  static const String FDN_TOTALCLOSED = "totalclosed";
  static const String FDN_TOTALCO = "totalco";
  static const String FDN_TOTALCOLL = "totalcoll";
  static const String FDN_TOTALCONFIRM = "totalconfirm";
  static const String FDN_TOTALCONNECTED = "totalconnected";
  static const String FDN_TOTALCONSUMED = "totalconsumed";
  static const String FDN_TOTALCORRECTION = "totalcorrection";
  static const String FDN_TOTALCOST = "totalcost";
  static const String FDN_TOTALCOSTLAST = "totalcostlast";
  static const String FDN_TOTALCOUNT = "totalcount";
  static const String FDN_TOTALCOUNTDIFF = "totalcountdiff";
  static const String FDN_TOTALCOUNTPER = "totalcountper";
  static const String FDN_TOTALCOUNTPERDIFF = "totalcountperdiff";
  static const String FDN_TOTALCOUNTPERPREV = "totalcountperprev";
  static const String FDN_TOTALCOUNTPREV = "totalcountprev";
  static const String FDN_TOTALCRCARD = "totalcrcard";
  static const String FDN_TOTALCREDIT = "totalcredit";
  static const String FDN_TOTALCURR = "totalcurr";
  static const String FDN_TOTALDAILYEMAIL = "totaldailyemail";
  static const String FDN_TOTALDAILYRES = "totaldailyres";
  static const String FDN_TOTALDAY = "totalday";
  static const String FDN_TOTALDAYS = "totaldays";
  static const String FDN_TOTALDEBIT = "totaldebit";
  static const String FDN_TOTALDIFF = "totaldiff";
  static const String FDN_TOTALDINNER = "totaldinner";
  static const String FDN_TOTALDISC = "totaldisc";
  static const String FDN_TOTALDISCAMOUNT = "totaldiscamount";
  static const String FDN_TOTALDISCOUNT = "totaldiscount";
  static const String FDN_TOTALDISCRATE = "totaldiscrate";
  static const String FDN_TOTALDONE = "totaldone";
  static const String FDN_TOTALDU = "totaldu";
  static const String FDN_TOTALDURATION = "totalduration";
  static const String FDN_TOTALDURATIONMIN = "totaldurationmin";
  static const String FDN_TOTALDURATIONMONTHLY = "totaldurationmonthly";
  static const String FDN_TOTALDURATIONSTR = "totaldurationstr";
  static const String FDN_TOTALDURATIONWEEKLY = "totaldurationweekly";
  static const String FDN_TOTALDURATIONYEARLY = "totaldurationyearly";
  static const String FDN_TOTALEMAIL = "totalemail";
  static const String FDN_TOTALEMPTY = "totalempty";
  static const String FDN_TOTALEMPTYUPD = "totalemptyupd";
  static const String FDN_TOTALEND = "totalend";
  static const String FDN_TOTALEXTRA = "totalextra";
  static const String FDN_TOTALEXTRABED = "totalextrabed";
  static const String FDN_TOTALEXTRAREV = "totalextrarev";
  static const String FDN_TOTALFOLIOPAX = "totalfoliopax";
  static const String FDN_TOTALFOLLOW = "totalfollow";
  static const String FDN_TOTALFREE = "totalfree";
  static const String FDN_TOTALFROM = "totalfrom";
  static const String FDN_TOTALFROMAMOUNT = "totalfromamount";
  static const String FDN_TOTALFROMCOST = "totalfromcost";
  static const String FDN_TOTALFROMCOSTTRANS = "totalfromcosttrans";
  static const String FDN_TOTALFROMTRANSCOST = "totalfromtranscost";
  static const String FDN_TOTALHOMECURR = "totalhomecurr";
  static const String FDN_TOTALHUSE = "totalhuse";
  static const String FDN_TOTALINPUT = "totalinput";
  static const String FDN_TOTALINTERESTRATE = "totalinterestrate";
  static const String FDN_TOTALINV = "totalinv";
  static const String FDN_TOTALINVNET = "totalinvnet";
  static const String FDN_TOTALINVOICE = "totalinvoice";
  static const String FDN_TOTALINVTAX = "totalinvtax";
  static const String FDN_TOTALINVTAX1 = "totalinvtax1";
  static const String FDN_TOTALINVTAX18 = "totalinvtax18";
  static const String FDN_TOTALINVTAX8 = "totalinvtax8";
  static const String FDN_TOTALINVWAIT = "totalinvwait";
  static const String FDN_TOTALKM = "totalkm";
  static const String FDN_TOTALLOCRES = "totallocres";
  static const String FDN_TOTALLUNCH = "totallunch";
  static const String FDN_TOTALMIN = "totalmin";
  static const String FDN_TOTALMINSTD = "totalminstd";
  static const String FDN_TOTALMINUTE = "totalminute";
  static const String FDN_TOTALMSG = "totalmsg";
  static const String FDN_TOTALNATION = "totalnation";
  static const String FDN_TOTALNET = "totalnet";
  static const String FDN_TOTALNEW = "totalnew";
  static const String FDN_TOTALNO = "totalno";
  static const String FDN_TOTALNOD = "totalnod";
  static const String FDN_TOTALNONASSIGN = "totalnonassign";
  static const String FDN_TOTALNONEXTRABED = "totalnonextrabed";
  static const String FDN_TOTALNONSTD = "totalnonstd";
  static const String FDN_TOTALNOTECOUNT = "totalnotecount";
  static const String FDN_TOTALOCC = "totalocc";
  static const String FDN_TOTALOFFDAY = "totaloffday";
  static const String FDN_TOTALONSITEMONTHLY = "totalonsitemonthly";
  static const String FDN_TOTALONSITEWEEKLY = "totalonsiteweekly";
  static const String FDN_TOTALONSITEYEARLY = "totalonsiteyearly";
  static const String FDN_TOTALOOD = "totalood";
  static const String FDN_TOTALOOO = "totalooo";
  static const String FDN_TOTALOOS = "totaloos";
  static const String FDN_TOTALOPEN = "totalopen";
  static const String FDN_TOTALOTHERPAY = "totalotherpay";
  static const String FDN_TOTALOUTPUT = "totaloutput";
  static const String FDN_TOTALPAGE = "totalpage";
  static const String FDN_TOTALPAIDOUT = "totalpaidout";
  static const String FDN_TOTALPAX = "totalpax";
  static const String FDN_TOTALPAXALL = "totalpaxall";
  static const String FDN_TOTALPAXCAP = "totalpaxcap";
  static const String FDN_TOTALPAXCHD = "totalpaxchd";
  static const String FDN_TOTALPAXCHD1 = "totalpaxchd1";
  static const String FDN_TOTALPAXCHD2 = "totalpaxchd2";
  static const String FDN_TOTALPAXFO = "totalpaxfo";
  static const String FDN_TOTALPAXHK = "totalpaxhk";
  static const String FDN_TOTALPAXLYMONTHUTD = "totalpaxlymonthutd";
  static const String FDN_TOTALPAXLYTODAY = "totalpaxlytoday";
  static const String FDN_TOTALPAXLYYEARUTD = "totalpaxlyyearutd";
  static const String FDN_TOTALPAXMONTHUTD = "totalpaxmonthutd";
  static const String FDN_TOTALPAXPRICED = "totalpaxpriced";
  static const String FDN_TOTALPAXYEARUTD = "totalpaxyearutd";
  static const String FDN_TOTALPAY = "totalpay";
  static const String FDN_TOTALPAYLESS = "totalpayless";
  static const String FDN_TOTALPAYMENT = "totalpayment";
  static const String FDN_TOTALPAYNONSTD = "totalpaynonstd";
  static const String FDN_TOTALPENDING = "totalpending";
  static const String FDN_TOTALPLAN = "totalplan";
  static const String FDN_TOTALPLANONEMP = "totalplanonemp";
  static const String FDN_TOTALPORTAL = "totalportal";
  static const String FDN_TOTALPOSTING = "totalposting";
  static const String FDN_TOTALPRICE = "totalprice";
  static const String FDN_TOTALPRICECURR = "totalpricecurr";
  static const String FDN_TOTALPRICEHOMECURR = "totalpricehomecurr";
  static const String FDN_TOTALPRIVATE = "totalprivate";
  static const String FDN_TOTALPUB = "totalpub";
  static const String FDN_TOTALPUBNO = "totalpubno";
  static const String FDN_TOTALPUBYES = "totalpubyes";
  static const String FDN_TOTALQCOUNT = "totalqcount";
  static const String FDN_TOTALQCOUNTPREV = "totalqcountprev";
  static const String FDN_TOTALQSCORE = "totalqscore";
  static const String FDN_TOTALQSCOREPREV = "totalqscoreprev";
  static const String FDN_TOTALRATE = "totalrate";
  static const String FDN_TOTALRATEDAY = "totalrateday";
  static const String FDN_TOTALRATEWEEK = "totalrateweek";
  static const String FDN_TOTALREJECTED = "totalrejected";
  static const String FDN_TOTALREMOTEMONTHLY = "totalremotemonthly";
  static const String FDN_TOTALREMOTEWEEKLY = "totalremoteweekly";
  static const String FDN_TOTALREMOTEYEARLY = "totalremoteyearly";
  static const String FDN_TOTALREQ = "totalreq";
  static const String FDN_TOTALREQBACK = "totalreqback";
  static const String FDN_TOTALREQTODO = "totalreqtodo";
  static const String FDN_TOTALRES = "totalres";
  static const String FDN_TOTALRESDAY = "totalresday";
  static const String FDN_TOTALRESPAX = "totalrespax";
  static const String FDN_TOTALRESROOM = "totalresroom";
  static const String FDN_TOTALREV = "totalrev";
  static const String FDN_TOTALREVENUE = "totalrevenue";
  static const String FDN_TOTALREVENUEABG = "totalrevenueabg";
  static const String FDN_TOTALREVENUECURR = "totalrevenuecurr";
  static const String FDN_TOTALREVENUEFT = "totalrevenueft";
  static const String FDN_TOTALREVENUEFTCURR = "totalrevenueftcurr";
  static const String FDN_TOTALREVENUEHC = "totalrevenuehc";
  static const String FDN_TOTALREVGROSS = "totalrevgross";
  static const String FDN_TOTALREVGROSSRPT1 = "totalrevgrossrpt1";
  static const String FDN_TOTALREVNET = "totalrevnet";
  static const String FDN_TOTALREVNETRPT1 = "totalrevnetrpt1";
  static const String FDN_TOTALROOM = "totalroom";
  static const String FDN_TOTALROOMALLOT = "totalroomallot";
  static const String FDN_TOTALROOMCAP = "totalroomcap";
  static const String FDN_TOTALROOMING = "totalrooming";
  static const String FDN_TOTALROOMLYMONTHUTD = "totalroomlymonthutd";
  static const String FDN_TOTALROOMLYTODAY = "totalroomlytoday";
  static const String FDN_TOTALROOMLYYEARUTD = "totalroomlyyearutd";
  static const String FDN_TOTALROOMMONTHUTD = "totalroommonthutd";
  static const String FDN_TOTALROOMOK = "totalroomok";
  static const String FDN_TOTALROOMRATE = "totalroomrate";
  static const String FDN_TOTALROOMREV = "totalroomrev";
  static const String FDN_TOTALROOMS = "totalrooms";
  static const String FDN_TOTALROOMYEARUTD = "totalroomyearutd";
  static const String FDN_TOTALSALE = "totalsale";
  static const String FDN_TOTALSCORE = "totalscore";
  static const String FDN_TOTALSC = "totalsc";
  static const String FDN_TOTALSCOREDIFF = "totalscorediff";
  static const String FDN_TOTALSCOREPER = "totalscoreper";
  static const String FDN_TOTALSCOREPERDIFF = "totalscoreperdiff";
  static const String FDN_TOTALSCOREPERPREV = "totalscoreperprev";
  static const String FDN_TOTALSCOREPREV = "totalscoreprev";
  static const String FDN_TOTALSERVICE = "totalservice";
  static const String FDN_TOTALSHIFT = "totalshift";
  static const String FDN_TOTALSHIFTMIN = "totalshiftmin";
  static const String FDN_TOTALSIT = "totalsit";
  static const String FDN_TOTALSTART = "totalstart";
  static const String FDN_TOTALSTAY = "totalstay";
  static const String FDN_TOTALTASK = "totaltask";
  static const String FDN_TOTALTAXED = "totaltaxed";
  static const String FDN_TOTALTEL = "totaltel";
  static const String FDN_TOTALTERM = "totalterm";
  static const String FDN_TOTALTERMINAL = "totalterminal";
  static const String FDN_TOTALTEST = "totaltest";
  static const String FDN_TOTALTO = "totalto";
  static const String FDN_TOTALTOAMOUNT = "totaltoamount";
  static const String FDN_TOTALTOCOST = "totaltocost";
  static const String FDN_TOTALTOCOSTTRANS = "totaltocosttrans";
  static const String FDN_TOTALTOTRANSCOST = "totaltotranscost";
  static const String FDN_TOTALTRIPMONTHLY = "totaltripmonthly";
  static const String FDN_TOTALTRIPWEEKLY = "totaltripweekly";
  static const String FDN_TOTALTRIPYEARLY = "totaltripyearly";
  static const String FDN_TOTALTSFORM = "totaltsform";
  static const String FDN_TOTALUNDONE = "totalundone";
  static const String FDN_TOTALUSED = "totalused";
  static const String FDN_TOTALUSERCERTMONTHLY = "totalusercertmonthly";
  static const String FDN_TOTALUSERCERTWEEKLY = "totalusercertweekly";
  static const String FDN_TOTALUSERCERTYEARLY = "totalusercertyearly";
  static const String FDN_TOTALUSERMONTHLY = "totalusermonthly";
  static const String FDN_TOTALUSERWEEKLY = "totaluserweekly";
  static const String FDN_TOTALUSERYEARLY = "totaluseryearly";
  static const String FDN_TOTALVC = "totalvc";
  static const String FDN_TOTALVD = "totalvd";
  static const String FDN_TOTALVIEW = "totalview";
  static const String FDN_TOTALVIRTUAL = "totalvirtual";
  static const String FDN_TOTALVISIT = "totalvisit";
  static const String FDN_TOTALVISITCALL = "totalvisitcall";
  static const String FDN_TOTALVISITCALLLASTYEARLY = "totalvisitcalllastyearly";
  static const String FDN_TOTALVISITCALLMONTHLY = "totalvisitcallmonthly";
  static const String FDN_TOTALVISITCALLWEEKLY = "totalvisitcallweekly";
  static const String FDN_TOTALVISITCALLYEARLY = "totalvisitcallyearly";
  static const String FDN_TOTALVISITMIN = "totalvisitmin";
  static const String FDN_TOTALVISITOR = "totalvisitor";
  static const String FDN_TOTALWAIT = "totalwait";
  static const String FDN_TOTALWORKDAY = "totalworkday";
  static const String FDN_TOTALYES = "totalyes";
  static const String FDN_TOTALYESRATE = "totalyesrate";
  static const String FDN_TOTAL_AVGDAY = "total_avgday";
  static const String FDN_TOTAL_TURNOVER = "total_turnover";
  static const String FDN_TOTASKDATE = "totaskdate";
  static const String FDN_TOTASKTIME = "totasktime";
  static const String FDN_TOTRANSTYPEDESC = "totranstypedesc";
  static const String FDN_TOUROPERATOR = "touroperator";
  static const String FDN_TOWN = "town";
  static const String FDN_TOWNCODE = "towncode";
  static const String FDN_TOWNDESC = "towndesc";
  static const String FDN_TOWNID = "townid";
  static const String FDN_TO_AMOUNT = "to_amount";
  static const String FDN_TO_DISC_TOTAL = "to_disc_total";
  static const String FDN_TO_ENTRANCE_AMOUNT = "to_entrance_amount";
  static const String FDN_TO_ENTRANCE_TOTAL = "to_entrance_total";
  static const String FDN_TO_EXIT_AMOUNT = "to_exit_amount";
  static const String FDN_TO_EXIT_TOTAL = "to_exit_total";
  static const String FDN_TO_PRICE = "to_price";
  static const String FDN_TO_TOTAL = "to_total";
  static const String FDN_TO_TRANSFER_AMOUNT = "to_transfer_amount";
  static const String FDN_TO_TRANSFER_TOTAL = "to_transfer_total";
  static const String FDN_TPLCODE = "tplcode";
  static const String FDN_TPLDESC = "tpldesc";
  static const String FDN_TPLID = "tplid";
  static const String FDN_TPLTABLENAME = "tpltablename";
  static const String FDN_TPLTYPE = "tpltype";
  static const String FDN_TPLTYPEDESC = "tpltypedesc";
  static const String FDN_TPLTYPEID = "tpltypeid";
  static const String FDN_TRACEBOARDRATE = "traceboardrate";
  static const String FDN_TRACEDESC = "tracedesc";
  static const String FDN_TRACEEXTRA = "traceextra";
  static const String FDN_TRACEID = "traceid";
  static const String FDN_TRACEROOMRATE = "traceroomrate";
  static const String FDN_TRACETYPE = "tracetype";
  static const String FDN_TRAINEDHOTEL = "trainedhotel";
  static const String FDN_TRAINEDPERSON = "trainedperson";
  static const String FDN_TRAINERCODE = "trainercode";
  static const String FDN_TRAINERID = "trainerid";
  static const String FDN_TRAININGDURHOUR = "trainingdurhour";
  static const String FDN_TRAININGEMPMONTHLY = "trainingempmonthly";
  static const String FDN_TRAININGEMPWEEKLY = "trainingempweekly";
  static const String FDN_TRAININGEMPYEARLY = "trainingempyearly";
  static const String FDN_TRAININGPERSONMONTHLY = "trainingpersonmonthly";
  static const String FDN_TRAININGPERSONWEEKLY = "trainingpersonweekly";
  static const String FDN_TRAININGPERSONYEARLY = "trainingpersonyearly";
  static const String FDN_TRAININGSESSION = "trainingsession";
  static const String FDN_TRAININGVISITCALL = "trainingvisitcall";
  static const String FDN_TRAININGVISITCALLLASTYEARLY = "trainingvisitcalllastyearly";
  static const String FDN_TRAININGVISITCALLMONTHLY = "trainingvisitcallmonthly";
  static const String FDN_TRAININGVISITCALLWEEKLY = "trainingvisitcallweekly";
  static const String FDN_TRAININGVISITCALLYEARLY = "trainingvisitcallyearly";
  static const String FDN_TRANSAMOUNT = "transamount";
  static const String FDN_TRANSATTNAME = "transattname";
  static const String FDN_TRANSATTPID = "transattpid";
  static const String FDN_TRANSATTREMADDRESS = "transattremaddress";
  static const String FDN_TRANSATTREMOTEPID = "transattremotepid";
  static const String FDN_TRANSATTREMPROCESS = "transattremprocess";
  static const String FDN_TRANSATTUSER = "transattuser";
  static const String FDN_TRANSBALANCE = "transbalance";
  static const String FDN_TRANSCODE = "transcode";
  static const String FDN_TRANSCOUNT = "transcount";
  static const String FDN_TRANSCOUNTER = "transcounter";
  static const String FDN_TRANSCOUNTERAPTCODE = "transcounteraptcode";
  static const String FDN_TRANSCOUNTERAPTDESC = "transcounteraptdesc";
  static const String FDN_TRANSCOUNTERAPTID = "transcounteraptid";
  static const String FDN_TRANSCREDIT = "transcredit";
  static const String FDN_TRANSDATE = "transdate";
  static const String FDN_TRANSDATEDAY = "transdateday";
  static const String FDN_TRANSDATEEMPTY = "transdateempty";
  static const String FDN_TRANSDATEMONTH = "transdatemonth";
  static const String FDN_TRANSDATEOCC = "transdateocc";
  static const String FDN_TRANSDATESTR = "transdatestr";
  static const String FDN_TRANSDATETIME = "transdatetime";
  static const String FDN_TRANSDATEYEAR = "transdateyear";
  static const String FDN_TRANSDAY = "transday";
  static const String FDN_TRANSDEBIT = "transdebit";
  static const String FDN_TRANSDESC = "transdesc";
  static const String FDN_TRANSDT = "transdt";
  static const String FDN_TRANSDURATION = "transduration";
  static const String FDN_TRANSDURMIN = "transdurmin";
  static const String FDN_TRANSEMPCODE = "transempcode";
  static const String FDN_TRANSEMPID = "transempid";
  static const String FDN_TRANSFERCOLL = "transfercoll";
  static const String FDN_TRANSFERCOUNT = "transfercount";
  static const String FDN_TRANSFERLINK = "transferlink";
  static const String FDN_TRANSFERPAY = "transferpay";
  static const String FDN_TRANSGID = "transgid";
  static const String FDN_TRANSGIDSTR = "transgidstr";
  static const String FDN_TRANSID = "transid";
  static const String FDN_TRANSKIND = "transkind";
  static const String FDN_TRANSMID = "transmid";
  static const String FDN_TRANSMONTH = "transmonth";
  static const String FDN_TRANSNO = "transno";
  static const String FDN_TRANSNOCLOSED = "transnoclosed";
  static const String FDN_TRANSNOOPENED = "transnoopened";
  static const String FDN_TRANSNOTE = "transnote";
  static const String FDN_TRANSRECEIPTNO = "transreceiptno";
  static const String FDN_TRANSSTATID = "transstatid";
  static const String FDN_TRANSTIME = "transtime";
  static const String FDN_TRANSTOTAL = "transtotal";
  static const String FDN_TRANSTYPE = "transtype";
  static const String FDN_TRANSTYPEDESC = "transtypedesc";
  static const String FDN_TRANSTYPELIST = "transtypelist";
  static const String FDN_TRANSUSERCODE = "transusercode";
  static const String FDN_TRANSUSERID = "transuserid";
  static const String FDN_TRANSWORKTYPE = "transworktype";
  static const String FDN_TRANSYEAR = "transyear";
  static const String FDN_TRAVELCHD = "travelchd";
  static const String FDN_TRAVELDATE = "traveldate";
  static const String FDN_TRAVELDAY = "travelday";
  static const String FDN_TRAVELWITH = "travelwith";
  static const String FDN_TRDELAYAVG = "trdelayavg";
  static const String FDN_TRDELAYFWAVG = "trdelayfwavg";
  static const String FDN_TRDELAYFWMIN = "trdelayfwmin";
  static const String FDN_TRDELAYFWTOTAL = "trdelayfwtotal";
  static const String FDN_TRDELAYMIN = "trdelaymin";
  static const String FDN_TRDELAYTOTAL = "trdelaytotal";
  static const String FDN_TRDURATIONAVG = "trdurationavg";
  static const String FDN_TRDURATIONMIN = "trdurationmin";
  static const String FDN_TREATEDBY = "treatedby";
  static const String FDN_TREELEVEL = "treelevel";
  static const String FDN_TREEORDERNO = "treeorderno";
  static const String FDN_TRGLANGCODE = "trglangcode";
  static const String FDN_TRGLANGDESC = "trglangdesc";
  static const String FDN_TRGLANGID = "trglangid";
  static const String FDN_TRGSUCC = "trgsucc";
  static const String FDN_TRGWORD = "trgword";
  static const String FDN_TRGWORDUPPER = "trgwordupper";
  static const String FDN_TRIDNO = "tridno";
  static const String FDN_TRIGGERNAME = "triggername";
  static const String FDN_TRIPCOUNT = "tripcount";
  static const String FDN_TRIPDURHOUR = "tripdurhour";
  static const String FDN_TRIPHOTEL = "triphotel";
  static const String FDN_TRIPLERATE = "triplerate";
  static const String FDN_TRIPLETEXT = "tripletext";
  static const String FDN_TRIPPERCENTMONTHLY = "trippercentmonthly";
  static const String FDN_TRIPPERCENTWEEKLY = "trippercentweekly";
  static const String FDN_TRIPPERCENTYEARLY = "trippercentyearly";
  static const String FDN_TRTOTAL = "trtotal";
  static const String FDN_TRYCOUNT = "trycount";
  static const String FDN_TRYOVER = "tryover";
  static const String FDN_TSCAT = "tscat";
  static const String FDN_TSCATDESC = "tscatdesc";
  static const String FDN_TSCATID = "tscatid";
  static const String FDN_TSCLOSED = "tsclosed";
  static const String FDN_TSCOUNT = "tscount";
  static const String FDN_TSDATE = "tsdate";
  static const String FDN_TSDESC = "tsdesc";
  static const String FDN_TSDESCCODE = "tsdesccode";
  static const String FDN_TSDESCDESC = "tsdescdesc";
  static const String FDN_TSDESCID = "tsdescid";
  static const String FDN_TSDESCODE = "tsdescode";
  static const String FDN_TSDURATION = "tsduration";
  static const String FDN_TSDURATIONSTR = "tsdurationstr";
  static const String FDN_TSDURTOTAL = "tsdurtotal";
  static const String FDN_TSDURTOTALMIN = "tsdurtotalmin";
  static const String FDN_TSENDTIME = "tsendtime";
  static const String FDN_TSFORMNOW = "tsformnow";
  static const String FDN_TSFORMOPEN = "tsformopen";
  static const String FDN_TSFORMPREV = "tsformprev";
  static const String FDN_TSLINEDURATION = "tslineduration";
  static const String FDN_TSLINEID = "tslineid";
  static const String FDN_TSNEEDCANCELTIME = "tsneedcanceltime";
  static const String FDN_TSNEEDCONFIRMTIME = "tsneedconfirmtime";
  static const String FDN_TSNEEDENDTIME = "tsneedendtime";
  static const String FDN_TSNEEDSTARTTIME = "tsneedstarttime";
  static const String FDN_TSOLCODE = "tsolcode";
  static const String FDN_TSOLDESC = "tsoldesc";
  static const String FDN_TSOLID = "tsolid";
  static const String FDN_TSOLINSDATETIME = "tsolinsdatetime";
  static const String FDN_TSOLINSUSERCODE = "tsolinsusercode";
  static const String FDN_TSOLINSUSERID = "tsolinsuserid";
  static const String FDN_TSOLMASTERID = "tsolmasterid";
  static const String FDN_TSOLTYPECODE = "tsoltypecode";
  static const String FDN_TSOLTYPEDESC = "tsoltypedesc";
  static const String FDN_TSOLTYPEID = "tsoltypeid";
  static const String FDN_TSOLUPDATETIME = "tsolupdatetime";
  static const String FDN_TSOLUSERCODE = "tsolusercode";
  static const String FDN_TSOLUSERID = "tsoluserid";
  static const String FDN_TSOPENED = "tsopened";
  static const String FDN_TSPRIORITY = "tspriority";
  static const String FDN_TSSTARTTIME = "tsstarttime";
  static const String FDN_TSSTATUS = "tsstatus";
  static const String FDN_TSSTATUSCOLOR = "tsstatuscolor";
  static const String FDN_TSSTATUSID = "tsstatusid";
  static const String FDN_TSTRANSCOUNT = "tstranscount";
  static const String FDN_TSTRANSEMPLIST = "tstransemplist";
  static const String FDN_TSTRANSNO = "tstransno";
  static const String FDN_TSTYPE = "tstype";
  static const String FDN_TSTYPECODE = "tstypecode";
  static const String FDN_TSTYPEDESC = "tstypedesc";
  static const String FDN_TSTYPEID = "tstypeid";
  static const String FDN_TUE = "tue";
  static const String FDN_TURNOVERDAYS = "turnoverdays";
  static const String FDN_TXTTYPEDESC = "txttypedesc";
  static const String FDN_TXTYPE = "txtype";
  static const String FDN_TYP = "typ";
  static const String FDN_TYPECATCODE = "typecatcode";
  static const String FDN_TYPECATCODELIST = "typecatcodelist";
  static const String FDN_TYPECATDESC = "typecatdesc";
  static const String FDN_TYPECATID = "typecatid";
  static const String FDN_TYPECODE = "typecode";
  static const String FDN_TYPECODELIST = "typecodelist";
  static const String FDN_TYPEDESC = "typedesc";
  static const String FDN_TYPEFULLDESC = "typefulldesc";
  static const String FDN_TYPEGRPCODE = "typegrpcode";
  static const String FDN_TYPEGRPCODELIST = "typegrpcodelist";
  static const String FDN_TYPEGRPDESC = "typegrpdesc";
  static const String FDN_TYPEGRPID = "typegrpid";
  static const String FDN_TYPEID = "typeid";
  static const String FDN_UAMODULEID = "uamoduleid";
  static const String FDN_UN = "un";
  static const String FDN_UNIPRICE = "uniprice";
  static const String FDN_UNIQENAME = "uniqename";
  static const String FDN_UNIQUENAME = "uniquename";
  static const String FDN_UPD = "upd";
  static const String FDN_UPDATEDATE = "updatedate";
  static const String FDN_UPDATES = "updates";
  static const String FDN_UPDATETIME = "updatetime";
  static const String FDN_CACHE_UPDATETIME = "updateTime";
  static const String FDN_UPDATETIMEFO = "updatetimefo";
  static const String FDN_UPDENDDT = "updenddt";
  static const String FDN_UPDREFINFO = "updrefinfo";
  static const String FDN_UPDSTARTDT = "updstartdt";
  static const String FDN_UPDT = "updt";
  static const String FDN_UPDTL = "updtl";
  static const String FDN_URL = "url";
  static const String FDN_USAGE = "usage";
  static const String FDN_USEACTION = "useaction";
  static const String FDN_USECHDAGE = "usechdage";
  static const String FDN_USECO = "useco";
  static const String FDN_USECOUNT = "usecount";
  static const String FDN_USEDAYS = "usedays";
  static const String FDN_USEENERGY = "useenergy";
  static const String FDN_USEEXTPRICE = "useextprice";
  static const String FDN_USEFORAUTOCALIB = "useforautocalib";
  static const String FDN_USEFORAUTOSERV = "useforautoserv";
  static const String FDN_USEGROUPPRICE = "usegroupprice";
  static const String FDN_USELUITEMS = "useluitems";
  static const String FDN_USEMASTERFOLIO = "usemasterfolio";
  static const String FDN_USESUPERHOTEL = "usesuperhotel";
  static const String FDN_USERCODE = "usercode";
  static const String FDN_USERDEPART = "userdepart";
  static const String FDN_USERDEPARTNAME = "userdepartname";
  static const String FDN_USERDESC = "userdesc";
  static const String FDN_USERGID = "usergid";
  static const String FDN_USERGROUP = "usergroup";
  static const String FDN_USERGROUPID = "usergroupid";
  static const String FDN_USERGROUPIDSTR = "usergroupidstr";
  static const String FDN_USERGROUPS = "usergroups";
  static const String FDN_USERID = "userid";
  static const String FDN_USERINBOXREPLYMID = "userinboxreplymid";
  static const String FDN_USERIP = "userip";
  static const String FDN_USERMID = "usermid";
  static const String FDN_USERNAME = "username";
  static const String FDN_USERPASS = "userpass";
  static const String FDN_USERPOS = "userpos";
  static const String FDN_USERROLE = "userrole";
  static const String FDN_USERSHORT = "usershort";
  static const String FDN_USERTEXT = "usertext";
  static const String FDN_USERTYPE = "usertype";
  static const String FDN_USETIME = "usetime";
  static const String FDN_USETYPE = "usetype";
  static const String FDN_USETYPEDESC = "usetypedesc";
  static const String FDN_UUID = "uuid";
  static const String FDN_VAL = "val";
  static const String FDN_VALUEBOOL = "valuebool";
  static const String FDN_VALUECODE = "valuecode";
  static const String FDN_VALUEDATE = "valuedate";
  static const String FDN_VALUEEXP = "valueexp";
  static const String FDN_VALUEFLOAT = "valuefloat";
  static const String FDN_VALUEFLT = "valueflt";
  static const String FDN_VALUEFORMONEY = "valueformoney";
  static const String FDN_VALUEINT = "valueint";
  static const String FDN_VALUELONGTEXT = "valuelongtext";
  static const String FDN_VALUEMAX = "valuemax";
  static const String FDN_VALUEMIN = "valuemin";
  static const String FDN_VALUEPER = "valueper";
  static const String FDN_VALUESTR = "valuestr";
  static const String FDN_VALUETEXT = "valuetext";
  static const String FDN_VALUETIME = "valuetime";
  static const String FDN_VALUETOTAL = "valuetotal";
  static const String FDN_VALUETXT = "valuetxt";
  static const String FDN_VALUETYP = "valuetyp";
  static const String FDN_VALUETYPE = "valuetype";
  static const String FDN_VALUETYPEDESC = "valuetypedesc";
  static const String FDN_VARNAME = "varname";
  static const String FDN_VARVALUE = "varvalue";
  static const String FDN_VAT = "vat";
  static const String FDN_VAT0 = "vat0";
  static const String FDN_VAT0AMOUNT = "vat0amount";
  static const String FDN_VAT0RATE = "vat0rate";
  static const String FDN_VAT0TOTAL = "vat0total";
  static const String FDN_VAT1 = "vat1";
  static const String FDN_VAT18AMOUNT = "vat18amount";
  static const String FDN_VAT18TOTAL = "vat18total";
  static const String FDN_VAT1AMOUNT = "vat1amount";
  static const String FDN_VAT1RATE = "vat1rate";
  static const String FDN_VAT1TOTAL = "vat1total";
  static const String FDN_VAT8 = "vat8";
  static const String FDN_VAT8AMOUNT = "vat8amount";
  static const String FDN_VAT8RATE = "vat8rate";
  static const String FDN_VAT8TOTAL = "vat8total";
  static const String FDN_VATNOWHTOTAL = "vatnowhtotal";
  static const String FDN_VATRATE = "vatrate";
  static const String FDN_VATTOTAL = "vattotal";
  static const String FDN_VATWHTOTAL = "vatwhtotal";
  static const String FDN_VC = "vc";
  static const String FDN_VD = "vd";
  static const String FDN_VDATE = "vdate";
  static const String FDN_VEHICLECODE = "vehiclecode";
  static const String FDN_VEHICLEDESC = "vehicledesc";
  static const String FDN_VEHICLEID = "vehicleid";
  static const String FDN_VEHICLETEMP = "vehicletemp";
  static const String FDN_VER = "ver";
  static const String FDN_VERSION = "version";
  static const String FDN_VERBALEVEL = "verbalevel";
  static const String FDN_VERGIDAIRESI = "vergidairesi";
  static const String FDN_VERGINO = "vergino";
  static const String FDN_VERSTR = "verstr";
  static const String FDN_VIDFILESIZE = "vidfilesize";
  static const String FDN_VIDHEIGHT = "vidheight";
  static const String FDN_VIDLENGTH = "vidlength";
  static const String FDN_VIDTYPE = "vidtype";
  static const String FDN_VIDTYPEDESC = "vidtypedesc";
  static const String FDN_VIDWIDTH = "vidwidth";
  static const String FDN_VIEVED = "vieved";
  static const String FDN_VIEWFIELD = "vv";
  static const String FDN_VIEWNAME = "viewname";
  static const String FDN_VIPLEVEL = "viplevel";
  static const String FDN_VISITCALLCOUNT = "visitcallcount";
  static const String FDN_VISITCOUNT = "visitcount";
  static const String FDN_VISITDURATION = "visitduration";
  static const String FDN_VISITDURATIONMIN = "visitdurationmin";
  static const String FDN_VISITDURATIONSTR = "visitdurationstr";
  static const String FDN_VISITDURMIN = "visitdurmin";
  static const String FDN_VISITEDDEPART = "visiteddepart";
  static const String FDN_VISITEDNAME = "visitedname";
  static const String FDN_VISITEND = "visitend";
  static const String FDN_VISITENDDELAYMIN = "visitenddelaymin";
  static const String FDN_VISITENDDELAYMINAVG = "visitenddelayminavg";
  static const String FDN_VISITENDDELAYTOTAL = "visitenddelaytotal";
  static const String FDN_VISITENDTIME = "visitendtime";
  static const String FDN_VISITENDUPDTIME = "visitendupdtime";
  static const String FDN_VISITGATECODE = "visitgatecode";
  static const String FDN_VISITGATEDESC = "visitgatedesc";
  static const String FDN_VISITGATEID = "visitgateid";
  static const String FDN_VISITID = "visitid";
  static const String FDN_VISITISOFF = "visitisoff";
  static const String FDN_VISITLIMIT = "visitlimit";
  static const String FDN_VISITOFFCOUNT = "visitoffcount";
  static const String FDN_VISITOFFDURATION = "visitoffduration";
  static const String FDN_VISITOFFDURMIN = "visitoffdurmin";
  static const String FDN_VISITOPEN = "visitopen";
  static const String FDN_VISITSTART = "visitstart";
  static const String FDN_VISITSTARTDELAYMIN = "visitstartdelaymin";
  static const String FDN_VISITSTARTDELAYMINAVG = "visitstartdelayminavg";
  static const String FDN_VISITSTARTDELAYTOTAL = "visitstartdelaytotal";
  static const String FDN_VISITSTARTTIME = "visitstarttime";
  static const String FDN_VISITSTARTUPDTIME = "visitstartupdtime";
  static const String FDN_VISITTOTAL = "visittotal";
  static const String FDN_VISITTYPE = "visittype";
  static const String FDN_VISITTYPECODE = "visittypecode";
  static const String FDN_VISITTYPEDESC = "visittypedesc";
  static const String FDN_VISITTYPEID = "visittypeid";
  static const String FDN_VNEWMID = "vnewmid";
  static const String FDN_VOLAMOUNT = "volamount";
  static const String FDN_VOLDMID = "voldmid";
  static const String FDN_VOLENGTH = "volength";
  static const String FDN_VOLHEIGHT = "volheight";
  static const String FDN_VOLQTY = "volqty";
  static const String FDN_VOLQTYCODE = "volqtycode";
  static const String FDN_VOLQTYDESC = "volqtydesc";
  static const String FDN_VOLQTYID = "volqtyid";
  static const String FDN_VOLWIDTH = "volwidth";
  static const String FDN_WAITALERT = "waitalert";
  static const String FDN_WAITDATE = "waitdate";
  static const String FDN_WAITER = "waiter";
  static const String FDN_WAITINTERVAL = "waitinterval";
  static const String FDN_WAITTIME = "waittime";
  static const String FDN_WAITUSERCODE = "waitusercode";
  static const String FDN_WAITUSERID = "waituserid";
  static const String FDN_WAKEUPDESCRIPTION = "wakeupdescription";
  static const String FDN_WAKEUPID = "wakeupid";
  static const String FDN_WARNDATE = "warndate";
  static const String FDN_WARNINGMAIL = "warningmail";
  static const String FDN_WARNINGNOTE = "warningnote";
  static const String FDN_WARNINTERVAL = "warninterval";
  static const String FDN_WARNNOTE = "warnnote";
  static const String FDN_WARNONCHG = "warnonchg";
  static const String FDN_WARNPERIOD = "warnperiod";
  static const String FDN_WARREND = "warrend";
  static const String FDN_WARRSTART = "warrstart";
  static const String FDN_WASEXCLUSIVE = "wasexclusive";
  static const String FDN_WAYBILLDATE = "waybilldate";
  static const String FDN_WAYBILLNO = "waybillno";
  static const String FDN_WDAY = "wday";
  static const String FDN_WEB = "web";
  static const String FDN_WEBDOMAIN = "webdomain";
  static const String FDN_WEBPARAMS = "webparams";
  static const String FDN_WEBURL = "weburl";
  static const String FDN_WED = "wed";
  static const String FDN_WEDDINGDATE = "weddingdate";
  static const String FDN_WEDDINGTIME = "weddingtime";
  static const String FDN_WEEKAVG = "weekavg";
  static const String FDN_WEEKBALANCE = "weekbalance";
  static const String FDN_WEEKDAYSINT = "weekdaysint";
  static const String FDN_WEEKDAYSTATUS = "weekdaystatus";
  static const String FDN_WEEKLASTPER = "weeklastper";
  static const String FDN_WEEKLYDAYS = "weeklydays";
  static const String FDN_WEEKPREV = "weekprev";
  static const String FDN_WEEKPREVSTART = "weekprevstart";
  static const String FDN_WEEKSTART = "weekstart";
  static const String FDN_WEEKTOTAL = "weektotal";
  static const String FDN_WEEKUTD = "weekutd";
  static const String FDN_WEEKVAT = "weekvat";
  static const String FDN_WHRATE = "whrate";
  static const String FDN_WIDGET = "widget";
  static const String FDN_WMONTH = "wmonth";
  static const String FDN_WORDLEN = "wordlen";
  static const String FDN_WORDPOS = "wordpos";
  static const String FDN_WORDSTR = "wordstr";
  static const String FDN_WORKADDRESS1 = "workaddress1";
  static const String FDN_WORKADDRESS2 = "workaddress2";
  static const String FDN_WORKCITY = "workcity";
  static const String FDN_WORKCOUNTRY = "workcountry";
  static const String FDN_WORKDATE = "workdate";
  static const String FDN_WORKDIRECT = "workdirect";
  static const String FDN_WORKDISTRICT = "workdistrict";
  static const String FDN_WORKDURATION = "workduration";
  static const String FDN_WORKDURMIN = "workdurmin";
  static const String FDN_WORKEMAIL = "workemail";
  static const String FDN_WORKPER = "workper";
  static const String FDN_WORKPERCENT = "workpercent";
  static const String FDN_WORKPOS = "workpos";
  static const String FDN_WORKREFALLOWED = "workrefallowed";
  static const String FDN_WORKSALARY = "worksalary";
  static const String FDN_WORKTITLE = "worktitle";
  static const String FDN_WORKTOWN = "worktown";
  static const String FDN_WORKTYPE = "worktype";
  static const String FDN_WORKTYPECODE = "worktypecode";
  static const String FDN_WORKTYPEDESC = "worktypedesc";
  static const String FDN_WORKTYPEID = "worktypeid";
  static const String FDN_WORKTYPETOTAL = "worktypetotal";
  static const String FDN_WORKTYPETOTALMIN = "worktypetotalmin";
  static const String FDN_WORKWEB = "workweb";
  static const String FDN_WORKZIP = "workzip";
  static const String FDN_WRAPPERCLASS = "wrapperclass";
  static const String FDN_WRAPPERID = "wrapperid";
  static const String FDN_WRITENLEVEL = "writenlevel";
  static const String FDN_WYEAR = "wyear";
  static const String FDN_XCODE = "xcode";
  static const String FDN_XED = "xed";
  static const String FDN_XEDKEYVALUE = "xedkeyvalue";
  static const String FDN_XMLREQSTR = "xmlreqstr";
  static const String FDN_XREASON = "xreason";
  static const String FDN_XREASONCODE = "xreasoncode";
  static const String FDN_XREASONDESC = "xreasondesc";
  static const String FDN_XREASONID = "xreasonid";
  static const String FDN_YEARAVG = "yearavg";
  static const String FDN_YEARBABY = "yearbaby";
  static const String FDN_YEARBALANCE = "yearbalance";
  static const String FDN_YEARCHD1 = "yearchd1";
  static const String FDN_YEARCHD2 = "yearchd2";
  static const String FDN_YEAREND = "yearend";
  static const String FDN_YEARLASTPER = "yearlastper";
  static const String FDN_YEARLYDAY = "yearlyday";
  static const String FDN_YEARLYMONTHS = "yearlymonths";
  static const String FDN_YEARPAX = "yearpax";
  static const String FDN_YEARPREV = "yearprev";
  static const String FDN_YEARPREVSTART = "yearprevstart";
  static const String FDN_YEARRATE = "yearrate";
  static const String FDN_YEARROOM = "yearroom";
  static const String FDN_YEARSECRATE = "yearsecrate";
  static const String FDN_YEARSTART = "yearstart";
  static const String FDN_YEARTARGET = "yeartarget";
  static const String FDN_YEARTOTAL = "yeartotal";
  static const String FDN_YEARUTD = "yearutd";
  static const String FDN_YEARUTDCURR = "yearutdcurr";
  static const String FDN_YEARVAR = "yearvar";
  static const String FDN_YEARVAT = "yearvat";
  static const String FDN_ZERODURTRANSCOUNT = "zerodurtranscount";
  static const String FDN_ZIP = "zip";
}
